USE `cnbg_20240511_001`;

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for sys_check_chain
-- ----------------------------
DROP TABLE IF EXISTS `sys_check_chain`;
CREATE TABLE `sys_check_chain`
(
    `chain_id`    INT AUTO_INCREMENT COMMENT 'Id',
    `chain_name`  VARCHAR(64) NOT NULL COMMENT '审批链名称',
    `node_qty`    VARCHAR(64) NOT NULL COMMENT '节点数',
    `del_flag`    VARCHAR(1)  NOT NULL DEFAULT '0' COMMENT '删除标记',
    `create_by`   VARCHAR(64) NOT NULL DEFAULT 'admin' COMMENT '创建人',
    `update_by`   VARCHAR(64) NOT NULL DEFAULT 'admin' COMMENT '修改人',
    `create_time` DATETIME    NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
    `update_time` DATETIME    NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
    PRIMARY KEY `pk_id` (`chain_id`) USING BTREE,
    UNIQUE KEY `uk_name` (`chain_name`) USING BTREE
) ENGINE = InnoDB
    COMMENT ='审批链';

-- ----------------------------
-- Records of sys_check_chain
-- ----------------------------
BEGIN;
INSERT INTO sys_check_chain (chain_id, chain_name, node_qty, del_flag, create_by, update_by, create_time, update_time)
VALUES (1, '中生营销行为证据链审批流', '6', '0', 'admin', 'admin', '2024-05-22 10:26:23', '2024-05-22 10:26:23');

COMMIT;


SET FOREIGN_KEY_CHECKS = 1;
