USE `cnbg_20240511_001`;

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for wm_agent_eval
-- ----------------------------
DROP TABLE IF EXISTS `wm_agent_eval`;
CREATE TABLE `wm_agent_eval`
(
    `eval_id`     BIGINT UNSIGNED AUTO_INCREMENT NOT NULL COMMENT '主键ID',
    `dept_id`     INT                            NOT NULL COMMENT '代理商ID',
    `eval_type`   VARCHAR(32)                    NOT NULL COMMENT '评价类型',
    `target_name` VARCHAR(64)                    NOT NULL COMMENT '响应人名称',
    `eval_time`   DATE                           NOT NULL COMMENT '评审日期',
    `eval_res`    JSON                           NULL COMMENT '评审结果',
    `admin_name`  VARCHAR(32)                    NOT NULL COMMENT '评审人',
    `sign_date`   DATE                           NOT NULL COMMENT '签约日期',
    `create_by`   VARCHAR(64)                    NOT NULL COMMENT '创建人',
    `update_by`   VARCHAR(64)                    NOT NULL COMMENT '修改人',
    `create_time` DATETIME                       NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
    `update_time` DATETIME                       NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '修改时间',
    PRIMARY KEY `pk_id` (`eval_id`)
) ENGINE = InnoDB
  DEFAULT CHARSET = utf8mb4
  COLLATE = utf8mb4_general_ci
  ROW_FORMAT = DYNAMIC COMMENT ='代理商评价表';


-- ----------------------------
-- Records of wm_agent_eval
-- ----------------------------
BEGIN;
COMMIT;


SET FOREIGN_KEY_CHECKS = 1;
