USE `cnbg_20240511_001`;

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for wm_qcc_info
-- ----------------------------
DROP TABLE IF EXISTS `wm_qcc_info`;
CREATE TABLE `wm_qcc_info`
(
    `info_id`                BIGINT UNSIGNED AUTO_INCREMENT     NOT NULL COMMENT '主键ID',
    `reg_code`               VARCHAR(32)                        NOT NULL COMMENT '三合一码',
    `biz_info`               JSON                               NULL COMMENT '工商照面信息',
    `revoke_info`            JSON                               NULL COMMENT '注销吊销信息',
    `bank_info`              JSON                               NULL COMMENT '开票信息',
    `scale`                  VARCHAR(10)                        NULL COMMENT '企业规模',
    `partner_list`           JSON                               NULL COMMENT '工商登记股东',
    `employee_list`          JSON                               NULL COMMENT '工商登记主要人员',
    `change_list`            JSON                               NULL COMMENT '变更信息',
    `actual_controller_list` JSON                               NULL COMMENT '实际控制人',
    `admin_license_list`     JSON                               NULL COMMENT '行政许可',
    `tax_credit_list`        JSON                               NULL COMMENT '纳税等级',
    `shi_xin`                JSON                               NULL COMMENT '失信人',
    `zhi_xing`               JSON                               NULL COMMENT '被执行人',
    `admin_penalty`          JSON                               NULL COMMENT '行政处罚',
    `exp`                    JSON                               NULL COMMENT '经营异常',
    `chattel_mortgage`       JSON                               NULL COMMENT '动产抵押',
    `liquidation`            JSON                               NULL COMMENT '清算信息',
    `serious_illegal`        JSON                               NULL COMMENT '严重违法',
    `bankruptcy`             JSON                               NULL COMMENT '破产重组',
    `sumptuary`              JSON                               NULL COMMENT '限制高消费',
    `tax_illegal`            JSON                               NULL COMMENT '税收违法',
    `tax_abnormal`           JSON                               NULL COMMENT '税收非正常户',
    `credit_rating`          JSON                               NULL COMMENT '信用评分',
    `create_by`              VARCHAR(32)                        NOT NULL COMMENT '创建人',
    `create_time`            DATETIME DEFAULT CURRENT_TIMESTAMP NOT NULL COMMENT '创建时间',
    PRIMARY KEY `pk_id` (`info_id`) USING BTREE
) ENGINE = InnoDB
  DEFAULT CHARSET = utf8mb4
  COLLATE = utf8mb4_general_ci
  ROW_FORMAT = DYNAMIC COMMENT ='企查查信息';


-- ----------------------------
-- Records of wm_pkg_rdp
-- ----------------------------
BEGIN;
COMMIT;


SET FOREIGN_KEY_CHECKS = 1;
