USE `cnbg_20240511_001`;

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for sys_ent_cont_info
-- ----------------------------
DROP TABLE IF EXISTS `sys_ent_cont_info`;
CREATE TABLE `sys_ent_cont_info`
(
    `info_id`           INT UNSIGNED AUTO_INCREMENT NOT NULL COMMENT '信息',
    `ent_id`            INT                         NOT NULL COMMENT '企业ID',
    `ent_name`          VARCHAR(64)                 NULL COMMENT '企业名称',
    `reg_code`          VARCHAR(64)                 NULL COMMENT '三合一信用代码',
    `ent_addr`          VARCHAR(255)                NULL COMMENT '企业地址',
    `ent_resp_name`     VARCHAR(64)                 NULL COMMENT '企业法人',
    `ent_contact_name`  VARCHAR(64)                 NULL COMMENT '企业联系人',
    `ent_contact_phone` VARCHAR(64)                 NULL COMMENT '企业联系电话',
    `ent_bank_name`     VARCHAR(64)                 NULL COMMENT '企业开户银行',
    `ent_bank_no`       VARCHAR(64)                 NULL COMMENT '企业开户行行号',
    `ent_bank_acc`      VARCHAR(64)                 NULL COMMENT '企业银行账号',
    `create_time`       DATETIME                    NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
    PRIMARY KEY `pk_id` (`info_id`) USING BTREE,
    KEY `idx_eid` (`ent_id`) USING BTREE
) ENGINE = InnoDB
  DEFAULT CHARSET = utf8mb4
  COLLATE = utf8mb4_general_ci
  ROW_FORMAT = DYNAMIC COMMENT ='企业合同信息';


-- ----------------------------
-- Records of sys_ent_cont_info
-- ----------------------------
BEGIN;
COMMIT;


SET FOREIGN_KEY_CHECKS = 1;
