USE `cnbg_20240511_001`;

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for wm_task_sup_adv
-- ----------------------------
DROP TABLE IF EXISTS `wm_task_sup_adv`;
CREATE TABLE `wm_task_sup_adv`
(
    `adv_id`                BIGINT UNSIGNED AUTO_INCREMENT     NOT NULL COMMENT '监督建议ID',
    `task_supervision_id`      BIGINT UNSIGNED                    NOT NULL COMMENT '任务监察ID',
    `task_supervision_content` VARCHAR(512)                       NULL COMMENT '监察内容',
    `advice_result`            TINYINT(1)                         NOT NULL COMMENT '意见结果',
    `del_flag`                 TINYINT(1)                         NOT NULL COMMENT '删除结果',
    `remarks`                  VARCHAR(512)                       NOT NULL COMMENT '监察说明',
    `create_by`                VARCHAR(32)                        NOT NULL COMMENT '创建人',
    `update_by`                VARCHAR(32)                        NOT NULL COMMENT '更新人',
    `create_time`              DATETIME DEFAULT CURRENT_TIMESTAMP NOT NULL COMMENT '创建时间',
    `update_time`              DATETIME DEFAULT CURRENT_TIMESTAMP NOT NULL ON UPDATE CURRENT_TIMESTAMP COMMENT '创建时间',
    PRIMARY KEY `pk_id` (`adv_id`) USING BTREE,
    KEY `idx_tpid` (`task_supervision_id`) USING BTREE
) ENGINE = InnoDB
  DEFAULT CHARSET = utf8mb4
  COLLATE = utf8mb4_general_ci
  ROW_FORMAT = DYNAMIC COMMENT ='服务监督建议表';


-- ----------------------------
-- Records of wm_task_sup
-- ----------------------------
BEGIN;
COMMIT;


SET FOREIGN_KEY_CHECKS = 1;
