USE `cnbg_20240511_001`;

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for sys_area
-- ----------------------------
DROP TABLE IF EXISTS `sys_area`;
CREATE TABLE `sys_area`
(
    `area_id`     BIGINT UNSIGNED NOT NULL COMMENT '主键ID',
    `parent_id`   BIGINT          NOT NULL COMMENT '父ID',
    `area_name`   VARCHAR(255)    NOT NULL COMMENT '地区名称',
    `letter`      VARCHAR(255)    NULL COMMENT '地区字母',
    `area_code`   VARCHAR(30)     NOT NULL COMMENT '地区编码',
    `lat`         DECIMAL(10, 6)  NULL COMMENT '经度',
    `lng`         DECIMAL(10, 6)  NULL COMMENT '纬度',
    `area_type`   CHAR(1)         NOT NULL COMMENT '0:国家,1:省,2:城市,3:区县',
    `area_status` TINYINT(1)      NOT NULL DEFAULT TRUE COMMENT '0:未生效，1:生效',
    `hot`         TINYINT(1)      NOT NULL DEFAULT FALSE COMMENT 'false:非热门，true:热门',
    `sort_order`  INT(5)          NOT NULL DEFAULT 0 COMMENT '排序值',
    `del_flag`    CHAR(1)         NOT NULL DEFAULT '0' COMMENT '删除标记',
    `create_by`   VARCHAR(64)     NOT NULL COMMENT '创建人',
    `update_by`   VARCHAR(64)     NOT NULL COMMENT '修改人',
    `create_time` DATETIME        NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
    `update_time` DATETIME        NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '修改时间',
    PRIMARY KEY `pk_id` (`area_id`)
) ENGINE = InnoDB
  DEFAULT CHARSET = utf8mb4
  COLLATE = utf8mb4_general_ci
  ROW_FORMAT = DYNAMIC COMMENT ='行政区划表';


-- ----------------------------
-- Records of sys_area
-- ----------------------------
BEGIN;
COMMIT;


SET FOREIGN_KEY_CHECKS = 1;
