
package com.qunzhixinxi.hnqz.common.security.component;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;
import com.qunzhixinxi.hnqz.common.core.constant.CommonConstants;
import com.qunzhixinxi.hnqz.common.security.exception.HnqzAuth2Exception;
import lombok.SneakyThrows;

/**
 * @author hnqz
 * @date 2018/11/16
 * <p>
 * OAuth2 异常格式化
 */
public class HnqzAuth2ExceptionSerializer extends StdSerializer<HnqzAuth2Exception> {

	public HnqzAuth2ExceptionSerializer() {
		super(HnqzAuth2Exception.class);
	}

	@Override
	@SneakyThrows
	public void serialize(HnqzAuth2Exception value, JsonGenerator gen, SerializerProvider provider) {
		gen.writeStartObject();
		gen.writeObjectField("code", CommonConstants.FAIL);
		gen.writeStringField("msg", value.getMessage());
		gen.writeStringField("data", value.getErrorCode());
		gen.writeEndObject();
	}

}
