package com.qunzhixinxi.hnqz.common.security.encoder;

import cn.hutool.core.text.CharSequenceUtil;
import cn.hutool.crypto.SmUtil;
import cn.hutool.crypto.symmetric.SymmetricCrypto;
import org.springframework.security.crypto.password.PasswordEncoder;

public class SM4PasswordEncoder implements PasswordEncoder {

    private final SymmetricCrypto sm4;


    public SM4PasswordEncoder() {
        this.sm4 = SmUtil.sm4("xViWF8DmiWET1ipf".getBytes());
    }

    /**
     * Encode the raw password. Generally, a good encoding algorithm applies a SHA-1 or
     * greater hash combined with an 8-byte or greater randomly generated salt.
     *
     * @param rawPassword 密码明文
     */
    @Override
    public String encode(CharSequence rawPassword) {
        String s = sm4.encryptHex(rawPassword.toString());
        return sm4.encryptHex(rawPassword.toString());
    }

    /**
     * Verify the encoded password obtained from storage matches the submitted raw
     * password after it too is encoded. Returns true if the passwords match, false if
     * they do not. The stored password itself is never decoded.
     *
     * @param rawPassword     the raw password to encode and match
     * @param encodedPassword the encoded password from storage to compare with
     * @return true if the raw password, after encoding, matches the encoded password from
     * storage
     */
    @Override
    public boolean matches(CharSequence rawPassword, String encodedPassword) {
        return CharSequenceUtil.equals(this.encode(rawPassword), encodedPassword);
    }
}
