package com.qunzhixinxi.hnqz.admin.api.constant;

import com.baomidou.mybatisplus.annotation.EnumValue;
import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * Upms状态枚举
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2022-08-15 15:24
 */
public class UpmsState {

    /**
     * 业务提醒已读状态
     *
     * @author lixuesong
     * @date 2023/10/25
     */
    @Getter
    @AllArgsConstructor
    public enum BizReminderReadStatus {

        READ("READ", "已读"),
        UNREAD("UNREAD", "未读");

        @EnumValue
        private final String status;
        private final String description;
    }

    /**
     * 积分包结算财务复核状态
     *
     * @author lixuesong
     * @date 2024/01/05
     */
    @Getter
    @AllArgsConstructor
    public enum SettleFinancialReviewStatus {
        AUTO("AUTO", "自动"),
        TO_BE_REVIEWED("TO_BE_REVIEWED", "待复核"),
        PASSED("PASSED", "通过"),
        REJECTED("REJECTED", "拒绝");

        @EnumValue
        private final String status;
        private final String description;
    }

    /**
     * 执行计划类型（可见实际类型）
     *
     * @author ImplementPlanType
     * @version 1.0.0
     * @date 2024/05/19 11:22
     */
    @Getter
    @AllArgsConstructor
    public enum ImplementPlanActionState {

        IN_PROGRESS("IN_PROGRESS", "执行中"),
        REJECTED("REJECTED", "拒绝"),

        AWAIT_2_LEADER("AWAIT_2_LEADER", "待营销中心分管领导审批"),
        AWAIT_2_OM("AWAIT_2_OM", "待运营管理员审批"),

        PASSED_AND_GO("PASSED_AND_GO", "审核通过已下发"),
        PASSED_TO_GO("PASSED_TO_GO", "审核通过待下发"),
        ;

        @EnumValue
        private final String state;
        private final String desc;
    }

    /**
     * 执行计划类型（可见实际类型）
     *
     * @author ImplementPlanType
     * @version 1.0.0
     * @date 2024/05/19 11:22
     */
    @Getter
    @AllArgsConstructor
    public enum ImplementPlanDetailsActionState {

        PASSED("PASSED", "审核通过"),
        REJECTED("REJECTED", "审核拒绝"),
        INIT("INIT", "待区域管理员审核"),
        CKT1("CKT1", "待商务组审核"),
        CKT2("CKT2", "待分管领导审核"),
        PENDING("PENDING", "待拆解"),
        ;

        @EnumValue
        private final String state;
        private final String desc;
    }


    /**
     * 执行计划类型
     *
     * @author ImplementPlanType
     * @version 1.0.0
     * @date 2024/05/19 11:22
     */
    @Getter
    @AllArgsConstructor
    public enum ImplementPlanState {

        INIT("INIT", "新建"),
        IN_PROGRESS("IN_PROGRESS", "执行中"),
        REJECTED("REJECTED", "拒绝"),
        PASSED("PASSED", "通过"),
        ;

        @EnumValue
        private final String state;
        private final String desc;
    }

    /**
     * 执行计划类型
     *
     * @author ImplementPlanType
     * @version 1.0.0
     * @date 2024/05/19 11:22
     */
    @Getter
    @AllArgsConstructor
    public enum ImplPlanDetailsState {

        INIT("INIT", "新建"),
        CKT1("CKT1", "待审核1"),
        CKT2("CKT2", "待审核2"),
        REJECTED("REJECTED", "拒绝"),
        PASSED("PASSED", "通过"),
        ;

        @EnumValue
        private final String state;
        private final String desc;
    }


    @Getter
    @AllArgsConstructor
    public enum PackageSupervisionState {

        INIT("INIT", "待部门负责人审核"),
        CKT1("CKT1", "待分管领导审核"),
        CKT2("CKT2", "待人用疫苗事业部总经理审核"),
        REJECTED("REJECTED", "拒绝"),
        PASSED("PASSED", "通过"),
        ;

        @EnumValue
        private final String state;
        private final String desc;
    }

    @Getter
    @AllArgsConstructor
    public enum TaskSupervisionState {

        INIT("INIT", "待部门负责人审核"),
        CKT1("CKT1", "待分管领导审核"),
        CKT2("CKT2", "待人用疫苗事业部总经理审核"),
        // REJECTED("REJECTED", "拒绝"),
        PASSED("PASSED", "通过"),
        ;

        @EnumValue
        private final String state;
        private final String desc;
    }

    @Getter
    @AllArgsConstructor
    public enum ScorePackageState {

        TO_PICKUP("1", "已下发待申领"),
        TO_CHECK("2", "已申领待审批"),
        DOING("3", "进行中"),
        TO_SETTLE("4", "已完成待结算"),
        STOP("6", "已终止"),
        TO_APPROVAL("7", "已完成待上级审批");

        @EnumValue
        private final String state;
        private final String desc;
    }

    @Getter
    @AllArgsConstructor
    public enum TaskState {

        UNCHECKED("1", "未审核"),
        CHECKING("2", "审核中"),
        PASSED("3", "审核通过"),
        REJECTED("4", "不通过");

        @EnumValue
        private final String state;
        private final String desc;
    }
}
