package com.qunzhixinxi.hnqz.admin.api.constant.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * 是否有效（是否禁用）状态枚举
 *
 * @author lixuesong
 * @date 2021年05月27日 11:06
 */
@Getter
@AllArgsConstructor
public enum  EnableEnum {

	/**
	 * 有效（没有禁用）
	 */
	ENABLE("0", "启用"),
	/**
	 * 无效（禁用）
	 */
	DISABLE("1", "停用");

	private String val;

	private String desc;

	public String val() {
		return val;
	}


	/**
	 * 获取 Val
	 *
	 * @param val 值
	 * @return {@link EnableEnum}
	 */
	public static EnableEnum getByVal(String val) {
		for (EnableEnum d : EnableEnum.values()) {
			if (d.val.equals(val)) {
				return d;
			}
		}
		return null;
	}
}
