package com.qunzhixinxi.hnqz.admin.api.dto;

import com.baomidou.mybatisplus.annotation.TableField;
import com.qunzhixinxi.hnqz.admin.api.entity.SysNotice;
import lombok.AccessLevel;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;
import java.time.LocalDateTime;

/**
 * 通知dto
 *
 * @author jimmy
 * @date 09/07/2024 17:50
 */
@NoArgsConstructor(access = AccessLevel.NONE)
public final class SysNoticeDto {

    @Data
    public static class OnPage {


        private Boolean read;


        @NotNull(message = "页码必填")
        @Min(value = 1, message = "页码最小为{value}")
        private Integer current;

        @NotNull(message = "分页数量必填")
        @Min(value = 1, message = "分页数量最小为{value}")
        @Max(value = 100, message = "分页数量最大为{value}")
        private Integer size;


    }

    @Data
    public static class OnRead {

        @NotNull(message = "通知ID必填")
        private Integer noticeId;

        @NotNull(message = "阅读标记必填")
        private Boolean read;

    }

    @Data
    public static class OnCreate {

        private String title;

        private String content;

        /**
         * 目标人
         */
        private Integer userId;


    }
}
