package com.qunzhixinxi.hnqz.admin.api.dto;

import lombok.AccessLevel;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;

/**
 * 统计dto
 *
 * @author jimmy
 * @date 17/07/2024 22:28
 */
@NoArgsConstructor(access = AccessLevel.NONE)
public final class SysStatisticDto {

    @Data
    public static class OnPlanTree {

        @NotNull(message = "页码必填")
        @Min(value = 1, message = "页码最小为{value}")
        private Integer current;

        @NotNull(message = "分页数量必填")
        @Min(value = 10, message = "分页数量最小为{value}")
        @Max(value = 100, message = "分页数量最大为{value}")
        private Integer size;
    }

    @Data
    public static class OnPkgTree {

        @NotNull(message = "页码必填")
        @Min(value = 1, message = "页码最小为{value}")
        private Integer current;

        @NotNull(message = "分页数量必填")
        @Min(value = 10, message = "分页数量最小为{value}")
        @Max(value = 100, message = "分页数量最大为{value}")
        private Integer size;

    }

    @Data
    public static class OnProviderQccData {
        @NotNull(message = "页码必填")
        @Min(value = 1, message = "页码最小为{value}")
        private Integer current;

        @NotNull(message = "分页数量必填")
        @Min(value = 10, message = "分页数量最小为{value}")
        @Max(value = 100, message = "分页数量最大为{value}")
        private Integer size;
    }

    @Data
    public static class OnProviderTree {
        @NotNull(message = "页码必填")
        @Min(value = 1, message = "页码最小为{value}")
        private Integer current;

        @NotNull(message = "分页数量必填")
        @Min(value = 10, message = "分页数量最小为{value}")
        @Max(value = 100, message = "分页数量最大为{value}")
        private Integer size;
    }

    @Data
    public static class OnSupData {

        @NotNull(message = "页码必填")
        @Min(value = 1, message = "页码最小为{value}")
        private Integer current;

        @NotNull(message = "分页数量必填")
        @Min(value = 10, message = "分页数量最小为{value}")
        @Max(value = 100, message = "分页数量最大为{value}")
        private Integer size;

    }
}
