package com.qunzhixinxi.hnqz.admin.api.dto;

import com.fasterxml.jackson.annotation.JsonAlias;
import lombok.AccessLevel;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.List;
import java.util.Set;

@NoArgsConstructor(access = AccessLevel.NONE)
public final class SysUserDTO {

    @Data
    public static class OnSalesmanCreate {

        @NotBlank(message = "用户名必填")
        private String username;

        @NotBlank(message = "联系方式必填")
        private String phone;


        @NotBlank(message = "真实名称必填")
        @JsonAlias("realname")
        private String realName;

        @NotEmpty(message = "角色ID必填")
        private List<Integer> role;

        @NotBlank(message = "锁定标记必填")
        private String lockFlag;

        private String idCardNumber;

        @NotNull(message = "所属企业必填")
        private Integer deptId;

        private List<Long> areaCodes;

        // @NotEmpty(message = "认证文件必填")
        private List<Long> certFileIds;
    }

    @Data
    public static class OnPltUserAgreementSign {

        @NotBlank(message = "协议名称必填")
        private String agreementName;

        @NotBlank(message = "协议版本必填")
        private String agreementVersion;

    }

    @Data
    public static class OnCertificateCreate {

        @NotNull(message = "用户ID必填")
        private Integer userId;

        @NotBlank(message = "证书类型必填")
        private String type;

        @NotEmpty(message = "文件ID必填")
        private List<Long> fileIds;
    }

    @Data
    public static class OnCertInfoPage {

        @NotNull(message = "页码必填")
        @Min(value = 1, message = "页码最小为{value}")
        private Integer current;

        @NotNull(message = "分页数量必填")
        @Min(value = 10, message = "分页数量最小为{value}")
        @Max(value = 100, message = "分页数量最大为{value}")
        private Integer size;
    }

    @Data
    public static class OnProdBind {

        // @NotNull(message = "业务员备案ID必填")
        private Integer certId;

        // @NotEmpty(message = "商品ID必填")
        private List<Integer> productIds;

        @NotNull(message = "业务员ID必填")
        private Integer userId;

    }


    @Data
    public static class OnPage{

        private String username;

        private String realname;

        private List<Integer> role;

        private Integer deptId;

        private List<Long> areaCodes;

        private String lockFlag;

        @NotNull(message = "size必填")
        private Integer size;

        @NotNull(message = "页码必填")
        private Integer current;

    }
}
