package com.qunzhixinxi.hnqz.admin.api.dto;

import lombok.AccessLevel;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.List;
import java.util.Map;

/**
 * 任务相关DTO
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2023-11-05 18:12
 */
@NoArgsConstructor(access = AccessLevel.NONE)
public final class WmTaskDTO {

    @Data
    public static class OnOutPartyCreate {

        @NotBlank(message = "任务类型ID必填")
        private String taskTypeId;

        private String pkgName;

        private String pkgId;

        @NotBlank(message = "代表用户名必填")
        private String username;

        @NotEmpty(message = "三方结构必填")
        private Map<String, Object> struct;

        @NotEmpty(message = "三方结果必填")
        private Map<String, Object> result;

    }

    /**
     * 更新任务备注参数
     *
     * @author lixuesong
     * @date 2024/01/31
     */
    @Data
    public static class TaskRemarkUpdate {

        /**
         * 任务类型主键id
         */
        @NotBlank(message = "id必填")
        private String id;

        /**
         * 任务备注
         */
        @NotBlank(message = "任务备注必填")
        private String taskRemark;
    }

    @Data
    public static class OnBatchCheck {

        @NotEmpty(message = "任务ID和节点关系必填")
        private Map<String, Integer> taskIdToNodeIdMap;

        @NotBlank(message = "审核状态必填")
        private String taskStatus;

    }

}
