package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsType;
import com.qunzhixinxi.hnqz.common.core.constant.CommonConstants;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 行政区划表
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2024/05/12 20:04
 */
@Data
@TableName(value = "sys_area")
public final class SysAreaEntity implements Serializable {


    @TableField(exist = false)
    private static final long serialVersionUID = 1L;


    /**
     * 主键ID
     */
    @TableId(type = IdType.INPUT)
    private Long areaId;

    /**
     * 父ID
     */
    private Long parentId;

    /**
     * 地区名称
     */
    private String areaName;

    /**
     * 地区字母
     */
    private String letter;

    /**
     * 地区编码
     */
    private String areaCode;

    /**
     * 经度
     */
    @TableField(value = "lat")
    private Double lat;

    /**
     * 纬度
     */
    @TableField(value = "lat")
    private Double lng;

    /**
     * 0:国家,1:省,2:城市,3:区县
     */
    private UpmsType.AreaType areaType;

    /**
     * 0:未生效，1:生效
     */
    private Boolean areaStatus;

    /**
     * false:非热门，true:热门
     */
    private Boolean hot;

    /**
     * 排序值
     */
    private Integer sortOrder;

    /**
     * 删除标记
     */
    @TableLogic(value = CommonConstants.STATUS_NORMAL, delval = CommonConstants.STATUS_DEL)
    private String delFlag;

    /**
     * 创建人
     */
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    /**
     * 修改人
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    /**
     * 创建时间
     */
    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createTime;

    /**
     * 修改时间
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updateTime;

}