package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.qunzhixinxi.hnqz.admin.api.constant.enums.DelEnum;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 审批链节点
 *
 * @TableName sys_chain_node
 */
@Data
@TableName(value = "sys_chain_node")
public class SysCheckChainNode implements Serializable {
    /**
     * Id
     */
    @TableId(type = IdType.AUTO)
    private Integer nodeId;

    /**
     * 节点名称
     */
    private String nodeName;

    /**
     * 上游节点
     */
    private Integer preNodeId;

    /**
     * 下游游节点
     */
    private Integer nextNodeId;

    /**
     * 组别ID
     */
    private Integer groupId;

    /**
     * 执行角色
     */
    private Integer execRoleId;

    /**
     * 前端显示文案
     */
    @TableField("dis_info")
    private String displayInfo;

    /**
     * 删除标记
     */
    @TableLogic
    private DelEnum delFlag;

    /**
     * 创建人
     */
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    /**
     * 修改人
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    /**
     * 创建时间
     */
    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createTime;

    /**
     * 更新时间
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updateTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;


}