package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 审批链节点审核历史
 *
 * @TableName sys_chain_node_check_his
 */
@Data
@TableName(value = "sys_chain_node_check_his")
public class SysCheckChainNodeCheckHistory implements Serializable {
    /**
     * Id
     */
    @TableId(value = "his_id", type = IdType.AUTO)
    private Integer historyId;

    /**
     * Id
     */
    private Integer nodeId;

    /**
     * 目标对象ID
     */
    private Integer targetId;

    /**
     * 审核结果
     */
    private Boolean checkResult;

    /**
     * 结果描述
     */
    private String checkMsg;

    /**
     * 创建人
     */
    @TableField(value = "create_by1", fill = FieldFill.INSERT)
    private String createBy;

    /**
     * 修改人
     */
    @TableField(value = "update_by1", fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    /**
     * 创建时间
     */
    @TableField(value = "create_time1", fill = FieldFill.INSERT)
    private LocalDateTime createTime;

    /**
     * 更新时间
     */
    @TableField(value = "update_time1", fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updateTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

}