package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsState;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.Date;

/**
 * 执行计划详情实体
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2024/05/19 20:08
 */
@Data
@TableName(value = "sys_impl_plan_details")
public class SysImplPlanDetails implements Serializable {
    /**
     * 主键ID
     */
    @TableId(type = IdType.AUTO)
    private Integer detailsId;

    /**
     * 计划ID
     */
    private Integer planId;

    /**
     * 计划任务总数
     */
    private Integer qty;

    /**
     * 计划总值
     */
    private Long total;

    /**
     * 详情状态
     */
    private UpmsState.ImplPlanDetailsState detailsState;

    /**
     * 审核结果
     */
    private Boolean cktRes1;

    /**
     * 审核意见
     */
    private String cktMsg1;

    /**
     * 审核时间
     */
    private LocalDateTime cktTime1;

    /**
     * 审核人用户名
     */
    private String cktName1;

    /**
     * 审核结果
     */
    private Boolean cktRes2;

    /**
     * 审核意见
     */
    private String cktMsg2;

    /**
     * 审核时间
     */
    private LocalDateTime cktTime2;

    /**
     * 审核人用户名
     */
    private String cktName2;

    /**
     * 审核结果
     */
    private Boolean cktRes3;

    /**
     * 审核意见
     */
    private String cktMsg3;

    /**
     * 审核时间
     */
    private LocalDateTime cktTime3;

    /**
     * 审核人用户名
     */
    private String cktName3;

    /**
     * 创建人
     */
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    /**
     * 修改人
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    /**
     * 创建时间
     */
    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createTime;

    /**
     * 修改时间
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updateTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

}