package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsState;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsType;
import com.qunzhixinxi.hnqz.admin.api.constant.enums.DelEnum;
import com.qunzhixinxi.hnqz.admin.api.constant.enums.LockEnum;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * 执行计划实体
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2024/05/19 11:00
 */
@Data
@TableName(value = "sys_impl_plan")
public class SysImplementPlan implements Serializable {

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

    /**
     * 主键ID
     */
    @TableId(type = IdType.AUTO)
    private Integer planId;

    /**
     * 计划名称
     */
    private String planName;

    /**
     * 计划类型
     */
    private UpmsType.ImplementPlanType planType;

    /**
     * 父ID
     */
    private Integer parentId;

    /**
     * 状态
     */
    private UpmsState.ImplementPlanState planState;

    /**
     * 可用值
     */
    private Long availScore;

    /**
     * 计划值
     */
    private Long planScore;

    /**
     * 产品ID必填
     */
    private Integer skuId;

    /**
     * 委托人ID
     */
    private Integer consignorId;

    /**
     * 受托人ID
     */
    private Integer consigneeId;

    /**
     * 签发时间
     */
    private LocalDate planIssue;

    /**
     * 截止日期
     */
    private LocalDate planExpiry;

    /**
     * 审核结果
     */
    @TableField(value = "ckt_res")
    private Boolean checkResult;

    /**
     * 审核信息
     */
    @TableField(value = "ckt_msg")
    private String checkMessage;

    /**
     * 审核时间
     */
    @TableField(value = "ckt_time")
    private LocalDateTime checkTime;

    /**
     * 审核人
     */
    @TableField(value = "ckt_name")
    private String checker;

    /**
     * 锁定标记
     */
    private LockEnum locFlag;

    /**
     * 删除标记
     */
    // @TableLogic
    private DelEnum delFlag;

    /**
     * 创建人
     */
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    /**
     * 修改人
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    /**
     * 创建时间
     */
    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createTime;

    /**
     * 修改时间
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updateTime;

}