package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 * 用户表
 * </p>
 *
 * @author hnqz
 * @since 2017-10-29
 */
@Data
public class SysUser implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键ID
     */
    @TableId(value = "user_id", type = IdType.AUTO)
    private Integer userId;

    /**
     * 最新更新密码时间
     */
    private LocalDateTime latestChangePwdTime;

    /**
     * 用户名
     */
    private String username;

    /**
     * 密码
     */
    private String password;

    /**
     * 身份证号
     */
    private String idCardNumber;

    /**
     * 签名
     */
    private String userSign;

    /**
     * 随机盐
     */
    @JsonIgnore
    private String salt;

    /**
     * 创建时间
     */
    private LocalDateTime createTime;

    /**
     * 修改时间
     */
    private LocalDateTime updateTime;

    /**
     * 0-正常，1-删除
     */
    @TableLogic
    private String delFlag;

    /**
     * 锁定标记
     */
    private String lockFlag;

    /**
     * 手机号
     */
    private String phone;

    /**
     * 头像
     */
    private String avatar;

    /**
     * 部门ID
     */
    private Integer deptId;

    /**
     * 租户ID
     */
    private Integer tenantId;

    /**
     * 微信openid
     */
    private String wxOpenid;

    /**
     * 微信小程序openId
     */
    private String miniOpenid;

    /**
     * QQ openid
     */
    private String qqOpenid;


    /**
     * 用户姓名
     */
    private String realname;

    /**
     * 备用字段1
     */
    private String temp1;
    /**
     * 备用字段2
     */
    private String temp2;
    /**
     * 备用字段3
     */
    private String temp3;
    /**
     * 备用字段4
     */
    private String temp4;
    /**
     * 物明经销商管理平台ID
     */
    private String temp5;

    /**
     * 物明经销商管理平台ID
     */
    private String platId;

    /**
     * 物明经销商管理平台ID
     */
    private Integer drugEntId;

    /**
     * 物明经销商管理平台ID
     */
    private String w1;

    /**
     * 小程序签署协议信息
     */
    private String signAgreement;

    /**
     * 是否提醒年龄超60周岁
     */
    private Boolean ageReminder;

    /**
     * 是否已补签协议
     */
    private Integer reSignedAgreement;

    /**
     * 性别，1男，2女，0未知
     */
    private String gender;

    /**
     * 学历
     */
    private String degree;

    /**
     * 医药代表资质备案号
     */
    private String qualificationRecordNumber;

    /**
     * 资质证书url
     */
    private String[] qualificationsUrl;

    /**
     * 区域编码
     */
	@TableField(exist = false)
    private List<Long> areaCodes;

}
