package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 服务商合规文件
 *
 * @author jimmy
 * @date 2024-07-07 11:48
 */
@Data
@TableName(value = "wm_agent_comp_doc", autoResultMap = true)
public class WmAgentComplianceDocument implements Serializable {

    private static final long serialVersionUID = 8155202747309692397L;

    /**
     * 主键ID
     */
    @TableId(value = "doc_id", type = IdType.AUTO)
    private Integer documentId;

    /**
     * 企业ID
     */
    private Integer deptId;

    /**
     * 员工规范手册
     */
    @TableField(value = "emp_book", typeHandler = JacksonTypeHandler.class)
    private DocumentItem[] employeeCodeHandbook;

    /**
     * 内部控制制度手册
     */
    @TableField(value = "ctrl_sys_manu", typeHandler = JacksonTypeHandler.class)
    private DocumentItem[] controlSystemManual;

    /**
     * 内部审计文件
     */
    @TableField(value = "inter_audit_doc", typeHandler = JacksonTypeHandler.class)
    private DocumentItem[] internalAuditDocuments;

    /**
     * 合规制度管理
     */
    @TableField(value = "comp_mant_sys", typeHandler = JacksonTypeHandler.class)
    private DocumentItem[] complianceMantSystem;

    /**
     * 反腐败和反贿赂制度
     */
    @TableField(value = "anti_corr_bri_sys", typeHandler = JacksonTypeHandler.class)
    private DocumentItem[] antiCorrAndAntiBriManSys;

    /**
     * 员工招待管理制度
     */
    @TableField(value = "emp_man_sys", typeHandler = JacksonTypeHandler.class)
    private DocumentItem[] employeeEntertainManSys;

    /**
     * 合规承诺函
     */
    @TableField(value = "comp_commit_let", typeHandler = JacksonTypeHandler.class)
    private DocumentItem[] complianceCommitLet;

    /**
     * 内部合规培训材料
     */
    @TableField(value = "inner_train_doc", typeHandler = JacksonTypeHandler.class)
    private DocumentItem[] internalComTrainMate;

    /**
     * 创建人
     */
    private String createBy;

    /**
     * 更新人
     */
    private String updateBy;

    /**
     * 创建时间
     */
    private LocalDateTime createTime;

    /**
     * 更新时间
     */
    private LocalDateTime updateTime;


    @Data
    public static class DocumentItem implements Serializable {

        private static final long serialVersionUID = 8155202747309692397L;

        private Integer fileId;

        private String filePath;

        private String orgName;

    }
}
