package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsType;
import com.qunzhixinxi.hnqz.common.core.entity.BaseEntity;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Set;

/**
 * 档案-代理商
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
@Data
@TableName("wm_da_agent")
public class WmDaAgent implements Serializable {
    private static final long serialVersionUID = 1L;


    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 代理商类型（团队：AT, 公司： AE）
     */
    private String agentType;

    /**
     * 公司名称
     */
    private String gsmc;

    /**
     * 营业执照
     */
    private String yyzz;

    /**
     * 社保缴纳证明
     */
    private String sbjnzm;

    /**
     * 法人身份证证明-正面
     */
    private String frsfzzmZm;

    /**
     * 法人身份证证明-背面
     */
    private String frsfzzmBm;
    /**
     * 法人身份证证明-手持
     */
    private String frsfzzmSc;
    /**
     * 是否审核
     */
    private String isExamine;

    /**
     * 证件类型
     */
    private String zjType;

    /**
     * 证件号码
     */
    private String zjNumber;

    /**
     * 结算账号
     */
    private String jsAccount;

    /**
     * 关联药企
     */
    private String extDrugEnt;
    /**
     * 组织机构ID
     */
    private Integer deptId;

    /**
     * 是否删除
     */
    private String delFlag;
    /**
     * 是否禁用
     */
    private String enableFlag;
    /**
     * 所属租户
     */
    private Integer tenantId;
    /**
     * 创建时间
     */
    private LocalDateTime createTime;
    /**
     * 创建人
     */
    private Integer createUser;
    /**
     * 更新时间
     */
    private LocalDateTime updateTime;
    /**
     * 更新人
     */
    private Integer updateUser;

    private String drugEntId;

    private String temp1;

    private String temp2;

    /**
     * 派工权限
     */
    private String pgqx;

    /**
     * 企业类型
     */
    private String qylx;

    /**
     * 企业类型
     */
    private String management;

    /**
     * 近12个月的依法纳税缴纳证明
     */
    @TableField(value = "tax_in_12m")
    private String taxRecordIn12m;

    /**
     * 公示系统查询结果
     */
    @TableField(value = "pub_sys_qry_res")
    private String publicitySystemQueryResults;

    /**
     * 市场服务协议
     */
    @TableField(value = "mkt_ser_agr")
    private String marketServicesAgreement;

    /**
     * 服务合同
     */
    @TableField(value = "ser_cnt")
    private String serviceContract;

    /**
     * 服务截止时间
     */
    @TableField(value = "ddl")
    private LocalDate serviceDeadline;

    /**
     * 服务产品
     */
    @TableField(value = "sku_id")
    private String skuIds;

    /**
     * 部门专用权限限制（0.导出）
     */
    @TableField(exist = false)
    private String[] deptPermissions;

    /**
     * 对应sys_dept表level字段
     */
    @TableField(exist = false)
    private Integer deptLevel;

    /**
     * 财务复核方式(字段存于sys_dept表)
     */
    @TableField(exist = false)
    private UpmsType.FinancialReviewType financialReviewType;

    /**
     * csm用户id
     */
    @TableField(exist = false)
    private Set<Integer> csmUserIdList;

    /**
     * 区域
     */
    @NotEmpty(message = "区域必填", groups = {BaseEntity.Create.class})
    @TableField(exist = false)
    private List<Long> areaCodes;

    @TableField(exist = false)
    private List<Long> entIds;

    @TableField(exist = false)
    private Integer current;

    @TableField(exist = false)
    private Integer size;

    /**
     * 是否存在评价信息
     */
    @TableField(exist = false)
    private Boolean evaluated;

    /**
     * 简称
     */
    @TableField(exist = false)
    private String abbr;

    /**
     * 服务省份简称
     */
    @TableField(exist = false)
    private String provAbbr;
}
