package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsType;
import com.qunzhixinxi.hnqz.common.core.entity.BaseEntity;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Set;

/**
 * 档案-药企
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
@Data
@TableName("wm_da_drug_ent")
public class WmDaDrugEnt implements Serializable {
    private static final long serialVersionUID = 1L;

    @NotNull(message = "ID必填", groups = {BaseEntity.Update.class})
    @TableId(type = IdType.AUTO)
    private Integer id;
    /**
     * 企业名称
     */
    private String entname;
    /**
     * 统一社会信用代码
     */
    private String entcode;

    private String temp1;

    private String temp2;

    private String temp3;

    private String temp4;
    /**
     * 组织机构ID
     */
    @NotNull(message = "企业ID必填", groups = {BaseEntity.Update.class})
    private Integer deptId;
    /**
     * 是否删除
     */
    private String delFlag;
    /**
     * 是否禁用
     */
    private String enableFlag;
    /**
     * 所属租户
     */
    private Integer tenantId;
    /**
     * 创建时间
     */
    private LocalDateTime createTime;
    /**
     * 创建人
     */
    private Integer createUser;
    /**
     * 更新时间
     */
    private LocalDateTime updateTime;
    /**
     * 更新人
     */
    private Integer updateUser;

    /**
     * 派工权限
     */
    private String pgqx;

    /**
     * 管理模式
     */
    private String management;

    /**
     * 部门专用权限限制（0.导出）
     */
    @TableField(exist = false)
    private String[] deptPermissions;

    /**
     * 财务复核方式(字段存于sys_dept表)
     */
    @TableField(exist = false)
    private UpmsType.FinancialReviewType financialReviewType;

    /**
     * csm用户id
     */
    @TableField(exist = false)
    private Set<Integer> csmUserIdList;

    /**
     * 区域
     */
    @NotEmpty(message = "所属区域必填", groups = {BaseEntity.Create.class})
    @TableField(exist = false)
    private List<Long> areaCodes;

    /**
     * 企业ID
     */
    @TableField(exist = false)
    private List<Long> entIds;

    @TableField(exist = false)
    private Integer current;

    @TableField(exist = false)
    private Integer size;

}
