package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.EnumValue;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import com.qunzhixinxi.hnqz.admin.api.model.WmPkgRedemptionNoticeItemModel;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.Getter;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 执行包兑付通知
 *
 * @author jimmy
 * @date 13/07/2024 17:55
 */
@Data
@TableName(value = "wm_pkg_rdp", autoResultMap = true)
public class WmPackageRedemptionNotice implements Serializable {
    private static final long serialVersionUID = 4760688421562936218L;

    @TableId(type = IdType.AUTO)
    private Integer noticeId;

    @TableField(value = "pkg_id")
    private Integer packageId;

    private Integer step;

    @TableField(value = "rdp_res", typeHandler = JacksonTypeHandler.class)
    private WmPkgRedemptionNoticeItemModel[] redemptionResult;

    @TableField(value = "cur_rdp_score")
    private Long currentRedemptionScore;

    @TableField(value = "cur_rdp_rate")
    private String currentRedemptionRate;

    // @TableField(value = "cur_rdp_weight")
    // private String currentRedemptionWeight;

    // 评价总值
    @TableField(value = "cur_rdp_total")
    private String currentRedemptionTotal;

    @TableField(value = "cur_rdp_amount")
    private String currentRedemptionTotalAmount;

    @TableField(value = "from_id")
    private Integer fromEntId;

    @TableField(value = "to_id")
    private Integer toEntId;

    /**
     * 通知状态
     */
    @TableField(value = "notice_state")
    private String noticeState;

    // ～====== 审核阶段

    /**
     * 审核状态（阶段）
     */
    @TableField(value = "check_state")
    private String checkState;

    // 审核结果
    private Boolean checkResult;

    // 结果信息
    private String checkRemarks;


    // ～==== 服务商接受阶段
    private LocalDateTime acceptTime;

    private Boolean accept;

    private String acceptRemarks;

    private String createBy;

    private LocalDateTime createTime;

    private String updateBy;

    private LocalDateTime updateTime;


    @Getter
    @AllArgsConstructor
    public enum NoticeState {

        PENDING("PENDING", "待发送"),
        SEND("SEND", "发送"),
        READ("READ", "已读"),
        CONFIRM("CONFIRM", "确认"),
        ARGUE("ARGUE", "申诉"),
        DONE("DONE", "完结");

        private final String state;

        private final String description;

    }

    @Getter
    @AllArgsConstructor
    public enum CheckState {

        PASSED("PASSED", "审核通过"),
        REJECTED("REJECTED", "审核拒绝"),
        INIT("INIT", "待市场组审批"),
        CKT1("CKT1", "待商务组审批"),
        CKT2("CKT2", "待事业部分管销售领导审批"),
        CKT3("CKT3", "待事业部总经理审批"),
        CKT4("CKT4", "待分管领导审批");

        @EnumValue
        private final String state;
        private final String desc;
    }
}
