package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsState;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 服务包监督实体
 *
 * @author jimmy
 * @date 11/07/2024 16:40
 */
@Data
@TableName(value = "wm_pkg_sup")
public final class WmPackageSupervision implements Serializable {
    private static final long serialVersionUID = 4003030371588886362L;

    /**
     * 监督记录ID
     */
    @TableId(value = "sup_id", type = IdType.AUTO)
    private Long supervisionId;

    /**
     * 服务包ID
     */
    @TableField(value = "pkg_id")
    private Integer packageId;

    /**
     * 监督监督意见
     */
    @TableField(value = "sup_res")
    private Boolean supervisionResult;

    /**
     * 监督结果
     */
    private String resultInfo;

    /**
     * 监督状态
     */
    @TableField(value = "sup_state")
    private UpmsState.PackageSupervisionState supervisionState;

    /**
     * 备注
     */
    private String remarks;

    private String createBy;
    private String updateBy;

    private LocalDateTime updateTime;
    private LocalDateTime createTime;

}
