package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 角色预警规则
 *
 * @TableName wm_role_sup_warn_rule
 */
@Data
@TableName(value = "wm_role_sup_warn_rule")
public class WmRoleSupervisionWarnRule implements Serializable {

    /**
     * 规则ID
     */
    @TableId(type = IdType.AUTO)
    private Integer ruleId;

    /**
     * 角色ID
     */
    private Integer roleId;

    /**
     * 预警类型
     */
    private String warnType;

    /**
     * 预警逻辑
     */
    private String warnLogic;

    /**
     * 预警值
     */
    @TableField(value = "warn_val")
    private Integer value;

    /**
     * 预警消息模板
     */
    @TableField(value = "warn_tmpl")
    private String template;

    /**
     * 创建人
     */
    private String createBy;

    /**
     * 更新人
     */
    private String updateBy;

    /**
     * 创建时间
     */
    private LocalDateTime createTime;

    /**
     * 创建时间
     */
    private LocalDateTime updateTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

}