package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.Getter;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 * 任务表
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:25
 */
@Data
@TableName(value = "wm_task", autoResultMap = true)
public class WmTask implements Serializable {
    private static final long serialVersionUID = 1L;

    /**
     * 任务ID
     */
    @TableId(type = IdType.AUTO)
    private String id;

    /**
     * 任务编号
     */
    private String taskNumber;

    /**
     * 任务类型ID
     */
    private String taskTypeId;

    /**
     * 任务类型名称
     */
    @TableField(exist = false)
    private String taskTypeName;

    /**
     * 任务积分
     */
    Integer score;

    String scorePackageDrugId;

    String scorePackageLevel1Id;

    String scorePackageId;

    /**
     * 积分包名称
     */
    @TableField(exist = false)
    private String scorePackageName;

    String taskRuleId;

    /**
     * 调研时间
     */
    private LocalDateTime lookintoDate;
    /**
     * 省
     */
    private String province;
    /**
     * 市
     */
    private String city;
    /**
     * 区
     */
    private String area;
    /**
     * 地址
     */
    private String address;
    /**
     * 调研类型ID
     */
    private String lookintoTypeId;
    /**
     * 任务内容ID
     */
    private String taskContentId;
    /**
     * 任务状态
     */
    private String taskStatus;

    /**
     * 提交审核状态
     */
    private String submitStatus;

    /**
     * 任务用户ID
     */
    private String taskUserId;

    /**
     * 用户类型ID
     */
    private String taskUserType;

    /**
     * 服务药企
     */
    private Integer drugEntId;

    /**
     * 分享图片地址
     */
    private String shareImgUrl;

    /**
     * 组织机构ID
     */
    private String deptId;
    /**
     * 是否删除
     */
    private String delFlag;
    /**
     * 是否禁用
     */
    private String enableFlag;
    /**
     * 所属租户
     */
    private Integer tenantId;
    /**
     * 创建时间
     */
    private LocalDateTime createTime;
    /**
     * 创建人
     */
    private Integer createUser;
    /**
     * 更新时间
     */
    private LocalDateTime updateTime;
    /**
     * 更新人
     */
    private String updateUser;

    private String platAuditStatus;

    @TableField(typeHandler = JacksonTypeHandler.class)
    private List<String> extIds;

    private String taskInfoImg;

    /**
     * 对比结果
     */
    private String compareResult;
    /**
     * 审批意见
     */
    private String approvalOpinion;
    /**
     * 审批说明
     */
    private String approvalInfo;

    private String realFlag;

    private Integer reportOneId;
    private String reportOneApprovalStatus;
    private String reportOneApprovalOpinion;
    private String reportOneApprovalInfo;

    private Integer reportSecondId;
    private String reportSecondApprovalStatus;
    private String reportSecondApprovalOpinion;
    private String reportSecondApprovalInfo;

    private Integer reportDrugId;
    private String reportDrugApprovalStatus;
    private String reportDrugApprovalOpinion;
    private String reportDrugApprovalInfo;

    /**
     * 接单对象list
     */
    @TableField(exist = false)
    private WmTaskContent wmTaskContent;

    @TableField(exist = false)
    private String type;

    /**
     * cso审批说明
     */
    private String taskStatusInfo;


    private String taskFrom;

    /**
     * 复审次数记录
     */
    private Integer reviewTaskCount;

    /**
     * 企业复审次数记录
     */
    private Integer deptReviewTaskCount;

    /**
     * 审核人userId
     */
    private Integer approvalUserId;

    /**
     * 审核人姓名
     */
    @TableField(exist = false)
    private String approvalUserName;

    /**
     * 审核时间
     */
    private LocalDateTime approvalTime;

    /**
     * 企业审核人userId
     */
    private Integer deptApprovalUserId;

    /**
     * 企业审核人姓名
     */
    @TableField(exist = false)
    private String deptApprovalUserName;

    /**
     * 企业审核时间
     */
    private LocalDateTime deptApprovalTime;

    /**
     * 任务用户用户名
     */
    @TableField(exist = false)
    private String taskUsername;

    /**
     * 关联的用户手机号
     */
    @TableField(exist = false)
    private String username;

    /**
     * 结算状态
     */
    @TableField(exist = false)
    private Integer settleStatus;

    /**
     * 提交时间
     */
    @TableField(exist = false)
    private LocalDateTime subTime;

    /**
     * 提交到零工时间
     */
    @TableField(exist = false)
    private LocalDateTime subToGigTime;

    /**
     * 结算时间
     */
    @TableField(exist = false)
    private LocalDateTime notifyDate;

    /**
     * 请求ip
     */
    private String remoteIp;

    /**
     * ip归属地
     */
    private String ip2region;

    /**
     * 乐观锁
     */
    private Integer version;

    /**
     * 任务提交审核信息
     */
    private String taskSettleStatus;

    /**
     * 任务类型父级ID
     */
    @TableField(exist = false)
    private String taskTypeParentId;

    /**
     * 序号用于统计
     */
    @TableField(exist = false)
    private Integer tmpId;

    /**
     * 审核信息
     */
    @TableField(exist = false)
    private Map<String, Object> checkState;

    /**
     * 审核节点ID
     */
    @TableField(exist = false)
    private Integer nodeId;

    /**
     * 批量审核节点集合
     */
    @TableField(exist = false)
    private String nodeIds;


    @Getter
    @AllArgsConstructor
    public enum TaskSettleStatusEnum {

        NOT_SUBMITTED("0", "未提交"),
        WAITING("1", "待结算"),
        SETTLING("2", "结算中"),
        SETTLED("3", "已结算"),
        REJECTED("4", "已打回");

        private final String code;

        private final String desc;
    }
}
