package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsState;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 服务任务监督实体
 *
 * @author jimmy
 * @date 11/07/2024 14:20
 */
@Data
@TableName("wm_task_sup")
public final class WmTaskSupervision implements Serializable {

    private static final long serialVersionUID = -8751029179018254028L;

    /**
     * 监督记录ID
     */
    @TableId(value = "sup_id", type = IdType.AUTO)
    private Long supervisionId;

    /**
     * 任务ID
     */
    private Integer taskId;

    @TableField(value = "pkg_id")
    private Integer packageId;

    /**
     * 监督结果
     */
    @TableField(value = "sup_res")
    private Boolean supervisionResult;

    /**
     * 监察状态
     */
    @TableField(value = "sup_state")
    private UpmsState.TaskSupervisionState supervisionState;

    /**
     * 是否可以修改
     */
    private Boolean modifiable;

    /**
     * 角色ID
     */
    private Integer roleId;

    /**
     * 备注
     */
    private String remarks;


    private String createBy;
    private String updateBy;

    private LocalDateTime createTime;
    private LocalDateTime updateTime;


}
