package com.qunzhixinxi.hnqz.admin.api.feign;

import com.qunzhixinxi.hnqz.admin.api.model.WmScorePackageSettleExcelModel;
import com.qunzhixinxi.hnqz.common.core.constant.SecurityConstants;
import com.qunzhixinxi.hnqz.common.core.constant.ServiceNameConstants;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;

import java.util.List;
import java.util.Map;

/**
 * 积分包feign服务
 *
 * @author lixuesong
 * @date 2024/02/23
 */
@FeignClient(contextId = "remoteScorePackageService", value = ServiceNameConstants.UPMS_SERVICE)
public interface RemoteScorePackageService {

	/**
	 * 结算包结算导出-内部
	 *
	 * @param params 参数
	 * @return excel模型
	 */
	@PostMapping("/settle/exportPackageSettleForInner")
	List<WmScorePackageSettleExcelModel> exportPackageSettle(@RequestBody Map<String, Object> params, @RequestHeader(SecurityConstants.FROM) String from);

	/**
	 * MAH结算包结算导出-内部
	 *
	 * @param params 参数
	 * @return excel模型
	 */
	@PostMapping("/settle/exportPackageSettleByMAHForInner")
	List<WmScorePackageSettleExcelModel> exportPackageSettleByMAH(@RequestBody Map<String, Object> params, @RequestHeader(SecurityConstants.FROM) String from);
}
