package com.qunzhixinxi.hnqz.admin.api.model.excel;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * 积分包
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
@Data
public class WmScorePackageExcelModel implements Serializable {
	private static final long serialVersionUID = -2712453720764666659L;

	/**
	 * 序号
	 */
	@ColumnWidth(10)
	@ExcelProperty("序号")
	private String number;

	/**
	 * 积分包序列号
	 */
	@ColumnWidth(20)
	@ExcelProperty("积分包编号")
	private String packageSn;

	/**
	 * 积分包名称
	 */
	@ColumnWidth(40)
	@ExcelProperty("积分包名称")
	private String scorePackageName;

	/**
	 * 积分包值
	 */
	@ColumnWidth(20)
	@ExcelProperty("积分包值")
	private String score;

	/**
	 * 所属月份
	 */
	@ColumnWidth(20)
	@ExcelProperty("发布日期")
	private String belongDate;

	/**
	 * 接单对象
	 */
	@ColumnWidth(20)
	@ExcelProperty("接单对象")
	private String userNames;

	/**
	 * 积分包状态
	 */
	@ColumnWidth(20)
	@ExcelProperty("积分包状态")
	private String scorePackageStatus;

	/**
	 * 完成积分值
	 */
	@ColumnWidth(20)
	@ExcelProperty("完成积分值")
	private Integer ysh;

	/**
	 * 已完成百分比
	 */
	@ColumnWidth(20)
	@ExcelProperty("完成百分比(%)")
	private String finishRate;

	/**
	 * 已支付积分值
	 */
	@ColumnWidth(20)
	@ExcelProperty("审核通过积分值")
	private Integer payScore;

	/**
	 * 已支付百分比
	 */
	@ColumnWidth(20)
	@ExcelProperty("审核通过百分比")
	private String payRate;

	/**
	 * 结算时间
	 */
	@ColumnWidth(20)
	@ExcelProperty("提交时间")
	private LocalDateTime settlementDate;

	/**
	 * 提交到零工时间
	 */
	@ColumnWidth(20)
	@ExcelProperty("下发时间")
	private LocalDateTime subToGigTime;

	/**
	 * 结算时间
	 */
	@ColumnWidth(20)
	@ExcelProperty("到账时间")
	private LocalDateTime notifyDate;

	/**
	 * 到账金额
	 */
	@ColumnWidth(20)
	@ExcelProperty("到账金额")
	private BigDecimal settleAmount;

	/**
	 * 关联积分包名称
	 */
	@ColumnWidth(20)
	@ExcelProperty("关联积分包名称")
	private String relationScoreId;

	/**
	 * 有效任务类型
	 */
	@ColumnWidth(20)
	@ExcelProperty("有效任务类型")
	private String taskTypes;

	/**
	 * 接单对象范围
	 */
	@ColumnWidth(20)
	@ExcelProperty("接单对象范围")
	private String packageUserScopeName;

	/**
	 * 接单对象类型
	 */
	@ColumnWidth(20)
	@ExcelProperty("接单对象类型")
	private String typeidName;
}
