package com.qunzhixinxi.hnqz.admin.api.model.excel;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import lombok.Data;

import java.io.Serializable;

/**
 * 积分包包信息模型
 */
@Data
public class WmScorePackageInfoExcelModel implements Serializable {
    private static final long serialVersionUID = -2712453720764666659L;

    /**
     * 执行包ID
     */
    @ColumnWidth(20)
    @ExcelProperty("执行包ID")
    private String pkgId;

    /**
     * 计划包名称
     */
    @ColumnWidth(128)
    @ExcelProperty("计划包名称")
    private String planName;

    /**
     * 执行包名称
     */
    @ColumnWidth(128)
    @ExcelProperty("执行包名称")
    private String pkgName;

    /**
     * 父级执行包
     */
    @ColumnWidth(128)
    @ExcelProperty("父级执行包")
    private String parentPkgName;

    /**
     * 产品名称
     */
    @ColumnWidth(32)
    @ExcelProperty("产品名称(通用名）")
    private String skuName;

    /**
     * 产品名称
     */
    @ColumnWidth(32)
    @ExcelProperty("产品名称（商品名）")
    private String prodName;

    /**
     * 生产企业
     */
    @ColumnWidth(32)
    @ExcelProperty("生产企业")
    private String mah;

    /**
     * 承接对象
     */
    @ColumnWidth(32)
    @ExcelProperty("承接对象")
    private String serviceName;

    /**
     * 执行包总值（省区拆分至服务商
     */
    @ColumnWidth(16)
    @ExcelProperty("执行包总值（省区拆分至服务商）")
    private String score;


    // tt -> task_type
    // ～53============================

    /**
     * 基础拜访（已下发）
     */
    @ColumnWidth(20)
    @ExcelProperty("基础拜访（已下发）")
    private String tt53dist;


    /**
     * 基础拜访（已提交）
     */
    @ColumnWidth(20)
    @ExcelProperty("基础拜访（已提交）")
    private String tt53Submit;


    /**
     * 基础拜访（已完成审批）
     */
    @ColumnWidth(20)
    @ExcelProperty("基础拜访（已完成审批）")
    private String tt53checked;


    /**
     * 基础拜访（已拒绝）
     */
    @ColumnWidth(20)
    @ExcelProperty("基础拜访（已拒绝）")
    private String tt53rejected;

    // ～52============================


    /**
     * 专项拜访（已下发）
     */
    @ColumnWidth(20)
    @ExcelProperty("专项拜访（已下发）")
    private String tt52dist;


    /**
     * 专项拜访（已提交）
     */
    @ColumnWidth(20)
    @ExcelProperty("专项拜访（已提交）")
    private String tt52submit;


    /**
     * 基础拜访（已完成审批）
     */
    @ColumnWidth(20)
    @ExcelProperty("专项拜访（已完成审批）")
    private String tt52checked;

    /**
     * 基础拜访（已拒绝）
     */
    @ColumnWidth(20)
    @ExcelProperty("专项拜访（已拒绝）")
    private String tt52rejected;

    // ～51============================


    /**
     * 专业拜访（已下发）
     */
    @ColumnWidth(20)
    @ExcelProperty("专业拜访（已下发）")
    private String tt51dist;


    /**
     * 专业拜访（已提交）
     */
    @ColumnWidth(20)
    @ExcelProperty("专业拜访（已提交）")
    private String tt51submit;


    /**
     * 专业拜访（已完成审批）
     */
    @ColumnWidth(20)
    @ExcelProperty("专业拜访（已完成审批）")
    private String tt51checked;

    /**
     * 专业拜访（已拒绝）
     */
    @ColumnWidth(20)
    @ExcelProperty("专业拜访（已拒绝）")
    private String tt51rejected;


    // ～14============================


    /**
     * 数据收集（已下发）
     */
    @ColumnWidth(20)
    @ExcelProperty("数据收集（已下发）")
    private String tt14dist;


    /**
     * 数据收集（已提交）
     */
    @ColumnWidth(20)
    @ExcelProperty("数据收集（已提交）")
    private String tt14submit;


    /**
     * 数据收集（已完成审批）
     */
    @ColumnWidth(20)
    @ExcelProperty("数据收集（已完成审批）")
    private String tt14checked;

    /**
     * 数据收集（已拒绝）
     */
    @ColumnWidth(20)
    @ExcelProperty("数据收集（已拒绝）")
    private String tt14rejected;


    // ～17============================


    /**
     * 医学警戒信息收集（已下发）
     */
    @ColumnWidth(20)
    @ExcelProperty("医学警戒信息收集（已下发）")
    private String tt17dist;


    /**
     * 医学警戒信息收集（已提交）
     */
    @ColumnWidth(20)
    @ExcelProperty("医学警戒信息收集（已提交）")
    private String tt17submit;


    /**
     * 医学警戒信息收集（已完成审批）
     */
    @ColumnWidth(20)
    @ExcelProperty("医学警戒信息收集（已完成审批）")
    private String tt17checked;

    /**
     * 医学警戒信息收集（已拒绝）
     */
    @ColumnWidth(20)
    @ExcelProperty("医学警戒信息收集（已拒绝）")
    private String tt17rejected;

    // ～12============================


    /**
     * 产品展示（已下发）
     */
    @ColumnWidth(20)
    @ExcelProperty("产品展示（已下发）")
    private String tt12dist;


    /**
     * 产品展示（已提交）
     */
    @ColumnWidth(20)
    @ExcelProperty("产品展示（已提交）")
    private String tt12submit;


    /**
     * 产品展示（已完成审批）
     */
    @ColumnWidth(20)
    @ExcelProperty("产品展示（已完成审批）")
    private String tt12Checked;

    /**
     * 产品展示（已拒绝）
     */
    @ColumnWidth(20)
    @ExcelProperty("产品展示（已拒绝）")
    private String tt12rejected;



    // ～13============================


    /**
     * 业务宣传服务（已下发）
     */
    @ColumnWidth(20)
    @ExcelProperty("业务宣传服务（已下发）")
    private String tt13dist;


    /**
     * 业务宣传服务（已提交）
     */
    @ColumnWidth(20)
    @ExcelProperty("业务宣传服务（已提交）")
    private String tt13submit;


    /**
     * 业务宣传服务（已完成审批）
     */
    @ColumnWidth(20)
    @ExcelProperty("业务宣传服务（已完成审批）")
    private String tt13checked;

    /**
     * 业务宣传服务（已拒绝）
     */
    @ColumnWidth(20)
    @ExcelProperty("业务宣传服务（已拒绝）")
    private String tt13rejected;

    // ～1============================


    /**
     * POV科室会（已下发）
     */
    @ColumnWidth(20)
    @ExcelProperty("POV科室会（已下发）")
    private String tt1dist;


    /**
     * POV科室会（已提交）
     */
    @ColumnWidth(20)
    @ExcelProperty("POV科室会（已提交）")
    private String tt1submit;


    /**
     * POV科室会（已完成审批）
     */
    @ColumnWidth(20)
    @ExcelProperty("POV科室会（已完成审批）")
    private String tt1checked;

    /**
     * POV科室会（已拒绝）
     */
    @ColumnWidth(20)
    @ExcelProperty("POV科室会（已拒绝）")
    private String tt1rejected;


    // ～2============================


    /**
     * 区县学术会议（已下发）
     */
    @ColumnWidth(20)
    @ExcelProperty("区县学术会议（已下发）")
    private String tt2dist;


    /**
     * 区县学术会议（已提交）
     */
    @ColumnWidth(20)
    @ExcelProperty("区县学术会议（已提交）")
    private String tt2submit;


    /**
     * 区县学术会议（已完成审批）
     */
    @ColumnWidth(20)
    @ExcelProperty("区县学术会议（已完成审批）")
    private String tt2checked;

    /**
     * 区县学术会议（已拒绝）
     */
    @ColumnWidth(20)
    @ExcelProperty("区县学术会议（已拒绝）")
    private String tt2rejected;

    // ～5============================


    /**
     * 沙龙会（已下发）
     */
    @ColumnWidth(20)
    @ExcelProperty("沙龙会（已下发）")
    private String tt5dist;


    /**
     * 沙龙会（已提交）
     */
    @ColumnWidth(20)
    @ExcelProperty("沙龙会（已提交）")
    private String tt5submit;


    /**
     * 沙龙会（已完成审批）
     */
    @ColumnWidth(20)
    @ExcelProperty("沙龙会（已完成审批）")
    private String tt5checked;

    /**
     * 沙龙会（已拒绝）
     */
    @ColumnWidth(20)
    @ExcelProperty("沙龙会（已拒绝）")
    private String tt5rejected;

    // ～3============================


    /**
     * 市级学术会议（已下发）
     */
    @ColumnWidth(20)
    @ExcelProperty("市级学术会议（已下发）")
    private String tt3dist;


    /**
     * 市级学术会议（已提交）
     */
    @ColumnWidth(20)
    @ExcelProperty("市级学术会议（已提交）")
    private String tt3submit;


    /**
     * 市级学术会议（已完成审批）
     */
    @ColumnWidth(20)
    @ExcelProperty("市级学术会议（已完成审批）")
    private String tt3checked;

    /**
     * 市级学术会议（已拒绝）
     */
    @ColumnWidth(20)
    @ExcelProperty("市级学术会议（已拒绝）")
    private String tt3rejected;

    // ～4============================


    /**
     * 省级学术会议（已下发）
     */
    @ColumnWidth(20)
    @ExcelProperty("省级学术会议（已下发）")
    private String tt4dist;


    /**
     * 省级学术会议（已提交）
     */
    @ColumnWidth(20)
    @ExcelProperty("省级学术会议（已提交）")
    private String tt4submit;


    /**
     * 省级学术会议（已完成审批）
     */
    @ColumnWidth(20)
    @ExcelProperty("省级学术会议（已完成审批）")
    private String tt4checked;

    /**
     * 省级学术会议（已拒绝）
     */
    @ColumnWidth(20)
    @ExcelProperty("省级学术会议（已拒绝）")
    private String tt4rejected;

    // ～64============================


    /**
     * 线上学术会议（已下发）
     */
    @ColumnWidth(20)
    @ExcelProperty("线上学术会议（已下发）")
    private String tt64dist;


    /**
     * 线上学术会议（已提交）
     */
    @ColumnWidth(20)
    @ExcelProperty("线上学术会议（已提交）")
    private String tt64submit;


    /**
     * 线上学术会议（已完成审批）
     */
    @ColumnWidth(20)
    @ExcelProperty("线上学术会议（已完成审批）")
    private String tt64checked;

    /**
     * 线上学术会议（已拒绝）
     */
    @ColumnWidth(20)
    @ExcelProperty("线上学术会议（已拒绝）")
    private String tt64rejected;

    // ～19============================


    /**
     * 健康教育课堂（已下发）
     */
    @ColumnWidth(20)
    @ExcelProperty("健康教育课堂（已下发）")
    private String tt19dist;


    /**
     * 健康教育课堂（已提交）
     */
    @ColumnWidth(20)
    @ExcelProperty("健康教育课堂（已提交）")
    private String tt19submit;


    /**
     * 健康教育课堂（已完成审批）
     */
    @ColumnWidth(20)
    @ExcelProperty("健康教育课堂（已完成审批）")
    private String tt19checked;

    /**
     * 健康教育课堂（已拒绝）
     */
    @ColumnWidth(20)
    @ExcelProperty("健康教育课堂（已拒绝）")
    private String tt19rejected;

}
