package com.qunzhixinxi.hnqz.admin.api.vo;

import com.qunzhixinxi.hnqz.admin.api.entity.SysDept;
import com.qunzhixinxi.hnqz.admin.api.entity.SysImplPlanDetails;
import com.qunzhixinxi.hnqz.admin.api.entity.SysImplPlanDetailsItem;
import com.qunzhixinxi.hnqz.admin.api.entity.SysImplementPlan;
import lombok.AccessLevel;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.List;
import java.util.Map;

/**
 * 试行计划vo
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2024/05/19 12:13
 */
@NoArgsConstructor(access = AccessLevel.NONE)
public final class SysImplementPlanVO {

    @Data
    @EqualsAndHashCode(callSuper = false)
    public static class ToPage extends SysImplementPlan {

        /**
         * 执行包积分值
         */
        private Long execScoreValue;

        /**
         * 承接人信息
         */
        private Map<String, Object> consigneeInfo;

        /**
         * 产品信息
         */
        private Map<String, Object> skuInfo;

        /**
         * 计划详情
         */
        private SysImplPlanDetails planDetails;


    }

    @Data
    @EqualsAndHashCode(callSuper = false)
    public static class ToList extends SysImplementPlan {

        /**
         * 承接人信息
         */
        private Map<String, Object> consigneeInfo;

        /**
         * 产品信息
         */
        private Map<String, Object> skuInfo;

        /**
         * 计划详情
         */
        private SysImplPlanDetails planDetails;

        /**
         * 详情子项
         */
        private List<Map<String, Object>> planItems;


        private Long parentPlanAvailScore;
        private Long parentPlanScore;


    }
}
