package com.qunzhixinxi.hnqz.admin.config;

import com.qunzhixinxi.hnqz.common.sequence.builder.SnowflakeSeqBuilder;
import com.qunzhixinxi.hnqz.common.sequence.properties.SequenceSnowflakeProperties;
import com.qunzhixinxi.hnqz.common.sequence.sequence.Sequence;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @author hnqz
 * @date 2019-05-26
 * <p>
 * 设置发号器生成规则
 */
@Configuration
public class SequenceConfig {

	/**
	 * 订单流水号发号器
	 *
	 * @param properties 配置
	 * @return 发号器
	 */
	@Bean
	public Sequence paySequence(SequenceSnowflakeProperties properties) {
		return SnowflakeSeqBuilder.create().datacenterId(properties.getDatacenterId()).workerId(properties.getWorkerId()).build();
	}

	/**
	 * 积分包发号器
	 *
	 * @param properties 配置
	 * @return 发号器
	 */
	@Bean(value = "pkgSequence")
	public Sequence pkgSequence(SequenceSnowflakeProperties properties) {
		return SnowflakeSeqBuilder.create().datacenterId(properties.getDatacenterId()).workerId(properties.getWorkerId()).build();
	}

	/**
	 * 任务发号器
	 *
	 * @param properties 参数
	 * @return 发号器
	 */
	@Bean(name = "taskSequence")
	public Sequence taskSequence(SequenceSnowflakeProperties properties) {
		return SnowflakeSeqBuilder.create().datacenterId(properties.getDatacenterId()).workerId(properties.getWorkerId()).build();
	}

	/**
	 * 企业
	 *
	 * @param properties 参数
	 * @return 发号器
	 */
	@Bean(name = "entSequence")
	public Sequence entSequence(SequenceSnowflakeProperties properties) {
		return SnowflakeSeqBuilder.create().datacenterId(properties.getDatacenterId()).workerId(properties.getWorkerId()).build();
	}
}
