package com.qunzhixinxi.hnqz.admin.controller;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.bean.copier.CopyOptions;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.io.FileUtil;
import cn.hutool.core.lang.Assert;
import cn.hutool.core.text.CharSequenceUtil;
import cn.hutool.core.text.StrPool;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.ArrayUtil;
import cn.hutool.core.util.IdcardUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.crypto.digest.DigestUtil;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.StringPool;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.google.zxing.WriterException;
import com.qunzhixinxi.hnqz.admin.api.constant.CacheConstants;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsType;
import com.qunzhixinxi.hnqz.admin.api.dto.SysUserDTO;
import com.qunzhixinxi.hnqz.admin.api.dto.UserBusinessCardDTO;
import com.qunzhixinxi.hnqz.admin.api.dto.UserDTO;
import com.qunzhixinxi.hnqz.admin.api.dto.WmPkgDTO;
import com.qunzhixinxi.hnqz.admin.api.dto.WmQuizDTO;
import com.qunzhixinxi.hnqz.admin.api.dto.WmTaskDTO;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDept;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDictItem;
import com.qunzhixinxi.hnqz.admin.api.entity.SysRole;
import com.qunzhixinxi.hnqz.admin.api.entity.SysUser;
import com.qunzhixinxi.hnqz.admin.api.entity.SysUserAgreementHistory;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDrugQuizRelation;
import com.qunzhixinxi.hnqz.admin.api.entity.WmPlatformQuizTestResult;
import com.qunzhixinxi.hnqz.admin.api.entity.WmQuiz;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskSubmissionPercentRule;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskSubmissionRule;
import com.qunzhixinxi.hnqz.admin.api.dto.UserUpdateInput;
import com.qunzhixinxi.hnqz.admin.api.model.WmQuizResultModel;
import com.qunzhixinxi.hnqz.admin.api.vo.PersonalScoreRecordVO;
import com.qunzhixinxi.hnqz.admin.api.vo.UserBusinessCardVO;
import com.qunzhixinxi.hnqz.admin.api.vo.UserVO;
import com.qunzhixinxi.hnqz.admin.api.vo.WmQuizVO;
import com.qunzhixinxi.hnqz.admin.config.UpmsConfig;
import com.qunzhixinxi.hnqz.admin.api.entity.MedicalEquipment;
import com.qunzhixinxi.hnqz.admin.api.entity.SysUserSub;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaAgent;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaDistribution;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaDrugEnt;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaDrugEntDrugtable;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaHospital;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaPharmacy;
import com.qunzhixinxi.hnqz.admin.api.entity.WmFeedback;
import com.qunzhixinxi.hnqz.admin.api.entity.WmScorePackage;
import com.qunzhixinxi.hnqz.admin.api.entity.WmScorePackageSettleNote;
import com.qunzhixinxi.hnqz.admin.api.entity.WmScorePackageStatus;
import com.qunzhixinxi.hnqz.admin.api.entity.WmScoreTaskType;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTask;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskContent;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskContentConfig;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskRule;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskType;
import com.qunzhixinxi.hnqz.admin.api.entity.WmUserSign;
import com.qunzhixinxi.hnqz.admin.api.entity.WmUserSignDetail;
import com.qunzhixinxi.hnqz.admin.api.entity.WmWkAlbum;
import com.qunzhixinxi.hnqz.admin.api.entity.WmWkArticle;
import com.qunzhixinxi.hnqz.admin.api.entity.WmWkArticleShare;
import com.qunzhixinxi.hnqz.admin.api.dto.SignAgreementDTO;
import com.qunzhixinxi.hnqz.admin.api.model.input.NoticeApiInput;
import com.qunzhixinxi.hnqz.admin.api.model.input.WmScorePackageApiInput;
import com.qunzhixinxi.hnqz.admin.api.model.input.WmScorePackageApiOutput;
import com.qunzhixinxi.hnqz.admin.api.model.input.WmWkAlbumApiInput;
import com.qunzhixinxi.hnqz.admin.api.vo.WmTaskTypeVO;
import com.qunzhixinxi.hnqz.admin.api.constant.enums.DelEnum;
import com.qunzhixinxi.hnqz.admin.api.constant.enums.DeptPermissionEnum;
import com.qunzhixinxi.hnqz.admin.api.constant.enums.EnableEnum;
import com.qunzhixinxi.hnqz.admin.api.constant.enums.PackageStatusEnum;
import com.qunzhixinxi.hnqz.admin.api.constant.enums.PackageTypeEnum;
import com.qunzhixinxi.hnqz.admin.api.constant.enums.ScorePackageStatusEnum;
import com.qunzhixinxi.hnqz.admin.api.constant.enums.TaskStatusEnum;
import com.qunzhixinxi.hnqz.admin.api.constant.enums.UserSignResultEnum;
import com.qunzhixinxi.hnqz.admin.event.TaskInfoImgEvent;
import com.qunzhixinxi.hnqz.admin.mapper.WmScoreTaskTypeMapper;
import com.qunzhixinxi.hnqz.admin.service.MedicalEquipmentService;
import com.qunzhixinxi.hnqz.admin.service.SysDeptService;
import com.qunzhixinxi.hnqz.admin.service.SysDictItemService;
import com.qunzhixinxi.hnqz.admin.service.SysFileService;
import com.qunzhixinxi.hnqz.admin.service.SysUserAgreementHistoryService;
import com.qunzhixinxi.hnqz.admin.service.SysUserService;
import com.qunzhixinxi.hnqz.admin.service.SysUserSubService;
import com.qunzhixinxi.hnqz.admin.service.WmDaAgentService;
import com.qunzhixinxi.hnqz.admin.service.WmDaDistributionService;
import com.qunzhixinxi.hnqz.admin.service.WmDaDrugEntDrugtableService;
import com.qunzhixinxi.hnqz.admin.service.WmDaDrugEntService;
import com.qunzhixinxi.hnqz.admin.service.WmDaHospitalService;
import com.qunzhixinxi.hnqz.admin.service.WmDaPharmacyService;
import com.qunzhixinxi.hnqz.admin.service.WmDrugQuizRelationService;
import com.qunzhixinxi.hnqz.admin.service.WmFeedbackService;
import com.qunzhixinxi.hnqz.admin.service.WmPlatformQuizTestResultService;
import com.qunzhixinxi.hnqz.admin.service.WmQuizService;
import com.qunzhixinxi.hnqz.admin.service.WmScorePackageService;
import com.qunzhixinxi.hnqz.admin.service.WmScorePackageStatusService;
import com.qunzhixinxi.hnqz.admin.service.WmScoreTaskTypeService;
import com.qunzhixinxi.hnqz.admin.service.WmTaskContentConfigService;
import com.qunzhixinxi.hnqz.admin.service.WmTaskContentService;
import com.qunzhixinxi.hnqz.admin.service.WmTaskRuleService;
import com.qunzhixinxi.hnqz.admin.service.WmTaskService;
import com.qunzhixinxi.hnqz.admin.service.WmTaskSubmissionPercentRuleService;
import com.qunzhixinxi.hnqz.admin.service.WmTaskSubmissionRuleService;
import com.qunzhixinxi.hnqz.admin.service.WmTaskTypeService;
import com.qunzhixinxi.hnqz.admin.service.WmUserSignDetailService;
import com.qunzhixinxi.hnqz.admin.service.WmUserSignService;
import com.qunzhixinxi.hnqz.admin.service.WmWkAlbumService;
import com.qunzhixinxi.hnqz.admin.service.WmWkArticleService;
import com.qunzhixinxi.hnqz.admin.service.WmWkArticleShareService;
import com.qunzhixinxi.hnqz.admin.util.Html2ImageByJsWrapper;
import com.qunzhixinxi.hnqz.admin.util.OsEnvUtils;
import com.qunzhixinxi.hnqz.admin.util.QRCodeGenerator;
import com.qunzhixinxi.hnqz.common.core.constant.CommonConstants;
import com.qunzhixinxi.hnqz.common.core.constant.enums.LoginTypeEnum;
import com.qunzhixinxi.hnqz.common.core.constant.enums.UpmsState;
import com.qunzhixinxi.hnqz.common.core.exception.BizException;
import com.qunzhixinxi.hnqz.common.core.util.HttpUtils;
import com.qunzhixinxi.hnqz.common.core.util.Ip2Region;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.log.annotation.SysLog;
import com.qunzhixinxi.hnqz.common.security.annotation.Inner;
import com.qunzhixinxi.hnqz.common.security.service.HnqzUser;
import com.qunzhixinxi.hnqz.common.security.util.SecurityUtils;
import com.qunzhixinxi.hnqz.common.sequence.sequence.Sequence;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.io.IOUtils;
import org.apache.commons.lang3.ArrayUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.mock.web.MockMultipartFile;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.imageio.ImageIO;
import javax.imageio.stream.ImageOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.Field;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.net.URI;
import java.net.URISyntaxException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.time.Duration;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.format.DateTimeFormatter;
import java.time.temporal.ChronoUnit;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Optional;
import java.util.Set;
import java.util.UUID;
import java.util.concurrent.TimeUnit;
import java.util.function.Function;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * 小程序请求接口
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2022-10-10 12:45
 */
@Slf4j
@RestController
@RequiredArgsConstructor
@RequestMapping("/api")
public class ApiController {
    private final Ip2Region ip2Region;
    private final WmTaskContentService wmTaskContentService;
    private final WmTaskContentConfigService wmTaskContentConfigService;
    private final WmWkArticleService wmWkArticleService;
    private final SysDictItemService sysDictItemService;
    private final WmDaDrugEntService wmDaDrugEntService;
    private final WmDaAgentService wmDaAgentService;
    private final SysUserService sysUserService;
    private final SysDeptService sysDeptService;
    private final WmTaskRuleService wmTaskRuleService;
    private final WmTaskTypeService wmTaskTypeService;
    private final WmWkArticleShareService wmWkArticleShareService;
    private final WmScorePackageService wmScorePackageService;
    private final WmScoreTaskTypeService wmScoreTaskTypeService;
    private final WmScoreTaskTypeMapper wmScoreTaskTypeMapper;
    private final WmScorePackageStatusService wmScorePackageStatusService;
    private final WmTaskService wmTaskService;
    private final WmDaDistributionService wmDaDistributionService;
    private final WmDaDrugEntDrugtableService wmDaDrugEntDrugtableService;
    private final SysFileService sysFileService;
    private final WmFeedbackService wmFeedbackService;
    private final WmDaPharmacyService wmDaPharmacyService;
    private final RedisTemplate<String, Object> redisTemplate;
    private final UpmsConfig upmsConfig;
    private final WmWkAlbumService wmWkAlbumService;
    private final WmUserSignDetailService wmUserSignDetailService;
    private final SysUserSubService sysUserSubService;
    private final WmTaskSubmissionRuleService taskSubmissionRuleService;
    private final WmTaskSubmissionPercentRuleService wmTaskSubmissionPercentRuleService;
    private final MedicalEquipmentService medicalEquipmentService;
    private final Sequence taskSequence;
    private final WmDaHospitalService wmDaHospitalService;
    private final WmQuizService quizService;
    private final WmUserSignService wmUserSignService;
    private final WmPlatformQuizTestResultService platformQuizTestResultService;
    private final ApplicationEventPublisher applicationEventPublisher;
    private final SysUserAgreementHistoryService userAgreementHistoryService;
    private final WmDrugQuizRelationService drugQuizRelationService;

    /**
     * 通过任务类型获取表单配置
     *
     * @param taskTypeId 任务类型
     * @return 配置列表
     */
    @SysLog("通过任务类型获取表单配置")
    @GetMapping("/getTaskContentConfigByTaskTypeId/{taskTypeId}")
    public R<?> getById(@PathVariable String taskTypeId) {
        log.info("get_task_content_config_by_task_type_id:{}", taskTypeId);
        if (null == taskTypeId) {
            return R.failed("taskTypeId不能为空");
        }
        Map<String, Object> configMap = getTaskContentConfigByTaskTypeId(taskTypeId);
        return R.ok(configMap);
    }

    /**
     * 根据任务类型id获取任务内容配置信息
     *
     * @param taskTypeId 任务类型id
     * @return 任务内容配置信息
     */
    private Map<String, Object> getTaskContentConfigByTaskTypeId(String taskTypeId) {
        Map<String, Object> configMap = new LinkedHashMap<>();
        Map<String, Object> dictMap = new LinkedHashMap<>();

        List<WmTaskContentConfig> listConfig = wmTaskContentConfigService.list(Wrappers.<WmTaskContentConfig>lambdaQuery()
                .eq(WmTaskContentConfig::getDelFlag, CommonConstants.STATUS_NORMAL)
                .eq(WmTaskContentConfig::getEnableFlag, CommonConstants.STATUS_NORMAL)
                .eq(WmTaskContentConfig::getTaskTypeId, taskTypeId)
                .orderByAsc(WmTaskContentConfig::getSeq));

        listConfig.forEach(config -> config.setTaskFiledType(config.getTaskFiledType().trim()));
        log.info("task_content_config:<{}>", listConfig);
        HnqzUser user = SecurityUtils.getUser();
        for (WmTaskContentConfig config : listConfig) {
            if ("select".equals(config.getTaskFiledType())) {
                List<SysDictItem> dictItems = sysDictItemService.list(Wrappers.<SysDictItem>lambdaQuery().eq(SysDictItem::getType, config.getDictGroupName()));
                dictMap.put(config.getDictGroupName(), dictItems);
            }

            if ("tree".equals(config.getTaskFiledType())) {
                if ("package_tree".equals(config.getDictGroupName())) {
                    // 查询可以关联的积分包
                    List<Map<String, Object>> listMap;
                    if (user != null) {
                        List<WmScorePackageStatus> statusList = wmScorePackageStatusService.list(
                                Wrappers.<WmScorePackageStatus>lambdaQuery().eq(WmScorePackageStatus::getUserId, user.getId().toString())
                                        .eq(WmScorePackageStatus::getStatus, "2")
                                        .eq(WmScorePackageStatus::getTaskAddFlag, "1")
                                        .eq(WmScorePackageStatus::getDelFlag, CommonConstants.STATUS_NORMAL)
                                        .eq(WmScorePackageStatus::getEnableFlag, CommonConstants.STATUS_NORMAL));

                        log.info("score_pkg_status:<--{}-->", statusList);
                        if (CollUtil.isNotEmpty(statusList)) {
                            Set<String> scoreIds = statusList.stream().map(WmScorePackageStatus::getPackageId).collect(Collectors.toSet());
                            // 批量查询积分包
                            LocalDate now = LocalDate.now();
                            log.info("score_pkg_ids:<--{}-->, start_time:<--{}-->", scoreIds, now);
                            // List<WmScorePackage> wmScorePackages = wmScorePackageService.listByIds(scoreIds);
                            List<WmScorePackage> wmScorePackages = wmScorePackageService.list(Wrappers.<WmScorePackage>lambdaQuery()
                                    .le(WmScorePackage::getStartTime, now)
                                    .in(WmScorePackage::getId, scoreIds));
                            log.info("score_pkgs:<--{}-->", wmScorePackages);
                            Map<String, WmScorePackage> scorePackageMap = wmScorePackages.stream().collect(Collectors.toMap(WmScorePackage::getId, Function.identity()));
                            // 批量查询scoreTaskType
                            log.info("score_package_map:<--{}-->", scorePackageMap);
                            List<Map<String, Object>> scoreTaskTypeCountList = wmScoreTaskTypeMapper.countByScoreId(taskTypeId, scoreIds);
                            log.info("score_task_type_count_list:<--{}-->", scoreTaskTypeCountList);
                            Map<String, Integer> scoreTaskTypeCountMap = new LinkedHashMap<>();
                            String pkgId = "-10";
                            String count = "0";
                            for (Map<String, Object> map : scoreTaskTypeCountList) {
                                for (Map.Entry<String, Object> entry : map.entrySet()) {
                                    Object value = entry.getValue();
                                    String key = entry.getKey();


                                    log.info("value:<--{}-->", value);
                                    if (Objects.nonNull(value) || !"null".equals(value.toString())) {
                                        if ("score_id".equals(key)) {
                                            pkgId = value.toString();
                                        }
                                        if ("COUNT".equalsIgnoreCase(key)) {
                                            count = value.toString();
                                        }
                                    }
                                }
                                log.info("pkg_id:{}, count:{}", pkgId, count);
                                scoreTaskTypeCountMap.put(pkgId, Integer.valueOf(count));

                            }

                            log.info("score_task_type_count_map:<--{}-->", scoreTaskTypeCountMap);
                            listMap = new ArrayList<>(statusList.size());
                            for (WmScorePackageStatus item : statusList) {
                                WmScorePackage wmScorePackage = scorePackageMap.get(item.getPackageId());
                                if (null != wmScorePackage) {
                                    if ("0".equals(wmScorePackage.getTaskAddFlag())) {
                                        continue;
                                    }
                                    if ("1".equals(wmScorePackage.getEnableFlag())) {
                                        continue;
                                    }
                                    if (PackageTypeEnum.TYPE2_SETTLE_PACKAGE.val().equals(wmScorePackage.getPackageType2()) && !PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val().equals(wmScorePackage.getPackageType1())) {
                                        continue;
                                    }
                                    if (LocalDate.now().isAfter(wmScorePackage.getEndTime())) {
                                        // 过截止日期的过滤掉
                                        continue;
                                    }

                                    if ("28".equals(taskTypeId)) {
                                        if ("3".equals(wmScorePackage.getPackageType1())) {
                                            Map<String, Object> map = new HashMap<>();
                                            map.put("label", wmScorePackage.getScorePackageName());
                                            map.put("value", wmScorePackage.getId());
                                            String drugProducer = ArrayUtils.isEmpty(wmScorePackage.getDrugProducerList()) ? "" : String.join(StrPool.COMMA, wmScorePackage.getDrugProducerList());
                                            map.put("drugProducer", drugProducer);
                                            listMap.add(map);
                                        }

                                    } else {
                                        if ("3".equals(wmScorePackage.getPackageType1())) {
                                            continue;
                                        }
                                        // 过滤有效任务类型
                                        WmScoreTaskType taskType = new WmScoreTaskType();
                                        taskType.setTaskTypeId(taskTypeId);
                                        taskType.setScoreId(wmScorePackage.getId());

                                        int total = scoreTaskTypeCountMap.getOrDefault(wmScorePackage.getId(), 0);
                                        log.info("total:<{}>", total);
                                        if (total != 0) {
                                            Map<String, Object> map = new HashMap<>(5);
                                            map.put("label", wmScorePackage.getScorePackageName());
                                            map.put("value", wmScorePackage.getId());
                                            String drugProducer = ArrayUtils.isEmpty(wmScorePackage.getDrugProducerList()) ? "" : String.join(StrPool.COMMA, wmScorePackage.getDrugProducerList());
                                            map.put("drugProducer", drugProducer);

                                            List<String> drugIds = Arrays.stream(wmScorePackage.getDrugtable()).distinct().collect(Collectors.toList());

                                            map.put("drugTableIds", drugIds);

                                            List<Integer> pkgQuizIds = new LinkedList<>();
                                            if (ArrayUtil.isNotEmpty(drugIds)) {

                                                // 获取药品绑定的试卷
                                                List<WmDrugQuizRelation> relations = drugQuizRelationService.list(Wrappers.<WmDrugQuizRelation>lambdaQuery().in(WmDrugQuizRelation::getDrugId, drugIds));

                                                Map<Integer, List<WmDrugQuizRelation>> drugIdToQuizzes = relations.stream().collect(Collectors.groupingBy(WmDrugQuizRelation::getDrugId));


                                                List<WmDaDrugEntDrugtable> drugtables = wmDaDrugEntDrugtableService.list(Wrappers.<WmDaDrugEntDrugtable>lambdaQuery().in(WmDaDrugEntDrugtable::getId, drugIds));

                                                if (CollUtil.isNotEmpty(drugtables)) {
                                                    List<Map<String, Object>> drugMap = drugtables.stream().map(drug -> {
                                                        Map<String, Object> res = new HashMap<>(3);
                                                        res.put("drugId", drug.getId());
                                                        res.put("drugName", drug.getDrugname());
                                                        res.put("drugPordName", drug.getDrugnameTy());
                                                        List<WmDrugQuizRelation> quizRelations = drugIdToQuizzes.get(Integer.valueOf(drug.getId()));
                                                        List<Integer> quizIds = CollUtil.isEmpty(quizRelations) ? Collections.emptyList() : quizRelations.stream().mapToInt(WmDrugQuizRelation::getQuizId).boxed().distinct().collect(Collectors.toList());
                                                        res.put("quizIds", quizIds);
                                                        pkgQuizIds.addAll(quizIds);
                                                        return res;
                                                    }).collect(Collectors.toList());
                                                    map.put("drugTable", drugMap);
                                                } else {
                                                    map.put("drugTable", Collections.emptyMap());
                                                }

                                            } else {
                                                map.put("drugTable", Collections.emptyMap());
                                            }
                                            map.put("pkgQuizIds", pkgQuizIds);

                                            listMap.add(map);
                                        }
                                    }
                                }
                            }
                        } else {
                            listMap = Collections.emptyList();
                        }
                    } else {
                        listMap = Collections.emptyList();
                    }

                    dictMap.put(config.getDictGroupName(), listMap);

                }
            }

            if ("domain".equals(config.getTaskFiledType())) {
                if ("ent_service".equals(config.getDictGroupName())) {
                    List<WmDaDrugEnt> wmDaDrugEnts = Objects.isNull(user) ? wmDaDrugEntService.list() : getDrugListBySecUser(user.getPlatId());

                    List<Map<String, Object>> listMap = wmDaDrugEnts.stream().map(ent -> {
                        Map<String, Object> map = new HashMap<>(3);
                        map.put("label", ent.getEntname());
                        map.put("value", ent.getId());
                        map.put("type", "drug");
                        return map;
                    }).collect(Collectors.toList());

                    dictMap.put(config.getDictGroupName(), listMap);

                } else if ("ent_bus".equals(config.getDictGroupName())) {
                    List<WmDaDistribution> wmDaDrugEnts = wmDaDistributionService.list();

                    List<Map<String, Object>> listMap = wmDaDrugEnts.stream().map(ent -> {
                        Map<String, Object> map = new HashMap<>(2);
                        map.put("label", ent.getGsmc());
                        map.put("value", ent.getId());
                        return map;
                    }).collect(Collectors.toList());
                    dictMap.put(config.getDictGroupName(), listMap);

                } else if ("ent_dclx".equals(config.getDictGroupName())) {
                    dictMap.put("hospital_service", Collections.emptyList());

                    List<WmDaDistribution> wmDaDistributions = wmDaDistributionService.list();
                    List<Map<String, Object>> wmDaDistributionList = wmDaDistributions.stream().map(dis -> {
                        Map<String, Object> map = new HashMap<>(2);
                        map.put("label", dis.getGsmc());
                        map.put("value", dis.getId());
                        return map;
                    }).collect(Collectors.toList());
                    dictMap.put("distribution_service", wmDaDistributionList);

                } else if ("ent_pharmacy".equals(config.getDictGroupName())) {

                    List<WmDaPharmacy> wmDaDrugEnts = wmDaPharmacyService.list();
                    List<Map<String, Object>> listMap = wmDaDrugEnts.stream().map(ent -> {
                        Map<String, Object> map = new HashMap<>(2);
                        map.put("label", ent.getPharmacyName());
                        map.put("value", ent.getId());
                        return map;
                    }).collect(Collectors.toList());
                    dictMap.put(config.getDictGroupName(), listMap);

                } else if ("package_list".equals(config.getDictGroupName())) {
                    // 查询可以关联的积分包
                    List<Map<String, Object>> listMap;
                    if (user != null) {
                        List<WmScorePackageStatus> statusList = wmScorePackageStatusService.list(
                                Wrappers.<WmScorePackageStatus>lambdaQuery().eq(WmScorePackageStatus::getUserId, user.getId().toString())
                                        .eq(WmScorePackageStatus::getStatus, "2")
                                        .eq(WmScorePackageStatus::getTaskAddFlag, "1")
                                        .eq(WmScorePackageStatus::getDelFlag, CommonConstants.STATUS_NORMAL)
                                        .eq(WmScorePackageStatus::getEnableFlag, CommonConstants.STATUS_NORMAL));

                        log.info("score_pkg_status:<--{}-->", statusList);
                        if (CollUtil.isNotEmpty(statusList)) {
                            Set<String> scoreIds = statusList.stream().map(WmScorePackageStatus::getPackageId).collect(Collectors.toSet());
                            // 批量查询积分包
                            log.info("score_pkg_ids:<--{}-->", scoreIds);
                            List<WmScorePackage> wmScorePackages = wmScorePackageService.listByIds(scoreIds);
                            log.info("score_pkgs:<--{}-->", wmScorePackages);
                            Map<String, WmScorePackage> scorePackageMap = wmScorePackages.stream().collect(Collectors.toMap(WmScorePackage::getId, Function.identity()));
                            // 批量查询scoreTaskType
                            log.info("score_package_map:<--{}-->", scorePackageMap);
                            List<Map<String, Object>> scoreTaskTypeCountList = wmScoreTaskTypeMapper.countByScoreId(taskTypeId, scoreIds);
                            log.info("score_task_type_count_list:<--{}-->", scoreTaskTypeCountList);
                            Map<String, Integer> scoreTaskTypeCountMap = new LinkedHashMap<>();
                            String pkgId = "-10";
                            String count = "0";
                            for (Map<String, Object> map : scoreTaskTypeCountList) {
                                for (Map.Entry<String, Object> entry : map.entrySet()) {
                                    Object value = entry.getValue();
                                    String key = entry.getKey();


                                    log.info("value:<--{}-->", value);
                                    if (Objects.nonNull(value) || !"null".equals(value.toString())) {
                                        if ("score_id".equals(key)) {
                                            pkgId = value.toString();
                                        }
                                        if ("COUNT".equalsIgnoreCase(key)) {
                                            count = value.toString();
                                        }
                                    }
                                }
                                log.info("pkg_id:{}, count:{}", pkgId, count);
                                scoreTaskTypeCountMap.put(pkgId, Integer.valueOf(count));

                            }

                            log.info("score_task_type_count_map:<--{}-->", scoreTaskTypeCountMap);
                            listMap = new ArrayList<>(statusList.size());
                            for (WmScorePackageStatus item : statusList) {
                                WmScorePackage wmScorePackage = scorePackageMap.get(item.getPackageId());
                                if (null != wmScorePackage) {
                                    if ("0".equals(wmScorePackage.getTaskAddFlag())) {
                                        continue;
                                    }
                                    if ("1".equals(wmScorePackage.getEnableFlag())) {
                                        continue;
                                    }
                                    if (PackageTypeEnum.TYPE2_SETTLE_PACKAGE.val().equals(wmScorePackage.getPackageType2()) && !PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val().equals(wmScorePackage.getPackageType1())) {
                                        continue;
                                    }
                                    if (LocalDate.now().isAfter(wmScorePackage.getEndTime())) {
                                        // 过截止日期的过滤掉
                                        continue;
                                    }

                                    if ("28".equals(taskTypeId)) {
                                        if ("3".equals(wmScorePackage.getPackageType1())) {
                                            Map<String, Object> map = new HashMap<>();
                                            map.put("label", wmScorePackage.getScorePackageName());
                                            map.put("value", wmScorePackage.getId());
                                            String drugProducer = ArrayUtils.isEmpty(wmScorePackage.getDrugProducerList()) ? "" : String.join(StrPool.COMMA, wmScorePackage.getDrugProducerList());
                                            map.put("drugProducer", drugProducer);
                                            listMap.add(map);
                                        }

                                    } else {
                                        if ("3".equals(wmScorePackage.getPackageType1())) {
                                            continue;
                                        }
                                        // 过滤有效任务类型
                                        WmScoreTaskType taskType = new WmScoreTaskType();
                                        taskType.setTaskTypeId(taskTypeId);
                                        taskType.setScoreId(wmScorePackage.getId());

                                        int total = scoreTaskTypeCountMap.getOrDefault(wmScorePackage.getId(), 0);
                                        log.info("total:<{}>", total);
                                        if (total != 0) {
                                            Map<String, Object> map = new HashMap<>(3);
                                            map.put("label", wmScorePackage.getScorePackageName());
                                            map.put("value", wmScorePackage.getId());
                                            String drugProducer = ArrayUtils.isEmpty(wmScorePackage.getDrugProducerList()) ? "" : String.join(StrPool.COMMA, wmScorePackage.getDrugProducerList());
                                            map.put("drugProducer", drugProducer);
                                            listMap.add(map);
                                        }
                                    }
                                }
                            }
                        } else {
                            listMap = Collections.emptyList();
                        }
                    } else {
                        listMap = Collections.emptyList();
                    }
                    dictMap.put(config.getDictGroupName(), listMap);

                } else if ("package_drug_list".equals(config.getDictGroupName())) {
                    // 前端自动获取
                    dictMap.put(config.getDictGroupName(), "package_drug_list");
                } else if ("medical_equipment_list".equals(config.getDictGroupName())) {
                    List<Map<String, Object>> listMap;
                    // 手术跟台任务类型-推广产品
                    List<MedicalEquipment> medicalEquipmentList = medicalEquipmentService.listByDrugId(user.getDeptId());
                    if (CollUtil.isNotEmpty(medicalEquipmentList)) {
                        listMap = medicalEquipmentList.stream().map(medicalEquipment -> {
                            Map<String, Object> equipmentMap = new HashMap<>();
                            equipmentMap.put("value", medicalEquipment.getId());
                            equipmentMap.put("label", medicalEquipment.getName());
                            return equipmentMap;
                        }).collect(Collectors.toList());
                    } else {
                        listMap = Collections.emptyList();
                    }
                    dictMap.put(config.getDictGroupName(), listMap);
                }

            }
        }
        configMap.put("config", listConfig);
        configMap.put("dict", dictMap);
        return configMap;
    }

    @SysLog("通过任务类型获取表单配置")
    @GetMapping("/getTaskContentConfigByTaskTypeByShareId/{taskTypeId}")
    public R<?> getShareById(@PathVariable String taskTypeId) {
        if (null == taskTypeId) {
            return R.failed("taskTypeId不能为空");

        }

        Map<String, Object> connfigMap = getTaskContentConfigByTaskTypeIdByShareId(taskTypeId);
        return R.ok(connfigMap);
    }

    private Map<String, Object> getTaskContentConfigByTaskTypeIdByShareId(String taskTypeId) {
        Map<String, Object> connfigMap = new LinkedHashMap<>();
        Map<String, Object> dictMap = new LinkedHashMap<>();

        List<WmTaskContentConfig> listConfig = wmTaskContentConfigService.list(Wrappers.<WmTaskContentConfig>lambdaQuery()
                .eq(WmTaskContentConfig::getDelFlag, CommonConstants.STATUS_NORMAL)
                .eq(WmTaskContentConfig::getEnableFlag, CommonConstants.STATUS_NORMAL)
                .eq(WmTaskContentConfig::getTaskTypeId, taskTypeId)
                .orderByAsc(WmTaskContentConfig::getSeq));

        HnqzUser user = SecurityUtils.getUser();
        for (WmTaskContentConfig config : listConfig) {
            if ("select".equals(config.getTaskFiledType().trim())) {
                List<SysDictItem> dictItems = sysDictItemService.list(Wrappers.<SysDictItem>lambdaQuery().eq(SysDictItem::getType, config.getDictGroupName()));
                dictMap.put(config.getDictGroupName(), dictItems);
            }

            if ("tree".equals(config.getTaskFiledType())) {
                if ("package_tree".equals(config.getDictGroupName())) {
                    // 查询可以关联的积分包
                    List<Map<String, Object>> listMap;
                    if (user != null) {
                        List<WmScorePackageStatus> statusList = wmScorePackageStatusService.list(
                                Wrappers.<WmScorePackageStatus>lambdaQuery().eq(WmScorePackageStatus::getUserId, user.getId().toString())
                                        .eq(WmScorePackageStatus::getStatus, "2")
                                        .eq(WmScorePackageStatus::getTaskAddFlag, "1")
                                        .eq(WmScorePackageStatus::getDelFlag, CommonConstants.STATUS_NORMAL)
                                        .eq(WmScorePackageStatus::getEnableFlag, CommonConstants.STATUS_NORMAL));

                        log.info("score_pkg_status:<--{}-->", statusList);
                        if (CollUtil.isNotEmpty(statusList)) {
                            Set<String> scoreIds = statusList.stream().map(WmScorePackageStatus::getPackageId).collect(Collectors.toSet());
                            // 批量查询积分包
                            LocalDate now = LocalDate.now();
                            log.info("score_pkg_ids:<--{}-->, start_time:<--{}-->", scoreIds, now);
                            // List<WmScorePackage> wmScorePackages = wmScorePackageService.listByIds(scoreIds);
                            List<WmScorePackage> wmScorePackages = wmScorePackageService.list(Wrappers.<WmScorePackage>lambdaQuery()
                                    .le(WmScorePackage::getStartTime, now)
                                    .in(WmScorePackage::getId, scoreIds));
                            log.info("score_pkgs:<--{}-->", wmScorePackages);
                            Map<String, WmScorePackage> scorePackageMap = wmScorePackages.stream().collect(Collectors.toMap(WmScorePackage::getId, Function.identity()));
                            // 批量查询scoreTaskType
                            log.info("score_package_map:<--{}-->", scorePackageMap);
                            List<Map<String, Object>> scoreTaskTypeCountList = wmScoreTaskTypeMapper.countByScoreId(taskTypeId, scoreIds);
                            log.info("score_task_type_count_list:<--{}-->", scoreTaskTypeCountList);
                            Map<String, Integer> scoreTaskTypeCountMap = new LinkedHashMap<>();
                            String pkgId = "-10";
                            String count = "0";
                            for (Map<String, Object> map : scoreTaskTypeCountList) {
                                for (Map.Entry<String, Object> entry : map.entrySet()) {
                                    Object value = entry.getValue();
                                    String key = entry.getKey();


                                    log.info("value:<--{}-->", value);
                                    if (Objects.nonNull(value) || !"null".equals(value.toString())) {
                                        if ("score_id".equals(key)) {
                                            pkgId = value.toString();
                                        }
                                        if ("COUNT".equalsIgnoreCase(key)) {
                                            count = value.toString();
                                        }
                                    }
                                }
                                log.info("pkg_id:{}, count:{}", pkgId, count);
                                scoreTaskTypeCountMap.put(pkgId, Integer.valueOf(count));

                            }

                            log.info("score_task_type_count_map:<--{}-->", scoreTaskTypeCountMap);
                            listMap = new ArrayList<>(statusList.size());
                            for (WmScorePackageStatus item : statusList) {
                                WmScorePackage wmScorePackage = scorePackageMap.get(item.getPackageId());
                                if (null != wmScorePackage) {
                                    if ("0".equals(wmScorePackage.getTaskAddFlag())) {
                                        continue;
                                    }
                                    if ("1".equals(wmScorePackage.getEnableFlag())) {
                                        continue;
                                    }
                                    if (PackageTypeEnum.TYPE2_SETTLE_PACKAGE.val().equals(wmScorePackage.getPackageType2()) && !PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val().equals(wmScorePackage.getPackageType1())) {
                                        continue;
                                    }
                                    if (LocalDate.now().isAfter(wmScorePackage.getEndTime())) {
                                        // 过截止日期的过滤掉
                                        continue;
                                    }

                                    if ("28".equals(taskTypeId)) {
                                        if ("3".equals(wmScorePackage.getPackageType1())) {
                                            Map<String, Object> map = new HashMap<>();
                                            map.put("label", wmScorePackage.getScorePackageName());
                                            map.put("value", wmScorePackage.getId());
                                            String drugProducer = ArrayUtils.isEmpty(wmScorePackage.getDrugProducerList()) ? "" : String.join(StrPool.COMMA, wmScorePackage.getDrugProducerList());
                                            map.put("drugProducer", drugProducer);
                                            listMap.add(map);
                                        }

                                    } else {
                                        if ("3".equals(wmScorePackage.getPackageType1())) {
                                            continue;
                                        }
                                        // 过滤有效任务类型
                                        WmScoreTaskType taskType = new WmScoreTaskType();
                                        taskType.setTaskTypeId(taskTypeId);
                                        taskType.setScoreId(wmScorePackage.getId());

                                        int total = scoreTaskTypeCountMap.getOrDefault(wmScorePackage.getId(), 0);
                                        log.info("total:<{}>", total);
                                        if (total != 0) {
                                            Map<String, Object> map = new HashMap<>(5);
                                            map.put("label", wmScorePackage.getScorePackageName());
                                            map.put("value", wmScorePackage.getId());
                                            String drugProducer = ArrayUtils.isEmpty(wmScorePackage.getDrugProducerList()) ? "" : String.join(StrPool.COMMA, wmScorePackage.getDrugProducerList());
                                            map.put("drugProducer", drugProducer);

                                            List<String> drugIds = Arrays.stream(wmScorePackage.getDrugtable()).distinct().collect(Collectors.toList());

                                            map.put("drugTableIds", drugIds);

                                            List<Integer> pkgQuizIds = new LinkedList<>();
                                            if (ArrayUtil.isNotEmpty(drugIds)) {

                                                // 获取药品绑定的试卷
                                                List<WmDrugQuizRelation> relations = drugQuizRelationService.list(Wrappers.<WmDrugQuizRelation>lambdaQuery().in(WmDrugQuizRelation::getDrugId, drugIds));

                                                Map<Integer, List<WmDrugQuizRelation>> drugIdToQuizzes = relations.stream().collect(Collectors.groupingBy(WmDrugQuizRelation::getDrugId));


                                                List<WmDaDrugEntDrugtable> drugtables = wmDaDrugEntDrugtableService.list(Wrappers.<WmDaDrugEntDrugtable>lambdaQuery().in(WmDaDrugEntDrugtable::getId, drugIds));

                                                if (CollUtil.isNotEmpty(drugtables)) {
                                                    List<Map<String, Object>> drugMap = drugtables.stream().map(drug -> {
                                                        Map<String, Object> res = new HashMap<>(3);
                                                        res.put("drugId", drug.getId());
                                                        res.put("drugName", drug.getDrugname());
                                                        res.put("drugPordName", drug.getDrugnameTy());
                                                        List<WmDrugQuizRelation> quizRelations = drugIdToQuizzes.get(Integer.valueOf(drug.getId()));
                                                        List<Integer> quizIds = CollUtil.isEmpty(quizRelations) ? Collections.emptyList() : quizRelations.stream().mapToInt(WmDrugQuizRelation::getQuizId).boxed().distinct().collect(Collectors.toList());
                                                        res.put("quizIds", quizIds);
                                                        pkgQuizIds.addAll(quizIds);
                                                        return res;
                                                    }).collect(Collectors.toList());
                                                    map.put("drugTable", drugMap);
                                                } else {
                                                    map.put("drugTable", Collections.emptyMap());
                                                }

                                            } else {
                                                map.put("drugTable", Collections.emptyMap());
                                            }
                                            map.put("pkgQuizIds", pkgQuizIds);

                                            listMap.add(map);
                                        }
                                    }
                                }
                            }
                        } else {
                            listMap = Collections.emptyList();
                        }
                    } else {
                        listMap = Collections.emptyList();
                    }

                    dictMap.put(config.getDictGroupName(), listMap);

                }
            }

            if ("domain".equals(config.getTaskFiledType().trim())) {
                if ("ent_service".equals(config.getDictGroupName())) {
                    List<WmDaDrugEnt> wmDaDrugEnts;
                    if (null == SecurityUtils.getUser()) {
                        wmDaDrugEnts = wmDaDrugEntService.list();
                    } else {
                        wmDaDrugEnts = getDrugListBySecUser(SecurityUtils.getUser().getPlatId());
                    }
                    List<Map<String, Object>> listMap = new ArrayList<>();
                    for (WmDaDrugEnt wmDaDrugEnt : wmDaDrugEnts) {
                        Map<String, Object> map = new HashMap<>(3);
                        map.put("label", wmDaDrugEnt.getEntname());
                        map.put("value", wmDaDrugEnt.getId());
                        map.put("type", "drug");
                        listMap.add(map);
                    }
                    dictMap.put(config.getDictGroupName(), listMap);

                    List<WmDaDistribution> wmDaDistributions = wmDaDistributionService.list();
                    List<Map<String, Object>> wmDaDistributionList = new ArrayList<>();
                    for (WmDaDistribution wmDaDistribution : wmDaDistributions) {
                        Map<String, Object> map = new HashMap<>(2);
                        map.put("label", wmDaDistribution.getGsmc());
                        map.put("value", wmDaDistribution.getId());
                        wmDaDistributionList.add(map);
                    }
                    dictMap.put("distribution_service", listMap);
                } else if ("ent_bus".equals(config.getDictGroupName())) {
                    List<WmDaDistribution> wmDaDrugEnts = wmDaDistributionService.list();
                    List<Map<String, Object>> listMap = new ArrayList<>();
                    for (WmDaDistribution wmDaDrugEnt : wmDaDrugEnts) {
                        Map<String, Object> map = new HashMap<>(2);
                        map.put("label", wmDaDrugEnt.getGsmc());
                        map.put("value", wmDaDrugEnt.getId());
                        listMap.add(map);
                    }
                    dictMap.put(config.getDictGroupName(), listMap);
                } else if ("ent_pharmacy".equals(config.getDictGroupName())) {
                    List<WmDaPharmacy> wmDaDrugEnts = wmDaPharmacyService.list();
                    List<Map<String, Object>> listMap = new ArrayList<>();
                    for (WmDaPharmacy wmDaDrugEnt : wmDaDrugEnts) {
                        Map<String, Object> map = new HashMap<>(2);
                        map.put("label", wmDaDrugEnt.getPharmacyName());
                        map.put("value", wmDaDrugEnt.getId());
                        listMap.add(map);
                    }
                    dictMap.put(config.getDictGroupName(), listMap);
                } else if ("package_list".equals(config.getDictGroupName())) {
                    // 查询可以关联的积分包
                    List<Map<String, Object>> listMap = new ArrayList<>();
                    if (SecurityUtils.getUser() != null) {
                        UserVO userVO = sysUserService.selectUserVoById(SecurityUtils.getUser().getId());
                        WmScorePackageStatus query = new WmScorePackageStatus();
                        query.setUserId(userVO.getUserId() + "");
                        query.setStatus("2");
                        query.setTaskAddFlag("1");
                        query.setDelFlag("0");
                        query.setEnableFlag("0");

                        List<WmScorePackageStatus> statusList = wmScorePackageStatusService.list(Wrappers.lambdaQuery(query));
                        for (WmScorePackageStatus item : statusList) {
                            WmScorePackage wmScorePackage = wmScorePackageService.getById(item.getPackageId());
                            if (null != wmScorePackage) {
                                if ("0".equals(wmScorePackage.getTaskAddFlag())) {
                                    continue;
                                }
                                if ("1".equals(wmScorePackage.getEnableFlag())) {
                                    continue;
                                }
                                if (PackageTypeEnum.TYPE2_SETTLE_PACKAGE.val().equals(wmScorePackage.getPackageType2())
                                        && !PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val().equals(wmScorePackage.getPackageType1())) {
                                    continue;
                                }

                                if ("28".equals(taskTypeId)) {
                                    if ("3".equals(wmScorePackage.getPackageType1())) {
                                        Map<String, Object> map = new HashMap<>();
                                        map.put("label", wmScorePackage.getScorePackageName());
                                        map.put("value", wmScorePackage.getId());
                                        listMap.add(map);
                                    }

                                } else {
                                    if ("3".equals(wmScorePackage.getPackageType1())) {
                                        continue;
                                    }
                                    // 过滤有效任务类型
                                    WmScoreTaskType taskType = new WmScoreTaskType();
                                    taskType.setTaskTypeId(taskTypeId);
                                    taskType.setScoreId(wmScorePackage.getId());

                                    int total = wmScoreTaskTypeService.count(Wrappers.query(taskType));

                                    if (total != 0) {
                                        Map<String, Object> map = new HashMap<>();
                                        map.put("label", wmScorePackage.getScorePackageName());
                                        map.put("value", wmScorePackage.getId());
                                        listMap.add(map);
                                    }
                                }

                            }
                        }
                    }

                    dictMap.put(config.getDictGroupName(), listMap);
                }

            }
        }

        connfigMap.put("config", listConfig);
        connfigMap.put("dict", dictMap);
        return connfigMap;
    }

    @GetMapping("/getDeptBuildName/{deptId}")
    public R<?> getDeptBuildName(@PathVariable String deptId) {
        Map<String, Object> connfigMap = new LinkedHashMap<>();
        if (CharSequenceUtil.isBlank(deptId)) {
            return R.failed("deptId不能为空");
        }

        connfigMap.put("buildName", wmDaAgentService.getDeptBuildName(deptId));
        return R.ok(connfigMap);
    }

    /**
     * 更新用户信息（openId 和头像)
     *
     * @param uId    用户ID
     * @param openId openId
     * @param avatar 头像
     */
    private void updateUserOpenIdAndAvatar(Integer uId, String openId, String avatar) {
        SysUser u = sysUserService.getById(uId);

        SysUser updateU = new SysUser();
        updateU.setUserId(uId);
        if (CharSequenceUtil.isBlank(u.getWxOpenid()) || "null".equals(u.getWxOpenid())) {
            updateU.setWxOpenid(openId);
        }

        if (CharSequenceUtil.isBlank(u.getAvatar())) {
            updateU.setAvatar(avatar);
        }

        updateU.setUpdateTime(LocalDateTime.now());
        sysUserService.updateById(updateU);
    }

    /**
     * 用户信息-获取用户基本信息
     *
     * @param code   小程序信息code
     * @param avatar 头像
     * @return 用户信息
     */
    @GetMapping("/getUserInfoByCode")
    public R<Map<String, Object>> getUserInfo(String code, String avatar) {
        Map<String, Object> result = new HashMap<>();

        // 获取用户基本信息
        HnqzUser hnqzUser = SecurityUtils.getUser();
        UserDTO userDTO = new UserDTO();
        userDTO.setPlatId(hnqzUser.getPlatId());
        List<UserVO> sysUserList = sysUserService.getUserVoByPlatId(userDTO);

        if (CollUtil.isEmpty(sysUserList)) {
            return R.failed("账号信息异常，请联系管理员");
        }

        updateUserOpenIdAndAvatar(hnqzUser.getId(), code, avatar);

        List<Integer> roleList = new ArrayList<>();

        List<Map<String, Object>> list = new ArrayList<>(sysUserList.size());
        for (UserVO sysU : sysUserList) {

            Map<String, Object> mapOne = new HashMap<>();
            mapOne.put("latestChangePwdTime", sysU.getLatestChangePwdTime());
            mapOne.put("userId", sysU.getUserId().toString());
            mapOne.put("realname", sysU.getRealname());
            mapOne.put("phone", sysU.getPhone());
            mapOne.put("idCardNumber", sysU.getIdCardNumber());
            mapOne.put("userSign", sysU.getUserSign());
            mapOne.put("reSignedAgreement", sysU.getReSignedAgreement());

            // 设置头像
            if (CharSequenceUtil.isBlank(sysU.getAvatar())) {
                SysUser u = new SysUser();
                u.setUserId(sysU.getUserId());
                u.setAvatar(avatar);
                sysUserService.updateById(u);
            } else {
                avatar = sysU.getAvatar();
            }
            mapOne.put("avatar", avatar);

            // 获取部门信息
            SysDept sysDept = sysDeptService.getById(sysU.getDeptId());
            mapOne.put("deptId", sysDept.getDeptId().toString());
            mapOne.put("deptName", sysDept.getName());

            String management;

            if (sysDept.getLevel() == 1) {
                mapOne.put("management", "1");
                management = "1";
            } else if (sysDept.getLevel() == 2) {
                WmDaDrugEnt drugEnt = wmDaDrugEntService.selectByDeptId(sysDept.getDeptId());
                mapOne.put("management", drugEnt.getManagement());
                management = drugEnt.getManagement();
            } else {
                WmDaAgent agent = wmDaAgentService.selectByDeptId(sysDept.getDeptId());
                mapOne.put("management", agent.getManagement());
                management = agent.getManagement();
            }

            // 小程序全角色列表放开
            List<Integer> roleIdList = sysU.getRoleList().stream().map(SysRole::getRoleId).collect(Collectors.toList());

            boolean managementFlag = ("2".equals(management) && roleIdList.contains(5))
                    || ("3".equals(management) && (roleIdList.contains(6) || roleIdList.contains(10)))
                    || ("4".equals(management));
            mapOne.put("managementFlag", managementFlag);

            WmDaDrugEnt wmDaDrugEnt = wmDaDrugEntService.getById(sysU.getDrugEntId());
            if (null != wmDaDrugEnt) {
                mapOne.put("drugEntId", wmDaDrugEnt.getId());
                mapOne.put("drugEntName", wmDaDrugEnt.getEntname());
            }

            mapOne.put("roles", roleIdList);
            mapOne.put("temp1", String.valueOf(sysU.getTemp1()));
            mapOne.put("temp2", String.valueOf(sysU.getTemp2()));
            mapOne.put("temp3", String.valueOf(sysU.getTemp3()));
            mapOne.put("temp4", String.valueOf(sysU.getTemp4()));
            mapOne.put("temp5", String.valueOf(sysU.getTemp5()));

            // 查询待审核包
            List<WmScorePackageStatus> statusList = wmScorePackageStatusService.list(Wrappers.<WmScorePackageStatus>lambdaQuery()
                    .eq(WmScorePackageStatus::getUserId, String.valueOf(sysU.getUserId()))
                    .eq(WmScorePackageStatus::getTaskAddFlag, "1")
                    .eq(WmScorePackageStatus::getDelFlag, CommonConstants.STATUS_NORMAL)
                    .eq(WmScorePackageStatus::getEnableFlag, CommonConstants.STATUS_NORMAL)
            );

            long onTheWay = 0;
            long waitApprove = statusList.stream().filter(item -> "1".equals(item.getStatus())).count();

            Set<String> pkgIds = statusList.stream().filter(item -> "2".equals(item.getStatus())).map(WmScorePackageStatus::getPackageId).collect(Collectors.toSet());
            List<Map<String, Object>> listMap;
            if (CollUtil.isNotEmpty(pkgIds)) {
                List<WmScorePackage> pkgs = wmScorePackageService.listByIds(pkgIds);
                listMap = pkgs.stream().map(pkg -> {
                    Map<String, Object> map = new HashMap<>(2);
                    map.put("label", pkg.getScorePackageName());
                    map.put("value", pkg.getId());
                    return map;
                }).collect(Collectors.toList());
                onTheWay = listMap.size();
            } else {
                listMap = Collections.emptyList();
            }

            mapOne.put("packageList", listMap);
            mapOne.put("waitApprove", String.valueOf(waitApprove));
            mapOne.put("onTheWay", String.valueOf(onTheWay));

            // 签署协议信息
            List<SysUserAgreementHistory> histories = userAgreementHistoryService.list(Wrappers.<SysUserAgreementHistory>lambdaQuery().eq(SysUserAgreementHistory::getCreateBy, sysU.getUsername()));
            mapOne.put("signedAgreement", histories);

            list.add(mapOne);

            roleList.addAll(roleIdList);

        }

        result.put("userInfo", list);
        result.put("roles", roleList);

        return R.ok(result);
    }

    /**
     * 获取积分规则
     *
     * @param input 输入
     * @return 积分规则列表
     */
    @SysLog("获取积分规则")
    @GetMapping("/getPackageCanTaskList")
    public R<?> getPackageCanTaskList(WmScorePackageApiInput input) {
        if (null == input.getPackageId()) {
            return R.failed("积分包ID不能为空");
        }

        WmScorePackage wmScorePackage = wmScorePackageService.getById(input.getPackageId());
        if (StringUtils.isEmpty(wmScorePackage.getRuleId())) {
            return R.ok();
        }
        WmScoreTaskType query = new WmScoreTaskType();
        query.setScoreId(input.getPackageId());

        // 所有能做的任务
        List<WmScoreTaskType> wmScoreTaskTypeList = wmScoreTaskTypeService.list(Wrappers.query(query));
        // 对应的taskTypeId
        List<String> baseIds = wmScoreTaskTypeList.stream().
                map(WmScoreTaskType::getTaskTypeId).collect(Collectors.toList());
        // 父级parent_id
        List<String> parentId = baseIds.stream().filter(item -> item.startsWith("p")).collect(Collectors.toList());
        // 子级parentId
        List<String> id = baseIds.stream().filter(item -> !item.startsWith("p")).collect(Collectors.toList());

        // 判断任务类型parentId是否包含'p-x'，不包含则直接跳过以下逻辑（解决积分包id9501 没有父类任务报错）
        List<WmTaskType> temp = new ArrayList<>();
        if (CollUtil.isNotEmpty(parentId)) {
            // 记录表中父id的所有子集
            List<WmTaskType> baseTypeList1 = wmTaskTypeService.list(Wrappers.<WmTaskType>query().lambda()
                    .eq(WmTaskType::getTaskTypeLevel, "1")
                    .in(WmTaskType::getParentId, parentId));

            if (CollUtil.isNotEmpty(baseTypeList1)) {

                // 按照父id分组
                Map<String, Map<String, List<WmTaskType>>> pTaskTypeMap = baseTypeList1.stream()
                        .collect(Collectors.groupingBy(WmTaskType::getParentId, Collectors.groupingBy(WmTaskType::getBaseId)));

                if (CollUtil.isNotEmpty(id)) {
                    // 查询所有子id对应的taskType列表
                    List<WmTaskType> baseTypeList2 = wmTaskTypeService.
                            list(Wrappers.<WmTaskType>query().lambda().eq(WmTaskType::getTaskTypeLevel, "1").in(WmTaskType::getId, id));

                    // 所有子id对应的taskType列表 按照父id分组
                    Map<String, Map<String, List<WmTaskType>>> cTaskTypeMap = baseTypeList2.stream()
                            .collect(Collectors.groupingBy(WmTaskType::getParentId, Collectors.groupingBy(WmTaskType::getBaseId)));
                    // 对应的parentId
                    Set<String> cPidSet = cTaskTypeMap.keySet();

                    // 解决页面父级id和数据库存的父级id不一致的问题（如一对一专访在页面父级是p-16，但taskType表中父级id为p-1）
                    // 比较baseTypeList1和baseTypeList2中parentId相同的taskTypeId的数据，如果baseId相同，则取baseTypeList2中的taskTypeId
                    for (Map.Entry<String, Map<String, List<WmTaskType>>> entry : pTaskTypeMap.entrySet()) {
                        // 获取父级id
                        String pid = entry.getKey();
                        // 判断大类中是否有相同的父类id
                        if (cPidSet.contains(pid)) {
                            // baseId
                            Map<String, List<WmTaskType>> value = entry.getValue();
                            Set<String> pBaseIds = value.keySet();
                            // small
                            Map<String, List<WmTaskType>> cVal = cTaskTypeMap.get(pid);
                            Set<String> cBaseIds = cVal.keySet();
                            // 求个交集，找出公共的
                            Set<String> res = new HashSet<>(pBaseIds);
                            res.retainAll(cBaseIds);
                            // 找出的存入temp
                            for (String bId : res) {
                                temp.addAll(cVal.get(bId));
                            }
                            // 取父级中对应baseId是独有的部分
                            pBaseIds.stream().filter(i -> !res.contains(i)).forEach(i -> temp.addAll(value.get(i)));
                        }
                    }
                } else {
                    temp.addAll(baseTypeList1);
                }
            } else {
                // 查询所有子id对应的taskType列表
                List<WmTaskType> baseTypeList2 = wmTaskTypeService.
                        list(Wrappers.<WmTaskType>query().lambda().eq(WmTaskType::getTaskTypeLevel, "1").in(WmTaskType::getId, id));
                temp.addAll(baseTypeList2);
            }
        }

        // 把上述操作没有覆盖到的子id加进来
        Set<String> tempIds = temp.stream().map(WmTaskType::getId).collect(Collectors.toSet());
        Set<String> extCIds = id.stream().filter(s -> !tempIds.contains(s)).collect(Collectors.toSet());
        if (CollUtil.isNotEmpty(extCIds)) {
            temp.addAll(wmTaskTypeService.listByIds(extCIds));
        }

        List<String> baseNames = temp.stream().
                map(WmTaskType::getTaskTypeName).distinct().collect(Collectors.toList());
        WmTaskType wmTaskType = new WmTaskType();
        wmTaskType.setRuleId(wmScorePackage.getRuleId());
        wmTaskType.setDelFlag("0");
        wmTaskType.setEnableFlag("0");
        List<WmTaskType> taskTypeList = wmTaskTypeService.list(Wrappers.query(wmTaskType)
                .lambda().in(WmTaskType::getTaskTypeName, baseNames));

        List<WmTaskTypeVO> taskTypeVOList = new ArrayList<>();
        if (CollUtil.isNotEmpty(taskTypeList)) {
            taskTypeList.forEach(taskType -> {
                WmTaskTypeVO taskTypeVO = BeanUtil.copyProperties(taskType, WmTaskTypeVO.class, "score");
                if (CharSequenceUtil.isNotBlank(taskType.getTaskTypeName()) && taskType.getTaskTypeName().startsWith("应收账款回款")) {
                    // 应收账款回款 任务类 保存的是1000倍数，需要转换回来
                    taskTypeVO.setScore(String.valueOf(taskType.getScore() / 1000.0D));
                } else {
                    taskTypeVO.setScore(String.valueOf(taskType.getScore()));
                }
                taskTypeVOList.add(taskTypeVO);
            });
        }

        return R.ok(taskTypeVOList);
    }

    /**
     * 获取药企列表
     *
     * @return 角色列表
     */
    @SysLog("获取积分规则")
    @GetMapping("/getTaskTypeListByRuleId")
    public R<?> getTaskTypeListByRuleId(WmTaskType wmTaskType) {

        if (StringUtils.isEmpty(wmTaskType.getRuleId())) {
            return R.failed("积分规则ID不能为空");
        }

        wmTaskType.setDelFlag("0");
        wmTaskType.setEnableFlag("0");
        List<String> noDisplayTaskTypeNameList = Arrays.asList("专家咨询", "受试者管理", "医学撰写", "受试者招募", "数据管理",
                "统计分析", "临床监督", "通用", "患者教育");
        List<WmTaskType> wmTaskTypeList = wmTaskTypeService.list(Wrappers.query(wmTaskType)).stream()
                .filter(taskType -> !noDisplayTaskTypeNameList.contains(taskType.getTaskTypeName()))
                .collect(Collectors.toList());

        List<WmTaskTypeVO> voList = new ArrayList<>();
        if (CollUtil.isNotEmpty(wmTaskTypeList)) {
            wmTaskTypeList.forEach(taskType -> {
                WmTaskTypeVO typeVO = BeanUtil.copyProperties(taskType, WmTaskTypeVO.class, "score");
                if (CharSequenceUtil.isNotBlank(taskType.getTaskTypeName()) && taskType.getTaskTypeName().startsWith("应收账款回款")) {
                    // 应收账款回款 任务类 保存的是1000倍数，需要转换回来
                    typeVO.setScore(String.valueOf(taskType.getScore() / 1000.0D));
                } else {
                    typeVO.setScore(String.valueOf(taskType.getScore()));
                }
                voList.add(typeVO);
            });
        }

        return R.ok(voList);
    }


    /**
     * 获取药企列表
     *
     * @return 角色列表
     */
    @SysLog("获取积分规则")
    @GetMapping("/taskTypeScoreList")
    public R<?> taskTypeScoreList(WmTaskType wmTaskType) {
        if (null == wmTaskType.getDurgentId()) {
            return R.failed("药企ID不能为空");
        }

        WmDaDrugEnt wmDaDrugEnt = wmDaDrugEntService.getById(wmTaskType.getDurgentId());

        SysUser sysUser = new SysUser();
        sysUser.setDrugEntId(wmDaDrugEnt.getId());
        sysUser.setPlatId(SecurityUtils.getUser().getPlatId());
        sysUser.setDelFlag("0");
        List<SysUser> sysUserList = sysUserService.list(Wrappers.query(sysUser));
        if (CollUtil.isNotEmpty(sysUserList)) {
            SysDept sysDept = sysDeptService.getById(sysUserList.get(0).getDeptId());
            wmTaskType.setLevel1Id(sysDept.getLevel2Id());
        } else {
            SysDept sysDept = sysDeptService.getById(SecurityUtils.getUser().getDeptId());
            wmTaskType.setLevel1Id(sysDept.getLevel2Id());
        }


        wmTaskType.setDelFlag("0");
        wmTaskType.setEnableFlag("0");
        wmTaskType.setTaskTypeLevel("2");

        return R.ok(wmTaskTypeService.list(Wrappers.query(wmTaskType)));
    }

    /**
     * 三方平台提交任务，无鉴权
     *
     * @param resource 结果内容
     * @return R
     */
    @Inner(value = false)
    @SysLog("三方平台提交任务，无鉴权")
    @PostMapping("/task/content/create")
    public R<?> saveTaskContent1(@RequestBody WmTaskDTO.OnOutPartyCreate resource) {

        log.info("三方平台提交任务，入参：{}", resource);

        if (CharSequenceUtil.isBlank(resource.getTaskTypeId())) {
            return R.failed("任务类型不能为空");
        }

        if (CharSequenceUtil.isBlank(resource.getPkgName()) && CharSequenceUtil.isBlank(resource.getPkgId())) {
            return R.failed("关联积分包不能为空, 必须指定ID或者名称");
        }

        if (CharSequenceUtil.isBlank(resource.getUsername())) {
            return R.failed("代表手机号必填");
        }

        if (CollUtil.isEmpty(resource.getResult())) {
            return R.failed("任务结果内容必填");
        }

        boolean succ = wmTaskContentService.saveTaskContent1(resource);

        return succ ? R.ok("三方提交结果成功") : R.failed("三方提交结果失败");
    }


    /**
     * 新增任务内容表
     *
     * @param wmTaskContent1 任务内容表
     * @return R
     */
    @SysLog("新增任务内容表")
    @PostMapping("/saveTaskContent")
    public R<?> saveTaskContent(@RequestBody WmTaskContent wmTaskContent1, HttpServletRequest request) {

        String paramStr = JSONUtil.toJsonStr(wmTaskContent1);

        // 计算参数md5
        String paramMd5 = DigestUtil.md5Hex(paramStr);

        String username = SecurityUtils.getUser().getUsername();

        String cacheKey1 = "save:task:content:ide:key:" + username + ":" + paramMd5;

        if (Boolean.FALSE.equals(redisTemplate.opsForValue().setIfAbsent(cacheKey1, paramStr, 90, TimeUnit.DAYS))) {
            throw new BizException("存在相似数据的提交记录，请重新填写");
        }


        WmTaskContent wmTaskContent = JSONUtil.toBean(paramStr, WmTaskContent.class);

        String ipAddr = HttpUtils.getIpAddr(request);
        log.info("提交任务远端IP: [{}]", ipAddr);
        String region = "未知-未知";
        try {
            region = ip2Region.toRegion(ipAddr);
        } catch (Exception e) {
            log.info("ip2Region error", e);
        }

        log.info("提交任务远端地址: [{}]", region);
        log.info("saveTaskContent入参：{}", wmTaskContent);
        Set<String> errorHash = new HashSet<>();
        List<String> ducImgUrl = new ArrayList<>();
        List<String> all = new ArrayList<>();

        String draftKey = wmTaskContent.getDraftKey();
        String taskTypeId = wmTaskContent.getTemp30();

        Integer id = SecurityUtils.getUser().getId();
        Field[] fields = wmTaskContent.getClass().getDeclaredFields();
        for (Field field : fields) {

            field.setAccessible(true);

            try {
                String fieldVal = (String) field.get(wmTaskContent);

                all = duplicateImage(fieldVal, id, errorHash, ducImgUrl, all);
            } catch (Exception ignored) {
            }

        }

        if (CollUtil.isNotEmpty(ducImgUrl)) {
            // 保存图片
            log.info("all size:{}", all.size());
            if (CollUtil.isNotEmpty(all)) {
                all.forEach(hash -> {
                    String key = String.format("%s:%s", id, hash);
                    log.info("key: {}", key);
                    redisTemplate.delete(key);
                });
            }
            return R.failed(ducImgUrl, "提交重复的图片");
        }

        if (CharSequenceUtil.isBlank(wmTaskContent.getTemp30())) {
            return R.failed("任务类型不能为空");
        }

        if (CharSequenceUtil.isBlank(wmTaskContent.getTemp32())) {
            return R.failed("关联积分包不能为空");
        }

        R<?> r = null;
        String locationId = null;
        try {
            r = wmTaskContentService.saveTaskContent(wmTaskContent, ipAddr, region);
        } catch (Exception e) {
            log.error("", e);
            return R.failed(e.getMessage());
        } finally {

            // 清除签到信息
            if (r != null && r.getCode() == CommonConstants.SUCCESS) {
                // 保存打卡记录
                if ("51".equals(wmTaskContent.getTemp30()) || "52".equals(wmTaskContent.getTemp30()) || "53".equals(wmTaskContent.getTemp30())) {

                    // 获取签到key
                    String cacheKey = String.format("user:sign:temp:%s:%s", SecurityUtils.getUser().getId(), wmTaskContent.getTemp9());

                    redisTemplate.delete(cacheKey);
                }
            }


            log.info("结果:{}, 草稿key:{}", r, draftKey);
            if (r != null && r.getCode() == CommonConstants.SUCCESS && CharSequenceUtil.isNotEmpty(draftKey)) {
                String key = String.format(CacheConstants.TASK_CONTENT_DRAFT, taskTypeId, id);
                log.info("删除草稿:{}", key);
                redisTemplate.delete(key);
            }

            if (r == null || (r.getCode() == CommonConstants.FAIL && CollUtil.isNotEmpty(all))) {
                // 保存图片
                log.info("all size:{}", all.size());
                all.forEach(hash -> {
                    String key = String.format("%s:%s", id, hash);
                    log.info("key: {}", key);
                    redisTemplate.delete(key);
                });
            }

            // // 获取签到key
            // if (CharSequenceUtil.isNotBlank(locationId)) {
            //     String cacheKey = String.format("user:sign:temp:%s:%s", id, locationId);
            //     redisTemplate.delete(cacheKey);
            // }

        }

        return r;
    }

    private List<String> duplicateImage(String contentValue, Integer userId, Set<String> errorHash, List<String> duplicateImageUrl, List<String> all) {


        if (contentValue.startsWith("/admin/sys-file/wmkj")) {

            List<String> split = CharSequenceUtil.split(contentValue, StrPool.COMMA);

            List<String> IMG_EXT_NAME = Arrays.asList("png", "jpg", "gif", "jpeg", "tif", "bmp");

            split.forEach(item -> {
                List<String> temp = CharSequenceUtil.split(item, StrUtil.DOT);
                String extName = temp.get(temp.size() - 1);

                if (IMG_EXT_NAME.contains(extName.toLowerCase())) {
                    // 文件md5
                    try {
                        log.info("图片地址:{}", upmsConfig.getClientUrl() + item);
                        byte[] bytes = IOUtils.toByteArray(new URI(upmsConfig.getClientUrl() + item));
                        MessageDigest md5 = MessageDigest.getInstance("MD5");
                        byte[] digest = md5.digest(bytes);
                        String hash = new BigInteger(1, digest).toString(16);
                        log.info("图片md5:{}", hash);
                        boolean aBoolean = Boolean.TRUE.equals(redisTemplate.opsForValue().setIfAbsent(String.format("%s:%s", userId, hash), item));
                        if (!aBoolean) {
                            log.error("上传了重复的图片, hash:{}", hash);
                            errorHash.add(hash);
                            duplicateImageUrl.add(upmsConfig.getClientUrl() + item);
                        } else {
                            all.add(hash);
                            log.info("hash:{}, size:{}, list:{}", hash, all.size(), all);
                        }
                    } catch (IOException | URISyntaxException | NoSuchAlgorithmException e) {
                        log.error("Oops！发生了错误", e);
                    }

                }


            });


        }
        return all;
    }

    /**
     * 保存任务内容
     *
     * @param wmTaskContent 任务内容表
     * @return R
     */
    @SysLog("保存任务内容")
    @PostMapping("/task-content/draft")
    public R<?> taskContentDraft(@RequestBody WmTaskContent wmTaskContent) {

        // 生成草稿key
        String draftKey = IdUtil.fastSimpleUUID();
        log.info("草稿key:{}", draftKey);
        wmTaskContent.setDraftKey(draftKey);

        HnqzUser user = SecurityUtils.getUser();
        String key = String.format(CacheConstants.TASK_CONTENT_DRAFT, wmTaskContent.getTemp30(), user.getId());

        redisTemplate.opsForValue().set(key, JSONUtil.toJsonStr(wmTaskContent), 12, TimeUnit.HOURS);

        return R.ok();
    }

    /**
     * 获取任务草稿
     *
     * @param taskTypeId 任务类型id
     * @return R
     */
    @SysLog("获取任务草稿")
    @GetMapping("/task-content/draft/{task_type_id}")
    public R<?> taskContentDraft(@PathVariable(value = "task_type_id") Integer taskTypeId) {

        HnqzUser user = SecurityUtils.getUser();

        String key = String.format(CacheConstants.TASK_CONTENT_DRAFT, taskTypeId, user.getId());

        String o = (String) redisTemplate.opsForValue().get(key);

        return R.ok(StringUtils.isNotEmpty(o) ? JSONUtil.toBean(o, WmTaskContent.class) : null);
    }


    /**
     * 修改任务内容表
     *
     * @param wmTaskContent 任务内容表
     * @return R
     */
    @SysLog("修改任务内容表")
    @PostMapping("/updateTaskContent")
    public R<?> updateById(@RequestBody WmTaskContent wmTaskContent) {
        return R.ok(wmTaskContentService.updateById(wmTaskContent));
    }

    /**
     * 分页查询
     *
     * @param page        分页对象
     * @param wmWkArticle 文库-文章
     * @return 分页结果
     */
    @GetMapping("/getArticlePage")
    public R<?> getWmWkArticlePage(Page<WmWkArticle> page, WmWkArticle wmWkArticle) {
        WmWkArticle query = new WmWkArticle();
        query.setEnableFlag(0);
        query.setDelFlag(0);
        LambdaQueryWrapper<WmWkArticle> wrapper = Wrappers.query(query).lambda();
        if (StringUtils.isNotEmpty(wmWkArticle.getArea())) {
            wrapper.like(WmWkArticle::getArea, wmWkArticle.getArea());
        }
        if (StringUtils.isNotEmpty(wmWkArticle.getTitle())) {
            wrapper.like(WmWkArticle::getTitle, wmWkArticle.getTitle());
        }
        wrapper.apply("(FIND_IN_SET({0}, source_ent) OR FIND_IN_SET({1}, source_ent))",
                String.valueOf(SecurityUtils.getUser().getDeptId()), "1");
        wrapper.orderByDesc(WmWkArticle::getHotFlag);
        wrapper.orderByDesc(WmWkArticle::getCreateTime);
        IPage<WmWkArticle> pages = wmWkArticleService.page(page, wrapper);

        return R.ok(pages);
    }


    /**
     * 通过id查询文库-文章
     *
     * @param id id
     * @return R
     */
    @GetMapping("/getArticleById")
    public R<?> getArticleById(Integer id) {
        WmWkArticle wmWkArticle = wmWkArticleService.getById(id);
        wmWkArticle.setReadNum(wmWkArticle.getReadNum() + 1);
        return R.ok(wmWkArticle);
    }

    /**
     * 通过id查询文库-相册
     *
     * @param articleId   文章id
     * @param shareUserId 分享人id
     * @param openUserId  获取打开人openid授权码
     * @param type        操作类型
     * @param packageId   积分包id
     * @param sharePicUrl 分享图片链接
     * @return 结果
     */
    @SysLog("文章转发")
    @GetMapping("/shareArticleById")
    public R<?> shareArticleById(String articleId, String shareUserId, String openUserId, String type, String packageId, String sharePicUrl, String remark) {
        return shareAndReadTaskMethod(articleId, shareUserId, openUserId, type, packageId, sharePicUrl, "article", remark);
    }


    /**
     * 分页查询
     *
     * @param page      分页对象
     * @param wmWkAlbum 文库-相册
     * @return 分页结果
     */
    @GetMapping("/getAlbumPage")
    public R<?> getWmWkAlbumPage(Page<WmWkAlbum> page, WmWkAlbum wmWkAlbum, String shareUserId) {

        // 查询当前登录人药企的
        log.info("share_user_id:{}", shareUserId);
        if (StringUtils.isNotEmpty(shareUserId)) {
            WmWkAlbumApiInput input = new WmWkAlbumApiInput();
            SysUser sysUser = sysUserService.getById(shareUserId);
            List<String> drugIds = new ArrayList<>();
            SysDept sysDept = sysDeptService.getById(sysUser.getDeptId());
            if (sysDept.getLevel() == 2) {
                WmDaDrugEnt drugEnt = wmDaDrugEntService.selectByDeptId(sysDept.getDeptId());
                drugIds.add(drugEnt.getId().toString());
            }
            if (sysDept.getLevel() == 3 || sysDept.getLevel() == 4) {

                List<WmDaDrugEnt> entList = wmDaDrugEntService.getListByCsoDeptId(sysDept.getDeptId());

                drugIds.addAll(entList.stream().map(ent -> ent.getId().toString()).collect(Collectors.toList()));
            }

            // 能查到药企
            if (CollectionUtils.isNotEmpty(drugIds)) {
                input.setDrugIds(drugIds);
                Page pageAnswer2 = wmWkAlbumService.pageByCondition(page, input);
                return R.ok(pageAnswer2);
            }
        }

        wmWkAlbum.setDelFlag(0);
        wmWkAlbum.setEnableFlag(0);
        Page<WmWkAlbum> pageAnswer = wmWkAlbumService.page(page, Wrappers.query(wmWkAlbum)
                .lambda()
                .orderByDesc(WmWkAlbum::getCreateTime));
        return R.ok(pageAnswer);
    }

    /**
     * 分页查询
     *
     * @param page      分页对象
     * @param wmWkAlbum 文库-相册
     * @return 分页结果
     */
    @Inner(false)
    @GetMapping("/getAlbumPageNew")
    public R<?> getAlbumPageNew(Page page, WmWkAlbum wmWkAlbum, String shareUserId) {

        // 查询当前登录人药企的

        System.out.println(shareUserId);
        if (StringUtils.isNotEmpty(shareUserId)) {
            WmWkAlbumApiInput input = new WmWkAlbumApiInput();
            SysUser sysUser = sysUserService.getById(shareUserId);
            input.setDeptId(sysUser.getDeptId());
            Page pageAnswer2 = wmWkAlbumService.pageByConditionNew(page, input);
            return R.ok(pageAnswer2);
        }

        wmWkAlbum.setDelFlag(0);
        wmWkAlbum.setEnableFlag(0);
        Page pageAnswer = wmWkAlbumService.page(page, Wrappers.query(wmWkAlbum)
                .lambda()
                .orderByDesc(WmWkAlbum::getCreateTime));

        return R.ok(pageAnswer);
    }


    /**
     * 通过id查询文库-相册
     *
     * @param id id
     * @return R
     */
    @GetMapping("/getAlbumById")
    public R<?> getById(Integer id) {
        WmWkAlbum wmWkAlbum = wmWkAlbumService.getById(id);
        if (null != wmWkAlbum) {
            if (null != wmWkAlbum.getGlyp()) {
                if (wmWkAlbum.getGlyp().indexOf(",") > 0) {
                    String drugTables[] = wmWkAlbum.getGlyp().split(",");
                    List<String> stringList = new ArrayList<>();
                    for (String str : drugTables) {
                        stringList.add(str);
                    }
                    List<WmDaDrugEntDrugtable> wmDaDrugEntDrugtableList = wmDaDrugEntDrugtableService.listByIds(stringList);
                    if (wmDaDrugEntDrugtableList.size() > 0) {
                        String drugStr = "";
                        for (int i = 0; i < wmDaDrugEntDrugtableList.size(); i++) {
                            drugStr += wmDaDrugEntDrugtableList.get(i).getDrugname();
                            if (i < wmDaDrugEntDrugtableList.size() - 1) {
                                drugStr += "、";
                            }
                        }
                        wmWkAlbum.setGlyp(drugStr);
                    }
                } else {
                    WmDaDrugEntDrugtable wmDaDrugEntDrugtable = wmDaDrugEntDrugtableService.getById(wmWkAlbum.getGlyp());
                    if (null != wmDaDrugEntDrugtable) {
                        wmWkAlbum.setGlyp(wmDaDrugEntDrugtable.getDrugname());
                    }
                }
            }
        }
        return R.ok(wmWkAlbum);
    }


    /**
     * 通过id查询文库-相册
     *
     * @param id          相册id
     * @param shareUserId 分享人id
     * @param openUserId  获取打开人openid授权码
     * @param type        操作类型
     * @param packageId   积分包id
     * @param sharePicUrl 分享图片链接
     * @return 结果
     */
    @SysLog("相册转发")
    @GetMapping("/shareAlbumById")
    public R<?> shareAlbumById(String id, String shareUserId, String openUserId, String type, String packageId, String sharePicUrl, String remark) {
        return shareAndReadTaskMethod(id, shareUserId, openUserId, type, packageId, sharePicUrl, "album", remark);
    }


    /**
     * 获取药企列表
     *
     * @return 角色列表
     */
    @GetMapping("/getDrugEntList")
    public R<?> listDrugEnt(WmDaDrugEnt wmDaDrugEnt) {
        System.out.println("SecurityUtils.getUser():" + SecurityUtils.getUser());
        System.out.println("SecurityUtils.getUser().getPlatId():" + SecurityUtils.getUser().getPlatId());

        if (null == SecurityUtils.getUser()) {
            wmDaDrugEnt.setDelFlag("0");
            wmDaDrugEnt.setDelFlag("0");
            return R.ok(wmDaDrugEntService.list(Wrappers.query(wmDaDrugEnt)));
        } else {
            List<SysUser> list = sysUserService.getUserByPlatId(SecurityUtils.getUser().getPlatId());
            if (CollUtil.isNotEmpty(list)) {
                List<String> deptIdList = new ArrayList<>();
                deptIdList.add("-1");
                for (SysUser sysU : list) {
                    UserVO userVO = sysUserService.selectUserVoById(sysU.getUserId());
                    for (SysRole sysRole : userVO.getRoleList()) {
                        if (5 == sysRole.getRoleId() || 6 == sysRole.getRoleId()) {
                            deptIdList.add(sysU.getDrugEntId() + "");
                        }
                    }
                }
                return R.ok(wmDaDrugEntService.listByIds(deptIdList));
            }
        }
        return R.ok();
    }


    public List<WmDaDrugEnt> getDrugListBySecUser(String platId) {
        List<SysUser> list = sysUserService.getUserByPlatId(platId);
        if (CollUtil.isNotEmpty(list)) {
            List<String> deptIdList = new ArrayList<>();
            for (SysUser sysU : list) {
                deptIdList.add(sysU.getDeptId() + "");
            }

            List<String> agentIdList = new ArrayList<>();
            List<SysDept> deptList = sysDeptService.listByIds(deptIdList);
            if (CollUtil.isNotEmpty(deptList)) {
                for (SysDept sysD : deptList) {
                    System.out.println("SysDept:" + sysD.getLevel());

                    if (3 == sysD.getLevel()) {
                        System.out.println("sysD.getLevel2Id():" + sysD.getLevel2Id());
                        agentIdList.add(sysD.getLevel2Id() + "");
                    } else if (4 == sysD.getLevel()) {
                        System.out.println("sysD.getLevel3Id():" + sysD.getLevel3Id());
                        agentIdList.add(sysD.getLevel3Id() + "");
                    }
                }
            }

            if (CollUtil.isNotEmpty(agentIdList)) {
                List<String> drugIdList = new ArrayList<>();
                List<WmDaAgent> wmDaAgentList = wmDaAgentService.listByIds(agentIdList);
                if (CollUtil.isNotEmpty(wmDaAgentList)) {
                    for (WmDaAgent wmDaAgent : wmDaAgentList) {
                        if (null != wmDaAgent.getExtDrugEnt()) {
                            drugIdList.addAll(Arrays.asList(wmDaAgent.getExtDrugEnt().split(",")));
                        }
                        drugIdList.add(wmDaAgent.getDrugEntId());
                    }
                    return wmDaDrugEntService.listByIds(drugIdList);
                }


            }

        }
        return null;
    }


    /**
     * 通过id查询用户签到表
     *
     * @param id id
     * @return R
     */
    @GetMapping("/getSignInfoById")
    public R<?> getSignInfoById(Integer id) {
        return R.ok(wmUserSignService.getById(id));
    }

    /**
     * 新增用户签到表
     *
     * @param paramsStr 用户签到表
     * @return R
     */
    @SysLog("新增用户签到表")
    @PostMapping("/saveSignInfo")
    public R<?> saveSignInfo(@RequestBody String paramsStr) {
        log.info("精细化拜访(医院/药店/商业公司打卡)参数:{}", paramsStr);

        WmUserSign wmUserSign = JSONUtil.toBean(paramsStr, WmUserSign.class);

        Boolean absent = redisTemplate.opsForValue().setIfAbsent("save_sign_info:user_id:" + wmUserSign.getSignUserid(), paramsStr, 5, TimeUnit.SECONDS);
        if (Boolean.FALSE.equals(absent)) {
            return R.failed("时间间隔太短，请5秒后重试");
        }

        // 重置打卡时间，以系统为准，规避端设备时间不准的问题
        LocalDateTime now = LocalDateTime.now().plusMinutes(5L);
        if (wmUserSign.getSignDate().isAfter(now)) {
            return R.failed("打卡时间异常，请检查设备日期");
        }

        if (null == wmUserSign.getLatitude() || null == wmUserSign.getLongitude()) {
            return R.failed("签到经纬度不能为空");
        }

        return wmUserSignService.saveWmUserSign(wmUserSign);
    }


    /**
     * 获取药企列表
     *
     * @return 角色列表
     */
    @GetMapping("/getSignListByUserId")
    public R<?> listDrugEnt(WmUserSign wmUserSign) {
        return R.ok(wmUserSignService.list(Wrappers.query(wmUserSign)));
    }


    /**
     * 获取药企列表
     *
     * @return 角色列表
     */
    @GetMapping("/getHospitalList")
    public R<?> getHospitalList() {
        return R.ok(wmDaHospitalService.list(Wrappers.emptyWrapper()));
    }

    /**
     * 小程序领取任务包（积分包）列表
     *
     * @return 积分包列表
     */
    @SysLog("小程序领取任务包（积分包）列表")
    @GetMapping("/getUserScorePackageList2")
    public R<?> getUserScorePackageList2(Page page, int selType, String packageName, String selDate, String activeId) {

        UserVO userVO = sysUserService.selectUserVoById(SecurityUtils.getUser().getId());

        List<WmScorePackageApiOutput> scorePackageList;
        if (1 == selType && isZbRole(userVO.getRoleList(), 5)) {
            return R.ok();
        }

        IPage<WmScorePackageApiOutput> scorePage;
        // 小程序角色:5-全职学术信息沟通专员, 6-兼职学术信息沟通专员, 10-兼职CRC, 13-HCP
        if (1 == selType && (isZbRole(userVO.getRoleList(), 6) || isZbRole(userVO.getRoleList(), 10) || isZbRole(userVO.getRoleList(), 13))) {
            WmScorePackage query = new WmScorePackage();
            query.setDeptId(userVO.getDeptId() + "");
            query.setTypeid("4");
            query.setScorePackageName(packageName);
            query.setBelongDate(selDate);
            query.setZbId(userVO.getUserId() + "");
            scorePage = wmScorePackageService.getPackageListForReceive(page, query);
            scorePackageList = scorePage.getRecords();

            // 获取积分包的关联试卷
            Map<Integer, Set<Integer>> quizMap = null;
            if (CollUtil.isNotEmpty(scorePackageList)) {
                Set<String> drugIds = scorePackageList.stream().flatMap(sp -> Arrays.stream(sp.getDrugtable())).collect(Collectors.toSet());
                List<WmDrugQuizRelation> relations = drugQuizRelationService.list(Wrappers.<WmDrugQuizRelation>lambdaQuery().in(WmDrugQuizRelation::getDrugId, drugIds));

                quizMap = relations.stream().collect(Collectors.groupingBy(WmDrugQuizRelation::getDrugId, Collectors.mapping(WmDrugQuizRelation::getQuizId, Collectors.toSet())));

            }

            for (WmScorePackageApiOutput item : scorePackageList) {
                WmScorePackageStatus queryGetUser = new WmScorePackageStatus();
                queryGetUser.setPackageId(item.getId());
                queryGetUser.setStatus("2");
                queryGetUser.setDelFlag("0");
                queryGetUser.setEnableFlag("0");
                item.setUserGetNum(wmScorePackageStatusService.count(Wrappers.query(queryGetUser)));

                if (PackageTypeEnum.TYPE1_HCP_PACKAGE.val().equals(item.getPackageType1()) && item.getScore() != null) {
                    // 如果是患者教育，则转换积分 '分'->'元'
                    item.setScore(String.format("%.2f", Integer.parseInt(item.getScore()) / 100.0));
                }

                String[] drugtable = item.getDrugtable();
                if (CollUtil.isNotEmpty(quizMap) && ArrayUtil.isNotEmpty(drugtable)) {
                    Set<Integer> integers = quizMap.get(Integer.valueOf(drugtable[0]));
                    item.setQuizIds(integers);
                }
            }
            return R.ok(scorePage);
        }

        if (2 == selType) {
            WmScorePackageApiInput input = new WmScorePackageApiInput();
            input.setScorePackageName(packageName);
            input.setSelDate(selDate);
            input.setUserId(userVO.getUserId() + "");
            if (isZbRole(userVO.getRoleList(), 5)) {
                // 小程序角色:5-全职学术信息沟通专员
                input.setTypeid("3");

                if ("2".equals(activeId)) {
                    input.setTaskAddFlag("1");
                    input.setStatus("2");
                } else if ("3".equals(activeId)) {
                    return R.ok();
                } else if ("4".equals(activeId)) {
                    input.setStatus("2");
                    input.setTaskAddFlag("0");
                }
            } else if (isZbRole(userVO.getRoleList(), 31)) {
                // 小程序角色:31-招商经理
                input.setTypeid("5");

                if ("2".equals(activeId)) {
                    input.setTaskAddFlag("1");
                    input.setStatus("2");
                } else if ("3".equals(activeId)) {
                    return R.ok();
                } else if ("4".equals(activeId)) {
                    input.setStatus("2");
                    input.setTaskAddFlag("0");
                }
            } else if (isZbRole(userVO.getRoleList(), 6) || isZbRole(userVO.getRoleList(), 10)
                    || isZbRole(userVO.getRoleList(), 13)) {
                // 小程序角色:6-兼职学术信息沟通专员, 10-兼职CRC, 13-HCP
                input.setTypeid("4");

                if ("2".equals(activeId)) {
                    input.setTaskAddFlag("1");
                    input.setStatus("2");
                } else if ("3".equals(activeId)) {
                    input.setTaskAddFlag("1");
                    input.setStatus("1");
                } else if ("4".equals(activeId)) {
                    input.setStatus("2");
                    input.setTaskAddFlag("0");
                }
            } else {
                return R.ok();
            }

            scorePage = wmScorePackageStatusService.getReceivedPackageList(page, input);

            scorePackageList = scorePage.getRecords();

            // 获取积分包的关联试卷
            Map<Integer, Set<Integer>> quizMap = null;
            if (CollUtil.isNotEmpty(scorePackageList)) {
                Set<String> drugIds = scorePackageList.stream().flatMap(sp -> Arrays.stream(sp.getDrugtable())).collect(Collectors.toSet());
                List<WmDrugQuizRelation> relations = drugQuizRelationService.list(Wrappers.<WmDrugQuizRelation>lambdaQuery().in(WmDrugQuizRelation::getDrugId, drugIds));

                quizMap = relations.stream().collect(Collectors.groupingBy(WmDrugQuizRelation::getDrugId, Collectors.mapping(WmDrugQuizRelation::getQuizId, Collectors.toSet())));

            }


            if (CollectionUtils.isNotEmpty(scorePackageList)) {
                Set<String> scorePackageIds = scorePackageList.stream()
                        .filter(output -> PackageTypeEnum.TYPE1_SCOTE_PACKAGE.val().equals(output.getPackageType1()))
                        .map(WmScorePackageApiOutput::getId).collect(Collectors.toSet());
                Map<String, List<WmScorePackageSettleNote>> settelMap = new HashMap<>();

                for (WmScorePackageApiOutput item : scorePackageList) {

                    String[] drugtable = item.getDrugtable();
                    if (CollUtil.isNotEmpty(quizMap) && ArrayUtil.isNotEmpty(drugtable)) {
                        Set<Integer> integers = quizMap.get(Integer.valueOf(drugtable[0]));
                        item.setQuizIds(integers);
                    }

                    if (PackageTypeEnum.TYPE1_SCOTE_PACKAGE.val().equals(item.getPackageType1())) {
                        // 只处理积分包的情况
                        List<WmScorePackageSettleNote> settleNoteList = settelMap.get(item.getId());
                        if (CollUtil.isNotEmpty(settleNoteList)) {
                            WmScorePackageSettleNote settleNote = settleNoteList.get(0);
                            item.setNotifyTime(settleNote.getNotifyTime());
                            item.setSettleNoteStatus(String.valueOf(settleNote.getSettleNoteStatus()));
                        }
                    }

                    WmScorePackageStatus queryGetUser = new WmScorePackageStatus();
                    queryGetUser.setPackageId(item.getId());
                    queryGetUser.setStatus("2");
                    queryGetUser.setDelFlag("0");
                    queryGetUser.setEnableFlag("0");
                    item.setUserGetNum(wmScorePackageStatusService.count(Wrappers.query(queryGetUser)));

                    if (PackageTypeEnum.TYPE1_HCP_PACKAGE.val()
                            .equals(item.getPackageType1()) && item.getScore() != null) {
                        // 如果是患者教育，则转换积分 '分'->'元'
                        item.setScore(String.format("%.2f", Integer.parseInt(item.getScore()) / 100.0));
                    }

                    WmTask wmTask = new WmTask();
                    wmTask.setScorePackageId(item.getId());
                    wmTask.setTaskUserId(userVO.getUserId() + "");
                    wmTask.setRealFlag("0");
                    List<WmTask> wmTaskList = wmTaskService.list(Wrappers.query(wmTask)
                            .lambda()
                            .eq(WmTask::getRealFlag, "0")
                            .eq(WmTask::getDelFlag, DelEnum.NOT_DEL.getVal())
                            .ne(WmTask::getTaskStatus, "4"));
                    item.setTaskFinishNum(wmTaskList.size());
                    item.setSpeedProgress(0);
                    item.setFinishScore(0);
                    item.setWaitApprovalScore(0);
                    item.setWaitApprovalTaskNum(0);
                    if ("3".equals(item.getStatus())) {
                        item.setTaskAddFlag("1");
                        continue;
                    }

                    if (CharSequenceUtil.equals(PackageTypeEnum.TYPE1_SCOTE_PACKAGE.val(), item.getPackageType1())
                            || CharSequenceUtil.equals(PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val(), item.getPackageType1())) {
                        Integer finishScore = 0;
                        Integer waitApprovalScore = 0;
                        for (WmTask task : wmTaskList) {
                            finishScore += task.getScore();
                            if ("2".equals(task.getTaskStatus())) {
                                waitApprovalScore += task.getScore();
                            }
                        }
                        item.setFinishScore(finishScore);
                        item.setWaitApprovalScore(waitApprovalScore);
                        if (StringUtils.isNumeric(item.getScore()) && Integer.parseInt(item.getScore()) > 0) {
                            double d = Math.ceil(finishScore * 100 / Integer.parseInt(item.getScore()));
                            if (d > 100) {
                                d = 100;
                            }
                            item.setSpeedProgress(new Double(d).intValue());
                        }
                    } else {
                        Integer waitApprovalTaskNum = 0;
                        double d = Math.ceil(wmTaskList.size() * 100 / item.getTaskNum());
                        if (d > 100) {
                            d = 100;
                        }
                        for (WmTask task : wmTaskList) {
                            if ("2".equals(task.getTaskStatus())) {
                                waitApprovalTaskNum++;
                            }
                        }
                        item.setWaitApprovalTaskNum(waitApprovalTaskNum);
                        item.setSpeedProgress(new Double(d).intValue());
                    }


                }
            }
            return R.ok(scorePage);

        }

        return R.ok();

    }

    /**
     * 通过id查询积分包
     *
     * @param id id
     * @return R
     */
    @GetMapping("/getScorePackageInfoById")
    public R<?> getScorePackageInfoById(String id) {

        Map<String, Object> map = new HashMap<>();


        WmScorePackage wms = wmScorePackageService.getById(id);


        SysDept dept = sysDeptService.getById(wms.getSendPackageDeptId());
        map.put("packageEntName", dept.getName());
        map.put("packageEntId", dept.getDeptId());

        String issueDate = wms.getStartTime().format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
        String expireDate = wms.getEndTime().format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
        map.put("termDate", issueDate + " 至 " + expireDate);

        map.put("status", wms.getPackageStatus());
        map.put("packageName", wms.getScorePackageName());
        if (PackageTypeEnum.TYPE1_HCP_PACKAGE.val().equals(wms.getPackageType1())) {
            // 如果是患者教育，则需要转换积分包单位 ‘分’->‘元’
            map.put("score", String.format("%.2f", wms.getScore() / 100.0) + "分");
        } else {
            map.put("score", wms.getScore() + "分");
        }
        map.put("userNum", wms.getUserNum());
        map.put("createTime", wms.getCreateTime());
        map.put("packageType1", wms.getPackageType1());
        map.put("id", wms.getId());
        map.put("finishScore", "0");

        WmScorePackageStatus wmScorePackageStatus = new WmScorePackageStatus();
        wmScorePackageStatus.setUserId(SecurityUtils.getUser().getId() + "");
        wmScorePackageStatus.setPackageId(id);
        wmScorePackageStatus.setDelFlag("0");
        wmScorePackageStatus.setEnableFlag("0");
        List<WmScorePackageStatus> statusList = wmScorePackageStatusService.
                list(Wrappers.query(wmScorePackageStatus).lambda().ne(WmScorePackageStatus::getStatus, "3"));

        if (CollectionUtils.isNotEmpty(statusList)) {
            map.put("receiveFlag", 0);
            if (wms.getTaskNum() == null) {
                map.put("taskNum", statusList.size() + "个");
            }
        } else {
            map.put("receiveFlag", 1);
            if (wms.getTaskNum() == null) {
                map.put("taskNum", "0个");
            }
        }

        // 判断是否可导出任务明细
        WmTask wmTask = new WmTask();
        wmTask.setScorePackageId(id);
        wmTask.setTaskStatus("3");
        int count = wmTaskService.count(Wrappers.query(wmTask));
        if (count > 0) {
            map.put("exportFlag", "1");
        } else {
            map.put("exportFlag", "0");
        }
        map.put("email", redisTemplate.opsForValue()
                .get(CacheConstants.EMAIL_KEY + SecurityUtils.getUser().getPlatId()));

        if ("1".equals(wms.getEnableFlag())) {
            map.put("receiveFlag", 0);
        }
        if (!"0".equals(wms.getEnableType())) {
            map.put("receiveFlag", 0);
        }

        return R.ok(map);
    }

    /**
     * 小程序领取积分包
     *
     * @param resource 积分包信息
     * @return 领取结果
     */
    @PostMapping("/pkg/pickup")
    @Transactional(rollbackFor = Exception.class)
    public R<?> receivePackage(@Valid @RequestBody WmPkgDTO.OnPkgPickup resource) {
        log.info("小程序领取积分包参数:{}", resource);

        String pkgId = resource.getPkgId();
        WmScorePackage wmScorePackage = wmScorePackageService.getById(pkgId);
        if (null == wmScorePackage) {
            return R.failed("积分包不存在");
        }

        if (!"0".equals(wmScorePackage.getEnableType())) {

            return R.failed("积分包剩余积分值已收回，不能领取");
        }

        if ("1".equals(wmScorePackage.getEnableFlag())) {
            return R.failed("积分包已终止，不能领取");
        }

        if ("1".equals(wmScorePackage.getIsReceive())) {
            return R.failed("积分包不能领取");
        }

        Integer userId = SecurityUtils.getUser().getId();
        log.info("当前领包人userId={}", userId);
        UserVO userVO = sysUserService.selectUserVoById(userId);

        if (null == userVO) {
            return R.failed("账号出错");
        }

        if (isZbRole(userVO.getRoleList(), 5)) {
            return R.failed("全职学术推广员不能领取积分包");
        }

        // 校验超过60周岁,不能做任务
        Map<String, String> checkResult = sysUserService.checkSixtyYearsOld(userVO);
        if (CollUtil.isNotEmpty(checkResult) && checkResult.containsKey("OVER")) {
            throw new RuntimeException(checkResult.get("OVER"));
        }

        // 校验是否已经领取

        int count = wmScorePackageStatusService.count(Wrappers.<WmScorePackageStatus>lambdaQuery()
                .eq(WmScorePackageStatus::getPackageId, pkgId)
                .eq(WmScorePackageStatus::getUserId, userVO.getUserId().toString())
                .eq(WmScorePackageStatus::getDelFlag, "0")
                .eq(WmScorePackageStatus::getEnableFlag, "0")
                .ne(WmScorePackageStatus::getStatus, 3)
        );

        if (count > 0) {
            return R.failed("积分包已领取");
        }

        // 校验企业是否开启了认证前置, 开启后则校验认证前置,否则不校验
        SysDept sysDept = sysDeptService.getById(userVO.getDeptId());
        if (ArrayUtil.contains(sysDept.getDeptPermissions(), DeptPermissionEnum.PRE_CERT.getVal())) {
            // 校验是否已经认证
            List<SysUserSub> userSubList = sysUserSubService.list(Wrappers.<SysUserSub>lambdaQuery()
                    .eq(SysUserSub::getDeptId, userVO.getDeptId())
                    .eq(SysUserSub::getUserId, userId));
            if (CollUtil.isEmpty(userSubList)) {
                return R.ok(1, "该积分包需要认证成功后才能领取，请点击“去认证”完成认证");
            }
            //// 该企业下只要有一个渠道是 “已核身/已认证”就可以领包
            // boolean certNoMatch = userSubList.stream().noneMatch(userSub -> Arrays.asList(1, 15).contains(userSub.getCertStatus())
            //		|| (userSub.getCertStatus().equals(2) && GigCallBackStatus.IN_PROGRESS.equals(userSub.getCallbackStatus())));
            // if (certNoMatch) {
            //	return R.ok(1, "该积分包需要认证成功后才能领取，请点击“去认证”完成认证");
            //}
        }

        // 封装结果
        WmScorePackageStatus wmScorePackageStatus = new WmScorePackageStatus();
        wmScorePackageStatus.setPackageId(pkgId);
        wmScorePackageStatus.setUserId(userVO.getUserId().toString());
        wmScorePackageStatus.setDelFlag("0");
        wmScorePackageStatus.setEnableFlag("0");
        wmScorePackageStatus.setStatus("1");
        wmScorePackageStatus.setTaskAddFlag("1");
        if (PackageTypeEnum.TYPE1_SCOTE_PACKAGE.val().equals(wmScorePackage.getPackageType1()) || PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val().equals(wmScorePackage.getPackageType1())) {
            wmScorePackageStatus.setUserScore(wmScorePackage.getScore().toString());
        } else {
            wmScorePackageStatus.setUserScore(wmScorePackage.getUserScore());
        }
        wmScorePackageStatus.setTaskNum(wmScorePackage.getTaskNum());
        wmScorePackageStatus.setDeptId(userVO.getDeptId().toString());
        LocalDateTime localDateTime = LocalDateTime.now();
        wmScorePackageStatus.setCreateTime(localDateTime);
        wmScorePackageStatus.setUpdateTime(localDateTime);
        wmScorePackageStatus.setQuizResult(resource.getQuizResults());

        boolean saved = wmScorePackageStatusService.save(wmScorePackageStatus);

        // 更新积分包状态
        WmScorePackage updateScorePackage = new WmScorePackage();
        updateScorePackage.setId(pkgId);
        updateScorePackage.setScorePackageStatus(ScorePackageStatusEnum.PENDING_APPROVAL.val());
        updateScorePackage.setIsConduct("1");
        wmScorePackageService.updateById(updateScorePackage);

        // code为0时, data的取值含义
        // 0-领包成功
        // 1-需要认证
        // 2-其他失败
        return saved ? R.ok(0, "领取积分包成功") : R.failed(2, "领取积分包失败");

    }

    /**
     * 根据积分包获取任务列表
     *
     * @return 根据积分包获取任务列表
     */
    @GetMapping("/getTaskListByPackageId")
    public R<?> getTaskListByPackageId(Page page, WmTask wmTask) {

        Page<WmTask> taskPage = wmTaskService.page(page,
                Wrappers.<WmTask>lambdaQuery()
                        .eq(WmTask::getScorePackageId, wmTask.getScorePackageId())
                        .eq(WmTask::getTaskUserId, wmTask.getTaskUserId())
                        .ne(WmTask::getScore, 0)
                        .eq(WmTask::getRealFlag, "0")
                        .eq(WmTask::getDelFlag, DelEnum.NOT_DEL.getVal())
                        .orderByDesc(WmTask::getCreateTime));

        List<WmTask> wmTaskList = taskPage.getRecords();

        List<WmTaskType> wmTaskTypeList = wmTaskTypeService.
                list(Wrappers.<WmTaskType>lambdaQuery().eq(WmTaskType::getTaskTypeLevel, "1"));

        Map<String, String> typeMap = wmTaskTypeList.stream()
                .collect(Collectors.toMap(WmTaskType::getId, WmTaskType::getTaskTypeName));

        for (int i = 0; i < wmTaskList.size(); i++) {
            wmTaskList.get(i).setTaskTypeId(typeMap.get(wmTaskList.get(i).getTaskTypeId()));
        }
        taskPage.setRecords(wmTaskList);

        return R.ok(taskPage);
    }


    /**
     * 小程序查询当前人的任务记录
     *
     * @param page   分页参数
     * @param wmTask 条件
     * @return 任务分页列表
     */
    @GetMapping("/getHistoryTaskList")
    public R<IPage<WmTask>> getNewHistoryTaskList(Page<WmTask> page, WmTask wmTask) {
        Integer userId = SecurityUtils.getUser().getId();

        LambdaQueryWrapper<WmTask> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper.eq(WmTask::getTaskUserId, userId);
        queryWrapper.ne(WmTask::getScore, 0);
        queryWrapper.orderByDesc(WmTask::getCreateTime);
        if (CharSequenceUtil.isNotBlank(wmTask.getTaskRuleId())) {
            queryWrapper.like(WmTask::getLookintoDate, wmTask.getTaskRuleId());
        }

        wmTaskService.page(page, queryWrapper);

        if (CollUtil.isNotEmpty(page.getRecords())) {
            Set<String> tasktypeIds = page.getRecords().stream().map(WmTask::getTaskTypeId).collect(Collectors.toSet());
            List<WmTaskType> taskTypes = wmTaskTypeService.listByIds(tasktypeIds);
            Map<String, String> taskTypeMap = taskTypes.stream().collect(Collectors.toMap(WmTaskType::getId, WmTaskType::getTaskTypeName));

            page.getRecords().forEach(record -> {
                record.setTaskTypeName(taskTypeMap.get(record.getTaskTypeId()));
                record.setTaskTypeId(taskTypeMap.get(record.getTaskTypeId()));
            });
        }

        return R.ok(page);
    }

    /**
     * 小程序查询当前人的任务记录(已弃用,改为调用getNewHistoryTaskList接口)
     *
     * @param page   分页参数
     * @param wmTask 条件
     * @return 任务分页列表
     */
    @Deprecated
    @GetMapping("/getHistoryTaskList1")
    public R<?> getHistoryTaskList1(Page page, WmTask wmTask) {
        wmTask.setEnableFlag("0");
        wmTask.setDelFlag("0");
        UserDTO userDTO = new UserDTO();
        userDTO.setPlatId(SecurityUtils.getUser().getPlatId());
        List<UserVO> userVOList = sysUserService.getUserVoByPlatId(userDTO);
        Page<WmTask> taskPage;
        LambdaQueryWrapper<WmTask> queryWrapper = Wrappers.lambdaQuery();

        int num = 0;
        int allnum = 0;
        for (UserVO userVO : userVOList) {

            if (null != wmTask.getTaskRuleId() && !"".equals(wmTask.getTaskRuleId())) {
                WmTaskRule wmTaskRule = new WmTaskRule();
                wmTaskRule.setRuleMonth(wmTask.getTaskRuleId());
                wmTaskRule.setDrugentId(userVO.getDrugEntId());
                List<WmTaskRule> wmTaskRuleList = wmTaskRuleService.list(Wrappers.query(wmTaskRule));
                if (CollUtil.isNotEmpty(wmTaskRuleList)) {
                    if (num == 0) {
                        queryWrapper.and(
                                Wrapper -> Wrapper.eq(WmTask::getTaskRuleId, wmTaskRuleList.get(0).getId())
                                        .eq(WmTask::getTaskUserId, userVO.getUserId() + "")
                        );
                    } else {
                        queryWrapper.or(
                                Wrapper -> Wrapper.eq(WmTask::getTaskRuleId, wmTaskRuleList.get(0).getId())
                                        .eq(WmTask::getTaskUserId, userVO.getUserId() + "")
                        );
                    }

                } else {
                    queryWrapper.eq(WmTask::getTaskRuleId, "-100");
                }
                num++;

            } else {
                if (allnum == 0) {
                    queryWrapper.and(Wrapper -> Wrapper.eq(WmTask::getTaskUserId, userVO.getUserId()));
                } else {
                    queryWrapper.or(Wrapper -> Wrapper.eq(WmTask::getTaskUserId, userVO.getUserId()));
                }
                allnum++;

            }
        }

        queryWrapper.ne(WmTask::getScore, 0);
        queryWrapper.orderByDesc(WmTask::getCreateTime);
        taskPage = wmTaskService.page(page, queryWrapper);
        List<WmTask> wmTaskList = taskPage.getRecords();

        for (int i = 0; i < wmTaskList.size(); i++) {
            WmTaskType wmTaskType = wmTaskTypeService.getById(wmTaskList.get(i).getTaskTypeId());
            if (null != wmTaskType) {
                wmTaskList.get(i).setTaskTypeId(wmTaskType.getTaskTypeName());
            }
        }
        taskPage.setRecords(wmTaskList);

        return R.ok(taskPage);
    }


    /**
     * 新增任务内容表
     *
     * @param taskId 任务内容表
     * @return R
     */
    @SysLog("任务-根据ID获取任务")
    @GetMapping("/getTaskInfoById")
    public R<?> getTaskInfoById(String taskId) {
        Map<String, Object> map = new HashMap<>();
        WmTask wmTask = wmTaskService.getById(taskId);
        if (null != wmTask) {
            map.put("taskType", wmTask.getTaskTypeId());
            WmTaskType wmTaskType = wmTaskTypeService.getById(wmTask.getTaskTypeId());
            map.put("taskInfo", wmTask);
            WmTaskContent wmTaskContent = wmTaskContentService.getById(wmTask.getTaskContentId());
            if (null != wmTaskContent) {
                WmScorePackage wmScorePackage = wmScorePackageService.getById(wmTask.getScorePackageId());
                if (null != wmScorePackage) {
                    wmTaskContent.setTemp32(wmScorePackage.getScorePackageName());
                }
                // 设置地图地址
                if ("30".equals(wmTask.getTaskTypeId()) || "15".equals(wmTask.getTaskTypeId())) {
                    wmTaskContent.setTemp31(wmTaskContent.getTemp16());
                }
                if ("16".equals(wmTask.getTaskTypeId())) {
                    wmTaskContent.setTemp31(wmTaskContent.getTemp4());
                }
                if (CharSequenceUtil.isNotBlank(wmTaskContent.getTemp24())) {
                    WmDaHospital hospital = wmDaHospitalService.getById(wmTaskContent.getTemp24());
                    if (hospital != null) {
                        wmTaskContent.setTemp24label(hospital.getYymc());
                    }
                }
            }
            map.put("wmTaskContent", wmTaskContent);

            if ("8".equals(wmTask.getTaskTypeId()) || "11".equals(wmTask.getTaskTypeId()) || "9".equals(wmTask.getTaskTypeId()) || "10"
                    .equals(wmTask.getTaskTypeId())) {
                map.put("title", "");
                WmWkArticleShare wmWkArticleShare = wmWkArticleShareService.getById(wmTask.getTaskContentId());
                if (null != wmWkArticleShare) {
                    if ("8".equals(wmTask.getTaskTypeId()) || "11".equals(wmTask.getTaskTypeId())) {
                        WmWkAlbum wmWkAlbum = wmWkAlbumService.getById(wmWkArticleShare.getArctileId());
                        map.put("title", wmWkAlbum.getXcmc());
                    } else {
                        WmWkArticle wmWkArticle = wmWkArticleService.getById(wmWkArticleShare.getArctileId());
                        map.put("title", wmWkArticle.getTitle());
                    }
                }
                map.put("score", wmTask.getScore());
                map.put("shareId", wmWkArticleShare.getArctileId());
                map.put("remark", wmWkArticleShare.getTemp1());

            }

            if ("33".equals(wmTask.getTaskTypeId()) || "73".equals(wmTask.getTaskTypeId())) {
                map.put("taskType", "33");
            }

            if (null != wmTaskType) {
                wmTask.setTaskTypeId(wmTaskType.getTaskTypeName());
            }
        }
        return R.ok(map);
    }


    /**
     * 通过id查询用户签到表
     *
     * @param id id
     * @return R
     */
    @GetMapping("/getSignInfoByTaskId")
    public R<?> getSignInfoByTaskId(Integer id) {
        WmTask wmTask = wmTaskService.getById(id);
        if (null != wmTask) {
            if (null != wmTask.getTaskContentId()) {
                WmTaskContent wmTaskContent = wmTaskContentService.getById(wmTask.getTaskContentId());

                if (null != wmTaskContent) {
                    if (null != wmTaskContent.getTemp3()) {
                        List<WmUserSign> wmUserSignList = new ArrayList<>();
                        WmUserSign userSign = wmUserSignService.getById(wmTaskContent.getTemp3());
                        // 如果配置了医院拜访的任务类型模板，则关联查询签到详情
//						if (wmDeptTaskTypeTemplateService.checkDeptIdHospitalTemplate(Integer.valueOf(wmTask.getDeptId()), wmTask.getTaskTypeId())) {
                        WmUserSignDetail userSignDetail = wmUserSignDetailService.getOne(Wrappers.<WmUserSignDetail>lambdaQuery()
                                .eq(WmUserSignDetail::getSignId, userSign.getId()));
                        if (userSignDetail != null) {
                            if (ArrayUtil.isNotEmpty(userSignDetail.getPurpose())) {
                                List<Integer> purposeList = Stream.of(userSignDetail.getPurpose())
                                        .map(Integer::parseInt)
                                        .collect(Collectors.toList());
                                String dictType = null;
                                switch (userSign.getSignEntType()) {
                                    case "1":
                                        dictType = "user_sign_detail_purpose";
                                        break;
                                    case "2":
                                        dictType = "user_sign_detail_distribution_purpose";
                                        break;
                                    case "3":
                                        dictType = "user_sign_detail_pharmacy_purpose";
                                        break;
                                    default:
                                        dictType = "";
                                }
                                List<SysDictItem> itemList = sysDictItemService.list(Wrappers.<SysDictItem>lambdaQuery()
                                        .in(SysDictItem::getValue, purposeList)
                                        .eq(SysDictItem::getType, dictType)
                                        .eq(SysDictItem::getDelFlag, DelEnum.NOT_DEL.getVal()));
                                if (CollUtil.isNotEmpty(itemList)) {
                                    String[] purposeNameArr = itemList.stream()
                                            .map(SysDictItem::getLabel)
                                            .toArray(String[]::new);
                                    userSignDetail.setPurposeName(purposeNameArr);
                                }
                            }
                            if (CharSequenceUtil.isNotBlank(userSignDetail.getResult())) {
                                userSignDetail.setResultName(Objects.requireNonNull(UserSignResultEnum.resolve(userSignDetail.getResult())).getName());
                            }

                            // 医院打卡, 兼容历史字段department
                            if ("1".equals(userSign.getSignEntType())) {
                                if (CollUtil.isEmpty(userSignDetail.getDetail()) && ArrayUtil.isNotEmpty(userSignDetail.getDepartment())) {
                                    List<Map<String, Object>> detail = new ArrayList<>();
                                    for (String dep : userSignDetail.getDepartment()) {
                                        Map<String, Object> detailMap = new HashMap<>();
                                        detailMap.put("departmentName", dep);
                                        detailMap.put("fileUrl", new String[0]);
                                        detail.add(detailMap);
                                    }
                                    userSignDetail.setDetail(detail);
                                }
                                userSignDetail.setDepartment(null);
                            }

                            userSign.setUserSignDetail(userSignDetail);
                        }
//						}

                        // 查询适配, 普通药店和连锁药房统一返回33
                        if ("3".equals(userSign.getSignEntType())) {
                            // 根据药店类型 区分任务类型33-普通药店/73-连锁药房
                            WmDaPharmacy daPharmacy = wmDaPharmacyService.getById(userSign.getSignEntId());
                            if (daPharmacy == null) {
                                throw new BizException("药店不存在或已停用");
                            }

                            String taskTypeId;
                            switch (daPharmacy.getPharmacyType()) {
                                case ORDINARY:
                                    taskTypeId = "33";
                                    break;
                                case CHAIN:
                                    taskTypeId = "73";
                                    break;
                                default:
                                    taskTypeId = "33";
                            }
                            wmTask.setTaskTypeId(taskTypeId);
                        }

                        wmUserSignList.add(userSign);
                        return R.ok(wmUserSignList);
                    }
                }
            }
        }
        return R.ok();
    }

    /**
     * 新增任务内容表
     *
     * @return R
     */
    @GetMapping("/getQrCodeByUrl")
    public R<?> getQrCodeByUrl(String url, int width, int height) throws FileNotFoundException {

        String QR_CODE_IMAGE_PATH = OsEnvUtils.getEachEnvPaths().get("EXCEL_FILE_PATH") + "out/" + UUID.randomUUID() + ".png";
        try {
            QRCodeGenerator.generateQRCodeImage(url, width, height, QR_CODE_IMAGE_PATH);
        } catch (WriterException | IOException e) {
            e.printStackTrace();
        }
        File imageFile = new File(QR_CODE_IMAGE_PATH);
        FileInputStream in = new FileInputStream(imageFile);
        MultipartFile file = null;
        R r = null;
        try {
            file = new MockMultipartFile("file", imageFile.getName(), "text/plain", IOUtils.toByteArray(in));
            r = sysFileService.uploadFile(file);

            // 删除缓存文件
            in.close();
            imageFile.delete();
        } catch (IOException e) {
            e.printStackTrace();
        }

        return R.ok(r);
    }


    /**
     * 修改用户信息接口
     *
     * @return R
     */
    @SysLog("修改用户信息接口")
    @PostMapping("/updateUserInfo")
    public R<?> updateUserInfo(@RequestBody UserUpdateInput userUpdateInput) {

        List<SysUser> list = sysUserService.getUserByPlatId(SecurityUtils.getUser().getPlatId());
        Optional<SysUser> userOptional = list.stream()
                .filter(user -> StringUtils.equals(String.valueOf(user.getUserId()), userUpdateInput.getUserId()))
                .findAny();

        if (!userOptional.isPresent()) {
            return R.failed("只能修改自己的用户信息");
        }

        SysUser sysUser = sysUserService.getById(userUpdateInput.getUserId());

        // 获取更新操作的用户角色
        List<Integer> roles = SecurityUtils.getRoles();
        int ageByIdCard;
        // 如果角色中包含全职和兼职就需要校验身份证年龄
        if (roles.contains(5) || roles.contains(6)) {
            // 校验身份证上的年龄
            if (StringUtils.isNotEmpty(userUpdateInput.getIdCardNumber())) {
                ageByIdCard = IdcardUtil.getAgeByIdCard(userUpdateInput.getIdCardNumber());
                if (ageByIdCard < 18) {
                    return R.failed("年龄未满十八");
                }
            }
        }

        sysUser.setAvatar(userUpdateInput.getAvatar());

        // 姓名去除空格（包括字符之间的所有空格都会去除）
        sysUser.setRealname(CharSequenceUtil.cleanBlank(userUpdateInput.getRealname()));
        sysUser.setUserSign(userUpdateInput.getUserSign());
        sysUserService.updateById(sysUser);


        return R.ok();
    }


    /**
     * 修改意见反馈
     *
     * @param wmFeedback 意见反馈
     * @return R
     */
    @SysLog("修改意见反馈")
    @PostMapping("/saveFeedBack")
    public R<?> saveFeedBack(@RequestBody WmFeedback wmFeedback) {
        return R.ok(wmFeedbackService.save(wmFeedback));
    }


    /**
     * 新增任务内容表
     *
     * @return R
     */
    @SysLog("分享名片接口")
    @GetMapping("/shareUserCard")
    public R<?> shareUserCard(String imgUrl) {
        int socre = 0;
        SysUser sysUser = sysUserService.getById(SecurityUtils.getUser().getId());

        List<SysUser> listUsers = sysUserService.getUserByPlatId(sysUser.getPlatId());
        if (CollUtil.isNotEmpty(listUsers)) {
            for (SysUser sysU : listUsers) {
                WmWkArticleShare wmWkArticleShare = new WmWkArticleShare();
                wmWkArticleShare.setShareUserid(sysU.getUserId() + "");
                wmWkArticleShare.setShareType("1");
                wmWkArticleShare.setCreateTime(LocalDateTime.now());
                wmWkArticleShare.setArctileId(imgUrl);
                wmWkArticleShareService.save(wmWkArticleShare);


                WmTask wmTask = new WmTask();
                wmTask.setTaskFrom("1");
                wmTask.setTaskUserId(sysU.getUserId() + "");  // 任务提交人
                wmTask.setLookintoDate(LocalDateTime.now());       // 调研时间
                wmTask.setTaskStatus("1");
                wmTask.setSubmitStatus("0");
                wmTask.setDrugEntId(sysU.getDrugEntId());// 任务状态
                wmTask.setTaskTypeId("7");
                wmTask.setShareImgUrl(imgUrl);

                SysDept sysDept = sysDeptService.getById(sysU.getDeptId());
                WmTaskType wmTaskType = new WmTaskType();
                wmTaskType.setDurgentId(sysU.getDrugEntId());
                WmTaskType wmTaskType1 = wmTaskTypeService.getById("7");
                wmTaskType.setTaskTypeName(wmTaskType1.getTaskTypeName());
                wmTaskType.setTaskEntId(sysDept.getLevel2Id());
                socre = wmTaskTypeService.getWmTaskTypeByEnt(wmTaskType);
                System.out.println("获取任务得分：" + socre);
                if (socre < 0) {
                    return R.failed("获取任务积分失败");
                }
                wmTask.setScore(socre);

                WmScorePackage wmScorePackage = new WmScorePackage();
                if (SecurityUtils.getRoles().contains(6)) {
                    wmScorePackage.setZbId(sysU.getUserId() + "");
                } else {
                    wmScorePackage.setXxdbId(sysU.getUserId() + "");
                }

                wmScorePackage.setDrugEntId(sysU.getDrugEntId());
                WmScorePackage tWmScorePackage = wmScorePackageService.getPackageScoreByTaskInfo(wmScorePackage);
                try {
                    String packageEntId = wmScorePackageService.getPackageScoreEntByTaskInfo(wmScorePackage);
                    wmTask.setScorePackageLevel1Id(packageEntId);
                } catch (Exception ex) {

                }
                System.out.println("获取积分包ID：" + tWmScorePackage);
                if (null == tWmScorePackage) {
                    // return R.failed("获取积分包失败");
                } else {
                    wmTask.setScorePackageId(tWmScorePackage.getId());
                    wmTask.setTaskRuleId(tWmScorePackage.getTaskRuleId());
                }

                wmTask.setTaskContentId(wmWkArticleShare.getId() + "");

                if (SecurityUtils.getRoles().contains(5)) {
                    wmTask.setTaskUserType("5");
                }

                wmTask.setCreateTime(LocalDateTime.now());

                if (SecurityUtils.getRoles().contains(6)) {
                    wmTask.setTaskUserType("6");
                }

                wmTask.setDeptId(sysU.getDeptId() + "");
                wmTask.setSubmitStatus("0");
                wmTask.setTaskNumber(taskSequence.nextNo());
                boolean isSave = wmTaskService.save(wmTask);   // 保存任务

                // 判断任务是否完成
                if (isSave && null != tWmScorePackage) {
                    WmScorePackage wmScorePackage1 = wmScorePackageService.getById(tWmScorePackage.getId());
                    if (null != wmScorePackage1) {
                        WmTask wmTask1 = new WmTask();
                        wmTask1.setScorePackageId(tWmScorePackage.getId());
                        wmTask1.setDrugEntId(sysU.getDrugEntId());
                        List<WmTask> wmTaskList = wmTaskService.list(Wrappers.query(wmTask1));
                        int totalCount = 0;
                        for (WmTask wmtask : wmTaskList) {
                            totalCount += wmtask.getScore();
                        }

                        if (totalCount >= wmScorePackage1.getScore()) {
                            wmScorePackage1.setPackageFinishStatus("1");
                        }
                        wmScorePackage1.setIsConduct("1");
                        wmScorePackageService.updateById(wmScorePackage1);
                    }
                } else {
                    return R.failed("任务保存失败");
                }
            }
        }
        Map<String, String> map = new HashMap<>();
        map.put("score", socre + "");
        return R.ok(map);
    }

    private boolean isZbRole(List<SysRole> sysRoles, int roleId) {
        for (SysRole sysRole : sysRoles) {
            if (sysRole.getRoleId() == roleId) {
                return true;
            }
        }
        return false;
    }


    /**
     * 分页查询
     *
     * @param page           分页对象
     * @param wmScorePackage 积分包
     * @return
     */
    @GetMapping("/h5PackagePage")
    public R<?> h5PackagePage(Page page, WmScorePackage wmScorePackage) {
        String id = wmScorePackage.getId();
        if (StringUtils.isBlank(id)) {
            return R.failed("积分包ID不能为空");
        }
        wmScorePackage.setId(null);

        String[] ids = id.split(" +");
        List<String> listIds = new ArrayList<>();
        listIds.addAll(Arrays.asList(ids));
        WmTask wmTask = new WmTask();
        wmTask.setExtIds(listIds);
        return R.ok(wmTaskService.getH5PackageList(page, wmTask));
    }


    /**
     * 分页查询
     *
     * @param page   分页对象
     * @param wmTask 任务
     * @return
     */
    @GetMapping("/h5TaskPage")
    public R<?> h5TaskPage(Page page, WmTask wmTask) {
        if (StringUtils.isBlank(wmTask.getId())) {
            return R.failed("积分包ID不能为空");
        }

        String id = wmTask.getId();
        wmTask.setId(null);
        wmTask.setScorePackageId(id);
        return R.ok(wmTaskService.getH5TaskList(page, wmTask));
    }


    /**
     * 分页查询
     *
     * @param taskId 积分包
     * @return
     */
    @GetMapping("/getH5To")
    @SysLog("更新任务截图")
    @Inner(value = false)
    public R<?> getH5To(String taskId) {
        WmTask wmTask = wmTaskService.getById(taskId);
        log.info("更新任务截图任务原数据:{}", wmTask);
        if (null == wmTask) {
            log.warn("任务不存在:taskId={}", wmTask.getId());
            return R.failed("任务不存在");
        }

        try {
            BufferedImage bufferedImage = Html2ImageByJsWrapper.renderHtml2Image(upmsConfig.getApiUrl()
                    + "/h5/#/pages/task/task-detail/index?id=" + wmTask.getId(), upmsConfig.getServerUrl());

            if (bufferedImage == null || bufferedImage.getWidth() == 0 || bufferedImage.getHeight() == 0) {
                log.error("图片截取失败: 截图服务处理失败");
                return R.failed("图片截取失败");
            }

            ByteArrayOutputStream bs = new ByteArrayOutputStream();
            ImageOutputStream imOut = ImageIO.createImageOutputStream(bs);
            ImageIO.write(bufferedImage, "png", imOut);

            InputStream inputStream = new ByteArrayInputStream(bs.toByteArray());

            String path = sysFileService.uploadImgByByte(inputStream);
            if (CharSequenceUtil.isNotBlank(path)) {
                WmTask updateTask = new WmTask();
                updateTask.setId(wmTask.getId());
                updateTask.setTaskInfoImg(path);
                wmTaskService.updateById(updateTask);
            }
        } catch (Exception e) {
            log.error("图片截取失败", e);
        }
        return R.ok();
    }


    /**
     * 根据经纬度获取周围的医院、商业公司、药店
     *
     * @param longitude 经度
     * @param latitude  维度
     * @return 信息列表
     */
    @SysLog("根据经纬度获取周围打卡信息")
    @GetMapping("/getPointSignInfo")
    public R<List<Map<String, Object>>> getPointSignInfo(String longitude, String latitude) {

        if (StrUtil.isBlank(longitude) || StrUtil.isBlank(latitude)) {
            throw new BizException("获取经纬度失败，请检查手机定位状态");
        }

        List<Map<String, Object>> mapList = new ArrayList<>();

        // 医院
        WmDaHospital qWmDaHospital = new WmDaHospital();
        qWmDaHospital.setLongitude(longitude);
        qWmDaHospital.setLatitude(latitude);

        List<WmDaHospital> wmDaHospitalList = wmDaHospitalService.listByPoint(qWmDaHospital);
        if (CollUtil.isNotEmpty(wmDaHospitalList)) {
            for (WmDaHospital wmDaHospital : wmDaHospitalList) {
                Map<String, Object> map = new HashMap<>(6);
                map.put("signEntId", wmDaHospital.getId());
                map.put("signEntName", wmDaHospital.getYymc());
                map.put("longitude", wmDaHospital.getLongitude());
                map.put("latitude", wmDaHospital.getLatitude());
                Double distance = wmDaHospital.getDistance();
                String dis;

                if (distance == null) {
                    dis = "--m";
                } else {
                    dis = String.format("%.2fkm", distance);
                }

                map.put("dis", dis);
                map.put("signEntType", "1");
                mapList.add(map);
            }
        }

        return R.ok(mapList);
    }

    /**
     * 小程序去掉通知--不再提示
     */
    @SysLog("小程序去掉通知")
    @PostMapping("/removeNotice")
    public R<?> removeNotice(@RequestBody NoticeApiInput input) {
        if (StringUtils.isEmpty(input.getUserId())) {
            return R.failed("参数异常，请求失败");
        }
        if (StringUtils.isEmpty(input.getType())) {
            return R.failed("参数异常，请求失败");
        }
        if ("1".equals(input.getType())) {
            redisTemplate.delete(CacheConstants.USER_NOTICE_KEY + input.getUserId());
        }
        if ("2".equals(input.getType())) {
            redisTemplate.delete(CacheConstants.USER_ADD_NOTICE_KEY + input.getUserId());
        }
        return R.ok();
    }

    /**
     * 获取登录人积分包(已知打卡/转发 的选择积分包列表用的这个接口)
     *
     * @param type 任务类型
     * @return 积分包信息
     */
    @SysLog("获取登录人积分包")
    @GetMapping("/getPackageListByTaskType")
    public R<?> getPackageListByTaskType(@RequestParam(value = "type") String type) {

        HnqzUser user = SecurityUtils.getUser();

        WmScorePackageStatus wmScorePackageStatus = new WmScorePackageStatus();
        wmScorePackageStatus.setUserId(user.getId() + "");
        wmScorePackageStatus.setTaskAddFlag("1");
        wmScorePackageStatus.setStatus("2");
        wmScorePackageStatus.setDelFlag("0");
        wmScorePackageStatus.setEnableFlag("0");
        List<WmScorePackageStatus> statusList = wmScorePackageStatusService.list(Wrappers.query(wmScorePackageStatus));

        if (CollUtil.isEmpty(statusList)) {
            return R.ok(Collections.emptyList());
        }

        List<Map<String, Object>> listMap = new LinkedList<>();

        // 获取领包记录对应的积分包ID && 获取积分包信息
        Set<String> pkgIds = statusList.stream().map(WmScorePackageStatus::getPackageId).collect(Collectors.toSet());
        List<WmScoreTaskType> scoreTaskTypes = wmScoreTaskTypeService.list(Wrappers.<WmScoreTaskType>lambdaQuery().eq(WmScoreTaskType::getTaskTypeId, type).in(WmScoreTaskType::getScoreId, pkgIds));

        Set<String> availPkgIds = scoreTaskTypes.stream().map(WmScoreTaskType::getScoreId).collect(Collectors.toSet());
        if (CollUtil.isEmpty(availPkgIds)) {
            return R.ok(Collections.emptyList());
        }

        List<WmScorePackage> packages = wmScorePackageService.listByIds(availPkgIds);

        for (WmScorePackage wmScorePackage : packages) {

            if ("0".equals(wmScorePackage.getTaskAddFlag())
                    || "1".equals(wmScorePackage.getEnableFlag())
                    || "3".equals(wmScorePackage.getPackageType1())
                    || (PackageTypeEnum.TYPE2_SETTLE_PACKAGE.val().equals(wmScorePackage.getPackageType2())
                    && !PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val().equals(wmScorePackage.getPackageType1()))
                    || LocalDate.now().isAfter(wmScorePackage.getEndTime())) {
                continue;
            }

            Map<String, Object> map = new HashMap<>(5);
            map.put("label", wmScorePackage.getScorePackageName());
            map.put("value", wmScorePackage.getId());
            String drugProducer = ArrayUtils.isEmpty(wmScorePackage.getDrugProducerList()) ? "" : String.join(StrPool.COMMA, wmScorePackage.getDrugProducerList());
            map.put("drugProducer", drugProducer);
            map.put("deptId", wmScorePackage.getDeptId());
            map.put("relDeptId", wmScorePackage.getRelatedService());
            listMap.add(map);

        }

        return R.ok(listMap);
    }


    /**
     * 获取登录人积分包（药品生产商发包或者cso单独发包）
     *
     * @param type    积分包类型
     * @param albumId 产品相册id
     * @return 积分包列表
     */
    @SysLog("获取登录人积分包（药品生产商发包或者cso单独发包")
    @GetMapping("/getPackageListByTaskTypeAndAlbumId")
    public R<?> getPackageListByTaskTypeAndAlbumId(String type, Integer albumId) {
        if (StringUtils.isEmpty(type) || albumId == null) {
            return R.failed("参数异常，请求失败");
        }
        // 获取用户基本信息
        if (null == SecurityUtils.getUser().getId()) {
            return R.failed("请求失败");
        }

        SysUser sysUser = sysUserService.getById(SecurityUtils.getUser().getId());

        // 获取相册信息
        WmWkAlbum album = wmWkAlbumService.getById(albumId);
        // 获取相册的关联的药品
        WmDaDrugEntDrugtable daDrugEntDrugtable = wmDaDrugEntDrugtableService.getById(album.getGlyp());
        // 获取关联药品的生产企业
        String drugProducer = daDrugEntDrugtable.getDrugEntName();
        // 筛选积分包
        WmScorePackageStatus wmScorePackageStatus = new WmScorePackageStatus();
        wmScorePackageStatus.setUserId(sysUser.getUserId() + "");
        wmScorePackageStatus.setTaskAddFlag("1");
        wmScorePackageStatus.setStatus("2");
        wmScorePackageStatus.setDelFlag("0");
        wmScorePackageStatus.setEnableFlag("0");
        List<WmScorePackageStatus> statusList = wmScorePackageStatusService.
                list(Wrappers.query(wmScorePackageStatus));

        if (CollUtil.isEmpty(statusList)) {
            return R.ok(Collections.emptyList());
        }

        List<Map<String, Object>> listMap = new ArrayList<>();

        // 获取领包记录对应的积分包ID && 获取积分包信息
        Set<String> pkgIds = statusList.stream().map(WmScorePackageStatus::getPackageId).collect(Collectors.toSet());
        // 过滤有效任务类型
        List<WmScoreTaskType> scoreTaskTypes = wmScoreTaskTypeService.list(Wrappers.<WmScoreTaskType>lambdaQuery()
                .eq(WmScoreTaskType::getTaskTypeId, type)
                .in(WmScoreTaskType::getScoreId, pkgIds));

        Set<String> availPkgIds = scoreTaskTypes.stream().map(WmScoreTaskType::getScoreId).collect(Collectors.toSet());
        if (CollUtil.isEmpty(availPkgIds)) {
            return R.ok(Collections.emptyList());
        }

        List<WmScorePackage> packages = wmScorePackageService.listByIds(availPkgIds);

        for (WmScorePackage wmScorePackage : packages) {

            if ("0".equals(wmScorePackage.getTaskAddFlag())
                    || "1".equals(wmScorePackage.getEnableFlag())
                    || "3".equals(wmScorePackage.getPackageType1())
                    || (PackageTypeEnum.TYPE2_SETTLE_PACKAGE.val().equals(wmScorePackage.getPackageType2())
                    && !PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val().equals(wmScorePackage.getPackageType1()))) {
                continue;
            }

            // 推广药品企业drugProducerList不为空, 则走推广药品企业的判断(历史数据判断), 否则判断推广药品是否包含(新数据判断)
            if (ArrayUtil.isEmpty(wmScorePackage.getDrugProducerList())) {
                // 只要关联了推广药品的积分包
                if (ArrayUtil.contains(wmScorePackage.getDrugtable(), album.getGlyp())) {
                    Map<String, Object> map = new HashMap<>();
                    map.put("label", wmScorePackage.getScorePackageName());
                    map.put("value", wmScorePackage.getId());
                    listMap.add(map);
                }
            } else {
                // 只要关联了推广药品企业的积分包(兼容历史数据)
                if (ArrayUtil.contains(wmScorePackage.getDrugProducerList(), drugProducer)) {
                    Map<String, Object> map = new HashMap<>();
                    map.put("label", wmScorePackage.getScorePackageName());
                    map.put("value", wmScorePackage.getId());
                    listMap.add(map);
                }
            }
        }
        return R.ok(listMap);
    }

    /**
     * 分享阅读任务方法
     *
     * @param id               文章或者相册id
     * @param shareUserId      分享人id
     * @param openUserId       打开人获取openid授权码
     * @param type             操作类型：share->分享， open->打开
     * @param packageId        积分包id
     * @param sharePicUrl      分享图片链接
     * @param taskCategoryName 任务类别名称
     * @param remark           备注
     * @return 结果
     */
    private R<?> shareAndReadTaskMethod(String id, String shareUserId, String openUserId, String type, String packageId,
                                        String sharePicUrl, String taskCategoryName, String remark) {

        LocalDateTime now = LocalDateTime.now();
        int score = 0;
        String msg = "";
        WmWkAlbum wmWkAlbum = null;
        WmWkArticle wmWkArticle = null;
        WmScorePackageStatus scorePackageStatus;

        if (StringUtils.isEmpty(id) || StringUtils.isEmpty(packageId)) {
            return R.ok();
        }

        if (StringUtils.isEmpty(shareUserId)) {
            return R.failed("分享人ID不能为空");
        }

        WmScorePackage tWmScorePackage = wmScorePackageService.getById(packageId);
        if (null == tWmScorePackage) {
            return R.failed("积分包异常，请选择其他积分包");
        }
        if ("0".equals(tWmScorePackage.getTaskAddFlag())) {
            return R.ok();
        }
        if (StringUtils.isEmpty(tWmScorePackage.getRuleId())) {
            return R.failed("积分包未配置积分规则");
        }
        if (LocalDate.now().isAfter(tWmScorePackage.getEndTime())) {
            throw new BizException("当前积分包已过截止日期");
        }

        if ("article".equalsIgnoreCase(taskCategoryName)) {
            wmWkArticle = wmWkArticleService.getById(id);
        } else if ("album".equalsIgnoreCase(taskCategoryName)) {
            wmWkAlbum = wmWkAlbumService.getById(id);
        }


        // 获取分享人
        SysUser sysUser = sysUserService.getById(shareUserId);

        if (null != sysUser) {
            UserVO userVO = sysUserService.selectUserVoById(sysUser.getUserId());
            if (null != userVO) {

                if (!StringUtils.equalsAny(type, "share", "open")) {
                    return R.failed("操作类型错误");
                }

                // 校验相册和文章转发次数限制
                if ("share".equals(type)) {
                    String info = null;
                    if ("album".equalsIgnoreCase(taskCategoryName)) {
                        info = checkAlbumLimit(wmWkAlbum, sysUser, "8", tWmScorePackage.getRelatedService());
                    } else if ("article".equalsIgnoreCase(taskCategoryName)) {
                        info = checkArticleLimit(wmWkArticle, sysUser, "9", tWmScorePackage.getRelatedService());
                    }
                    if (StringUtils.isNotEmpty(info)) {
                        return R.failed(info);
                    }
                }

                if (CharSequenceUtil.equals(PackageTypeEnum.TYPE1_SCOTE_PACKAGE.val(), tWmScorePackage.getPackageType1())
                        || CharSequenceUtil.equals(PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val(), tWmScorePackage.getPackageType1())) {

                    wmTaskContentService.limitScore(sysUser.getUserId(), sysUser.getDeptId(), tWmScorePackage.getPackageType1());
                }

                List<WmScorePackageStatus> statusList = wmScorePackageStatusService.list(
                        Wrappers.<WmScorePackageStatus>lambdaQuery()
                                .eq(WmScorePackageStatus::getUserId, String.valueOf(userVO.getUserId()))
                                .eq(WmScorePackageStatus::getStatus, "2")
                                .eq(WmScorePackageStatus::getTaskAddFlag, "1")
                                .eq(WmScorePackageStatus::getPackageId, tWmScorePackage.getId())
                                .eq(WmScorePackageStatus::getDelFlag, "0")
                                .eq(WmScorePackageStatus::getEnableFlag, "0")
                );

                if (CollectionUtils.isEmpty(statusList)) {
                    return R.ok();
                }

                if (statusList.size() != 1) {
                    log.warn("获取积分包异常，任务保存失败9002：{}", tWmScorePackage.getId());
                    return R.failed("获取积分包异常，任务保存失败");
                }

                scorePackageStatus = statusList.get(0);

                WmWkArticleShare wmWkArticleShare = new WmWkArticleShare();
                wmWkArticleShare.setShareUserid(userVO.getUserId() + "");
                wmWkArticleShare.setShareType("1");
                wmWkArticleShare.setCreateTime(LocalDateTime.now());
                wmWkArticleShare.setArctileId(id);
                wmWkArticleShare.setTemp1(remark);

                WmTask wmTask = new WmTask();
                log.info("获取积分包ID：{}", tWmScorePackage.getId());
                // 根据任务类型获取积分值

                if ("share".equalsIgnoreCase(type)) {
                    if ("article".equalsIgnoreCase(taskCategoryName)) {
                        wmTask.setTaskTypeId("9");
                    } else if ("album".equalsIgnoreCase(taskCategoryName)) {
                        wmTask.setTaskTypeId("8");
                    }
                } else if ("open".equalsIgnoreCase(type)) {
                    if ("article".equalsIgnoreCase(taskCategoryName)) {
                        wmTask.setTaskTypeId("10");
                    } else if ("album".equalsIgnoreCase(taskCategoryName)) {
                        wmTask.setTaskTypeId("11");
                    }
                }

                // 校验超过60周岁,不能做任务
                Map<String, String> checkResult = sysUserService.checkSixtyYearsOld(BeanUtil.copyProperties(sysUser, UserVO.class));
                if (CollUtil.isNotEmpty(checkResult) && checkResult.containsKey("OVER")) {
                    throw new RuntimeException(checkResult.get("OVER"));
                }

                // 查询任务类型启用状态
                List<WmTaskSubmissionPercentRule> rules = wmTaskSubmissionPercentRuleService.list(Wrappers.<WmTaskSubmissionPercentRule>lambdaQuery()
                        .eq(WmTaskSubmissionPercentRule::getDeptId, sysUser.getDeptId())
                        .eq(WmTaskSubmissionPercentRule::getSubCategory, UpmsType.TaskSubCategory2.TASK_TYPE_CONFIG));
                if (CollUtil.isEmpty(rules)) {
                    throw new RuntimeException("当前企业未开启该任务！");
                }
                String[] taskTypeIds = rules.get(0).getRule().getTaskTypeIds();
                if (!ArrayUtil.contains(taskTypeIds, wmTask.getTaskTypeId())) {
                    throw new RuntimeException("当前企业未开启该任务！");
                }

                WmTaskType _baseTaskType = wmTaskTypeService.getById(wmTask.getTaskTypeId());

                // 校验任务类型是否启用
                WmTaskType queryTaskType = new WmTaskType();
                queryTaskType.setRuleId(tWmScorePackage.getRuleId());
                queryTaskType.setTaskTypeName(_baseTaskType.getTaskTypeName());
                queryTaskType.setDelFlag("0");
                List<WmTaskType> deptTaskTypes = wmTaskTypeService.list(Wrappers.query(queryTaskType));
                if (CollUtil.isEmpty(deptTaskTypes)) {
                    msg = _baseTaskType.getTaskTypeName() + "任务类型不存在";
                    log.info(msg);
                    return R.failed(_baseTaskType.getTaskTypeName() + "任务类型不存在");
                }

                WmTaskType deptTaskType = deptTaskTypes.get(0);
                if (EnableEnum.DISABLE.val().equals(deptTaskType.getEnableFlag())) {
                    msg = _baseTaskType.getTaskTypeName() + "任务类型已停用";
                    log.info(msg);
                    wmTask.setScore(0);
                } else {
                    WmTaskType wmTaskType = new WmTaskType();
                    wmTaskType.setRuleId(tWmScorePackage.getRuleId());
                    wmTaskType.setTaskTypeName(_baseTaskType.getTaskTypeName());
                    score = deptTaskType.getScore();
                }

                log.info("任务类型预设积分：{}", score);
                if (score < 0) {
                    return R.failed("获取任务积分失败");
                }
                wmTask.setScore(score);


                boolean needToCheckLimit = tWmScorePackage.getScore() > 3000;
                if ("open".equals(type)) {
                    List<WmWkArticleShare> wmWkArticleShareList = wmWkArticleShareService.list(Wrappers.
                            <WmWkArticleShare>lambdaQuery()
                            .eq(WmWkArticleShare::getArctileId, id)
                            .eq(WmWkArticleShare::getShareType, "1")
                            .orderByDesc(WmWkArticleShare::getCreateTime));
                    if (CollectionUtils.isNotEmpty(wmWkArticleShareList)) {
                        List<String> stringList = wmWkArticleShareList.stream()
                                .map(articleShare -> String.valueOf(articleShare.getId())).collect(Collectors.toList());
                        List<WmTask> wmTaskList = wmTaskService.list(Wrappers.<WmTask>lambdaQuery()
                                .in(WmTask::getTaskContentId, stringList)
                                .orderByDesc(WmTask::getCreateTime));
                        if (CollectionUtils.isNotEmpty(wmTaskList)) {
                            Optional<WmTask> first = wmTaskList.stream()
                                    .filter(t -> StringUtils.isNotEmpty(t.getShareImgUrl()))
                                    .findFirst();
                            first.ifPresent(task -> wmTask.setShareImgUrl(task.getShareImgUrl()));
                        }
                    }

                    // 获取打开用户的openid
                    if (StringUtils.isEmpty(openUserId)) {
                        log.info("openUserId为null，任务积分为0。");
                        wmTask.setScore(0);
                    } else {
                        String readerOpenId = openUserId.trim();
                        if (readerOpenId.contains("null")) {
                            log.info("获取阅读者openid失败，积分值为0");
                            wmTask.setScore(0);
                        } else {
                            // 过滤文章分享list，如果阅读者已经阅读过同一个分享人分享的的同一篇文章，就不再记录分数
                            List<WmWkArticleShare> shares = wmWkArticleShareList
                                    .stream()
                                    .filter(s -> readerOpenId.equals(s.getOpenUser()) && shareUserId.equals(s.getShareUserid()))
                                    .collect(Collectors.toList());
                            if (CollectionUtils.isNotEmpty(shares)) {
                                log.info("同一个分享存在多次打开记录:{}", shares);
                                wmTask.setScore(0);
                            }
                            //  记录阅读者openid
                            wmWkArticleShare.setOpenUser(readerOpenId);

                        }
                    }

                    // 校验打开结果
                    if (needToCheckLimit) {
                        if ("article".equalsIgnoreCase(taskCategoryName)) {
                            needToCheckLimit = checkArticleOpenLimit(wmWkArticle, sysUser, wmTask, "10", tWmScorePackage.getRelatedService());
                        } else if ("album".equalsIgnoreCase(taskCategoryName)) {
                            needToCheckLimit = checkAlbumOpenLimit(wmWkAlbum, sysUser, wmTask, "11", tWmScorePackage.getRelatedService());
                        }
                    }
                }

                // 记录分享记录
                wmWkArticleShareService.save(wmWkArticleShare);

                wmTask.setTaskFrom("1");
                wmTask.setTaskUserId(String.valueOf(userVO.getUserId()));  // 任务提交人
                wmTask.setLookintoDate(now);       // 调研时间
                wmTask.setUpdateTime(now);
                wmTask.setDrugEntId(userVO.getDrugEntId());
                wmTask.setShareImgUrl(sharePicUrl);
                wmTask.setScorePackageId(tWmScorePackage.getId());
                wmTask.setTaskRuleId(tWmScorePackage.getTaskRuleId());
                wmTask.setTaskContentId(String.valueOf(wmWkArticleShare.getId()));
                wmTask.setCreateTime(now);
                wmTask.setDeptId(String.valueOf(userVO.getDeptId()));

                if (isZbRole(userVO.getRoleList(), 5)) {
                    wmTask.setTaskUserType("5");
                }

                if (isZbRole(userVO.getRoleList(), 6)) {
                    wmTask.setTaskUserType("6");
                }

                // 校验任务百分比限制规则（如果积分包值大于【任务配置】-【百分比限制】配置的起始值，
                // 且【任务配置】-【百分比限制】所选的任务类型对应的任务总完成积分值>积分包值*【任务配置】-【百分比限制】配置的百分比，则校验不通过）
                R<?> checkPercentRuleResult =
                        wmTaskSubmissionPercentRuleService.checkPercentRule(tWmScorePackage, sysUser.getDeptId(),
                                Integer.valueOf(shareUserId), Arrays.asList("8", "9", "10", "11"));
                if (checkPercentRuleResult.getCode() != 0) {
                    wmTask.setScore(0);
                    msg = checkPercentRuleResult.getMsg();
                }

                // 校验结果为0积分的自动审核不通过
                boolean autoRejectFlag = wmTask.getScore() == 0;

                wmTask.setTaskStatus(autoRejectFlag ? "4" : "2"); // 任务状态
                wmTask.setSubmitStatus(autoRejectFlag ? "1" : "0");
                wmTask.setTaskNumber(taskSequence.nextNo());
                boolean isSave = wmTaskService.save(wmTask);   // 保存任务


                // 判断任务是否完成
                if (isSave) {
                    WmScorePackage wmScorePackage1 = wmScorePackageService.getById(tWmScorePackage.getId());
                    // 判断任务是否完成
                    if (null != wmScorePackage1) {
                        // 查询出 审核通过和审核中的任务
                        List<WmTask> wmTaskList = wmTaskService.list(Wrappers.<WmTask>lambdaQuery()
                                .eq(WmTask::getScorePackageId, tWmScorePackage.getId())
                                // 查询出 审核通过和审核中的任务
                                .ne(WmTask::getTaskStatus, "4")
                                .eq(WmTask::getRealFlag, "0"));
                        // 判断定量还是定额 1- 定额   2-定量 6-定额+定量
                        if (CharSequenceUtil.equals(PackageTypeEnum.TYPE1_SCOTE_PACKAGE.val(), wmScorePackage1.getPackageType1())) {

                            int totalCount = 0;
                            for (WmTask wmtask : wmTaskList) {
                                totalCount += wmtask.getScore();
                            }

                            if (totalCount >= wmScorePackage1.getScore()) {
                                wmScorePackage1.setTaskAddFlag("0");
                                scorePackageStatus.setTaskAddFlag("0");
                                wmScorePackageStatusService.updateById(scorePackageStatus);
                            }
                        } else if (CharSequenceUtil.equals(PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val(), wmScorePackage1.getPackageType1())) {
                            // 多人积分包处理
                            int totalCount = 0;
                            for (WmTask wmtask : wmTaskList) {
                                totalCount += wmtask.getScore();
                            }

                            if (totalCount >= wmScorePackage1.getScore()) {
                                wmScorePackage1.setTaskAddFlag("0");
                                List<WmScorePackageStatus> packageStatusList = wmScorePackageStatusService.list(Wrappers.<WmScorePackageStatus>lambdaQuery()
                                        .eq(WmScorePackageStatus::getStatus, "2")
                                        .eq(WmScorePackageStatus::getTaskAddFlag, "1")
                                        .eq(WmScorePackageStatus::getPackageId, tWmScorePackage.getId()));
                                if (CollUtil.isNotEmpty(packageStatusList)) {
                                    packageStatusList.forEach(packageStatus -> {
                                        WmScorePackageStatus updatePackageStatus = new WmScorePackageStatus();
                                        updatePackageStatus.setId(packageStatus.getId());
                                        updatePackageStatus.setTaskAddFlag("0");
                                        updatePackageStatus.setUpdateTime(LocalDateTime.now());
                                        wmScorePackageStatusService.updateById(updatePackageStatus);
                                    });
                                }
                            }
                        } else if ("2".equals(wmScorePackage1.getPackageType1())) {
                            score = 0;

                            List<WmTask> userTaskList = wmTaskList.stream()
                                    .filter(item -> item.getTaskUserId().equals(String.valueOf(userVO.getUserId())))
                                    .collect(Collectors.toList());

                            if (userTaskList.size() >= scorePackageStatus.getTaskNum()) {
                                scorePackageStatus.setTaskAddFlag("0");
                                wmScorePackageStatusService.updateById(scorePackageStatus);
                                // 改变大包状态
                                WmScorePackageStatus queryAll = new WmScorePackageStatus();
                                queryAll.setPackageId(tWmScorePackage.getId());
                                queryAll.setStatus("2");
                                queryAll.setTaskAddFlag("0");
                                List<WmScorePackageStatus> statusAll = wmScorePackageStatusService.
                                        list(Wrappers.query(queryAll));
                                if (new BigDecimal(wmScorePackage1.getUserNum())
                                        .compareTo(new BigDecimal(statusAll.size())) <= 0) {
                                    wmScorePackage1.setTaskAddFlag("0");
                                }
                            }

                        }

                        wmScorePackage1.setIsConduct("1");
                        wmScorePackageService.updateById(wmScorePackage1);

                    }

                } else {
                    return R.failed("任务保存失败");
                }

                // 推送任务h5截图
                applicationEventPublisher.publishEvent(new TaskInfoImgEvent(wmTask.getId()));
            }
        }

        if ("album".equalsIgnoreCase(taskCategoryName)) {
            if ("share".equalsIgnoreCase(type)) {
                wmWkAlbum.setForwardNum(wmWkAlbum.getForwardNum() + 1);
            }
            wmWkAlbumService.updateById(wmWkAlbum);
            wmWkAlbum.setScore(String.valueOf(score));

            return R.ok(wmWkAlbum, msg);
        } else if ("article".equalsIgnoreCase(taskCategoryName)) {
            if ("share".equalsIgnoreCase(type)) {
                wmWkArticle.setForwardNum(wmWkArticle.getForwardNum() + 1);
            }
            wmWkArticleService.updateById(wmWkArticle);
            wmWkArticle.setScore(String.valueOf(score));
            return R.ok(wmWkArticle, msg);
        }

        return R.ok(null, msg);
    }


    /**
     * 文章打开判断
     *
     * @param article    文章
     * @param user       分享用户
     * @param task       任务
     * @param taskTypeId 任务类型id
     * @param pkgId      积分包id
     * @return 校验信息
     */
    @SuppressWarnings("unchecked")
    private Boolean checkArticleOpenLimit(WmWkArticle article, SysUser user, WmTask task, String taskTypeId, String pkgId) {
        Assert.notNull(article);

        List<WmTaskSubmissionRule.SubmissionRule> rules = wmTaskContentService.getTaskSubmissionRule(taskTypeId, pkgId);

        int maxShareTimes = upmsConfig.getMaxShareTimes();
        if (CollUtil.isNotEmpty(rules)) {
            // 获取限制
            for (WmTaskSubmissionRule.SubmissionRule rule : rules) {
                Map<String, Object> map = (Map<String, Object>) rule;
                WmTaskSubmissionRule.SubmissionRule r = BeanUtil.mapToBean(map, WmTaskSubmissionRule.SubmissionRule.class, true, new CopyOptions());

                if ("同一个人对同一篇文章的转发上限".equals(r.getManual())) {

                    List<Integer> quantity = r.getFrequency().stream().map(f -> {
                        Object o = f.get("quantity");
                        return o instanceof String ? Integer.parseInt((String) o) : (int) o;
                    }).sorted().collect(Collectors.toList());
                    maxShareTimes = quantity.get(0);
                }
            }


        }

        LocalDateTime now = LocalDateTime.now();
        final String cacheKey = CacheConstants.ARTICLE_PERSONAL_SHARE_KEY + DateUtil.format(now, "yyyyMMdd:")
                + user.getUserId() + ":" + article.getId();
        Integer times = (Integer) redisTemplate.opsForValue().get(cacheKey);
        if (null != times && times >= maxShareTimes) {
            log.info("{}:{}已经转发文章{}次数:{}", user.getUserId(), user.getRealname(), article.getId(), times);
            task.setScore(0);
            return false;
        }
        return true;
    }

    /**
     * 相册打开判断
     *
     * @param album      相册
     * @param user       分享用户
     * @param task       任务
     * @param taskTypeId 任务类型id
     * @param pkgId      积分包id
     * @return 校验信息
     */
    @SuppressWarnings("unchecked")
    private boolean checkAlbumOpenLimit(WmWkAlbum album, SysUser user, WmTask task, String taskTypeId, String pkgId) {
        Assert.notNull(album);

        List<WmTaskSubmissionRule.SubmissionRule> rules = wmTaskContentService.getTaskSubmissionRule(taskTypeId, pkgId);

        int maxShareTimes = upmsConfig.getMaxShareTimes();
        if (CollUtil.isNotEmpty(rules)) {
            // 获取限制
            for (WmTaskSubmissionRule.SubmissionRule rule : rules) {
                Map<String, Object> map = (Map<String, Object>) rule;
                WmTaskSubmissionRule.SubmissionRule r = BeanUtil.mapToBean(map, WmTaskSubmissionRule.SubmissionRule.class, true, new CopyOptions());

                if ("同一个人对同一个相册的转发上限".equals(r.getManual())) {

                    List<Integer> quantity = r.getFrequency().stream().map(f -> {
                        Object o = f.get("quantity");
                        return o instanceof String ? Integer.parseInt((String) o) : (int) o;
                    }).sorted().collect(Collectors.toList());
                    maxShareTimes = quantity.get(0);
                }
            }


        }

        if (StringUtils.isNotEmpty(album.getGlyp())) {
            List<WmDaDrugEntDrugtable> drugTableList =
                    wmDaDrugEntDrugtableService.listByIds(Arrays.asList(album.getGlyp().split(",")));
            if (CollectionUtils.isNotEmpty(drugTableList)) {
                String date = DateUtil.today() + ":";
                log.info("DateUtil.today():{}", date);
                for (WmDaDrugEntDrugtable drug : drugTableList) {
                    if (StringUtils.isEmpty(drug.getDrugEntId())) {
                        continue;
                    }
                    String key = CacheConstants.DRUG_ENT_PERSONAL_SHARE_KEY1 + date
                            + drug.getDrugEntId() + CacheConstants.DRUG_ENT_PERSONAL_SHARE_KEY2 + user.getUserId();
                    log.info("key:{}", key);
                    Integer times = (Integer) redisTemplate.opsForValue().get(key);
                    if (times != null && times >= maxShareTimes) {
                        task.setScore(0);
                        return false;
                    }
                }
            }
        }
        return true;
    }

    /**
     * 校验文章转发限制
     *
     * @param wmWkArticle 文章
     * @param sysUser     转发人
     * @param taskTypeId  任务类型id
     * @param pkgId       积分包id
     * @return 校验信息
     */
    @SuppressWarnings("unchecked")
    private String checkArticleLimit(WmWkArticle wmWkArticle, SysUser sysUser, String taskTypeId, String pkgId) {
        Assert.notNull(wmWkArticle);

        List<WmTaskSubmissionRule.SubmissionRule> rules = wmTaskContentService.getTaskSubmissionRule(taskTypeId, pkgId);

        int maxShareTimes = upmsConfig.getMaxShareTimes();
        if (CollUtil.isNotEmpty(rules)) {
            // 获取限制
            for (WmTaskSubmissionRule.SubmissionRule rule : rules) {
                Map<String, Object> map = (Map<String, Object>) rule;
                WmTaskSubmissionRule.SubmissionRule r = BeanUtil.mapToBean(map, WmTaskSubmissionRule.SubmissionRule.class, true, new CopyOptions());

                if ("同一个人对同一篇文章的转发上限".equals(r.getManual())) {

                    List<Integer> quantity = r.getFrequency().stream().map(f -> {
                        Object o = f.get("quantity");
                        return o instanceof String ? Integer.parseInt((String) o) : (int) o;
                    }).sorted().collect(Collectors.toList());
                    maxShareTimes = quantity.get(0);
                }
            }


        }


        LocalDateTime now = LocalDateTime.now();
        final String cacheKey = CacheConstants.ARTICLE_PERSONAL_SHARE_KEY + DateUtil.format(now, "yyyyMMdd:")
                + sysUser.getUserId() + ":" + wmWkArticle.getId();
        Integer times = (Integer) redisTemplate.opsForValue().get(cacheKey);
        if (null != times) {
            log.info("{}:{}已经转发文章{}次数:{}", sysUser.getUserId(), sysUser.getRealname(), wmWkArticle.getId(), times);
            if (times++ >= maxShareTimes) {
                return String.format("您当日转发的该药企产品相册次数已超过%s次，转发将不再获得积分", maxShareTimes);
            }
        } else {
            log.info("{}:{}已经首次转发文章:{}", sysUser.getUserId(), sysUser.getRealname(), wmWkArticle.getId(), times);
            times = 1;
        }
        redisTemplate.opsForValue()
                .set(cacheKey, times, Duration.between(now, LocalDateTime.of(now.toLocalDate(), LocalTime.MAX)));
        return null;
    }

    /**
     * 校验相册转发限制
     *
     * @param wmWkAlbum  相册
     * @param sysUser    分享人
     * @param taskTypeId 任务类型id
     * @param pkgId      积分包id
     * @return 校验结果信息
     */
    @SuppressWarnings("unchecked")
    private String checkAlbumLimit(WmWkAlbum wmWkAlbum, SysUser sysUser, String taskTypeId, String pkgId) {

        Assert.notNull(wmWkAlbum);

        List<WmTaskSubmissionRule.SubmissionRule> rules = wmTaskContentService.getTaskSubmissionRule(taskTypeId, pkgId);

        int maxShareTimes = upmsConfig.getMaxShareTimes();
        if (CollUtil.isNotEmpty(rules)) {
            // 获取限制
            for (WmTaskSubmissionRule.SubmissionRule rule : rules) {
                Map<String, Object> map = (Map<String, Object>) rule;
                WmTaskSubmissionRule.SubmissionRule r = BeanUtil.mapToBean(map, WmTaskSubmissionRule.SubmissionRule.class, true, new CopyOptions());

                if ("同一个人对同一个相册的转发上限".equals(r.getManual())) {

                    List<Integer> quantity = r.getFrequency().stream().map(f -> {
                        Object o = f.get("quantity");
                        return o instanceof String ? Integer.parseInt((String) o) : (int) o;
                    }).sorted().collect(Collectors.toList());
                    maxShareTimes = quantity.get(0);
                }
            }


        }

        if (StringUtils.isNotEmpty(wmWkAlbum.getGlyp())) {
            List<WmDaDrugEntDrugtable> drugTableList =
                    wmDaDrugEntDrugtableService.listByIds(Arrays.asList(wmWkAlbum.getGlyp().split(",")));
            if (CollectionUtils.isNotEmpty(drugTableList)) {

                // 2020-12-13 修改 需求有逻辑BUG
                String date = DateUtil.today() + ":";
                log.error("DateUtil.today():{}", date);

                Set<String> drugEntIds = drugTableList.stream()
                        .map(WmDaDrugEntDrugtable::getDrugEntId)
                        .filter(CharSequenceUtil::isNotBlank)
                        .collect(Collectors.toSet());

                for (String drugEntId : drugEntIds) {

                    String key = CacheConstants.DRUG_ENT_PERSONAL_SHARE_KEY1 + date + drugEntId + CacheConstants.DRUG_ENT_PERSONAL_SHARE_KEY2 + sysUser.getUserId();
                    log.info("key:{}", key);
                    if (Boolean.TRUE.equals(redisTemplate.hasKey(key))) {
                        int times = Integer.parseInt(redisTemplate.opsForValue().get(key).toString());
                        if (times >= maxShareTimes) {
                            return String.format("您当日转发的该药企产品相册%s次,已超过%s次，转发将不再获得积分", times, maxShareTimes);
                        }
                        times++;
                        redisTemplate.opsForValue().set(key, times, CacheConstants.SHARE_TIME, TimeUnit.DAYS);
                    } else {
                        redisTemplate.opsForValue().set(key, 1, CacheConstants.SHARE_TIME, TimeUnit.DAYS);
                    }
                }

            }
        }
        return null;
    }

    /**
     * 小程序上传
     *
     * @param file 资源
     * @return R(/ admin / bucketName / filename)
     */
    @PostMapping("/file/upload/mobile")
    public R<?> uploadForMobile(@RequestParam("file") MultipartFile file) throws IOException, NoSuchAlgorithmException {

        String originalFilename = file.getOriginalFilename();

        String extName = FileUtil.extName(originalFilename);

        List<String> IMG_EXT_NAME = Arrays.asList("png", "jpg", "gif", "jpeg", "tif", "bmp");

        log.info("源文件名称:{}", originalFilename);
        log.info("源文件后缀:{}", extName);
        if (IMG_EXT_NAME.contains(extName)) {
            HnqzUser user = SecurityUtils.getUser();
            log.info("用户:{}", user);
            if (user == null) {
                return R.failed("无法获取用户id");
            }

            // 文件md5

            byte[] bytes = file.getBytes();
            MessageDigest md5 = MessageDigest.getInstance("MD5");
            byte[] digest = md5.digest(bytes);
            String hash = new BigInteger(1, digest).toString(16);

            log.info("图片md5:{}", hash);
        }

        return sysFileService.uploadFile(file);
    }

    /**
     * 获取任务类型的小程序端限制规则
     *
     * @param deptId      企业id
     * @param subCategory 二级分类
     * @return 限制规则
     */
    @GetMapping(value = "/task-sub-rule")
    public R<?> listTaskSubmissionRule(@RequestParam(value = "deptId") Integer deptId, @RequestParam(value = "subCategory") UpmsType.TaskSubCategory subCategory) {
        WmTaskSubmissionRule rule = taskSubmissionRuleService.getOne(Wrappers.<WmTaskSubmissionRule>lambdaQuery()
                .eq(WmTaskSubmissionRule::getDeptId, deptId)
                .eq(WmTaskSubmissionRule::getSubCategory, subCategory)
        );
        return R.ok(rule.getRule());

    }

    /**
     * 校验是财务验证码是否存在
     *
     * @return 校验结果
     */
    @GetMapping(value = "/check-code/for-fina")
    public R<?> checkFinaCode(@RequestParam(value = "code") String code) {


        Integer userId = SecurityUtils.getUser().getId();

        // 获取用户信息判断，是否需要发送验证码
        SysUser sysUser = sysUserService.getById(userId);

        if (Objects.isNull(sysUser)) {
            log.error("用户不存在");
            return R.failed("用户不存在");
        }

        log.info("是否需要发送验证码temp3：{}", sysUser.getTemp3());
        String username = sysUser.getUsername();

        final String key = com.qunzhixinxi.hnqz.common.core.constant.CacheConstants.DEFAULT_CODE_KEY + LoginTypeEnum.SMS.getType() + StringPool.AT + username + "@fina";


        Boolean res = Boolean.TRUE.equals(redisTemplate.hasKey(key)) ? code.equals(redisTemplate.opsForValue().get(key)) : Boolean.FALSE;

        if (res) {
            redisTemplate.delete(key);
        }

        return R.ok(res);

    }

    /**
     * 我的积分-积分记录列表
     *
     * @param page   分页参数
     * @param status 状态
     * @return 分页结果
     */
    @GetMapping("/page-accumulative-score")
    public R<Page<PersonalScoreRecordVO>> pageAccumulativeScore(Page<PersonalScoreRecordVO> page,
                                                                @RequestParam(value = "status", required = true) PersonalScoreRecordVO.PersonalScoreRecordStatus status) {

        Integer userId = SecurityUtils.getUser().getId();

        // 获取当前用户任务领包记录
        List<WmScorePackageStatus> packageStatuses = wmScorePackageStatusService.list(Wrappers.<WmScorePackageStatus>lambdaQuery()
                .eq(WmScorePackageStatus::getUserId, userId)
                .eq(WmScorePackageStatus::getStatus, PackageStatusEnum.APPROVED.val()));
        if (CollUtil.isEmpty(packageStatuses)) {
            return R.ok(page);
        }

        // 查询积分包
        Set<String> ids = packageStatuses.stream().map(WmScorePackageStatus::getPackageId).collect(Collectors.toSet());
        List<WmScorePackage> packages = wmScorePackageService.listByIds(ids);
        // 转为map key-积分包id，value-积分包名称
        Map<String, String> packageMap = packages.stream()
                .filter(pkg -> CharSequenceUtil.split(status.getScorePackageStatus(), StrPool.COMMA).contains(pkg.getScorePackageStatus()))
                .filter(pkg -> {
                    if (PersonalScoreRecordVO.PersonalScoreRecordStatus.PAID.getSettleStatus().equals(String.valueOf(pkg.getSettleStatus()))) {
                        // 如果条件是已结算，则直接返回
                        return true;
                    } else {
                        // 如果是待结算，则过滤掉对应的积分包状态
                        return CharSequenceUtil.split(status.getScorePackageStatus(), StrPool.COMMA).contains(pkg.getScorePackageStatus());
                    }
                })
                .collect(Collectors.toMap(WmScorePackage::getId, WmScorePackage::getScorePackageName));

        if (CollUtil.isEmpty(packageMap)) {
            return R.ok(page);
        }

        // 过滤得已结算、待结算积分包id
        Set<String> packageIds = packageMap.keySet();

        // 查询taskType
        List<WmTaskType> taskTypeList = wmTaskTypeService.list(Wrappers.<WmTaskType>lambdaQuery()
                .eq(WmTaskType::getTaskTypeLevel, "1")
                .eq(WmTaskType::getDelFlag, DelEnum.NOT_DEL.getVal())
                .eq(WmTaskType::getEnableFlag, EnableEnum.ENABLE.val()));
        // taskType通过id分组（key为parentId，value为taskTypeId的set）
        Map<String, String> taskTypeIdMap = taskTypeList.stream()
                .collect(Collectors.toMap(WmTaskType::getId, WmTaskType::getTaskTypeName));

        // 查询任务
        Page<WmTask> wmTaskPage = wmTaskService.page(new Page<>(page.getCurrent(), page.getSize()), Wrappers.<WmTask>lambdaQuery()
                .in(WmTask::getScorePackageId, packageIds)
                .eq(WmTask::getTaskUserId, userId)
                .eq(WmTask::getTaskStatus, TaskStatusEnum.APPROVED.val())
                .eq(WmTask::getDelFlag, DelEnum.NOT_DEL.getVal())
                .eq(WmTask::getEnableFlag, EnableEnum.ENABLE.val()));
        List<PersonalScoreRecordVO> recordVOS = new ArrayList<>();
        wmTaskPage.getRecords().forEach(wmTask -> {
            PersonalScoreRecordVO recordVO = new PersonalScoreRecordVO();
            recordVO.setScore(wmTask.getScore());
            recordVO.setTaskTypeId(wmTask.getTaskTypeId());
            recordVO.setLookintoDate(wmTask.getLookintoDate());
            recordVO.setScorePackageId(wmTask.getScorePackageId());
            recordVO.setScorePackageName(packageMap.get(wmTask.getScorePackageId()));
            recordVO.setTaskTypeName(taskTypeIdMap.get(wmTask.getTaskTypeId()));
            recordVOS.add(recordVO);
        });

        page.setRecords(recordVOS);
        page.setTotal(wmTaskPage.getTotal());
        page.setPages(wmTaskPage.getPages());

        return R.ok(page);
    }

    /**
     * 获取当前积分包对应的积分规则
     *
     * @param packageId 积分包id
     * @return 规则
     */
    @GetMapping("/package-rule-task-type/{packageId}")
    public R<?> getScorePackageRuleScore(@PathVariable("packageId") String packageId) {
        WmScorePackage scorePackage = wmScorePackageService.getById(packageId);
        if (scorePackage == null) {
            throw new RuntimeException("积分包不存在");
        }
        // 查询当前企业的任务类型积分
        WmTaskType queryTaskType = new WmTaskType();
        queryTaskType.setRuleId(scorePackage.getRuleId());
        queryTaskType.setDelFlag("0");
        queryTaskType.setEnableFlag("0");
        List<WmTaskType> list = wmTaskTypeService.list(Wrappers.query(queryTaskType));
        if (CollUtil.isNotEmpty(list)) {
            List<Map<String, Object>> result = list.stream().map(wmTaskType -> {
                Map<String, Object> map = new HashMap<>(3);
                map.put("taskTypeName", wmTaskType.getTaskTypeName());
                if (wmTaskType.getTaskTypeName().startsWith("应收账款回款")) {
                    // 应收账款回款 任务类 保存的是1000倍数，需要转换回来
                    map.put("score", String.valueOf(wmTaskType.getScore() / 1000.0D));
                } else {
                    map.put("score", String.valueOf(wmTaskType.getScore()));
                }
                return map;
            }).collect(Collectors.toList());
            return R.ok(result);
        }

        return R.ok(Collections.emptyList());
    }


    @SysLog(value = "平台用户信息签署")
    @PostMapping("/plt/user/agr/sign")
    public R<Boolean> signUserAgreement(@Validated @RequestBody SysUserDTO.OnPltUserAgreementSign resource) {
        HnqzUser user = SecurityUtils.getUser();

        if (userAgreementHistoryService.checkSigned(resource.getAgreementName(), resource.getAgreementVersion(), user)) {
            return R.failed(false, String.format("协议【%s(%s)】已签署，请勿重复签署", resource.getAgreementName(), resource.getAgreementVersion()));
        }


        return R.ok(userAgreementHistoryService.doSign(resource, user));


    }

    /**
     * 小程序签署协议
     *
     * @param signAgreementDTO 请求参数
     * @return {@link R}<{@link ?}> 结果
     */
    @SysLog("小程序签署协议")
    @PostMapping("/sign-agreement")
    public R<Boolean> signAgreement(@Validated @RequestBody SignAgreementDTO signAgreementDTO) {
        log.info("小程序签署协议请求:{}", signAgreementDTO);

        String username = SecurityUtils.getUser().getUsername();
        List<SysUser> userList = sysUserService.list(Wrappers.<SysUser>lambdaQuery()
                .eq(SysUser::getUsername, username)
                .eq(SysUser::getDelFlag, DelEnum.NOT_DEL.getVal()));


        for (SysUser user : userList) {
            Set<Object> signAgreementDTOList = new HashSet<>();
            if (CharSequenceUtil.isBlank(user.getSignAgreement())) {
                signAgreementDTOList.add(JSONUtil.parseObj(signAgreementDTO));
            } else {
                JSONArray agreements = JSONUtil.parseArray(user.getSignAgreement());
                signAgreementDTOList.add(JSONUtil.parseObj(signAgreementDTO));
                signAgreementDTOList.addAll(agreements);
            }
            sysUserService.update(Wrappers.<SysUser>lambdaUpdate()
                    .eq(SysUser::getUserId, user.getUserId())
                    .set(SysUser::getSignAgreement, JSONUtil.toJsonStr(signAgreementDTOList))
                    .set(SysUser::getUpdateTime, LocalDateTime.now()));
        }


        return R.ok(Boolean.TRUE);
    }

    /**
     * 关闭年满60周岁提醒
     *
     * @return {@link R}<{@link Boolean}>
     */
    @PostMapping("/stop-sixtyyearsold-reminder")
    public R<Boolean> stopSixtyYearsOldReminder() {
        Integer userId = SecurityUtils.getUser().getId();
        SysUser queryUser = sysUserService.getById(userId);
        log.info("关闭年满60周岁提醒:userId={},idCardNumber={}", userId, queryUser.getIdCardNumber());

        boolean update = false;
        if (CharSequenceUtil.isNotBlank(queryUser.getIdCardNumber())) {
            update = sysUserService.update(Wrappers.<SysUser>lambdaUpdate()
                    .eq(SysUser::getIdCardNumber, queryUser.getIdCardNumber())
                    .set(SysUser::getAgeReminder, Boolean.FALSE)
                    .set(SysUser::getUpdateTime, LocalDateTime.now()));
        }

        return R.ok(update);
    }

    /**
     * 获取当前用户的平台试题测试结果
     *
     * @return 平台测试结果信息
     */
    @GetMapping(value = "/quiz/plt/test/result")
    public R<WmQuizVO.ToPltQuizTestVO> checkPlatQuizTestResult() {

        // 获取用户信息
        HnqzUser user = SecurityUtils.getUser();

        // 判断当前企业的的合规权限
        SysDept ent = sysDeptService.getById(user.getDeptId());
        String[] deptPermissions = ent.getDeptPermissions();
        boolean required = ArrayUtil.isNotEmpty(deptPermissions) && Stream.of(deptPermissions).collect(Collectors.toSet()).contains("3");

        // 获取平台的问卷 和 答题的情况
        List<WmQuiz> quizzes = quizService.listEntQuizzes(upmsConfig.getPltEntId(), UpmsState.QuizState.RELEASE);
        List<Map<String, Object>> histories = new LinkedList<>();
        if (CollUtil.isNotEmpty(quizzes)) {
            List<Integer> quizIds = quizzes.stream().mapToInt(WmQuiz::getQuizId).boxed().distinct().collect(Collectors.toList());
            Map<Integer, List<WmPlatformQuizTestResult>> collect =
                    platformQuizTestResultService.listPltQuizResults(user.getId(), quizIds).stream()
                            .collect(Collectors.groupingBy(WmPlatformQuizTestResult::getQuizId));
            LocalDate today = LocalDate.now();
            for (WmQuiz quiz : quizzes) {
                Map<String, Object> history = new HashMap<>(4);

                // 存在历史答题记录
                Integer finalMark = null;
                String expiryDate = null;
                boolean valid = false;

                List<WmPlatformQuizTestResult> quizTestResults = collect.get(quiz.getQuizId());
                if (CollUtil.isNotEmpty(quizTestResults)) {
                    // 已经倒序排了， 所以一定是最后的答题结果
                    WmPlatformQuizTestResult historyResult = quizTestResults.get(0);

                    finalMark = historyResult.getQuizResult().getFinalMark();
                    expiryDate = historyResult.getExpiry().format(DatePattern.NORM_DATE_FORMATTER);
                    valid = today.isBefore(historyResult.getExpiry());
                }

                history.put("quiz", quiz);
                history.put("finalMark", finalMark);
                history.put("expiryDate", expiryDate);
                history.put("valid", valid);
                histories.add(history);
            }
        }
        WmQuizVO.ToPltQuizTestVO vo = new WmQuizVO.ToPltQuizTestVO();
        vo.setRequired(required);
        vo.setTestResults(histories);

        return R.ok(vo);
    }


    /**
     * 获取当前用户的平台试题测试结果
     *
     * @return 平台测试结果信息
     */
    @GetMapping(value = "/quiz/plt/test/result/grouping")
    public R<Map<String, List<Integer>>> checkPlatQuizTestResult1() {

        // 获取用户信息
        HnqzUser user = SecurityUtils.getUser();

        // 获取平台的问卷 和 答题的情况
        List<WmQuiz> quizzes = quizService.listEntQuizzes(upmsConfig.getPltEntId(), UpmsState.QuizState.RELEASE);

        if (CollUtil.isEmpty(quizzes)) {
            return R.ok(Collections.emptyMap());
        }


        List<Integer> quizIds = quizzes.stream().mapToInt(WmQuiz::getQuizId).boxed().distinct().collect(Collectors.toList());

        Map<Integer, List<WmPlatformQuizTestResult>> collect =
                platformQuizTestResultService.listPltQuizResults(user.getId(), quizIds).stream()
                        .collect(Collectors.groupingBy(WmPlatformQuizTestResult::getQuizId));


        Map<String, List<Integer>> histories = new HashMap<>(2);

        List<Integer> passed = new LinkedList<>();
        List<Integer> failed = new LinkedList<>();

        quizIds.forEach(id -> {

            List<WmPlatformQuizTestResult> wmPlatformQuizTestResults = collect.get(id);
            if (CollUtil.isEmpty(wmPlatformQuizTestResults)) {
                failed.add(id);
            } else {
                WmPlatformQuizTestResult wmPlatformQuizTestResult = wmPlatformQuizTestResults.get(0);
                WmQuizResultModel quizResult = wmPlatformQuizTestResult.getQuizResult();

                if (quizResult.getFinalMark() - quizResult.getPassingMark() >= 0) {
                    passed.add(id);
                } else {
                    failed.add(id);
                }

            }
        });

        histories.put("passed", passed);
        histories.put("failed", failed);

        return R.ok(histories);

    }


    /**
     * 用户保存平台试卷测试结果
     *
     * @param resource 测试结果
     * @return 保存结果
     */
    @SysLog(value = "用户保存平台试卷测试结果")
    @PostMapping(value = "/quiz/plt/test/result/create")
    public R<Boolean> createUserPltQuizTestResult(@Valid @RequestBody WmQuizDTO.OnUserPltTestResultCreate resource) {
        HnqzUser user = SecurityUtils.getUser();

        Boolean succ = platformQuizTestResultService.createQuizTestResult(resource.getQuizResults(), user);

        return succ ? R.ok(true, "保存测试结果成功") : R.failed(false, "保存测试结果失败");
    }

    /**
     * 保存个人名片
     *
     * @param resource 参数
     * @return {@link R}<{@link ?}> 结果
     */
    @SysLog("保存个人名片")
    @PostMapping("/save-personal-business-card")
    public R<?> savePersonalBusinessCard(@RequestBody @Validated UserBusinessCardDTO resource) {

        SysUser updateUser = new SysUser();
        updateUser.setUserId(resource.getUserId());
        updateUser.setGender(resource.getGender());

        // 已签约/认证 或 已发起的不能修改姓名/身份证号
        int toCertCount = sysUserSubService.count(Wrappers.<SysUserSub>lambdaQuery()
                .eq(SysUserSub::getUserId, resource.getUserId())
                .notIn(SysUserSub::getCertStatus, 0, 10));

        if (toCertCount <= 0) {
            updateUser.setRealname(resource.getRealname());
            updateUser.setIdCardNumber(resource.getIdCardNumber());
        }
        updateUser.setDegree(resource.getDegree());
        updateUser.setQualificationRecordNumber(resource.getQualificationRecordNumber());
        updateUser.setQualificationsUrl(resource.getQualificationsUrl());
        sysUserService.updateById(updateUser);

        return R.ok();
    }

    /**
     * 查询个人名片
     *
     * @param userId 用户id
     * @return {@link R}<{@link ?}> 结果
     */
    @GetMapping("/get-personal-business-card/{userId}")
    public R<?> getPersonalBusinessCard(@PathVariable("userId") Integer userId) {
        SysUser user = sysUserService.getById(userId);
        SysDept dept = sysDeptService.getById(user.getDeptId());

        UserBusinessCardVO cardVO = new UserBusinessCardVO();
        // 基本信息
        cardVO.setUserId(userId);
        cardVO.setRealname(user.getRealname());
        cardVO.setGender(user.getGender());
        cardVO.setIdCardNumber(user.getIdCardNumber());
        cardVO.setUsername(user.getUsername());
        if (IdcardUtil.isValidCard(user.getIdCardNumber())) {
            // 根据身份证号计算年龄
            cardVO.setAge(IdcardUtil.getAgeByIdCard(user.getIdCardNumber()));
        }
        cardVO.setDegree(user.getDegree());

        // 平台经历
        cardVO.setServiceDeptName(dept.getName());
        // 服务时长 = 当前时间 - 用户创建时间
        long monthDifference = ChronoUnit.MONTHS.between(user.getCreateTime(), LocalDateTime.now());
        cardVO.setServiceDuration(String.format("%s个月", monthDifference));
        // 完成任务量
        int finishTaskCount = wmTaskService.count(Wrappers.<WmTask>lambdaQuery()
                .eq(WmTask::getTaskUserId, userId)
                .eq(WmTask::getDelFlag, DelEnum.NOT_DEL.getVal())
                .eq(WmTask::getRealFlag, "0")
                .ne(WmTask::getTaskStatus, TaskStatusEnum.INIT.val())
                .gt(WmTask::getScore, 0));
        // 审核通过任务量
        int approvedTaskCount = wmTaskService.count(Wrappers.<WmTask>lambdaQuery()
                .eq(WmTask::getTaskUserId, userId)
                .eq(WmTask::getDelFlag, DelEnum.NOT_DEL.getVal())
                .eq(WmTask::getRealFlag, "0")
                .eq(WmTask::getTaskStatus, TaskStatusEnum.APPROVED.val())
                .gt(WmTask::getScore, 0));
        cardVO.setFinishTaskCount(finishTaskCount);
        cardVO.setApprovedTaskCount(approvedTaskCount);
        if (finishTaskCount > 0) {
            cardVO.setApprovedTaskRate(String.format("%.2f%%", approvedTaskCount * 100.00 / finishTaskCount));
        } else {
            cardVO.setApprovedTaskRate("0.00%");
        }

        // 专业技能
        cardVO.setQualificationRecordNumber(user.getQualificationRecordNumber());
        cardVO.setQualificationsUrl(user.getQualificationsUrl());

        return R.ok(cardVO);
    }
}
