package com.qunzhixinxi.hnqz.admin.controller;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.LocalDateTimeUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.json.JSONUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.google.common.collect.Lists;
import com.pig4cloud.plugin.excel.annotation.RequestExcel;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsState;
import com.qunzhixinxi.hnqz.admin.api.constant.enums.DelEnum;
import com.qunzhixinxi.hnqz.admin.api.entity.SysAreaEntity;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDept;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDeptRelation;
import com.qunzhixinxi.hnqz.admin.api.entity.SysLog;
import com.qunzhixinxi.hnqz.admin.api.entity.SysUser;
import com.qunzhixinxi.hnqz.admin.api.entity.SysUserArea;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaAgent;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaDrugEnt;
import com.qunzhixinxi.hnqz.admin.api.entity.WmPackageTaskTypeQty;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTask;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskContent;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskType;
import com.qunzhixinxi.hnqz.admin.api.model.excel.WmTaskDupModel;
import com.qunzhixinxi.hnqz.admin.event.PackageContractEvent;
import com.qunzhixinxi.hnqz.admin.mapper.SysDeptMapper;
import com.qunzhixinxi.hnqz.admin.mapper.SysDeptRelationMapper;
import com.qunzhixinxi.hnqz.admin.mapper.WmDaAgentMapper;
import com.qunzhixinxi.hnqz.admin.mapper.WmDaDrugEntMapper;
import com.qunzhixinxi.hnqz.admin.mapper.WmTaskTypeMapper;
import com.qunzhixinxi.hnqz.admin.service.SysAreaEntityService;
import com.qunzhixinxi.hnqz.admin.service.SysLogService;
import com.qunzhixinxi.hnqz.admin.service.SysUserAreaService;
import com.qunzhixinxi.hnqz.admin.service.SysUserService;
import com.qunzhixinxi.hnqz.admin.service.WmPackageTaskTypeQtyService;
import com.qunzhixinxi.hnqz.admin.service.WmTaskContentService;
import com.qunzhixinxi.hnqz.admin.service.WmTaskService;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.security.annotation.Inner;
import com.qunzhixinxi.hnqz.common.security.util.SecurityUtils;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.http.MediaType;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.function.Function;
import java.util.stream.Collectors;

import static org.bouncycastle.asn1.x500.style.RFC4519Style.o;


/**
 * 初始化控制器
 *
 * @author jimmy
 * @date 2022/05/07 12:59
 */
@Slf4j
@AllArgsConstructor
@RestController
@RequestMapping(value = "/init", produces = MediaType.APPLICATION_JSON_VALUE)
public class InitController {

    private final WmTaskContentService taskContentService;
    private final WmTaskService taskService;
    private final SysLogService logService;
    private final WmTaskTypeMapper wmTaskTypeMapper;
    private final SysDeptMapper sysDeptMapper;
    private final WmDaDrugEntMapper wmDaDrugEntMapper;
    private final SysDeptRelationMapper sysDeptRelationMapper;
    private final WmDaAgentMapper wmDaAgentMapper;
    private final SysUserAreaService userAreaService;
    private final SysAreaEntityService areaEntityService;
    private final SysUserService userService;
    private final RedisTemplate<String, Object> redisTemplate;
    private final ApplicationEventPublisher applicationEventPublisher;
    private final WmPackageTaskTypeQtyService packageTaskTypeQtyService;


    @Inner(value = false)
    @GetMapping(value = "/cnbg/test")
    public R<String> cnbgInitTest() {
        return R.ok("TEST:" + System.currentTimeMillis());
    }

    /**
     * 批量同步指定的任务类型给所有企业
     *
     * @return 结果
     */
    @Inner(value = false)
    @PostMapping(value = "/cnbg/tasktype")
    public R<?> taskTypeInit() {

        List<WmTaskType> tempList = wmTaskTypeMapper.selectList(Wrappers.<WmTaskType>lambdaQuery().eq(WmTaskType::getTaskTypeLevel, "1"));

        // List<WmTaskType> tempList = wmTaskTypeMapper.selectBatchIds(wmTaskTypes);

        // 1.第一级是药企的情况
//		List<SysDept> deptList = sysDeptMapper.selectList(Wrappers.<SysDept>lambdaQuery()
//				.eq(SysDept::getLevel, 2));
        List<SysDept> sysDepts1 = sysDeptMapper.listAllDept();
        List<SysDept> deptList = new ArrayList<>();
        if (CollectionUtil.isNotEmpty(sysDepts1)) {
            deptList = sysDepts1.stream()
                    .filter(sysDept -> sysDept.getLevel().equals(2))
                    .collect(Collectors.toList());
        }
        // 遍历药企
        for (SysDept dept : deptList) {
            // 生成药企任务类型
            WmDaDrugEnt wmDaDrugEnt = wmDaDrugEntMapper.selectOne(Wrappers.<WmDaDrugEnt>lambdaQuery()
                    .eq(WmDaDrugEnt::getDeptId, dept.getDeptId())
//					.eq(WmDaDrugEnt::getEnableFlag, EnableEnum.ENABLE.val())
                    .eq(WmDaDrugEnt::getDelFlag, DelEnum.NOT_DEL.getVal()));
            if (wmDaDrugEnt == null) {
                continue;
            }
            for (WmTaskType wmTaskType1 : tempList) {
                WmTaskType newOne = BeanUtil.copyProperties(wmTaskType1, WmTaskType.class);
                newOne.setCreateTime(null);
                newOne.setId(null);
                newOne.setDurgentId(wmDaDrugEnt.getId());
                newOne.setTaskTypeLevel("2");
                newOne.setTaskEntId(wmDaDrugEnt.getId());
                newOne.setDeptId(wmDaDrugEnt.getDeptId());
                newOne.setStatus("0");
                newOne.setBaseId(wmTaskType1.getId());
                newOne.setRuleId(String.valueOf(wmDaDrugEnt.getId()));
                newOne.setParentId(wmTaskType1.getParentId());
                newOne.setTaskReceiverType(wmTaskType1.getTaskReceiverType());
                List<WmTaskType> taskTypeList = wmTaskTypeMapper.selectList(Wrappers.<WmTaskType>lambdaQuery()
                        .eq(WmTaskType::getTaskTypeName, wmTaskType1.getTaskTypeName())
                        .eq(WmTaskType::getRuleId, newOne.getRuleId())
                        .eq(WmTaskType::getDeptId, newOne.getDeptId())
                        .eq(WmTaskType::getTaskEntId, newOne.getTaskEntId()));
                if (CollectionUtil.isEmpty(taskTypeList)) {
                    newOne.setCreateTime(LocalDateTime.now());
                    wmTaskTypeMapper.insert(newOne);
                }
            }

            // 查询一级CSO
            List<SysDeptRelation> deptRelationList = sysDeptRelationMapper.selectList(Wrappers.<SysDeptRelation>lambdaQuery()
                    .eq(SysDeptRelation::getAncestor, dept.getDeptId())
                    .ne(SysDeptRelation::getDescendant, dept.getDeptId()));
            if (CollectionUtil.isEmpty(deptRelationList)) {
                continue;
            }
            List<Integer> oneCSODeptIdList = deptRelationList.stream()
                    .map(SysDeptRelation::getDescendant)
                    .collect(Collectors.toList());
            List<SysDept> oneCSODeptList = sysDeptMapper.selectByIds(oneCSODeptIdList);
//			List<SysDept> oneCSODeptList = sysDeptMapper.selectList(Wrappers.<SysDept>lambdaQuery()
//					.eq(SysDept::getParentId, dept.getDeptId())
//					.eq(SysDept::getDelFlag, DelEnum.NOT_DEL.getVal())
//					.eq(SysDept::getLevel, 3));
            for (SysDept oneCSODept : oneCSODeptList) {
                // 生成药企给一级CSO的任务类型
                WmDaAgent wmDaAgent = wmDaAgentMapper.selectOne(Wrappers.<WmDaAgent>lambdaQuery()
                        .eq(WmDaAgent::getDelFlag, DelEnum.NOT_DEL.getVal())
//						.eq(WmDaAgent::getEnableFlag, EnableEnum.ENABLE.val())
                        .eq(WmDaAgent::getDeptId, oneCSODept.getDeptId()));
                if (wmDaAgent == null) {
                    continue;
                }
                for (WmTaskType wmTaskType1 : tempList) {
                    WmTaskType newOne = BeanUtil.copyProperties(wmTaskType1, WmTaskType.class);
                    newOne.setCreateTime(null);
                    newOne.setId(null);
                    newOne.setLevel1Id(wmDaAgent.getId());
                    newOne.setDurgentId(wmDaDrugEnt.getId());
                    newOne.setTaskTypeLevel("2");
                    newOne.setRuleId("" + wmDaDrugEnt.getId() + wmDaAgent.getId());
                    newOne.setTaskEntId(wmDaAgent.getId());
                    newOne.setDeptId(wmDaAgent.getDeptId());
                    newOne.setStatus("0");
                    newOne.setBaseId(wmTaskType1.getId());
                    newOne.setTaskReceiverType(wmTaskType1.getTaskReceiverType());
                    List<WmTaskType> taskTypeList = wmTaskTypeMapper.selectList(Wrappers.<WmTaskType>lambdaQuery()
                            .eq(WmTaskType::getTaskTypeName, wmTaskType1.getTaskTypeName())
                            .eq(WmTaskType::getRuleId, newOne.getRuleId())
                            .eq(WmTaskType::getDeptId, newOne.getDeptId())
                            .eq(WmTaskType::getTaskEntId, newOne.getTaskEntId()));
                    if (CollectionUtil.isEmpty(taskTypeList)) {
                        newOne.setCreateTime(LocalDateTime.now());
                        wmTaskTypeMapper.insert(newOne);
                    }
                }
                // 生成一级CSO的任务类型
                for (WmTaskType wmTaskType2 : tempList) {
                    WmTaskType newOne = BeanUtil.copyProperties(wmTaskType2, WmTaskType.class);
                    newOne.setCreateTime(null);
                    newOne.setId(null);
                    newOne.setLevel1Id(wmDaAgent.getId());
                    newOne.setTaskTypeLevel("2");
                    newOne.setTaskEntId(wmDaAgent.getId());
                    newOne.setRuleId(String.valueOf(wmDaAgent.getId()));
                    newOne.setDeptId(wmDaAgent.getDeptId());
                    newOne.setStatus("0");
                    newOne.setBaseId(wmTaskType2.getId());
                    newOne.setTaskReceiverType(wmTaskType2.getTaskReceiverType());
                    List<WmTaskType> taskTypeList = wmTaskTypeMapper.selectList(Wrappers.<WmTaskType>lambdaQuery()
                            .eq(WmTaskType::getTaskTypeName, wmTaskType2.getTaskTypeName())
                            .eq(WmTaskType::getRuleId, newOne.getRuleId())
                            .eq(WmTaskType::getDeptId, newOne.getDeptId())
                            .eq(WmTaskType::getTaskEntId, newOne.getTaskEntId()));
                    if (CollectionUtil.isEmpty(taskTypeList)) {
                        newOne.setCreateTime(LocalDateTime.now());
                        wmTaskTypeMapper.insert(newOne);
                    }
                }

                // 查询二级CSO
                List<SysDept> twoCSODeptList = sysDeptMapper.selectList(Wrappers.<SysDept>lambdaQuery()
                        .eq(SysDept::getParentId, oneCSODept.getDeptId())
//						.eq(SysDept::getDelFlag, DelEnum.NOT_DEL.getVal())
                        .eq(SysDept::getLevel, 4));
                for (SysDept twoCSODept : twoCSODeptList) {
                    // 生成二级CSO任务类型
                    WmDaAgent wmDaAgent2 = wmDaAgentMapper.selectOne(Wrappers.<WmDaAgent>lambdaQuery()
                            .eq(WmDaAgent::getDelFlag, DelEnum.NOT_DEL.getVal())
//							.eq(WmDaAgent::getEnableFlag, EnableEnum.ENABLE.val())
                            .eq(WmDaAgent::getDeptId, twoCSODept.getDeptId()));
                    if (wmDaAgent2 == null) {
                        continue;
                    }
                    for (WmTaskType wmTaskType2 : tempList) {
                        WmTaskType newOne = BeanUtil.copyProperties(wmTaskType2, WmTaskType.class);
                        newOne.setCreateTime(null);
                        newOne.setId(null);
                        newOne.setLevel1Id(wmDaAgent2.getId());
                        newOne.setTaskTypeLevel("2");
                        newOne.setTaskEntId(wmDaAgent2.getId());
                        newOne.setRuleId(String.valueOf(wmDaAgent2.getId()));
                        newOne.setDeptId(wmDaAgent2.getDeptId());
                        newOne.setStatus("0");
                        newOne.setBaseId(wmTaskType2.getId());
                        newOne.setTaskReceiverType(wmTaskType2.getTaskReceiverType());
                        List<WmTaskType> taskTypeList = wmTaskTypeMapper.selectList(Wrappers.<WmTaskType>lambdaQuery()
                                .eq(WmTaskType::getTaskTypeName, wmTaskType2.getTaskTypeName())
                                .eq(WmTaskType::getRuleId, newOne.getRuleId())
                                .eq(WmTaskType::getDeptId, newOne.getDeptId())
                                .eq(WmTaskType::getTaskEntId, newOne.getTaskEntId()));
                        if (CollectionUtil.isEmpty(taskTypeList)) {
                            newOne.setCreateTime(LocalDateTime.now());
                            wmTaskTypeMapper.insert(newOne);
                        }
                    }
                }

            }

        }

        // 2.第一级是CSO的情况
//		List<SysDept> deptList2 = sysDeptMapper.selectList(Wrappers.<SysDept>lambdaQuery()
//				.eq(SysDept::getLevel, 3)
//				.isNull(SysDept::getParentId));
        List<SysDept> sysDepts = sysDeptMapper.listAllDept();
        List<SysDept> deptList2 = new ArrayList<>();
        if (CollectionUtil.isNotEmpty(sysDepts)) {
            deptList2 = sysDepts.stream()
                    .filter(sysDept -> sysDept.getLevel().equals(3) && sysDept.getParentId() == null)
                    .collect(Collectors.toList());
        }
        // 查询一级CSO
        for (SysDept oneCSODept : deptList2) {
            // 生成药企给一级CSO的任务类型
            WmDaAgent wmDaAgent = wmDaAgentMapper.selectOne(Wrappers.<WmDaAgent>lambdaQuery()
                    .eq(WmDaAgent::getDelFlag, DelEnum.NOT_DEL.getVal())
//					.eq(WmDaAgent::getEnableFlag, EnableEnum.ENABLE.val())
                    .eq(WmDaAgent::getDeptId, oneCSODept.getDeptId()));
            if (wmDaAgent == null) {
                continue;
            }
            // 生成一级CSO的任务类型
            for (WmTaskType wmTaskType2 : tempList) {
                WmTaskType newOne = BeanUtil.copyProperties(wmTaskType2, WmTaskType.class);
                newOne.setCreateTime(null);
                newOne.setId(null);
                newOne.setLevel1Id(wmDaAgent.getId());
                newOne.setTaskTypeLevel("2");
                newOne.setTaskEntId(wmDaAgent.getId());
                newOne.setRuleId(String.valueOf(wmDaAgent.getId()));
                newOne.setDeptId(wmDaAgent.getDeptId());
                newOne.setStatus("0");
                newOne.setBaseId(wmTaskType2.getId());
                newOne.setTaskReceiverType(wmTaskType2.getTaskReceiverType());
                List<WmTaskType> taskTypeList = wmTaskTypeMapper.selectList(Wrappers.<WmTaskType>lambdaQuery()
                        .eq(WmTaskType::getTaskTypeName, wmTaskType2.getTaskTypeName())
                        .eq(WmTaskType::getRuleId, newOne.getRuleId())
                        .eq(WmTaskType::getDeptId, newOne.getDeptId())
                        .eq(WmTaskType::getTaskEntId, newOne.getTaskEntId()));
                if (CollectionUtil.isEmpty(taskTypeList)) {
                    newOne.setCreateTime(LocalDateTime.now());
                    wmTaskTypeMapper.insert(newOne);
                }
            }

            // 查询二级CSO
            List<SysDept> twoCSODeptList = sysDeptMapper.selectList(Wrappers.<SysDept>lambdaQuery()
                    .eq(SysDept::getParentId, oneCSODept.getDeptId())
//					.eq(SysDept::getDelFlag, DelEnum.NOT_DEL.getVal())
                    .eq(SysDept::getLevel, 4));
            for (SysDept twoCSODept : twoCSODeptList) {
                // 生成二级CSO任务类型
                WmDaAgent wmDaAgent2 = wmDaAgentMapper.selectOne(Wrappers.<WmDaAgent>lambdaQuery()
                        .eq(WmDaAgent::getDelFlag, DelEnum.NOT_DEL.getVal())
//						.eq(WmDaAgent::getEnableFlag, EnableEnum.ENABLE.val())
                        .eq(WmDaAgent::getDeptId, twoCSODept.getDeptId()));
                if (wmDaAgent2 == null) {
                    continue;
                }
                for (WmTaskType wmTaskType2 : tempList) {
                    WmTaskType newOne = BeanUtil.copyProperties(wmTaskType2, WmTaskType.class);
                    newOne.setCreateTime(null);
                    newOne.setId(null);
                    newOne.setLevel1Id(wmDaAgent2.getId());
                    newOne.setTaskTypeLevel("2");
                    newOne.setTaskEntId(wmDaAgent2.getId());
                    newOne.setRuleId(String.valueOf(wmDaAgent2.getId()));
                    newOne.setDeptId(wmDaAgent2.getDeptId());
                    newOne.setStatus("0");
                    newOne.setBaseId(wmTaskType2.getId());
                    newOne.setTaskReceiverType(wmTaskType2.getTaskReceiverType());
                    List<WmTaskType> taskTypeList = wmTaskTypeMapper.selectList(Wrappers.<WmTaskType>lambdaQuery()
                            .eq(WmTaskType::getTaskTypeName, wmTaskType2.getTaskTypeName())
                            .eq(WmTaskType::getRuleId, newOne.getRuleId())
                            .eq(WmTaskType::getDeptId, newOne.getDeptId())
                            .eq(WmTaskType::getTaskEntId, newOne.getTaskEntId()));
                    if (CollectionUtil.isEmpty(taskTypeList)) {
                        newOne.setCreateTime(LocalDateTime.now());
                        wmTaskTypeMapper.insert(newOne);
                    }
                }
            }
        }
        return R.ok();
    }

    @Inner(value = false)
    @PostMapping(value = "/cnbg/user/area/{userId}")
    public R<Boolean> initUserArea(@PathVariable(value = "userId") Long userId) {
        List<SysAreaEntity> list = areaEntityService.list(Wrappers.<SysAreaEntity>lambdaQuery().eq(SysAreaEntity::getAreaStatus, true));


        Set<Long> collect = list.stream().mapToLong(SysAreaEntity::getAreaId).boxed().collect(Collectors.toSet());

        LocalDateTime now = LocalDateTime.now();
        List<SysUserArea> collect1 = collect.stream().map(aId -> {
            SysUserArea userArea = new SysUserArea();
            userArea.setUserId(userId);
            userArea.setAreaId(aId);
            userArea.setCreateTime(now);
            return userArea;

        }).collect(Collectors.toList());

        userAreaService.saveBatch(collect1);
        return R.ok();
    }

    @Inner(value = false)
    @PostMapping(value = "/cnbg/user/area/batch")
    @Transactional(rollbackFor = Exception.class)
    public R<Boolean> initUserArea() {

        List<SysUser> users = userService.list(Wrappers.<SysUser>lambdaQuery().gt(SysUser::getCreateTime, LocalDateTime.of(LocalDate.now(), LocalTime.MIN)));


        List<SysAreaEntity> list = areaEntityService.list(Wrappers.<SysAreaEntity>lambdaQuery().eq(SysAreaEntity::getAreaStatus, true));


        Set<Long> collect = list.stream().mapToLong(SysAreaEntity::getAreaId).boxed().collect(Collectors.toSet());

        LocalDateTime now = LocalDateTime.now();

        for (SysUser user : users) {

            List<SysUserArea> collect1 = collect.stream().map(aId -> {
                SysUserArea userArea = new SysUserArea();
                userArea.setUserId((long) user.getUserId());
                userArea.setAreaId(aId);
                userArea.setCreateTime(now);
                return userArea;

            }).collect(Collectors.toList());
            userAreaService.saveBatch(collect1);
        }

        return R.ok();
    }

    @Inner(value = false)
    @PostMapping(value = "/cnbg/cache/clean")
    public R<Boolean> clean(@RequestBody Map<String, Object> params) {


        Object o = params.get("username");

        final String errorKey = "login:error:lock:" + o;

        if (Boolean.TRUE.equals(redisTemplate.hasKey(errorKey))) {
            Boolean delete = redisTemplate.delete(errorKey);

            return R.ok(delete);
        } else {
            return R.ok(false, "key:" + errorKey + ",不存在");
        }


    }

    @Inner(value = false)
    @PostMapping(value = "/cnbg/pkg/contract/create")
    public R<Boolean> sendPkgContractEvent(@RequestBody Map<String, Object> params) {
        Integer pkgId = (Integer) params.get("pkgId");

        List<WmPackageTaskTypeQty> list = packageTaskTypeQtyService.list(Wrappers.<WmPackageTaskTypeQty>lambdaQuery().eq(WmPackageTaskTypeQty::getPackageId, pkgId).orderByDesc(WmPackageTaskTypeQty::getCreateTime));

        if (CollectionUtil.isEmpty(list)) {
            return R.failed(Boolean.FALSE, "不存在任务数量明细");
        }

        Map<LocalDateTime, List<WmPackageTaskTypeQty>> collect = list.stream().collect(Collectors.groupingBy(WmPackageTaskTypeQty::getCreateTime));
        LocalDateTime now = LocalDateTime.now();
        LocalDateTime localDateTime = collect.keySet().stream().max(Comparator.comparing(item -> Math.abs(LocalDateTimeUtil.between(now, item).getSeconds()))).orElse(null);

        PackageContractEvent event = new PackageContractEvent();
        event.setPackageId(pkgId);
        event.setTaskTypeQtiyList(collect.get(localDateTime));
        event.setCreator("admin");

        applicationEventPublisher.publishEvent(event);

        return R.ok(Boolean.TRUE, "合同生成事件已发送");
    }

    @Inner(value = false)
    @GetMapping(value = "/cnbg/task/content/update")
    public R<Boolean> init1() {

        List<SysLog> logs = logService.list(Wrappers.<SysLog>lambdaQuery()
                .ge(SysLog::getCreateTime, LocalDateTime.of(2024, 11, 10, 0, 0, 0))
                .eq(SysLog::getTitle, "新增任务内容表"));


        if (CollUtil.isEmpty(logs)) {
            return R.ok(Boolean.TRUE, "不存在日志");
        }

        List<String> collect = logs.stream().map(SysLog::getParams).filter(StrUtil::isNotBlank).collect(Collectors.toList());


        if (CollUtil.isEmpty(collect)) {

            return R.ok(Boolean.TRUE, "日志参数不存在");
        }

        Set<String> ttIds = Set.of("2", "3", "4");
        Map<String, WmTaskContent> tempContent = collect.stream()
                // json 2 bean
                .map(p -> JSONUtil.toBean(p, WmTaskContent.class))
                //  获取修复的类型
                .filter(tc -> ttIds.contains(tc.getTemp30()))
                // temp10分组
                .collect(Collectors.toMap(WmTaskContent::getTemp10, Function.identity(), (v1, v2) -> v2));


        // List<String> tcIds = taskService.list(Wrappers.<WmTask>lambdaQuery().ge(WmTask::getCreateTime, LocalDateTime.of(2024, 11, 10, 0, 0, 0)))
        //         .stream().map(WmTask::getTaskContentId).sorted().collect(Collectors.toList());

        List<WmTaskContent> taskContents = taskContentService.list(Wrappers.<WmTaskContent>lambdaQuery()
                // .in(WmTaskContent::getId, tcIds)
                .in(WmTaskContent::getTemp30, ttIds));


        List<WmTaskContent> updateed = new LinkedList<>();

        for (WmTaskContent taskContent : taskContents) {

            String temp10 = taskContent.getTemp10();

            WmTaskContent params = tempContent.get(temp10);

            if (params == null) {
                continue;
            }
            String temp17 = params.getTemp17();


            if (StrUtil.isBlank(temp17)) {
                continue;
            }
            WmTaskContent newOne = new WmTaskContent();
            newOne.setId(taskContent.getId());
            newOne.setTemp27(temp17);
            updateed.add(newOne);

        }


        taskContentService.updateBatchById(updateed);

        log.info("updateed:{}", JSONUtil.toJsonStr(updateed));
        return R.ok(Boolean.TRUE, updateed.size() + "");
    }


    @Inner(value = false)
    @PostMapping(value = "/cnbg/del/dup/task")
    @Transactional(rollbackFor = Exception.class)
    public R<Map<String, Collection<String>>> delDupTaskContent(@RequestExcel(ignoreEmptyRow = true) List<WmTaskDupModel> dup) {


        if (CollUtil.isEmpty(dup)) {
            return R.ok(Collections.EMPTY_MAP, "重复数据集为空");
        }


        List<WmTask> targetTasks = new LinkedList<>();

        // 排序去重 && 获取重复的任务记录
        List<String> taskNumbers = dup.stream().map(WmTaskDupModel::getTaskNumber).distinct().sorted().collect(Collectors.toList());

        List<List<String>> partition = Lists.partition(taskNumbers, 100);

        for (List<String> numberList : partition) {

            List<WmTask> temp = taskService.list(Wrappers.<WmTask>lambdaQuery().in(WmTask::getTaskNumber, numberList));
            targetTasks.addAll(temp);
        }


        Map<String, WmTask> tcIds2TaskMap = targetTasks.stream().collect(Collectors.toMap(WmTask::getTaskContentId, Function.identity()));
        Map<String, WmTask> tIds2TaskMap = targetTasks.stream().collect(Collectors.toMap(WmTask::getId, Function.identity()));


        // 获取重复任务的任务内容
        List<WmTaskContent> taskContents = new LinkedList<>();

        List<List<String>> partition1 = Lists.partition(new ArrayList<>(tcIds2TaskMap.keySet()), 100);

        for (List<String> numberList : partition1) {
            List<WmTaskContent> byId = taskContentService.listByIds(numberList);
            taskContents.addAll(byId);
        }


        Map<String, List<WmTaskContent>> collect = taskContents.stream().collect(Collectors.groupingBy(this::getContentStr));

        // 要保留的数据
        Set<String> tIds = new HashSet<>();
        Set<String> tcIds = new HashSet<>();
        for (Map.Entry<String, List<WmTaskContent>> entry : collect.entrySet()) {
            List<WmTaskContent> value = entry.getValue();

            if (value.size() < 2) {
                continue;
            }

            List<WmTask> tempTasks = new LinkedList<>();
            for (WmTaskContent taskContent : value) {

                String tcId = taskContent.getId().toString();
                WmTask task = tcIds2TaskMap.get(tcId);

                tempTasks.add(task);

            }

            Map<Boolean, List<WmTask>> statusMap = tempTasks.stream().collect(Collectors.partitioningBy(t -> UpmsState.TaskState.REJECTED.getState().equals(t.getTaskStatus())));
            List<WmTask> rejected = statusMap.get(true);
            List<WmTask> others = statusMap.get(false);
            // 如果全是拒绝的
            if (CollUtil.isEmpty(others)) {
                tIds.add(rejected.get(0).getId());
                tcIds.add(rejected.get(0).getTaskContentId());
            }
            // 部分拒绝的
            else {
                Map<Boolean, List<WmTask>> passedAndPending = others.stream().collect(Collectors.partitioningBy(t -> UpmsState.TaskState.PASSED.getState().equals(t.getTaskStatus())));
                List<WmTask> passed = passedAndPending.get(true);
                List<WmTask> pending = passedAndPending.get(false);
                if (CollUtil.isNotEmpty(passed)) {
                    tIds.add(passed.get(0).getId());
                    tcIds.add(passed.get(0).getTaskContentId());
                } else {
                    if (CollUtil.isNotEmpty(pending)) {
                        tIds.add(pending.get(0).getId());
                        tcIds.add(pending.get(0).getTaskContentId());
                    }
                }

            }

        }


        Collection<String> disForTask = CollUtil.disjunction(tIds, tIds2TaskMap.keySet());
        Collection<String> disForTaskContent = CollUtil.disjunction(tcIds, tcIds2TaskMap.keySet());

        Map<String, Collection<String>> rest = new LinkedHashMap<>(4);

        rest.put("disForTask", disForTask);
        rest.put("availForTask", tIds);
        rest.put("availForTaskContent", tcIds);
        rest.put("disForTaskContent", disForTaskContent);

        return R.ok(rest, Boolean.TRUE.toString());

    }

    private String getContentStr(WmTaskContent content) {

        return content.getTemp1() +
                content.getTemp2() +
                content.getTemp3() +
                content.getTemp4() +
                content.getTemp5() +
                content.getTemp6() +
                content.getTemp7() +
                content.getTemp8() +
                content.getTemp9() +
                content.getTemp10() +
                content.getTemp11() +
                content.getTemp12() +
                content.getTemp13() +
                content.getTemp14() +
                content.getTemp15() +
                content.getTemp16() +
                content.getTemp17() +
                content.getTemp18() +
                content.getTemp19() +
                content.getTemp20() +
                content.getTemp21() +
                content.getTemp22() +
                content.getTemp23() +
                content.getTemp24() +
                content.getTemp25() +
                content.getTemp26() +
                content.getTemp27() +
                content.getTemp28() +
                content.getTemp29() +
                content.getTemp30() +
                content.getTemp31() +
                content.getTemp32();


    }


}
