package com.qunzhixinxi.hnqz.admin.controller;

import com.qunzhixinxi.hnqz.admin.service.MobileService;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.security.annotation.Inner;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author hnqz
 * @date 2018/11/14
 * <p>
 * 手机验证码
 */
@Slf4j
@RestController
@AllArgsConstructor
@RequestMapping("/mobile")
public class MobileController {

    private final MobileService cnbgMobileService;

    @Inner(value = false)
    @GetMapping("/{mobile}")
    public R<Boolean> sendSmsCode(@PathVariable String mobile) {
        return cnbgMobileService.sendSmsCode(mobile);
    }

    /**
     * 忘记密码
     *
     * @param mobile 手机号
     * @return 发送结果
     */
    @Inner(value = false)
    @GetMapping("/upd/{mobile}")
    public R<Boolean> sendSmsCode1(@PathVariable String mobile) {
        return cnbgMobileService.sendSmsCode1(mobile);
    }


    @GetMapping("/pc/{mobile}")
    public R<Boolean> sendSmsCodePc(@PathVariable String mobile) {
        return cnbgMobileService.sendSmsCodePc(mobile);
    }

    @GetMapping("/verify/{mobile}/{code}")
    public R<Boolean> verifyCode(@PathVariable(value = "code") String code, @PathVariable(value = "mobile") String mobile) {

        return R.ok(cnbgMobileService.verifyCode(mobile, code));
    }


}
