package com.qunzhixinxi.hnqz.admin.controller;

import com.qunzhixinxi.hnqz.admin.api.dto.SysArchiveDto;
import com.qunzhixinxi.hnqz.admin.manager.SysArchiveManager;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.log.annotation.SysLog;
import com.qunzhixinxi.hnqz.common.security.util.SecurityUtils;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

/**
 * 归档前端控制器
 *
 * @author jimmy
 * @date 2024-11-24 16:28
 */
@Slf4j
@RestController
@AllArgsConstructor
public class SysArchiveController {

    private SysArchiveManager archiveManager;

    @SysLog("归档计划")
    @PostMapping(value = "/archive/plan")
    public R<Boolean> doPlanArchive(@Validated @RequestBody SysArchiveDto.OnPlanArchive resource) {

        return R.ok(archiveManager.destroyPlan(resource, SecurityUtils.getUser()));
    }
}
