package com.qunzhixinxi.hnqz.admin.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.admin.api.dto.SysNoticeDto;
import com.qunzhixinxi.hnqz.admin.api.entity.SysNotice;
import com.qunzhixinxi.hnqz.admin.service.SysNoticeService;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.log.annotation.SysLog;
import com.qunzhixinxi.hnqz.common.security.util.SecurityUtils;
import lombok.AllArgsConstructor;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * 系统通知前端控制器
 *
 * @author jimmy
 * @date 09/07/2024 15:51
 */
@RestController
@AllArgsConstructor
public class SysNoticeController {

    private final SysNoticeService noticeService;


    @GetMapping(value = "/notice/page")
    public R<Page<SysNotice>> pageNotices(@Validated SysNoticeDto.OnPage query) {

        return R.ok(noticeService.pageNotices(query, SecurityUtils.getUser()));
    }

    @SysLog(value = "阅读通知")
    @PostMapping(value = "/notice/read")
    public R<Boolean> readNotice(@Validated @RequestBody SysNoticeDto.OnRead resource) {

        return R.ok(noticeService.readNotice(resource, SecurityUtils.getUser()));

    }


    @GetMapping(value = "/notice/count")
    public R<Integer> countNotice(@RequestParam(value = "read") Boolean read) {
        return R.ok(noticeService.countNotices(read, SecurityUtils.getUser()));
    }
}
