package com.qunzhixinxi.hnqz.admin.controller;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.text.CharSequenceUtil;
import cn.hutool.core.text.StrPool;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsType;
import com.qunzhixinxi.hnqz.admin.api.dto.WmDaAgentDTO;
import com.qunzhixinxi.hnqz.admin.api.entity.SysAreaEntity;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDept;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDeptRelation;
import com.qunzhixinxi.hnqz.admin.api.entity.SysUser;
import com.qunzhixinxi.hnqz.admin.api.constant.enums.DelEnum;
import com.qunzhixinxi.hnqz.admin.api.constant.enums.EnableEnum;
import com.qunzhixinxi.hnqz.admin.api.entity.WmAgentComplianceDocument;
import com.qunzhixinxi.hnqz.admin.api.entity.WmAgentEvaluation;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaAgent;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaDrugEnt;
import com.qunzhixinxi.hnqz.admin.api.entity.WmRelation;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskType;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskTypeEntRef;
import com.qunzhixinxi.hnqz.admin.api.model.input.WmDept;
import com.qunzhixinxi.hnqz.admin.mapper.SysDeptMapper;
import com.qunzhixinxi.hnqz.admin.mapper.SysDeptRelationMapper;
import com.qunzhixinxi.hnqz.admin.mapper.SysUserMapper;
import com.qunzhixinxi.hnqz.admin.mapper.WmDaAgentMapper;
import com.qunzhixinxi.hnqz.admin.mapper.WmDaDrugEntMapper;
import com.qunzhixinxi.hnqz.admin.mapper.WmRelationMapper;
import com.qunzhixinxi.hnqz.admin.mapper.WmTaskTypeEntRefMapper;
import com.qunzhixinxi.hnqz.admin.mapper.WmTaskTypeMapper;
import com.qunzhixinxi.hnqz.admin.service.SysAreaEntityService;
import com.qunzhixinxi.hnqz.admin.service.SysCsmUserRelationService;
import com.qunzhixinxi.hnqz.admin.service.SysDeptRelationService;
import com.qunzhixinxi.hnqz.admin.service.SysDeptService;
import com.qunzhixinxi.hnqz.admin.service.SysEnterpriseAreaService;
import com.qunzhixinxi.hnqz.admin.service.SysUserAreaService;
import com.qunzhixinxi.hnqz.admin.service.WmAgentComplianceDocumentService;
import com.qunzhixinxi.hnqz.admin.service.WmAgentEvaluationService;
import com.qunzhixinxi.hnqz.admin.service.WmDaAgentService;
import com.qunzhixinxi.hnqz.admin.service.WmDaDrugEntService;
import com.qunzhixinxi.hnqz.admin.service.WmRelationService;
import com.qunzhixinxi.hnqz.admin.util.AreaUtils;
import com.qunzhixinxi.hnqz.common.core.constant.CommonConstants;
import com.qunzhixinxi.hnqz.common.core.entity.BaseEntity;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.log.annotation.SysLog;
import com.qunzhixinxi.hnqz.common.security.util.SecurityUtils;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * 档案-代理商
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
@Slf4j
@RestController
@AllArgsConstructor
@RequestMapping("/wmdaagent")
public class WmDaAgentController {

    private final WmDaAgentService wmDaAgentService;
    private final WmDaDrugEntService wmDaDrugEntService;
    private final WmRelationService wmRelationService;
    private final WmDaDrugEntMapper wmDaDrugEntMapper;
    private final SysDeptService sysDeptService;
    private final SysUserMapper sysUserMapper;
    private final SysDeptMapper deptMapper;
    private final WmTaskTypeEntRefMapper wmTaskTypeEntRefMapper;
    private final WmTaskTypeMapper wmTaskTypeMapper;
    private final WmRelationMapper wmRelationMapper;
    private final WmDaAgentMapper wmDaAgentMapper;
    private final SysDeptRelationMapper sysDeptRelationMapper;
    private final SysDeptMapper sysDeptMapper;
    private final SysDeptRelationService sysDeptRelationService;
    private final SysCsmUserRelationService sysCsmUserRelationService;
    private final SysUserAreaService userAreaService;
    private final SysEnterpriseAreaService enterpriseAreaService;
    private final SysAreaEntityService areaEntityService;
    private final WmAgentEvaluationService agentEvaluationService;
    private final WmAgentComplianceDocumentService agentComplianceDocumentService;

    /**
     * 分页查询
     *
     * @param wmDaAgent 档案-代理商
     * @return 分页结果
     */
    @PostMapping("/page")
    public R<?> getWmDaAgentPage(@RequestBody WmDaAgent wmDaAgent) {

        Page<WmDaAgent> page1 = new Page<>(wmDaAgent.getCurrent(), wmDaAgent.getSize());
        Integer myselfId = SecurityUtils.getUser().getDeptId();

        Set<Integer> ids = new HashSet<>();
        ids.add(myselfId);


        // 查询我的下游
        WmRelation wmRelation = new WmRelation();
        wmRelation.setUpId(myselfId);
        List<WmRelation> wmRelationList = wmRelationMapper.selectUpIdList(wmRelation);
        if (CollUtil.isNotEmpty(wmRelationList)) {
            // 下游ID
            List<Integer> downIds = wmRelationList.stream().map(WmRelation::getDownId).collect(Collectors.toList());
            if (CollUtil.isNotEmpty(downIds)) {
                ids.addAll(downIds);
            }

        }


        // 区域限制
        List<Long> entIds = new LinkedList<>();
        if (CollUtil.isNotEmpty(wmDaAgent.getAreaCodes())) {
            entIds = enterpriseAreaService.listAreaEnts(wmDaAgent.getAreaCodes());
        } else {
            List<Long> areaId = userAreaService.listUserAreas(Long.valueOf(SecurityUtils.getUser().getId()));
            if (CollUtil.isNotEmpty(areaId)) {

                // 集合分片

                List<List<Long>> partition = AreaUtils.partition(areaId);


                for (List<Long> p : partition) {
                    List<Long> collect = areaEntityService.list(Wrappers.<SysAreaEntity>lambdaQuery()
                                    .in(SysAreaEntity::getAreaId, p)
                                    .eq(SysAreaEntity::getAreaStatus, Boolean.TRUE)
                                    .eq(SysAreaEntity::getAreaType, UpmsType.AreaType.DISTRICT))
                            .stream()
                            .mapToLong(SysAreaEntity::getAreaId).boxed().distinct().collect(Collectors.toList());

                    if (CollUtil.isEmpty(collect)) {
                        continue;
                    }

                    List<Long> eIds = enterpriseAreaService.listAreaEnts(collect);

                    entIds.addAll(eIds);
                }

            }

        }

        // List<Long> entIds = enterpriseAreaService.listAreaEnts(areaId);

        // 交集
        Set<Integer> resSet = new HashSet<>(ids);
        resSet.retainAll(entIds.stream().map(Long::intValue).collect(Collectors.toSet()));


        if (CollUtil.isEmpty(resSet)) {
            return R.ok(page1);
        }

        List<WmDaAgent> wmDaAgentList = wmDaAgentMapper.selectDeptByIds(resSet, wmDaAgent.getGsmc());

        if (CollUtil.isEmpty(wmDaAgentList)) {
            return R.ok(page1);
        }

        // 获取评价信息
        Set<Integer> deptIds = wmDaAgentList.stream().map(WmDaAgent::getDeptId).collect(Collectors.toSet());

        Map<Integer, List<WmAgentEvaluation>> admission = agentEvaluationService.list(Wrappers.<WmAgentEvaluation>lambdaQuery().in(WmAgentEvaluation::getDeptId, deptIds).eq(WmAgentEvaluation::getEvalType, "admission"))
                .stream().collect(Collectors.groupingBy(WmAgentEvaluation::getDeptId));

        wmDaAgentList.forEach(agent -> agent.setEvaluated(admission.containsKey(agent.getDeptId())));


        // 每页数据条数
        int count = wmDaAgentList.size();
        List<WmDaAgent> pageList = new ArrayList<>();
        // 计算当前页第一条数据的下标
        int currId = wmDaAgent.getCurrent() > 1 ? (wmDaAgent.getCurrent() - 1) * wmDaAgent.getSize() : 0;
        for (int i = 0; i < wmDaAgent.getSize() && i < count - currId; i++) {
            pageList.add(wmDaAgentList.get(currId + i));
        }
        page1.setSize(wmDaAgent.getSize());
        page1.setCurrent(wmDaAgent.getCurrent());
        page1.setTotal(count);
        // 计算分页总页数
        page1.setPages(count % wmDaAgent.getSize() == 0 ? count / wmDaAgent.getSize() : count / wmDaAgent.getSize() + 1);

        if (CollUtil.isNotEmpty(pageList)) {
            pageList.forEach(p -> {

                List<Long> areas = enterpriseAreaService.listEntAreas(Collections.singletonList(Long.valueOf(p.getDeptId())));
                p.setAreaCodes(areas);

            });
        }


        page1.setRecords(pageList);
        return R.ok(page1);
    }


    /**
     * 通过id查询档案-代理商
     *
     * @param id id
     * @return R
     */
    @GetMapping("/{id}")
    public R<WmDaAgent> getById(@PathVariable("id") Integer id) {
        return R.ok(wmDaAgentService.getById(id));
    }


    @SysLog("派工企业管理-新增")
    @PostMapping("/insert")
    public R<?> insert(@RequestBody WmDaAgent wmDaAgent) {
        return wmDaAgentService.insert(wmDaAgent);
    }


    @SysLog("创建企业类型服务商")
    @PostMapping("/{agent_type}/create")
    @Transactional(rollbackFor = Exception.class)
    public R<Boolean> createAgent(@PathVariable(value = "agent_type") String agentType, @Validated @RequestBody WmDaAgentDTO.OnEntAgentCreate resource) {

        if (!"ae".equalsIgnoreCase(agentType)) {
            return R.failed(false, "支持企业类型服务商创建");
        }

        Integer deptId = SecurityUtils.getUser().getDeptId();

        WmDaAgent query = new WmDaAgent();
        query.setGsmc(resource.getAgentName());
        List<WmDaAgent> list1 = wmDaAgentService.list(Wrappers.query(query));

        WmDaAgent wmDaAgent4 = new WmDaAgent();
        wmDaAgent4.setZjNumber(resource.getRegCode());
        List<WmDaAgent> list5 = wmDaAgentMapper.selectList(Wrappers.query(wmDaAgent4));
        List<WmDaAgent> list3 = wmDaAgentMapper.selectByGsmcList(query);
        SysDeptRelation sysDeptRelation = new SysDeptRelation();

        if (CollUtil.isNotEmpty(list3)) {
            sysDeptRelation.setAncestor(deptId);
            sysDeptRelation.setDescendant(list3.get(0).getDeptId());
        }

        List<SysDeptRelation> list4 = sysDeptRelationMapper.selectDeptRelation(sysDeptRelation);

        WmDaDrugEnt wmDaDrugEnt = new WmDaDrugEnt();
        wmDaDrugEnt.setDeptId(SecurityUtils.getUser().getDeptId());
        WmDaDrugEnt wmDaDrugEnt1 = wmDaDrugEntMapper.selectDeptId(wmDaDrugEnt);
        if (list1.size() > 0 && list4.size() > 0) {
            return R.failed("代理商名称及关系已存在");
        }
        if (list5.size() < 1 && list1.size() > 0) {
            return R.failed("企业名称已经存在");
        }
        if (list5.size() > 0 && list1.size() < 1) {
            return R.failed("统一社会信用代码已经存在");
        }
        if (list1.size() < 1 && list4.size() < 1) {
            SysDept sysDept = sysDeptService.getById(SecurityUtils.getUser().getDeptId());
            if (sysDept.getLevel() == 4) {
                return R.failed("组织机构选择二级代理商不能继续添加代理商");
            }

            WmDaAgent wmDaAgent = new WmDaAgent();
            wmDaAgent.setAgentType(agentType.toUpperCase());
            wmDaAgent.setGsmc(resource.getAgentName());
            wmDaAgent.setYyzz(resource.getBizLicenceImg());
            wmDaAgent.setSbjnzm(resource.getSocialInsuranceImg());
            wmDaAgent.setFrsfzzmZm(resource.getIdCardFrontImg());
            wmDaAgent.setFrsfzzmBm(resource.getIdCardBackImg());
            wmDaAgent.setFrsfzzmSc(resource.getIdCardHolderImg());
            wmDaAgent.setZjNumber(resource.getRegCode());
            wmDaAgent.setTaxRecordIn12m(resource.getTaxRecordIn12m());
            wmDaAgent.setPublicitySystemQueryResults(resource.getPublicitySystemQueryResults());
            wmDaAgent.setMarketServicesAgreement(resource.getMarketServicesAgreement());
            wmDaAgent.setServiceContract(resource.getServiceContract());
            wmDaAgent.setServiceDeadline(resource.getServiceDeadline());
            wmDaAgent.setExtDrugEnt(resource.getExtDrugEnt().toString());
            wmDaAgent.setEnableFlag(resource.getEnableFlag());
            wmDaAgent.setDeptId(sysDept.getDeptId());
            wmDaAgent.setTenantId(CommonConstants.TENANT_ID_1);
            wmDaAgent.setAreaCodes(resource.getAreaCodes());
            wmDaAgent.setAbbr(resource.getAbbr());
            wmDaAgent.setProvAbbr(resource.getProvAbbr());
            wmDaAgent.setQylx("0");
            wmDaAgent.setUpdateUser(0);
            wmDaAgent.setManagement("1");
            wmDaAgent.setPgqx("1");
            wmDaAgent.setSkuIds(CharSequenceUtil.join(StrPool.COMMA, resource.getSkuIds()));
            if (wmDaDrugEnt1 != null) {
                wmDaAgent.setTemp1(wmDaDrugEnt1.getEntname());
            }
            WmDaAgent wmDaAgent1 = new WmDaAgent();
            wmDaAgent1.setDeptId(sysDept.getDeptId());
            WmDaAgent wmDaAgent2 = wmDaAgentMapper.selectByDeptId(wmDaAgent1);
            if (wmDaDrugEnt1 == null && wmDaAgent2 != null) {
                wmDaAgent.setTemp1(wmDaAgent2.getGsmc());
            }
            if (wmDaAgentService.saveAgent(wmDaAgent)) {
                WmRelation wmRelation = new WmRelation();
                wmRelation.setDownId(wmDaAgent.getDeptId());
                wmRelation.setUpId(SecurityUtils.getUser().getDeptId());
                List<WmRelation> list2 = wmRelationService.list(Wrappers.query(wmRelation));
                if (CollUtil.isEmpty(list2)) {
                    wmRelationMapper.insert(wmRelation);
                }
                if (2 == sysDept.getLevel()) {
                    WmTaskTypeEntRef wmTaskTypeEntRef = new WmTaskTypeEntRef();
                    wmTaskTypeEntRef.setDrugentId(wmDaDrugEnt1.getId());
                    wmTaskTypeEntRef.setAgentId(wmDaAgent.getId());
                    wmTaskTypeEntRef.setDeptId(wmDaAgent.getDeptId().toString());
                    WmTaskType wmTaskType = new WmTaskType();
                    wmTaskType.setDurgentId(wmDaDrugEnt1.getId());
                    wmTaskType.setLevel1Id(wmDaAgent.getId());
                    wmTaskType.setDelFlag(CommonConstants.STATUS_NORMAL);
                    List<WmTaskType> list = wmTaskTypeMapper.selectList(Wrappers.query(wmTaskType));
                    if (CollUtil.isNotEmpty(list)) {
                        return R.failed("一代积分规则已分配");
                    } else {
//					if (null != wmDaAgent) {
//						wmTaskTypeEntRef.setDeptId(list3.get(0).getDeptId());
//					}
                        wmTaskTypeEntRefMapper.insert(wmTaskTypeEntRef);

                        WmTaskType wmTaskTypeQ = new WmTaskType();
                        wmTaskTypeQ.setTaskTypeLevel("1");
                        wmTaskTypeQ.setStatus("0");
                        wmTaskTypeQ.setDelFlag(CommonConstants.STATUS_NORMAL);

                        List<WmTaskType> tempList = wmTaskTypeMapper.selectList(Wrappers.query(wmTaskTypeQ));

                        for (WmTaskType wmTaskType1 : tempList) {
                            WmTaskType newOne = wmTaskType1;
                            newOne.setId(null);
                            newOne.setLevel1Id(wmTaskTypeEntRef.getAgentId());
                            newOne.setDurgentId(wmDaDrugEnt1.getId());
                            newOne.setTaskTypeLevel("2");
                            newOne.setRuleId("" + wmTaskTypeEntRef.getDrugentId() + wmTaskTypeEntRef.getAgentId());
                            newOne.setTaskEntId(wmTaskTypeEntRef.getAgentId());
                            newOne.setDeptId(wmDaAgent.getDeptId());
                            newOne.setCreateTime(LocalDateTime.now());
                            newOne.setStatus("0");
                            newOne.setBaseId(wmTaskType1.getId());
                            wmTaskTypeMapper.insert(newOne);
                        }
                    }
                    WmTaskTypeEntRef wmTaskTypeEntRef1 = new WmTaskTypeEntRef();
                    wmTaskTypeEntRef1.setDrugentId(null);
                    wmTaskTypeEntRef1.setAgentId(wmDaAgent.getId());
                    wmTaskTypeEntRef1.setDeptId(wmDaAgent.getDeptId().toString());
                    WmTaskType wmTaskType1 = new WmTaskType();
                    wmTaskType1.setDurgentId(wmDaDrugEnt1.getId());
                    wmTaskType1.setLevel1Id(wmDaAgent.getId());
                    wmTaskType1.setDelFlag("0");
//					if (null != wmDaAgent) {
//						wmTaskTypeEntRef1.setDeptId(list3.get(0).getDeptId());
//					}
                    wmTaskTypeEntRefMapper.insert(wmTaskTypeEntRef1);

                    WmTaskType wmTaskTypeQ = new WmTaskType();
                    wmTaskTypeQ.setTaskTypeLevel("1");
                    wmTaskTypeQ.setStatus("0");
                    wmTaskTypeQ.setDelFlag(CommonConstants.STATUS_NORMAL);

                    List<WmTaskType> tempList = wmTaskTypeMapper.selectList(Wrappers.query(wmTaskTypeQ));

                    for (WmTaskType wmTaskType2 : tempList) {
                        WmTaskType newOne = wmTaskType2;
                        newOne.setId(null);
                        newOne.setLevel1Id(wmTaskTypeEntRef1.getAgentId());
                        newOne.setTaskTypeLevel("2");
                        newOne.setTaskEntId(wmTaskTypeEntRef1.getAgentId());
                        newOne.setRuleId(wmTaskTypeEntRef1.getAgentId().toString());
                        newOne.setDeptId(wmDaAgent.getDeptId());
                        newOne.setCreateTime(LocalDateTime.now());
                        newOne.setStatus("0");
                        newOne.setBaseId(wmTaskType2.getId());
                        wmTaskTypeMapper.insert(newOne);
                    }
                } else if (3 == sysDept.getLevel()) {
                    // 一级cso给二级cso配置积分规则
                    WmDaAgent level1DaAgent = wmDaAgentService.getOne(Wrappers.<WmDaAgent>lambdaQuery()
                            .eq(WmDaAgent::getDeptId, SecurityUtils.getUser().getDeptId()));
                    WmTaskTypeEntRef wmTaskTypeEntRef1 = new WmTaskTypeEntRef();
                    wmTaskTypeEntRef1.setDrugentId(null);
                    wmTaskTypeEntRef1.setAgentId(wmDaAgent.getId());
                    wmTaskTypeEntRef1.setDeptId(wmDaAgent.getDeptId().toString());
                    wmTaskTypeEntRefMapper.insert(wmTaskTypeEntRef1);

                    WmTaskType wmTaskTypeQ = new WmTaskType();
                    wmTaskTypeQ.setTaskTypeLevel("1");
                    wmTaskTypeQ.setStatus("0");
                    wmTaskTypeQ.setDelFlag("0");
                    List<WmTaskType> tempList = wmTaskTypeMapper.selectList(Wrappers.query(wmTaskTypeQ));

                    for (WmTaskType wmTaskType2 : tempList) {
                        WmTaskType newOne = wmTaskType2;
                        newOne.setId(null);
                        newOne.setLevel1Id(level1DaAgent.getId());
                        newOne.setTaskTypeLevel("2");
                        newOne.setTaskEntId(wmDaAgent.getId());
                        newOne.setRuleId(wmDaAgent.getId().toString());
                        newOne.setDeptId(wmDaAgent.getDeptId());
                        newOne.setCreateTime(LocalDateTime.now());
                        newOne.setStatus("0");
                        newOne.setBaseId(wmTaskType2.getId());
                        wmTaskTypeMapper.insert(newOne);
                    }
                }
            }
        }
        if (list1.size() > 0 && list4.size() < 1 && list5.size() > 0) {
            SysDept sysDept = sysDeptService.getById(SecurityUtils.getUser().getDeptId());
            SysDeptRelation sysDeptRelation1 = new SysDeptRelation();
            sysDeptRelation1.setAncestor(SecurityUtils.getUser().getDeptId());
            sysDeptRelation1.setDescendant(list3.get(0).getDeptId());
            sysDeptRelationService.save(sysDeptRelation1);
            WmRelation wmRelation = new WmRelation();
            wmRelation.setDownId(Integer.valueOf(list1.get(0).getDeptId()));
            if (wmDaDrugEnt1 != null) {
                wmRelation.setUpId(wmDaDrugEnt1.getDeptId());
            } else {
                WmDaAgent wmDaAgent1 = new WmDaAgent();
                wmDaAgent1.setDeptId(SecurityUtils.getUser().getDeptId());
                WmDaAgent wmDaAgent2 = wmDaAgentMapper.selectDeptId(wmDaAgent1);
                wmRelation.setUpId(Integer.valueOf(wmDaAgent2.getDeptId()));
                WmDaAgent wmDaAgent3 = wmDaAgentMapper.selectByGsmc(query);
                wmDaAgent3.setExtDrugEnt(list1.get(0).getExtDrugEnt() + "," + wmDaAgent2.getId());
                wmDaAgent3.setTemp1(list1.get(0).getTemp1() + "," + wmDaAgent2.getGsmc());
                wmDaAgentMapper.updateById(wmDaAgent3);
            }
            List<WmRelation> list2 = wmRelationService.list(Wrappers.query(wmRelation));
            if (list2.size() == 0) {
                wmRelationMapper.insert(wmRelation);
            }
            if (2 == sysDept.getLevel()) {
                WmTaskTypeEntRef wmTaskTypeEntRef = new WmTaskTypeEntRef();
                wmTaskTypeEntRef.setDrugentId(wmDaDrugEnt1.getId());
                wmTaskTypeEntRef.setAgentId(list3.get(0).getId());
                wmTaskTypeEntRef.setDeptId(list3.get(0).getDeptId().toString());
                WmDaAgent wmDaAgent1 = wmDaAgentMapper.selectByGsmc(query);
                wmDaAgent1.setExtDrugEnt(list1.get(0).getExtDrugEnt() + "," + wmDaDrugEnt1.getId());
                wmDaAgent1.setTemp1(list1.get(0).getTemp1() + "," + wmDaDrugEnt1.getEntname());
                wmDaAgentMapper.updateById(wmDaAgent1);
                wmTaskTypeEntRefMapper.insert(wmTaskTypeEntRef);

                WmTaskType wmTaskTypeQ = new WmTaskType();
                wmTaskTypeQ.setTaskTypeLevel("1");
                wmTaskTypeQ.setStatus("0");
                wmTaskTypeQ.setDelFlag("0");

                List<WmTaskType> tempList = wmTaskTypeMapper.selectList(Wrappers.query(wmTaskTypeQ));

                for (WmTaskType wmTaskType1 : tempList) {
                    WmTaskType newOne = wmTaskType1;
                    newOne.setId(null);
                    newOne.setLevel1Id(wmTaskTypeEntRef.getAgentId());
                    newOne.setDurgentId(wmDaDrugEnt1.getId());
                    newOne.setTaskTypeLevel("2");
                    newOne.setRuleId("" + wmTaskTypeEntRef.getDrugentId() + wmTaskTypeEntRef.getAgentId());
                    newOne.setTaskEntId(wmTaskTypeEntRef.getAgentId());
                    newOne.setDeptId(list3.get(0).getDeptId());
                    newOne.setCreateTime(LocalDateTime.now());
                    newOne.setStatus("0");
                    newOne.setBaseId(wmTaskType1.getId());
                    wmTaskTypeMapper.insert(newOne);
                }
            }
        }

        return R.ok();
    }

    /**
     * 新CSO管理-新增
     *
     * @param wmDaAgent CSO管理-新增
     * @return R
     */
    @SysLog("CSO管理-新增")
    @PostMapping
    @Transactional(rollbackFor = Exception.class)
    public R<Boolean> save(@Validated(value = BaseEntity.Create.class) @RequestBody WmDaAgent wmDaAgent) {
        Integer deptId = SecurityUtils.getUser().getDeptId();

        WmDaAgent query = new WmDaAgent();
        query.setGsmc(wmDaAgent.getGsmc());
        List<WmDaAgent> list1 = wmDaAgentService.list(Wrappers.query(query));

        WmDaAgent wmDaAgent4 = new WmDaAgent();
        wmDaAgent4.setZjNumber(wmDaAgent.getZjNumber());
        List<WmDaAgent> list5 = wmDaAgentMapper.selectList(Wrappers.query(wmDaAgent4));
        List<WmDaAgent> list3 = wmDaAgentMapper.selectByGsmcList(query);
        SysDeptRelation sysDeptRelation = new SysDeptRelation();

        if (CollUtil.isNotEmpty(list3)) {
            sysDeptRelation.setAncestor(deptId);
            sysDeptRelation.setDescendant(list3.get(0).getDeptId());
        }

        List<SysDeptRelation> list4 = sysDeptRelationMapper.selectDeptRelation(sysDeptRelation);

        WmDaDrugEnt wmDaDrugEnt = new WmDaDrugEnt();
        wmDaDrugEnt.setDeptId(SecurityUtils.getUser().getDeptId());
        WmDaDrugEnt wmDaDrugEnt1 = wmDaDrugEntMapper.selectDeptId(wmDaDrugEnt);
        if (list1.size() > 0 && list4.size() > 0) {
            return R.failed("代理商名称及关系已存在");
        }
        if (list5.size() < 1 && list1.size() > 0) {
            return R.failed("企业名称已经存在");
        }
        if (list5.size() > 0 && list1.size() < 1) {
            return R.failed("统一社会信用代码已经存在");
        }
        if (list1.size() < 1 && list4.size() < 1) {
            SysDept sysDept = sysDeptService.getById(SecurityUtils.getUser().getDeptId());
            if (sysDept.getLevel() == 4) {
                return R.failed("组织机构选择二级代理商不能继续添加代理商");
            }
            wmDaAgent.setDeptId(sysDept.getDeptId());
            wmDaAgent.setTenantId(1);
            wmDaAgent.setQylx("0");
            wmDaAgent.setManagement("1");
            wmDaAgent.setPgqx("1");
            if (wmDaDrugEnt1 != null) {
                wmDaAgent.setTemp1(wmDaDrugEnt1.getEntname());
            }
            WmDaAgent wmDaAgent1 = new WmDaAgent();
            wmDaAgent1.setDeptId(sysDept.getDeptId());
            WmDaAgent wmDaAgent2 = wmDaAgentMapper.selectByDeptId(wmDaAgent1);
            if (wmDaDrugEnt1 == null && wmDaAgent2 != null) {
                wmDaAgent.setTemp1(wmDaAgent2.getGsmc());
            }
            if (wmDaAgentService.saveAgent(wmDaAgent)) {
                WmRelation wmRelation = new WmRelation();
                wmRelation.setDownId(wmDaAgent.getDeptId());
                wmRelation.setUpId(SecurityUtils.getUser().getDeptId());
                List<WmRelation> list2 = wmRelationService.list(Wrappers.query(wmRelation));
                if (CollUtil.isEmpty(list2)) {
                    wmRelationMapper.insert(wmRelation);
                }
                if (2 == sysDept.getLevel()) {
                    WmTaskTypeEntRef wmTaskTypeEntRef = new WmTaskTypeEntRef();
                    wmTaskTypeEntRef.setDrugentId(wmDaDrugEnt1.getId());
                    wmTaskTypeEntRef.setAgentId(wmDaAgent.getId());
                    wmTaskTypeEntRef.setDeptId(wmDaAgent.getDeptId().toString());
                    WmTaskType wmTaskType = new WmTaskType();
                    wmTaskType.setDurgentId(wmDaDrugEnt1.getId());
                    wmTaskType.setLevel1Id(wmDaAgent.getId());
                    wmTaskType.setDelFlag(CommonConstants.STATUS_NORMAL);
                    List<WmTaskType> list = wmTaskTypeMapper.selectList(Wrappers.query(wmTaskType));
                    if (CollUtil.isNotEmpty(list)) {
                        return R.failed("一代积分规则已分配");
                    } else {
//					if (null != wmDaAgent) {
//						wmTaskTypeEntRef.setDeptId(list3.get(0).getDeptId());
//					}
                        wmTaskTypeEntRefMapper.insert(wmTaskTypeEntRef);

                        WmTaskType wmTaskTypeQ = new WmTaskType();
                        wmTaskTypeQ.setTaskTypeLevel("1");
                        wmTaskTypeQ.setStatus("0");
                        wmTaskTypeQ.setDelFlag(CommonConstants.STATUS_NORMAL);

                        List<WmTaskType> tempList = wmTaskTypeMapper.selectList(Wrappers.query(wmTaskTypeQ));

                        for (WmTaskType wmTaskType1 : tempList) {
                            WmTaskType newOne = wmTaskType1;
                            newOne.setId(null);
                            newOne.setLevel1Id(wmTaskTypeEntRef.getAgentId());
                            newOne.setDurgentId(wmDaDrugEnt1.getId());
                            newOne.setTaskTypeLevel("2");
                            newOne.setRuleId("" + wmTaskTypeEntRef.getDrugentId() + wmTaskTypeEntRef.getAgentId());
                            newOne.setTaskEntId(wmTaskTypeEntRef.getAgentId());
                            newOne.setDeptId(wmDaAgent.getDeptId());
                            newOne.setCreateTime(LocalDateTime.now());
                            newOne.setStatus("0");
                            newOne.setBaseId(wmTaskType1.getId());
                            wmTaskTypeMapper.insert(newOne);
                        }
                    }
                    WmTaskTypeEntRef wmTaskTypeEntRef1 = new WmTaskTypeEntRef();
                    wmTaskTypeEntRef1.setDrugentId(null);
                    wmTaskTypeEntRef1.setAgentId(wmDaAgent.getId());
                    wmTaskTypeEntRef1.setDeptId(wmDaAgent.getDeptId().toString());
                    WmTaskType wmTaskType1 = new WmTaskType();
                    wmTaskType1.setDurgentId(wmDaDrugEnt1.getId());
                    wmTaskType1.setLevel1Id(wmDaAgent.getId());
                    wmTaskType1.setDelFlag("0");
//					if (null != wmDaAgent) {
//						wmTaskTypeEntRef1.setDeptId(list3.get(0).getDeptId());
//					}
                    wmTaskTypeEntRefMapper.insert(wmTaskTypeEntRef1);

                    WmTaskType wmTaskTypeQ = new WmTaskType();
                    wmTaskTypeQ.setTaskTypeLevel("1");
                    wmTaskTypeQ.setStatus("0");
                    wmTaskTypeQ.setDelFlag(CommonConstants.STATUS_NORMAL);

                    List<WmTaskType> tempList = wmTaskTypeMapper.selectList(Wrappers.query(wmTaskTypeQ));

                    for (WmTaskType wmTaskType2 : tempList) {
                        WmTaskType newOne = wmTaskType2;
                        newOne.setId(null);
                        newOne.setLevel1Id(wmTaskTypeEntRef1.getAgentId());
                        newOne.setTaskTypeLevel("2");
                        newOne.setTaskEntId(wmTaskTypeEntRef1.getAgentId());
                        newOne.setRuleId(wmTaskTypeEntRef1.getAgentId().toString());
                        newOne.setDeptId(wmDaAgent.getDeptId());
                        newOne.setCreateTime(LocalDateTime.now());
                        newOne.setStatus("0");
                        newOne.setBaseId(wmTaskType2.getBaseId());
                        wmTaskTypeMapper.insert(newOne);
                    }
                } else if (3 == sysDept.getLevel()) {
                    // 一级cso给二级cso配置积分规则
                    WmDaAgent level1DaAgent = wmDaAgentService.getOne(Wrappers.<WmDaAgent>lambdaQuery()
                            .eq(WmDaAgent::getDeptId, SecurityUtils.getUser().getDeptId()));
                    WmTaskTypeEntRef wmTaskTypeEntRef1 = new WmTaskTypeEntRef();
                    wmTaskTypeEntRef1.setDrugentId(null);
                    wmTaskTypeEntRef1.setAgentId(wmDaAgent.getId());
                    wmTaskTypeEntRef1.setDeptId(wmDaAgent.getDeptId().toString());
                    wmTaskTypeEntRefMapper.insert(wmTaskTypeEntRef1);

                    WmTaskType wmTaskTypeQ = new WmTaskType();
                    wmTaskTypeQ.setTaskTypeLevel("1");
                    wmTaskTypeQ.setStatus("0");
                    wmTaskTypeQ.setDelFlag("0");
                    List<WmTaskType> tempList = wmTaskTypeMapper.selectList(Wrappers.query(wmTaskTypeQ));

                    for (WmTaskType wmTaskType2 : tempList) {
                        WmTaskType newOne = wmTaskType2;
                        newOne.setId(null);
                        newOne.setLevel1Id(level1DaAgent.getId());
                        newOne.setTaskTypeLevel("2");
                        newOne.setTaskEntId(wmDaAgent.getId());
                        newOne.setRuleId(wmDaAgent.getId().toString());
                        newOne.setDeptId(wmDaAgent.getDeptId());
                        newOne.setCreateTime(LocalDateTime.now());
                        newOne.setStatus("0");
                        newOne.setBaseId(wmTaskType2.getBaseId());
                        wmTaskTypeMapper.insert(newOne);
                    }
                }
            }
        }
        if (list1.size() > 0 && list4.size() < 1 && list5.size() > 0) {
            SysDept sysDept = sysDeptService.getById(SecurityUtils.getUser().getDeptId());
            SysDeptRelation sysDeptRelation1 = new SysDeptRelation();
            sysDeptRelation1.setAncestor(SecurityUtils.getUser().getDeptId());
            sysDeptRelation1.setDescendant(list3.get(0).getDeptId());
            sysDeptRelationService.save(sysDeptRelation1);
            WmRelation wmRelation = new WmRelation();
            wmRelation.setDownId(Integer.valueOf(list1.get(0).getDeptId()));
            if (wmDaDrugEnt1 != null) {
                wmRelation.setUpId(wmDaDrugEnt1.getDeptId());
            } else {
                WmDaAgent wmDaAgent1 = new WmDaAgent();
                wmDaAgent1.setDeptId(SecurityUtils.getUser().getDeptId());
                WmDaAgent wmDaAgent2 = wmDaAgentMapper.selectDeptId(wmDaAgent1);
                wmRelation.setUpId(Integer.valueOf(wmDaAgent2.getDeptId()));
                WmDaAgent wmDaAgent3 = wmDaAgentMapper.selectByGsmc(query);
                wmDaAgent3.setExtDrugEnt(list1.get(0).getExtDrugEnt() + "," + wmDaAgent2.getId());
                wmDaAgent3.setTemp1(list1.get(0).getTemp1() + "," + wmDaAgent2.getGsmc());
                wmDaAgentMapper.updateById(wmDaAgent3);
            }
            List<WmRelation> list2 = wmRelationService.list(Wrappers.query(wmRelation));
            if (list2.size() == 0) {
                wmRelationMapper.insert(wmRelation);
            }
            if (2 == sysDept.getLevel()) {
                WmTaskTypeEntRef wmTaskTypeEntRef = new WmTaskTypeEntRef();
                wmTaskTypeEntRef.setDrugentId(wmDaDrugEnt1.getId());
                wmTaskTypeEntRef.setAgentId(list3.get(0).getId());
                wmTaskTypeEntRef.setDeptId(list3.get(0).getDeptId().toString());
                WmDaAgent wmDaAgent1 = wmDaAgentMapper.selectByGsmc(query);
                wmDaAgent1.setExtDrugEnt(list1.get(0).getExtDrugEnt() + "," + wmDaDrugEnt1.getId());
                wmDaAgent1.setTemp1(list1.get(0).getTemp1() + "," + wmDaDrugEnt1.getEntname());
                wmDaAgentMapper.updateById(wmDaAgent1);
                wmTaskTypeEntRefMapper.insert(wmTaskTypeEntRef);

                WmTaskType wmTaskTypeQ = new WmTaskType();
                wmTaskTypeQ.setTaskTypeLevel("1");
                wmTaskTypeQ.setStatus("0");
                wmTaskTypeQ.setDelFlag("0");

                List<WmTaskType> tempList = wmTaskTypeMapper.selectList(Wrappers.query(wmTaskTypeQ));

                for (WmTaskType wmTaskType1 : tempList) {
                    WmTaskType newOne = wmTaskType1;
                    newOne.setId(null);
                    newOne.setLevel1Id(wmTaskTypeEntRef.getAgentId());
                    newOne.setDurgentId(wmDaDrugEnt1.getId());
                    newOne.setTaskTypeLevel("2");
                    newOne.setRuleId("" + wmTaskTypeEntRef.getDrugentId() + wmTaskTypeEntRef.getAgentId());
                    newOne.setTaskEntId(wmTaskTypeEntRef.getAgentId());
                    newOne.setDeptId(list3.get(0).getDeptId());
                    newOne.setCreateTime(LocalDateTime.now());
                    newOne.setStatus("0");
                    newOne.setBaseId(wmTaskType1.getBaseId());
                    wmTaskTypeMapper.insert(newOne);
                }
            }
        }

        return R.ok();
    }

    /**
     * CSO管理-修改
     *
     * @param wmDaAgent 信息
     * @return R
     */
    @SysLog("CSO管理-修改")
    @PutMapping
    @Transactional(rollbackFor = Exception.class)
    public R<Boolean> updateById(@RequestBody WmDaAgent wmDaAgent) {

        SysDept sysDept = sysDeptMapper.selectById(wmDaAgent.getDeptId());
        sysDept.setDelFlag(wmDaAgent.getEnableFlag());
        sysDept.setName(wmDaAgent.getGsmc());
        sysDept.setAbbr(wmDaAgent.getAbbr());
        sysDept.setProvAbbr(wmDaAgent.getProvAbbr());
        sysDept.setDeptId(wmDaAgent.getDeptId());
        sysDept.setTaxCode(wmDaAgent.getZjNumber());
        sysDeptMapper.updateByPrimaryKeySelective(sysDept);

        SysUser sysUser1 = new SysUser();
        sysUser1.setDeptId(wmDaAgent.getDeptId());

        List<SysUser> sysUserList = sysUserMapper.selectUserById(sysUser1);
        List<Integer> id1 = sysUserList.stream().map(SysUser::getUserId).collect(Collectors.toList());
        for (Integer id : id1) {
            SysUser sysUser = new SysUser();
            sysUser.setUserId(id);
            sysUser.setDelFlag(wmDaAgent.getEnableFlag());
            sysUserMapper.updateByPrimaryKeySelective(sysUser);
        }
        wmDaAgentService.updateById(wmDaAgent);

        if (CollUtil.isNotEmpty(wmDaAgent.getAreaCodes())) {
            // 删除历史的
            enterpriseAreaService.delRelation(Long.valueOf(wmDaAgent.getDeptId()));

            // 添加新的
            enterpriseAreaService.saveRelation(Long.valueOf(wmDaAgent.getDeptId()), wmDaAgent.getAreaCodes());
        }
        return R.ok(wmDaAgentService.updateById(wmDaAgent));
    }

    /**
     * 派工企业管理-修改
     *
     * @param wmDaAgent 档案-代理商
     * @return R
     */
    @SysLog("派工企业管理-修改")
    @PutMapping("/update")
    public R<?> update(@RequestBody WmDaAgent wmDaAgent) {
        return R.ok(wmDaAgentService.updateByPrimaryKeySelective(wmDaAgent));
    }


    /**
     * 通过id删除档案-代理商
     *
     * @param id id
     * @return R
     */
    @SysLog("通过id删除档案-代理商")
    @DeleteMapping("/{id}")
    @PreAuthorize("@pms.hasPermission('admin_wmdaagent_del')")
    public R<?> removeById(@PathVariable Integer id) {
        return R.ok(wmDaAgentService.removeById(id));
    }

    /**
     * 查询服务上级组织列表
     *
     * @param deptLevel 等级
     * @return 结果
     */
    @GetMapping("/listDrugEntOrAgent")
    public R<?> listDrugEntOrAgent(String deptLevel) {
        // 根据deptLevel（对应sys_dept的level字段）查询服务上级组织，deptLevel=4查询一级代理商，deptLevel=3和其他情况查询药企
        final List<Map<String, String>> result = new ArrayList<>();
        if ("4".equals(deptLevel)) {
            // 查询一级代理商
            List<WmDaAgent> daAgentList = wmDaAgentService.listAgentByDeptLevel("3");
            if (CollectionUtil.isNotEmpty(daAgentList)) {
                daAgentList.forEach(wmDaAgent -> {
                    Map<String, String> agentMap = new HashMap<>();
                    agentMap.put("value", wmDaAgent.getId().toString());
                    agentMap.put("name", wmDaAgent.getGsmc());
                    result.add(agentMap);
                });
            }
        } else {
            // 查询药企
            Wrapper<WmDaDrugEnt> queryWrapper = Wrappers.<WmDaDrugEnt>lambdaQuery()
                    .eq(WmDaDrugEnt::getDelFlag, DelEnum.NOT_DEL.getVal())
                    .eq(WmDaDrugEnt::getEnableFlag, EnableEnum.ENABLE.val());
            List<WmDaDrugEnt> drugEntList = wmDaDrugEntService.list(queryWrapper);
            if (CollectionUtil.isNotEmpty(drugEntList)) {
                drugEntList.forEach(daDrugEnt -> {
                    Map<String, String> agentMap = new HashMap<>();
                    agentMap.put("value", daDrugEnt.getId().toString());
                    agentMap.put("name", daDrugEnt.getEntname());
                    result.add(agentMap);
                });
            }
        }
        return R.ok(result);
    }

    /**
     * 获取药企列表
     *
     * @return 角色列表
     */
    @GetMapping("/list")
    public R<?> listDrugEnt(WmDaAgent wmDaAgent, String agentTypeId) {
        List<String> stringList = new ArrayList<>();
        if (null != agentTypeId && null != SecurityUtils.getUser().getDrugEntId()) {
            SysDept sysDept = new SysDept();
            if (null != SecurityUtils.getUser().getDrugEntId()) {
                sysDept.setLevel1Id(SecurityUtils.getUser().getDrugEntId());
            }
            List<SysDept> sysDeptList = deptMapper.selectList(Wrappers.query(sysDept));
            if (CollUtil.isNotEmpty(sysDeptList)) {
                for (SysDept sys :
                        sysDeptList) {
                    if ("1".equals(agentTypeId)) {
                        if (null != sys.getLevel2Id()) {
                            stringList.add(sys.getLevel2Id() + "");
                        }
                    } else if ("2".equals(agentTypeId)) {
                        if (null != sys.getLevel3Id()) {
                            stringList.add(sys.getLevel3Id() + "");
                        }
                    }

                }
            }
        }


        wmDaAgent.setDelFlag("0");
        wmDaAgent.setEnableFlag("0");
        List<WmDaAgent> listWmDaAgent;
        String gsmc;
        if (null != wmDaAgent.getGsmc()) {
            gsmc = wmDaAgent.getGsmc();
            wmDaAgent.setGsmc(null);
            if (CollUtil.isNotEmpty(stringList)) {
                listWmDaAgent = wmDaAgentService.selectByScope(Wrappers.query(wmDaAgent).lambda().like(WmDaAgent::getGsmc, gsmc).in(WmDaAgent::getId, stringList));
            } else {
                listWmDaAgent = wmDaAgentService.selectByScope(Wrappers.query(wmDaAgent).lambda().like(WmDaAgent::getGsmc, gsmc));
            }
        } else {
            if (CollUtil.isNotEmpty(stringList)) {
                listWmDaAgent = wmDaAgentService.selectByScope(Wrappers.query(wmDaAgent).lambda().in(WmDaAgent::getId, stringList));
            } else {
                listWmDaAgent = wmDaAgentService.selectByScope(Wrappers.query(wmDaAgent));
            }
        }

        return R.ok(listWmDaAgent);
    }


    /**
     * 获取药企列表
     *
     * @return 角色列表
     */
    @GetMapping("/listNoScope")
    public R<?> listNoScope(WmDaAgent wmDaAgent, String agentTypeId) {
        List<String> stringList = new ArrayList<>();
        if (null != agentTypeId && null != SecurityUtils.getUser().getDrugEntId()) {
            SysDept sysDept = new SysDept();
            if (!SecurityUtils.getRoles().contains(2)) {
                if (null != SecurityUtils.getUser().getDrugEntId()) {
                    sysDept.setLevel1Id(SecurityUtils.getUser().getDrugEntId());
                }
            }

            List<SysDept> sysDeptList = deptMapper.selectList(Wrappers.query(sysDept));
            if (CollUtil.isNotEmpty(sysDeptList)) {
                for (SysDept sys : sysDeptList) {
                    if ("1".equals(agentTypeId)) {
                        if (null != sys.getLevel2Id()) {
                            stringList.add(sys.getLevel2Id().toString());
                        }
                    } else if ("2".equals(agentTypeId)) {
                        if (null != sys.getLevel3Id()) {
                            stringList.add(sys.getLevel3Id().toString());
                        }
                    }

                }
            }
        }


        wmDaAgent.setDelFlag("0");
        wmDaAgent.setEnableFlag("0");
        List<WmDaAgent> listWmDaAgent;
        String gsmc;
        if (null != wmDaAgent.getGsmc()) {
            gsmc = wmDaAgent.getGsmc();
            wmDaAgent.setGsmc(null);
            if (CollUtil.isNotEmpty(stringList)) {
                listWmDaAgent = wmDaAgentService.list(Wrappers.query(wmDaAgent).lambda().like(WmDaAgent::getGsmc, gsmc).in(WmDaAgent::getId, stringList));
            } else {
                listWmDaAgent = wmDaAgentService.list(Wrappers.query(wmDaAgent).lambda().like(WmDaAgent::getGsmc, gsmc));
            }
        } else {
            if (CollUtil.isNotEmpty(stringList)) {
                listWmDaAgent = wmDaAgentService.list(Wrappers.query(wmDaAgent).lambda().in(WmDaAgent::getId, stringList));
            } else {
                listWmDaAgent = wmDaAgentService.list(Wrappers.query(wmDaAgent));
            }
        }

        return R.ok(listWmDaAgent);
    }

    /**
     * 分页查询
     *
     * @param page      分页对象
     * @param wmDaAgent 档案-代理商
     * @return 分页
     */
    @GetMapping("/page1")
    public R<Page<WmDaAgent>> getWmDaAgentPage1(Page<WmDaAgent> page, WmDaAgent wmDaAgent) {
        if (SecurityUtils.getRoles().contains(19)) {
            // CSM只能查看自己维护的企业下的用户, 以及下属维护的企业下的用户
            Integer userId = SecurityUtils.getUser().getId();
            // 递归查询下属关联的userId
            Set<Integer> allUserIds = sysCsmUserRelationService.recurseCsmLowerUserId(Collections.singleton(userId), new AtomicInteger(10));
            wmDaAgent.setCsmUserIdList(allUserIds);
        }

        return R.ok(wmDaAgentService.selectWmManagementList(page, wmDaAgent));
    }

    /**
     * 代理商
     *
     * @return 代理商信息
     */
    @SysLog("查询档案-代理商")
    @GetMapping("/selectExtDrugEnt")
    public R<List<Map<String, Object>>> selectExtDrugEnt() {
        return R.ok(wmDaAgentService.selectDeptId1(SecurityUtils.getUser().getDeptId()));
    }

    /**
     * 获取cso列表 (接包对象)
     *
     * @return cso列表 二期  业务平台
     */
    @GetMapping("/listCso")
    public R<?> listCso(Integer deptId) {

        if (deptId == null) {
            deptId = SecurityUtils.getUser().getDeptId();
        }

        SysDept sysDept = sysDeptService.getById(deptId);

        List<WmDaAgent> wmDaDrugEnts = null;
        if (sysDept.getLevel() == 2) {
            wmDaDrugEnts = wmDaAgentService.selectWmDaDrugEntByDeptId(sysDept.getDeptId());
        } else if (sysDept.getLevel() == 3) {
            wmDaDrugEnts = wmDaAgentService.selectWmDaDrugEntByDeptIds(sysDept.getDeptId());
        }

        if (CollUtil.isNotEmpty(wmDaDrugEnts)){
            Set<Integer> collect = wmDaDrugEnts.stream().mapToInt(WmDaAgent::getDeptId).boxed().collect(Collectors.toSet());
            List<SysDept> sysDepts = sysDeptService.listByIds(collect);
            if (CollUtil.isNotEmpty(sysDepts)){
                Set<Integer> undup = sysDepts.stream().mapToInt(SysDept::getDeptId).boxed().collect(Collectors.toSet());
                List<WmDaAgent> agents = wmDaDrugEnts.stream().filter(e -> undup.contains(e.getDeptId())).collect(Collectors.toList());
                return R.ok(agents);
            }
        }


        return R.ok(wmDaDrugEnts);
    }

    /**
     * 获取cso列表
     *
     * @return cso列表 二期  业务平台
     */
    @GetMapping("/getCso")
    public R<?> getCso() {
//		SysDept sysDept1 = new SysDept();
//		sysDept1.setDeptId(SecurityUtils.getUser().getDeptId());
//		SysDept byId = sysDeptMapper.selectDeptId(sysDept1);

        SysDept byId = sysDeptService.getById(SecurityUtils.getUser().getDeptId());

//		WmDaAgent anId = wmDaAgentService.selectByDeptId(byId.getDeptId());
//		WmDaDrugEnt drId = wmDaDrugEntService.selectByDeptId(byId.getDeptId());
        List wmDaDrugEnts = null;
        if (byId.getLevel() == 2) {
            wmDaDrugEnts = wmDaAgentService.selectWmDaDrugEntByDeptId(byId.getDeptId());
        } else if (byId.getLevel() == 3 || byId.getLevel() == 4) {
            wmDaDrugEnts = wmDaAgentService.selectWmDaAgentByRelationId(byId.getDeptId());
        }
        return R.ok(wmDaDrugEnts);
    }

    /**
     * 获取关联服务企业
     *
     * @return 关联服务企业 二期  业务平台
     */
    @GetMapping("/listCsoById")
    public R<?> listCsoById() {
//		SysDept sysDept1 = new SysDept();
//		sysDept1.setDeptId(SecurityUtils.getUser().getDeptId());
//		SysDept byId = sysDeptMapper.selectDeptId(sysDept1);

        SysDept byId = sysDeptService.getById(SecurityUtils.getUser().getDeptId());

        List wmDaDrugEnts = null;
        // 只有药企
        if (byId.getLevel() == 2) {
//			WmDaDrugEnt wmDaDrugEnt = wmDaDrugEntService.selectByDeptId(byId.getDeptId());
            wmDaDrugEnts = wmDaDrugEntService.selectEntNameByDeptId(byId.getDeptId());
        } else if (byId.getLevel() == 3) {
//			WmDaAgent anId = wmDaAgentService.selectByDeptId(byId.getDeptId());
            List<WmRelation> wmRelation = wmRelationMapper.selectByUpId(byId.getDeptId());
            if (CollectionUtil.isEmpty(wmRelation)) {
                // 如果为空，则直接返回当前自己的
                wmDaDrugEnts = wmDaDrugEntService.selectEntNameByByDeptIds(byId.getDeptId());
            } else {
                // 获取上级药企和cso自己
                for (WmRelation wmRelation1 : wmRelation) {
                    wmDaDrugEnts = wmDaDrugEntService.selectEntNameByByDeptIds(wmRelation1.getDownId());
//				wmDaDrugEnts = wmDaDrugEntService.selectEntNameByDeptId(byId.getDeptId());
                }
            }
        }
        return R.ok(wmDaDrugEnts);
    }

    /**
     * 通过用户deptId查询用户信息
     */
    @PostMapping("/getUserDeptId")
    public R<?> getUserDeptId(Integer deptId) {
        return R.ok(wmDaAgentService.selectNameByDeptId(deptId));
    }

    /**
     * 通过用户deptId修改用户信息
     */
    @PostMapping("/updateUserByDeptId")
    public R<?> updateUserByDeptId(@RequestBody WmDaAgent wmDaAgent) {
        return R.ok(wmDaAgentService.updateUserByDeptId(wmDaAgent));
    }

    /**
     * 查询组织架构
     */
    @GetMapping("/listByDept")
    public R<?> listByDept() {
        List<WmDept> dept = wmDaAgentService.listByDept();

        if (CollUtil.isNotEmpty(dept)) {

            Set<Long> collect = dept.stream().map(d -> Long.valueOf(d.getDeptId())).collect(Collectors.toSet());
            Map<Long, List<Long>> longListMap = enterpriseAreaService.listEntAreas1(collect);

            dept.forEach(d -> {
                d.setAreaCodes(longListMap.get(Long.valueOf(d.getDeptId())));
            });
        }

        return R.ok(dept);
    }

    @SysLog("企业评价")
    @PostMapping(value = "/eval/create")
    public R<Boolean> evalAgent(@Validated @RequestBody WmDaAgentDTO.OnEval resource) {

        if (!"admission".equalsIgnoreCase(resource.getEvalType())) {
            log.error("当前仅支持准入评价");
            return R.failed(false, "当前仅支持准入评价");
        }

        if (agentEvaluationService.evaluated(resource.getDeptId(), resource.getEvalType())) {
            log.error("准入评价已存在，请勿重复评价");
            return R.failed(false, "准入评价已存在，请勿重复评价");
        }

        return R.ok(agentEvaluationService.evaluate(resource, SecurityUtils.getUser()));

    }

    @GetMapping(value = "/eval/details")
    public R<WmAgentEvaluation> getAgentEvalResult(@RequestParam(value = "deptId") Integer deptId,
                                                   @RequestParam(value = "evalType", defaultValue = "admission") String evalType) {

        return R.ok(agentEvaluationService.getEvalDetails(deptId, evalType));

    }

    @SysLog(value = "添加企业合规文件")
    @PostMapping(value = "/comp/doc/create")
    public R<Boolean> createAgentComplianceDocument(@Validated @RequestBody WmDaAgentDTO.OnCompDocCreate resource) {


        boolean res = agentComplianceDocumentService.create(resource, SecurityUtils.getUser());

        return R.ok(res);

    }

    @GetMapping(value = "/comp/doc/{dept_id}")
    public R<WmAgentComplianceDocument> getAgentComplianceDocument(@PathVariable(value = "dept_id") Integer deptId) {

        return R.ok(agentComplianceDocumentService.getDoc(deptId));

    }


}
