package com.qunzhixinxi.hnqz.admin.controller;

import com.pig4cloud.plugin.excel.annotation.ResponseExcel;
import com.pig4cloud.plugin.excel.annotation.Sheet;
import com.qunzhixinxi.hnqz.admin.api.model.excel.WmScorePackageInfoExcelModel;
import com.qunzhixinxi.hnqz.admin.manager.WmPackageManager;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import java.time.LocalDate;
import java.util.List;

/**
 * 积分包前端控制器v2
 *
 * @author jimmy
 * @date 2024-12-02 18:36
 */
@Slf4j
@RestController
@AllArgsConstructor
public class WmScorePackageControllerV2 {

    private final WmPackageManager packageManager;

    @GetMapping(value = "/pkg/info/export")
    @ResponseExcel(name = "pkgInfoExcel", sheets = {@Sheet(sheetName = "执行包信息")})
    public List<WmScorePackageInfoExcelModel> exportPkgInfo() {

        LocalDate today = LocalDate.now();

        // 获取三个月内的数据
        LocalDate startDate = today.minusMonths(3);


        return packageManager.exportPkgInfo(startDate, today);

    }


}
