package com.qunzhixinxi.hnqz.admin.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDeptCsm;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * 部门客户成功mapper
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2022-10-10 12:10
 */
@Mapper
public interface SysDeptCsmMapper extends BaseMapper<SysDeptCsm> {

	/**
	 * 列出非重复用户CSM的配置信息
	 *
	 * @param userIds 用户 ID
	 * @return {@link List}<{@link SysDeptCsm}> 结果
	 */
	@Select("<script>" +
			"select distinct wl_qrcode_id as qr_code_id, corp_id, user_id from sys_dept_csm where wl_qrcode_id is not null " +
			"and corp_id is not null and user_id in " +
			"    <foreach item='item' index='index' collection='userIds' open='(' separator=',' close=')'>" +
			"       #{item}" +
			"    </foreach>" +
			"</script>")
	List<SysDeptCsm> listDistinctUserCsm(@Param("userIds") List<Integer> userIds);
}
