package com.qunzhixinxi.hnqz.admin.mapper;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDept;
import com.qunzhixinxi.hnqz.admin.api.vo.SysEnterpriseRelationVO;
import com.qunzhixinxi.hnqz.common.data.datascope.DataScopeMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 部门管理 Mapper 接口
 * </p>
 *
 * @author hnqz
 * @since 2018-01-20
 */
@Mapper
public interface SysDeptMapper extends DataScopeMapper<SysDept> {
    List<SysDept> selectDeptList(@Param("query") SysDept sysDept);

    List<SysDept> selectListByDept(@Param("query") SysDept sysDept);

    List<SysDept> selectDeptByIds(@Param("query") SysDept sysDept);

    List<SysDept> getAllParentDept(@Param("query") SysDept sysDept);

    SysDept selectDistinctDeptId(@Param("query") SysDept sysDept);

    List<SysDept> selectDeptByName(@Param("query") SysDept sysDept);

    List<Map<String, Object>> selectDeptById(@Param("query") SysDept sysDept);

    List<SysDept> selectByName(String entname);


    String selectEntCodeByLevelId(@Param(value = "levelId") long levelId,
                                  @Param(value = "level") int level);

    /**
     * 修改名称 结算渠道
     */
    void updateByPrimaryKeySelective(SysDept sysDept);

    SysDept selectDept(SysDept sysDept);

    List<SysDept> getParentDept(@Param("query") SysDept sysDept);

    List<Map<String, Object>> getDeptConvertToName();

    List<Map<String, Object>> getChildDept(@Param("query") SysDept sysDept);

    /**
     * 查询所有dept
     *
     * @return 部门列表
     */
    List<SysDept> listAllDept();

    /**
     * 分页查询所有dept
     *
     * @param page         页
     * @param queryWrapper 查询包装器
     * @return {@link IPage}<{@link SysDept}> 结果
     */
    IPage<SysDept> pageAllDept(Page<SysDept> page, @Param(Constants.WRAPPER) LambdaQueryWrapper<SysDept> queryWrapper);

    /**
     * 根据id批量查询
     *
     * @param ids
     * @return
     */
    List<SysDept> selectByIds(@Param("ids") List<Integer> ids);

    /**
     * 获取企业关系分页
     *
     * @param entName 企业名称
     * @param page    分页信息
     * @return 分页结果
     */
    Page<SysEnterpriseRelationVO> pageEntRels(Page<SysEnterpriseRelationVO> page, @Param("entName") String entName);
}
