
package com.qunzhixinxi.hnqz.admin.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDeptRelation;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author hnqz
 * @since 2018-02-12
 */
@Mapper
public interface SysDeptRelationMapper extends BaseMapper<SysDeptRelation> {

	/**
	 * 删除部门关系表数据
	 * @param id 部门ID
	 */
	void deleteDeptRelationsById(Integer id);

	/**
	 * 更改部分关系表数据
	 * @param deptRelation
	 */
	void updateDeptRelations(SysDeptRelation deptRelation);

	void deleteDeptById(Integer id);

	List<SysDeptRelation> selectDeptRelationsList(@Param("query") SysDeptRelation sysDeptRelation);

	List<SysDeptRelation> selectDeptRelation(@Param("query") SysDeptRelation sysDeptRelation);

	List<SysDeptRelation> selectByDescendantList(@Param("query") SysDeptRelation sysDeptRelation);

	List<SysDeptRelation> selectListByAncestor(@Param("query") SysDeptRelation sysDeptRelation);

	List<SysDeptRelation> selectListByDescendant(@Param("query") SysDeptRelation sysDeptRelation);

	int deleteByPrimaryKey(Long id);
}
