package com.qunzhixinxi.hnqz.admin.mapper;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaAgent;
import com.qunzhixinxi.hnqz.common.data.datascope.DataScopeMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 档案-代理商
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
@Mapper
public interface WmDaAgentMapper extends DataScopeMapper<WmDaAgent> {
    WmDaAgent selectByDeptId(WmDaAgent wmDaAgent);

    List<WmDaAgent> selectByUserDeptId(Integer deptId);

    WmDaAgent selectByDeptIds(Integer deptId);

    List<WmDaAgent> selectByDrugIds(Integer id);

    List<WmDaAgent> selectByDrugId(Integer id);

    List<WmDaAgent> selectByRelationId(Integer id);

    List<WmDaAgent> selectByRelationIds(Integer id);

    Page<WmDaAgent> selectWmManagementPage(Page<WmDaAgent> page, @Param("query") WmDaAgent wmDaAgent);

    List<WmDaAgent> selectWmManagementList(@Param("query") WmDaAgent wmDaAgent);

    int insert1(WmDaAgent wmDaAgent);

    List<WmDaAgent> selectExtDrugEntList(@Param("query") WmDaAgent wmDaAgent);

    WmDaAgent selectDeptId(WmDaAgent wmDaAgent);

    List<WmDaAgent> selectDeptByIds(@Param("deptIds") Collection<Integer> deptIds,
                                    @Param("entName") String entName);

    List<Map<String, Object>> selectDeptId1(@Param("deptId") Integer deptId);

    WmDaAgent selectExtDrugEnt(WmDaAgent wmDaAgent);

    List<WmDaAgent> selectByGsmcList(@Param("query") WmDaAgent wmDaAgent);

    WmDaAgent selectByGsmc(@Param("query") WmDaAgent wmDaAgent);

    List<WmDaAgent> selectEntNameByDrugIds(Integer id);

    List<WmDaAgent> selectWmDaDrugEntByDeptId(Integer deptId);

    List<WmDaAgent> selectWmDaDrugEntByDeptIds(Integer deptId);

    List<WmDaAgent> selectWmDaAgentByRelationId(Integer deptId);

    List<WmDaAgent> selectWmDaAgentByRelationIds(Integer deptId);

    List<WmDaAgent> selectWmDaAgentByDeptId(String deptId);

    List<WmDaAgent> selectWmDaAgentByDeptIds(String deptId);

    /**
     * 根据sys_dept表的level字段查询
     *
     * @param deptLevel 部门等级
     * @return cso列表
     */
    List<WmDaAgent> listAgentByDeptLevel(@Param("deptLevel") String deptLevel);

    /**
     * 根据deptRelation查询
     *
     * @param deptId 部门ID
     * @return cso列表
     */
    List<WmDaAgent> listAgentByDeptRelation(@Param("deptId") Integer deptId);
}
