
package com.qunzhixinxi.hnqz.admin.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.admin.api.entity.WmScorePackageStatus;
import com.qunzhixinxi.hnqz.admin.api.model.input.WmScorePackageApiInput;
import com.qunzhixinxi.hnqz.admin.api.model.input.WmScorePackageApiOutput;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 积分包状态
 *
 * @author pigx code generator
 * @date 2020-07-17 23:32:01
 */
@Mapper
public interface WmScorePackageStatusMapper extends BaseMapper<WmScorePackageStatus> {

    IPage<WmScorePackageStatus> getPage(Page page, @Param("query") WmScorePackageStatus wmScorePackageStatus);

    List<WmScorePackageStatus> getByPackageId(@Param("query") WmScorePackageStatus wmScorePackageStatus);

    IPage<WmScorePackageApiOutput> getReceivedPackageList(Page page, @Param("query") WmScorePackageApiInput input);

    IPage<WmScorePackageStatus> getWmScorePackageStatusPage(Page page, @Param("query") WmScorePackageStatus wmScorePackageStatus);

    /**
     * 获取当前部门已接单人的列表
     *
     * @param deptId       部门id
     * @param packageType1 积分包任务类型1
     * @param packageType2 积分包任务类型2
     * @return
     */
    List<Map<String, String>> getDeptReceiveUserList(@Param("deptId") String deptId, @Param("packageType1") String packageType1,
                                                     @Param("packageType2") String packageType2);
}
