package com.qunzhixinxi.hnqz.admin.service;

import cn.hutool.core.lang.tree.Tree;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.entity.SysAreaEntity;

import java.util.Collection;
import java.util.List;

/**
 * 行政区划表服务
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2024/05/12 20:03
 */
public interface SysAreaEntityService extends IService<SysAreaEntity> {

    /**
     * 查询行政区划树
     *
     * @param sysArea 查询条件
     * @return 树
     */
    List<Tree<Long>> selectTree(SysAreaEntity sysArea);


    /**
     * 查询行政区划树
     *
     * @param areaIds 查询条件
     * @return 树
     */
    List<Tree<Long>> selectTree(Collection<Long> areaIds);

    /**
     * 分页查询
     *
     * @param page    分页对象
     * @param sysArea 行政区划
     * @return Page
     */
    Page<SysAreaEntity> selectPage(Page<SysAreaEntity> page, SysAreaEntity sysArea);

    List<SysAreaEntity> listAreas(Long parentId);
}
