package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDept;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDeptRelation;

import java.util.Map;

/**
 * <p>
 * 企业关系服务
 * </p>
 *
 * @author hnqz
 * @since 2018-02-12
 */
public interface SysDeptRelationService extends IService<SysDeptRelation> {

    /**
     * 新建部门关系
     *
     * @param sysDept 部门
     */
    void insertDeptRelation(SysDept sysDept);

    /**
     * 通过ID删除部门关系
     *
     * @param id 企业ID
     */
    void deleteAllDeptRelation(Integer id);

    /**
     * 根据ID删除企业
     *
     * @param id 企业ID
     */
    void deleteDeptById(Integer id);

	Page<Map<String, Object>> selectSysDeptList(Page<?> page, SysDept sysDept);

    /**
     * 更新部门关系
     *
     * @param relation 关系
     */
    void updateDeptRelation(SysDeptRelation relation);

}
