package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.entity.SysEnterpriseArea;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 企业区域关系表
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2024/05/13 13:41
 */
public interface SysEnterpriseAreaService extends IService<SysEnterpriseArea> {

    /**
     * 保存企业区域关系
     *
     * @param deptId    部门ID
     * @param areaCodes 区域ID
     */
    void saveRelation(Long deptId, Collection<Long> areaCodes);

    /**
     * 更新企业区域关系
     *
     * @param deptId    企业ID
     * @param areaCodes 区域ID
     */
    void updateRelation(Long deptId, Collection<Long> areaCodes);

    /**
     * 获取企业的区域
     *
     * @param deptId 企业ID
     * @return 区域列表
     */
    List<Long> listEntAreas(Collection<Long> deptId);

    /**
     * 查询企业的所属区域
     *
     * @param deptId 部门ID
     * @return 映射关系
     */
    Map<Long, List<Long>> listEntAreas1(Collection<Long> deptId);

    /**
     * 删除关系
     *
     * @param deptId 部门ID
     */
    void delRelation(Long deptId);


    List<Long> listAreaEnts(List<Long> areas);
}
