
package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.entity.SysFile;
import com.qunzhixinxi.hnqz.common.core.util.R;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.Map;

/**
 * 文件管理
 *
 * @author Luckly
 * @date 2019-06-18 17:18:42
 */
public interface SysFileService extends IService<SysFile> {

    /**
     * 上传文件
     *
     * @param file 文件
     * @return 上传结果
     */
    R<Map<String, String>> uploadFile(MultipartFile file);


    /**
     * 上传文件
     *
     * @param file 文件
     * @return 上传结果
     */
    Map<String, String> upload(MultipartFile file, String username);

    /**
     * 上传文件
     *
     * @param file
     * @return
     */
    R uploadFileAllUrl(MultipartFile file);

    R uploadFileAllUrlRealName(MultipartFile file);

    R uploadFileAllUrlRealName(String fileName, String suffix, FileInputStream io);

    /**
     * 读取文件
     *
     * @param bucket   桶名称
     * @param fileName 文件名称
     * @param response 输出流
     */
    void getFile(String bucket, String fileName, HttpServletResponse response);

    /**
     * 删除文件
     *
     * @param id
     * @return
     */
    Boolean deleteFile(Long id);

    String uploadImgByByte(InputStream inputStream);

    void getFileById(Integer fileId, HttpServletResponse response);
}
