package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsState;
import com.qunzhixinxi.hnqz.admin.api.entity.SysImplPlanDetails;

/**
 * 执行计划详情服务
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2024/05/19 15:53
 */
public interface SysImplPlanDetailsService extends IService<SysImplPlanDetails> {

    /**
     * 创建详情
     *
     * @param details 详情
     */
    void createDetails(SysImplPlanDetails details);

    /**
     * 更新结果
     *
     * @param details 详情
     * @return 更新结果
     */
    Boolean updateDetails(SysImplPlanDetails details);

    /**
     * 获取计划的详情
     *
     * @param planId 计划ID
     * @return 计划详情
     */
    SysImplPlanDetails getDetailsByPlanId(Integer planId, UpmsState.ImplPlanDetailsState detailsState);
}
