package com.qunzhixinxi.hnqz.admin.service;

import com.qunzhixinxi.hnqz.admin.api.constant.UpmsState;
import com.qunzhixinxi.hnqz.admin.api.entity.SysImplementPlan;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.Collection;

/**
 * 执行计划服务
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2024/05/19 11:13
 */
public interface SysImplementPlanService extends IService<SysImplementPlan> {

    /**
     * 创建计划
     *
     * @param plan 计划信息
     * @return 创建结果
     */
    Boolean createPlan(SysImplementPlan plan);

    /**
     * 更新计划
     *
     * @param plan 计划
     * @return 更新结果
     */
    Boolean updatePlan(SysImplementPlan plan);

    /**
     * 校验状态
     *
     * @param planId              计划ID
     * @param res                 结果
     * @param implementPlanStates 目标状态
     */
    void checkState(Integer planId, Boolean res, Collection<UpmsState.ImplementPlanState> implementPlanStates);

    /**
     * 可用分
     *
     * @param planId    计划ID
     * @param planScore 目标值
     * @return 可用分
     */
    Long calcAvailScore(Integer planId, Long planScore);

    /**
     * 校验是否重名
     *
     * @param planName    计划名称
     * @param ignoreIds   忽略的ID
     * @param consignorId 企业ID
     * @return 校验结果
     */
    boolean dupName(String planName, Integer consignorId, Collection<Integer> ignoreIds);


    /**
     * 获取计划信息
     *
     * @param planName    计划名称
     * @param consignorId 企业ID
     * @return 校验结果
     */
    SysImplementPlan getPlanByName(String planName, Integer consignorId);


}
