package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.dto.SysNoticeDto;
import com.qunzhixinxi.hnqz.admin.api.entity.SysNotice;
import com.qunzhixinxi.hnqz.common.security.service.HnqzUser;
import org.springframework.lang.Nullable;

/**
 * 系统通知服务
 *
 * @author jimmy
 * @date 09/07/2024 15:48
 */
public interface SysNoticeService extends IService<SysNotice> {

    /**
     * 分页查询通知
     *
     * @param query 查询条件
     * @param user  操作人
     * @return 分页结果
     */
    Page<SysNotice> pageNotices(SysNoticeDto.OnPage query, HnqzUser user);

    /**
     * 阅读通知
     *
     * @param resource 通知信息
     * @param user     阅读人
     * @return 阅读结果
     */
    Boolean readNotice(SysNoticeDto.OnRead resource, HnqzUser user);

    /**
     * 创建通知
     *
     * @param resource 通知信息
     * @param user     操作人
     * @return 创建结果
     */
    Boolean createNotice(SysNoticeDto.OnCreate resource, HnqzUser user);

    /**
     * 统计通知
     *
     * @param read 阅读状态
     * @return 统计结果
     */
    int countNotices(@Nullable Boolean read, HnqzUser user);
}
