package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.entity.SysUserArea;

import java.util.Collection;
import java.util.List;

/**
 * 用户区域关系表
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2024/05/13 13:39
 */
public interface SysUserAreaService extends IService<SysUserArea> {

    /**
     * 保存关系
     *
     * @param userId    用户ID
     * @param areaCodes 区域列表
     */
    void saveRelation(Long userId, Collection<Long> areaCodes);

    /**
     * 查询用户的区域
     *
     * @param userId 用户id
     * @return 区域ID列表
     */
    List<Long> listUserAreas(Long userId);

    /**
     * 获取区域的人员
     *
     * @param areaIds 区域列表
     * @return 人员列表
     */
    List<Long> listAreaUser(Collection<Long> areaIds);

    /**
     * 获取区域的人员
     *
     * @param areaIds 区域列表
     * @return 人员列表
     */
    List<Long> listAreaUser1(Collection<Long> areaIds);


    /**
     * 删除用户的区域
     *
     * @param userId 用户ID
     */
    void delUserArea(Long userId);
}
