package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.dto.WmDaAgentDTO;
import com.qunzhixinxi.hnqz.admin.api.entity.WmAgentComplianceDocument;
import com.qunzhixinxi.hnqz.common.security.service.HnqzUser;

/**
 * 企业合规材料服务
 *
 * @author jimmy
 * @date 07/07/2024 12:12
 */
public interface WmAgentComplianceDocumentService extends IService<WmAgentComplianceDocument> {

    /**
     * 添加企业合规材料
     *
     * @param resource 合规材料
     * @param user     操作人
     * @return 添加结果
     */
    boolean create(WmDaAgentDTO.OnCompDocCreate resource, HnqzUser user);

    /**
     * 获取企业合规文件记录
     *
     * @param deptId 企业ID
     * @return 文件记录
     */
    WmAgentComplianceDocument getDoc(Integer deptId);
}
