package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.dto.WmDaAgentDTO;
import com.qunzhixinxi.hnqz.admin.api.entity.WmAgentEvaluation;
import com.qunzhixinxi.hnqz.common.security.service.HnqzUser;

public interface WmAgentEvaluationService extends IService<WmAgentEvaluation> {

    /**
     * 判断是否已经评价了
     *
     * @param deptId   企业ID
     * @param evalType 评价类型
     * @return 判断结果
     */
    boolean evaluated(Integer deptId, String evalType);

    /**
     * 企业评价
     *
     * @param resource 评价信息
     * @param user     操作人
     * @return 评价操作结果
     */
    Boolean evaluate(WmDaAgentDTO.OnEval resource, HnqzUser user);

    /**
     * 获取准入评价
     *
     * @param deptId   企业ID
     * @param evalType 评价类型
     * @return 评价详情
     */
    WmAgentEvaluation getEvalDetails(Integer deptId, String evalType);
}
