package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaAgent;
import com.qunzhixinxi.hnqz.admin.api.model.input.WmDept;
import com.qunzhixinxi.hnqz.common.core.util.R;
import feign.Param;

import java.util.List;
import java.util.Map;

/**
 * 档案-代理商
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
public interface WmDaAgentService extends IService<WmDaAgent> {


    String getDeptBuildName(String deptId);

    List<WmDaAgent> selectByScope(Wrapper<WmDaAgent> queryWrapper);

    Boolean saveAgent(WmDaAgent wmDaAgent);

    WmDaAgent selectByDeptId(Integer deptId);

    List selectNameByDeptId(Integer deptId);

    List<WmDept> listByDept();

    int updateUserByDeptId(WmDaAgent wmDaAgent);


    Page<WmDaAgent> selectWmManagementList(Page<WmDaAgent> page, @Param("query") WmDaAgent wmDaAgent);

    R insert(WmDaAgent wmDaAgent);

    R updateByPrimaryKeySelective(@Param("query") WmDaAgent wmDaAgent);

    List<Map<String, Object>> selectDeptId1(Integer deptId);

    List<WmDaAgent> selectWmDaDrugEntByDeptId(Integer deptId);

    List<WmDaAgent> selectWmDaDrugEntByDeptIds(Integer deptId);

    List selectWmDaAgentByRelationId(Integer deptId);

    List selectWmDaAgentByRelationIds(Integer deptId);

    List selectWmDaAgentByDeptId(String deptId);

    /**
     * 根据sys_dept表的level字段查询
     *
     * @param deptLevel
     * @return
     */
    List<WmDaAgent> listAgentByDeptLevel(String deptLevel);

    /**
     * 根据deptRelation查询
     *
     * @param deptId
     * @return
     */
    List<WmDaAgent> listAgentByDeptRelation(Integer deptId);


}
