
package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaDistribution;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTask;
import com.qunzhixinxi.hnqz.admin.api.model.excel.BatchDistributionExcelModel;
import com.qunzhixinxi.hnqz.common.core.util.R;

import java.util.List;
import java.util.Map;

/**
 * 档案-配送公司
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
public interface WmDaDistributionService extends IService<WmDaDistribution> {

	public boolean saveOrUpdateDistributionlByTask(WmTask wmTask);

	public List<WmDaDistribution> listByPoint(WmDaDistribution wmDaDistribution);

	public R approvalDistribution(String taskId);

	public R updateByApproval(Map<String,String> map);

	R updateByapprovalForManualOperation(Map<String,String> map);

	/**
	 * 解析商业公司地址
	 */
    void parseAddress();

	/**
	 * 批量导入
	 *
	 * @param excelModelList 商业公司列表
	 * @return 结果
	 */
	Map<String, String> batchByExcel(List<BatchDistributionExcelModel> excelModelList);
}
