package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaDrugEntDrugtable;
import com.qunzhixinxi.hnqz.common.core.util.R;

import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * 档案-药企药品
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
public interface WmDaDrugEntDrugtableService extends IService<WmDaDrugEntDrugtable> {

    /**
     * 给药品分配推广企业
     *
     * @param wmDaDrugEntDrugtable 条件
     * @return 结果
     */
    R<Boolean> distribute(WmDaDrugEntDrugtable wmDaDrugEntDrugtable);

    /**
     * 获取推广企业列表
     *
     * @param wmDaDrugEntDrugtable 条件
     * @return 结果
     */
    R<List<String>> listReDept(WmDaDrugEntDrugtable wmDaDrugEntDrugtable);

    /**
     * 获取药品
     *
     * @param page     分页信息
     * @param deptId   部门id
     * @param drugName 药品名称
     * @return 药品列表
     */
    IPage<WmDaDrugEntDrugtable> listDrugs(Page<WmDaDrugEntDrugtable> page, Integer deptId, String drugName);

    /**
     * 根据部门id获取关联药品生产生产企业名称
     *
     * @param deptId 部门id
     * @return 生产企业列表
     */
    Set<String> listDrugProducerByDeptId(Integer deptId);


    /**
     * 获取分配给指定企业的药品列表
     *
     * @param deptId 部门id
     * @return {@link List}<{@link Map}<{@link String}, {@link String}>>
     */
    List<Map<String, String>> listDrugByDeptId(Collection<Integer> deptId);

    List<Map<String, String>> listDrugs(Collection<Integer> drugIds);
}
