package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaDrugEnt;
import com.qunzhixinxi.hnqz.common.security.service.HnqzUser;

import java.util.List;
import java.util.Map;

/**
 * 档案-药企
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
public interface WmDaDrugEntService extends IService<WmDaDrugEnt> {

    List<WmDaDrugEnt> selectByScope(Wrapper<WmDaDrugEnt> queryWrapper);

    /**
     * 保存药企
     *
     * @param wmDaDrugEnt 药企信息
     * @param operator    操作人
     * @return 保存结果
     */
    Boolean saveDrugEnt(WmDaDrugEnt wmDaDrugEnt, HnqzUser operator);

    WmDaDrugEnt selectByDeptId(Integer deptId);

    List<Map<String, Object>> selectEntNameByDeptId(Integer deptId);

    List selectEntNameByByDeptIds(Integer upId);

    List<WmDaDrugEnt> getListByCsoDeptId(Integer deptId);

    /**
     * 分页查询
     *
     * @param page        分页对象
     * @param wmDaDrugEnt 实体对象
     */
    void selectPage(Page<WmDaDrugEnt> page, WmDaDrugEnt wmDaDrugEnt);
}
