package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaHospital;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTask;
import com.qunzhixinxi.hnqz.admin.api.model.excel.BatchHospitalExcelModel;
import com.qunzhixinxi.hnqz.common.core.util.R;

import java.util.List;
import java.util.Map;

/**
 * 档案-医院
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
public interface WmDaHospitalService extends IService<WmDaHospital> {

    boolean saveOrUpdateHospitalByTask(WmTask wmTask);


    List<WmDaHospital> listByPoint(WmDaHospital wmDaHospital);

    R approvalHospital(String taskId);


    R updateByApproval(Map<String, String> map);

    /**
     * 手动处理调查信息入库
     *
     * @param map
     * @return
     */
    R updateByApprovalForManualOperation(Map<String, String> map);

    Map<String, String> compareDictItem(String name, String str1, String str2, String param);

    /**
     * 初始化获取经纬度
     */
    void parseAddress();

    /**
     * 批量导入
     *
     * @param excelModelList 医院列表
     * @return 结果
     */
    Map<String, String> batchByExcel(List<BatchHospitalExcelModel> excelModelList);

}
