package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.dto.WmSupervisionDto;
import com.qunzhixinxi.hnqz.admin.api.entity.WmPackageSupervision;
import com.qunzhixinxi.hnqz.common.security.service.HnqzUser;

import java.util.Map;

/**
 * 服务包监督服务
 *
 * @author jimmy
 * @date 11/07/2024 16:49
 */
public interface WmPackageSupervisionService extends IService<WmPackageSupervision> {

    /**
     * 监督结果
     *
     * @param resource 监督信息
     * @param user     操作人
     * @return 监督结果
     */
    Boolean createPkgSupervision(WmSupervisionDto.OnPkgSupervision resource, HnqzUser user);

    /**
     * 校验积分包是否已经监督过了
     *
     * @param pkgId 积分包ID
     * @return 校验结果
     */
    boolean hasChecked(Integer pkgId);
}
