package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.entity.WmQccInfo;
import com.qunzhixinxi.hnqz.common.security.service.HnqzUser;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 企查查信息服务
 *
 * @author jimmy
 * @date 10/07/2024 11:12
 */
public interface WmQccInfoService extends IService<WmQccInfo> {

    /**
     * 刷新企查查信息
     *
     * @param regCode 信用代码
     * @param user    操作人
     * @return 刷新结果
     */
    Map<String, Object> refresh(String regCode, HnqzUser user);

    /**
     * 获取企业企查查信息
     *
     * @param regCode 企业信用代码
     * @return 企查查信息
     */
    WmQccInfo getQccInfo(String regCode);

    /**
     * 批量获取企业企查查信息
     *
     * @param regCodes 企业信用代码
     * @return 企查查信息
     */
    Map<String, List<WmQccInfo>> getQccInfo1(Collection<String> regCodes);
}
