package com.qunzhixinxi.hnqz.admin.service;

import com.qunzhixinxi.hnqz.admin.api.dto.WmSupervisionDto;
import com.qunzhixinxi.hnqz.admin.api.entity.WmRoleSupervisionWarnRule;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.common.security.service.HnqzUser;

/**
 * @author jimmy
 * @description 针对表【wm_role_sup_warn_rule(角色预警规则)】的数据库操作Service
 * @createDate 2024-07-13 12:20:00
 */
public interface WmRoleSupervisionWarnRuleService extends IService<WmRoleSupervisionWarnRule> {

    /**
     * 创建预警规则
     *
     * @param resource 规则信息
     * @param user     创建人
     * @return 创建结果
     */
    Boolean createWarnRule(WmSupervisionDto.OnWarnRulCreate resource, HnqzUser user);

    /**
     * 校验类型是否存在
     *
     * @param warnType 类型
     * @param roleId   角色ID
     * @return 是否存在
     */
    boolean hasType(String warnType, Integer roleId);

    /**
     * 修改预警规则
     *
     * @param resource 规则信息
     * @param user     创建人
     * @return 修改结果
     */
    Boolean updateWarnRule(WmSupervisionDto.OnWarnRulUpdate resource, HnqzUser user);
}
