
package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsType;
import com.qunzhixinxi.hnqz.admin.api.dto.WmPkgDTO;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDept;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDictItem;
import com.qunzhixinxi.hnqz.admin.api.entity.WmReportOpt;
import com.qunzhixinxi.hnqz.admin.api.vo.WmScorePackageVO;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaDrugEntDrugtable;
import com.qunzhixinxi.hnqz.admin.api.entity.WmScorePackage;
import com.qunzhixinxi.hnqz.admin.api.entity.WmScorePackageStatus;
import com.qunzhixinxi.hnqz.admin.api.entity.WmScoreTaskType;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTask;
import com.qunzhixinxi.hnqz.admin.api.dto.UnpackDTO;
import com.qunzhixinxi.hnqz.admin.api.model.input.WmScorePackageApiOutput;
import com.qunzhixinxi.hnqz.admin.api.model.input.WmScorePackageSettleInput;
import com.qunzhixinxi.hnqz.admin.api.model.input.WmScorePackageSettleOutput;
import com.qunzhixinxi.hnqz.admin.api.vo.SettleFinancialReviewVO;
import com.qunzhixinxi.hnqz.admin.event.PackageContractEvent;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.security.service.HnqzUser;

import java.time.LocalDate;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.Future;

/**
 * 积分包
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
public interface WmScorePackageService extends IService<WmScorePackage> {

    List<WmScorePackage> listWmScorePackageAndTask(WmScorePackage wmScorePackage);

    List<WmScorePackage> listWmScorePackageAndTaskExt(WmScorePackage wmScorePackage);

    IPage<WmScorePackage> listWmScorePackageAndTaskExt(Page<WmScorePackage> page, WmScorePackage wmScorePackage);

    List<WmScorePackage> listWmScorePackageAndTaskExtOld(WmScorePackage wmScorePackage);

    List<WmScorePackage> listWmScorePackageAndTaskExt2(WmScorePackage wmScorePackage);

    IPage<WmScorePackage> listWmScorePackageAndTaskExt2(Page<WmScorePackage> page, WmScorePackage wmScorePackage);

    List<WmScorePackage> listWmScorePackageAndTaskExt2Old(WmScorePackage wmScorePackage);

    List<WmScorePackage> listWmScorePackageAndTaskLevel1(WmScorePackage wmScorePackage);

    List<WmScorePackage> listWmScorePackageAndTaskLevel3(WmScorePackage wmScorePackage);

    List<WmScorePackage> pageList(QueryWrapper<WmScorePackage> wrappers);

    WmScorePackage getPackageScoreByTaskInfo(WmScorePackage wmScorePackage);

    String getPackageScoreEntByTaskInfo(WmScorePackage wmScorePackage);

    List<WmScorePackage> listPage(Page page, WmScorePackage wmScorePackage);

    IPage<WmScorePackage> getExportPackageTotalList(Page page, WmScorePackage wmScorePackage);

    IPage<WmScorePackage> getExportPackageTotalList1(Page page, WmScorePackage wmScorePackage);

    IPage<Map<String, Object>> getPlatTotalData(Page page, WmScorePackage wmScorePackage);

    IPage<Map<String, Object>> selectWmScorePackageList(Page page, WmScorePackage wmScorePackage);

    Boolean updateByIdWithType(WmScorePackageVO wmScorePackageVO);

    WmScorePackage selectByPackage(String id);

    List<WmScorePackage> selectLists(WmScorePackage wmScorePackage);

    Map<String, Object> selectSettleStatus(WmScorePackage wmScorePackage);

    List<SysDept> selectSendPackageDeptId(WmScorePackage wmScorePackage);


    List<WmScorePackage> selectWmScorePackageByCode(Map<String, Object> map);

    WmScorePackage selectWmScorePackage(WmScorePackage wmScorePackage);

    Page<WmScorePackage> selectWmScorePackageLists(Page<WmScorePackage> page, WmScorePackage wmScorePackage);

    WmScorePackage selectKfpjf(String scoreId);

    WmScorePackage selectKfpjfs(String scoreName);

    WmScorePackage selectWmScorePackageById(String relationScoreId);

    List<WmScorePackage> selectRelationScoreId(String relationScoreId);

    List<WmScorePackage> selectByReRelatedService(WmScorePackage wmScorePackage);

    R<?> getRelationScoreList(WmScorePackage wmScorePackage);

    R<?> addWmScorePackage(WmScorePackage wmScorePackage);

    R<?> getScorePackagePage(Page page, WmScorePackage wmScorePackage);

    R<?> updateEnable(WmScorePackage wmScorePackage);

    R<?> getScorePackagePageById(WmScorePackage wmScorePackage);

    R<?> updateEasy(WmScorePackage wmScorePackage);

    R<?> updateWmScorePackage(WmScorePackage wmScorePackage);

    WmScorePackage selectRelationScoreIdList(WmScorePackage wmScorePackage);

    List<WmScorePackage> listWmScorePackages(WmScorePackage wmScorePackage1);

    IPage<WmScorePackageApiOutput> getPackageListForReceive(Page page, WmScorePackage wmScorePackage);

    /**
     * 积分包结算列表（分页）
     *
     * @param page  分页信息
     * @param input 分页参数
     * @return 分页结果
     */
    Page<WmScorePackageSettleOutput> listPackageSettleList(Page<WmScorePackageSettleOutput> page, WmScorePackageSettleInput input);

    /**
     * 积分包结算列表
     *
     * @param input
     * @return
     */
    List<WmScorePackageSettleOutput> listAllPackageSettle(WmScorePackageSettleInput input);

    /**
     * 获取当前部门的基于所有积分包的相关信息
     *
     * @param deptId 部门ID
     * @return 部门积分包信息
     */
    Map<String, Object> getDeptScorePackageInfo(Integer deptId);

    /**
     * 根据积分包获取推广的药品
     *
     * @param page      分页信息
     * @param packageId 积分包id
     * @param drugName  药品名称
     * @return 药品列表
     */
    IPage<WmDaDrugEntDrugtable> listDrugsByPackageId(Page page, Integer packageId, String drugName);

    Page<WmScorePackage> selectWmScorePackageLists(Page<WmScorePackage> page, Integer deptId, String scorePackageName, String acceptSug,
                                                   LocalDate allocationDate, LocalDate endLabelDate);

    Future<WmScorePackage> finishRate(WmScorePackage wmScorePackage);

    R<?> getScorePackagePage(Page<WmScorePackage> page, Integer packageType1, Integer packageType2,
                             String scorePackageName, Integer scorePackageStatus, String typeId);


    Future<WmScorePackage> buildScorePackage(WmScorePackage wmScorePackage, Integer packageType1, Integer packageType2);

    /**
     * 同步处理积分包详情数据
     *
     * @param wmScorePackage       积分包信息
     * @param packageType1         积分包type1
     * @param packageType2         积分包type2
     * @param tasks
     * @param statuses
     * @param packageType1List
     * @param packageType2List
     * @param parentPackageNameMap
     * @param scoreTaskTypes
     */
    void buildScorePackageSync(WmScorePackage wmScorePackage,
                               Integer packageType1,
                               Integer packageType2,
                               List<WmTask> tasks,
                               List<WmScorePackageStatus> statuses,
                               List<SysDictItem> packageType1List,
                               List<SysDictItem> packageType2List,
                               Map<String, WmScorePackage> parentPackageNameMap,
                               List<WmScoreTaskType> scoreTaskTypes);

    void getReportOpt(WmScorePackage wmScorePackage);

    /**
     * 查询excel报告导出状态
     *
     * @param wmScorePackage
     * @param excelReportCacheKey
     */
    void getExcelReportOpt(WmScorePackage wmScorePackage, String excelReportCacheKey);

    /**
     * 查询新版报告导出状态
     *
     * @param wmScorePackage 积分包
     * @param reportCacheKey 缓存key
     * @return 状态结果
     */
    WmReportOpt getNewReportOpt(WmScorePackage wmScorePackage, String reportCacheKey);

    /**
     * 校验积分包是否可以结算
     *
     * @param pkg 基本包
     */
    void checkPkgToSettle(WmScorePackage pkg);

    /**
     * 拆包
     *
     * @param unpackDTO 拆包参数
     * @return 是否成功
     */
    Boolean unpack(UnpackDTO unpackDTO);

    /**
     * 终止积分包(个人)
     *
     * @param packageId            积分包id
     * @param terminatePackageType 终止积分包类型
     * @return {@link Boolean} 结果
     */
    Boolean terminatePackageForPersonal(String packageId, UpmsType.TerminatePackageType terminatePackageType);

    /**
     * 终止积分包(企业大包)
     *
     * @param packageId            积分包id
     * @param terminatePackageType 终止积分包类型
     * @return {@link Boolean} 结果
     */
    Boolean terminatePackageForDept(String packageId, UpmsType.TerminatePackageType terminatePackageType);

    /**
     * 获取指定企业下积分包的可分配积分值
     *
     * @param superDeptId 上级企业id
     * @param deptId      企业id
     * @param typeIds     企业类型
     * @param packageIds  积分包id
     * @return 结果
     */
    List<WmScorePackage> getScorePackagekfpjf(Integer superDeptId, Integer deptId, String[] typeIds, String[] packageIds);


    /**
     * 查询财务结算复核数据详情
     *
     * @param query 查询条件
     * @return 结果
     */
    IPage<WmScorePackageSettleOutput> pageFinancialReviewDetail(Page<WmScorePackageSettleOutput> page, SettleFinancialReviewVO query);

    /**
     * 获取积分包监督分页
     *
     * @param pkgName     包名称
     * @param supervision 监督状态
     * @param finalEntIds 所属服务商ID
     */
    void pageForSupervision(Page<Map<String, Object>> page, String pkgName, Boolean supervision, Set<Integer> finalEntIds, Collection<Integer> drugIds);

    Map<String, Object> indPkgStat(HnqzUser user);

    /**
     * 创建大包
     *
     * @param wmScorePackage 包参数
     * @return 合同事件
     */
    PackageContractEvent saveEntPkg(WmScorePackage wmScorePackage);

    /**
     * 批量创建企业包
     *
     * @param resource 信息
     * @return 创建结果
     */
    List<Map<String, String>> batchCreateEntPkg(List<WmPkgDTO.OnEntPkgBatchCreate> resource, HnqzUser user);
}
