package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.dto.WmSupervisionDto;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskSupervisionAdvice;
import com.qunzhixinxi.hnqz.common.security.service.HnqzUser;

/**
 * 任务监察建议
 *
 * @author jimmy
 * @date 2024-11-14 17:24
 */
public interface WmTaskSupervisionAdviceService extends IService<WmTaskSupervisionAdvice> {

    /**
     * 创建监察意见
     *
     * @param supervisionId      监察ID
     * @param supervisionContent 原始内容
     * @param resource           意见信息
     * @param operator           操作人
     */
    void createAdvice(Long supervisionId, WmSupervisionDto.OnTaskSupervision resource, String supervisionContent, HnqzUser operator);

    /**
     * 删除历史
     *
     * @param supervisionId 监察ID
     * @param operator      操作人
     */
    void delAdvice(Long supervisionId, HnqzUser operator);
}
