package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.dto.WmSupervisionDto;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskSupervision;
import com.qunzhixinxi.hnqz.common.security.service.HnqzUser;

/**
 * 任务监督服务
 *
 * @author jimmy
 * @date 11/07/2024 16:48
 */
public interface WmTaskSupervisionService extends IService<WmTaskSupervision> {
    /**
     * 创建审核
     *
     * @param resource 监督信息
     * @param user     操作人
     * @return 操作结果
     */
    Boolean createTaskSupervision(WmSupervisionDto.OnTaskSupervision resource, HnqzUser user);

    /**
     * 获取任务的监察记录
     *
     * @param taskId 任务ID
     * @return 监察记录
     */
    WmTaskSupervision getSupervisionByTaskId(Integer taskId);


    /**
     * 更新监察信息
     *
     * @param supervisionId 监察ID
     * @param remarks       备注
     * @param modifiable    是否可编辑
     * @param operator      操作人
     */
    void updateSupervision(Long supervisionId, String remarks, Boolean modifiable, HnqzUser operator);
}

