package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskType;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskTypeTree;
import com.qunzhixinxi.hnqz.admin.api.model.output.WmTaskTypeDeptOutput;
import com.qunzhixinxi.hnqz.common.core.util.R;

import java.util.List;
import java.util.Map;

/**
 * 任务类型打分表
 *
 * @author gaoyang
 * @date 2020-07-01 20:20:05
 */
public interface WmTaskTypeService extends IService<WmTaskType> {
    int getWmTaskTypeByEnt(WmTaskType wmTaskType);

    List<WmTaskType> selectByRuleId(WmTaskType wmTaskType);

    List<WmTaskTypeTree> getTaskTree(String description);

    /**
     * 查询有效任务类型树
     *
     * @param description 描述
     * @return 有效任务类型树
     */
    R<Map<String, Object>> getTaskTypeTree(String description);

    List<WmTaskTypeDeptOutput> getTaskTypeDeptList(WmTaskType query);

    /**
     * 获取平台父级任务类型
     *
     * @return 任务类型列表
     */
    List<WmTaskType> listParentTaskType();
}
