package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.dto.WmSupervisionDto;
import com.qunzhixinxi.hnqz.admin.api.entity.WmWarnUserRelation;
import com.qunzhixinxi.hnqz.common.security.service.HnqzUser;

/**
 * @author jimmy
 * @date 13/07/2024 15:31
 */
public interface WmWarnUserRelationService extends IService<WmWarnUserRelation> {

    /**
     * 阅读警告信息
     *
     * @param resource 警告信息
     * @param user     阅读人
     * @return 阅读结果
     */
    Boolean read(WmSupervisionDto.OnWarnCreate resource, HnqzUser user);

    /**
     * 判断是否已经阅读了
     *
     * @param warnId 警告ID
     * @param id     阅读人ID
     * @return 阅读结果
     */
    boolean hasRead(Integer warnId, Integer id);
}
