package com.qunzhixinxi.hnqz.admin.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qunzhixinxi.hnqz.admin.api.entity.SysCheckChainNodeCheckHistory;
import com.qunzhixinxi.hnqz.admin.mapper.SysCheckChainNodeCheckHistoryMapper;
import com.qunzhixinxi.hnqz.admin.service.SysCheckChainNodeCheckHistoryService;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Collection;
import java.util.List;

/**
 * 审批链节点审核历史服务实现
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2024/05/22 12:10
 */
@Slf4j
@Service
@AllArgsConstructor
public class SysCheckChainNodeCheckHistoryServiceImpl extends ServiceImpl<SysCheckChainNodeCheckHistoryMapper, SysCheckChainNodeCheckHistory>
        implements SysCheckChainNodeCheckHistoryService {

    @Override
    public List<SysCheckChainNodeCheckHistory> getTargetLatestCheckState(Collection<Integer> targetIds) {
        return this.list(Wrappers.<SysCheckChainNodeCheckHistory>lambdaQuery().in(SysCheckChainNodeCheckHistory::getTargetId, targetIds).orderByDesc(SysCheckChainNodeCheckHistory::getCreateTime));
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean createHistory(Collection<SysCheckChainNodeCheckHistory> history) {

        return this.saveBatch(history);
    }
}




