
package com.qunzhixinxi.hnqz.admin.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDept;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDeptSub;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaAgent;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaDrugEnt;
import com.qunzhixinxi.hnqz.admin.api.model.input.DeptSubLimitAmountInput;
import com.qunzhixinxi.hnqz.admin.api.model.input.SettleAmountMonitorInput;
import com.qunzhixinxi.hnqz.admin.api.model.output.SettleAmountMonitorOutput;
import com.qunzhixinxi.hnqz.admin.api.constant.enums.DelEnum;
import com.qunzhixinxi.hnqz.admin.api.constant.enums.EnableEnum;
import com.qunzhixinxi.hnqz.admin.mapper.SysDeptMapper;
import com.qunzhixinxi.hnqz.admin.mapper.SysDeptSubMapper;
import com.qunzhixinxi.hnqz.admin.mapper.WmDaAgentMapper;
import com.qunzhixinxi.hnqz.admin.mapper.WmDaDrugEntMapper;
import com.qunzhixinxi.hnqz.admin.service.SysDeptSubService;
import com.qunzhixinxi.hnqz.common.core.util.R;
import lombok.AllArgsConstructor;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Set;

/**
 * 部门管理
 *
 * @author ryz
 * @date 2021-04-19 16:02:30
 */
@Service
@AllArgsConstructor
public class SysDeptSubServiceImpl extends ServiceImpl<SysDeptSubMapper, SysDeptSub> implements SysDeptSubService {


	private final SysDeptSubMapper sysDeptSubMapper;

	private final SysDeptMapper sysDeptMapper;

	private final WmDaAgentMapper wmDaAgentMapper;

	private final WmDaDrugEntMapper wmDaDrugEntMapper;

	@Override
	@Transactional
	public R updateSubLimitAmount(DeptSubLimitAmountInput input) {

		List<SysDeptSub> subInputList = input.getSubList();
		for (SysDeptSub deptSub : subInputList) {
			this.baseMapper.updateById(deptSub);
		}
		return R.ok();
	}

}
