package com.qunzhixinxi.hnqz.admin.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qunzhixinxi.hnqz.admin.api.entity.SysImplPlanDetailsItem;
import com.qunzhixinxi.hnqz.admin.mapper.SysImplPlanDetailsItemMapper;
import com.qunzhixinxi.hnqz.admin.service.SysImplPlanDetailsItemService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Collection;
import java.util.List;

/**
 * 执行计划详情项服务实现
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2024/05/19 15:52
 */
@Service
public class SysImplPlanDetailsItemServiceImpl extends ServiceImpl<SysImplPlanDetailsItemMapper, SysImplPlanDetailsItem>
        implements SysImplPlanDetailsItemService {

    /**
     * 保存详情项
     *
     * @param detailsItems 详情项
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public void saveItems(Collection<SysImplPlanDetailsItem> detailsItems) {
        this.saveBatch(detailsItems);
    }

    @Override
    public List<SysImplPlanDetailsItem> listDetailItems(Integer detailsId) {
        return this.list(Wrappers.<SysImplPlanDetailsItem>lambdaQuery().eq(SysImplPlanDetailsItem::getDetailsId, detailsId));
    }
}




