package com.qunzhixinxi.hnqz.admin.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qunzhixinxi.hnqz.admin.api.dto.SysUserDTO;
import com.qunzhixinxi.hnqz.admin.api.entity.SysUserAgreementHistory;
import com.qunzhixinxi.hnqz.admin.mapper.SysUserAgreementHistoryMapper;
import com.qunzhixinxi.hnqz.admin.service.SysUserAgreementHistoryService;
import com.qunzhixinxi.hnqz.common.security.service.HnqzUser;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.time.LocalDateTime;

@Slf4j
@Service
public class SysUserAgreementHistoryImpl extends ServiceImpl<SysUserAgreementHistoryMapper, SysUserAgreementHistory> implements SysUserAgreementHistoryService {


    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean doSign(SysUserDTO.OnPltUserAgreementSign resource, HnqzUser user) {
        SysUserAgreementHistory history = new SysUserAgreementHistory();
        history.setAgreementName(resource.getAgreementName());
        history.setVersion(resource.getAgreementVersion());
        history.setCreateBy(user.getUsername());
        history.setCreateTime(LocalDateTime.now());
        return this.save(history);
    }

    @Override
    public boolean checkSigned(String agreementName, String agreementVersion, HnqzUser user) {
        return CollUtil.isNotEmpty(this.list(Wrappers.<SysUserAgreementHistory>lambdaQuery()
                .eq(SysUserAgreementHistory::getCreateBy, user.getUsername())
                .eq(SysUserAgreementHistory::getAgreementName, agreementName)
                .eq(SysUserAgreementHistory::getVersion, agreementName)));
    }
}
