package com.qunzhixinxi.hnqz.admin.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qunzhixinxi.hnqz.admin.api.entity.SysUserDrug;
import com.qunzhixinxi.hnqz.admin.mapper.SysUserDrugMapper;
import com.qunzhixinxi.hnqz.admin.service.SysUserDrugService;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

/**
 * 用户管理员药品关系服务实现
 *
 * @author jimmy
 * @date 2024-10-20 14:09
 */
@Slf4j
@Service
@AllArgsConstructor
public class SysUserDrugServiceImpl extends ServiceImpl<SysUserDrugMapper, SysUserDrug> implements SysUserDrugService {

    /**
     * 根据用户ID获取绑定的产品
     *
     * @param uId 用户ID
     * @return 药品ID列表
     */
    @Override
    public List<Integer> listDrugIdByUserId(Integer uId) {
        return this.list(Wrappers.<SysUserDrug>lambdaQuery().eq(SysUserDrug::getUserId, uId)).stream().mapToInt(SysUserDrug::getDrugId).boxed().distinct().sorted().collect(Collectors.toList());
    }
}
