
package com.qunzhixinxi.hnqz.admin.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.metadata.OrderItem;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qunzhixinxi.hnqz.admin.api.entity.WmCro;
import com.qunzhixinxi.hnqz.admin.mapper.WmCroMapper;
import com.qunzhixinxi.hnqz.admin.service.WmCroService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

/**
 * CRO管理
 *
 * @author Dhy
 * @date 2020-12-17 14:37:09
 */
@Service
@AllArgsConstructor
public class WmCroServiceImpl extends ServiceImpl<WmCroMapper, WmCro> implements WmCroService {
	private final WmCroMapper wmCroMapper;

	@Override
	public IPage<WmCro> selectCroList(Page page, WmCro wmCro) {

		OrderItem orderItem=new OrderItem();
		orderItem.setColumn("create_time");
		orderItem.setAsc(false);
		page.addOrder(orderItem);

		QueryWrapper queryWrapper= Wrappers.query();
		if(null!=wmCro.getQymc())
		{
			queryWrapper.like("qymc",wmCro.getQymc());
		}
		if(null!=wmCro.getTyshxydm())
		{
			queryWrapper.like("tyshxydm",wmCro.getTyshxydm());
		}

		return wmCroMapper.selectCroList(page, wmCro);
	}
}
