package com.qunzhixinxi.hnqz.admin.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsType;
import com.qunzhixinxi.hnqz.admin.api.entity.SysAreaEntity;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDept;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDeptCsm;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDeptRelation;
import com.qunzhixinxi.hnqz.admin.api.entity.SysUser;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaAgent;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaDrugEnt;
import com.qunzhixinxi.hnqz.admin.api.entity.WmRelation;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskType;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskTypeEntRef;
import com.qunzhixinxi.hnqz.admin.api.model.input.WmDept;
import com.qunzhixinxi.hnqz.admin.api.constant.enums.EnableEnum;
import com.qunzhixinxi.hnqz.admin.mapper.SysDeptCsmMapper;
import com.qunzhixinxi.hnqz.admin.mapper.SysDeptMapper;
import com.qunzhixinxi.hnqz.admin.mapper.SysDeptRelationMapper;
import com.qunzhixinxi.hnqz.admin.mapper.SysUserMapper;
import com.qunzhixinxi.hnqz.admin.mapper.WmDaAgentMapper;
import com.qunzhixinxi.hnqz.admin.mapper.WmDaDrugEntMapper;
import com.qunzhixinxi.hnqz.admin.mapper.WmRelationMapper;
import com.qunzhixinxi.hnqz.admin.mapper.WmTaskTypeEntRefMapper;
import com.qunzhixinxi.hnqz.admin.mapper.WmTaskTypeMapper;
import com.qunzhixinxi.hnqz.admin.service.SysAreaEntityService;
import com.qunzhixinxi.hnqz.admin.service.SysCsmUserRelationService;
import com.qunzhixinxi.hnqz.admin.service.SysDeptRelationService;
import com.qunzhixinxi.hnqz.admin.service.SysDeptService;
import com.qunzhixinxi.hnqz.admin.service.SysEnterpriseAreaService;
import com.qunzhixinxi.hnqz.admin.service.SysUserAreaService;
import com.qunzhixinxi.hnqz.admin.service.WmDaAgentService;
import com.qunzhixinxi.hnqz.admin.service.WmDaDrugEntService;
import com.qunzhixinxi.hnqz.admin.service.WmRelationService;
import com.qunzhixinxi.hnqz.admin.service.WmTaskSubmissionPercentRuleService;
import com.qunzhixinxi.hnqz.admin.service.WmTaskSubmissionRuleService;
import com.qunzhixinxi.hnqz.common.core.constant.CacheConstants;
import com.qunzhixinxi.hnqz.common.core.constant.CommonConstants;
import com.qunzhixinxi.hnqz.common.core.util.IDUtils;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.data.datascope.DataScope;
import com.qunzhixinxi.hnqz.common.security.util.SecurityUtils;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.stream.Collectors;

/**
 * 档案-代理商
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
@Slf4j
@Service
@AllArgsConstructor
public class WmDaAgentServiceImpl extends ServiceImpl<WmDaAgentMapper, WmDaAgent> implements WmDaAgentService {
    private final SysDeptService sysDeptService;
    private final SysUserMapper sysUserMapper;
    private final WmDaAgentMapper wmDaAgentMapper;
    private final WmDaDrugEntMapper wmDaDrugEntMapper;
    private final SysDeptRelationService sysDeptRelationService;
    private final SysDeptRelationMapper sysDeptRelationMapper;
    private final WmDaDrugEntService wmDaDrugEntService;
    private final WmRelationMapper wmRelationMapper;
    private final WmRelationService wmRelationService;
    private final WmTaskTypeMapper wmTaskTypeMapper;
    private final WmTaskTypeEntRefMapper wmTaskTypeEntRefMapper;
    private final SysDeptMapper sysDeptMapper;
    private final WmTaskSubmissionRuleService taskSubmissionRuleService;
    private final WmTaskSubmissionPercentRuleService taskSubmissionPercentRuleService;
    private final SysCsmUserRelationService sysCsmUserRelationService;
    private final SysDeptCsmMapper sysDeptCsmMapper;
    private final RedisTemplate<String, Object> redisTemplate;
    private final SysEnterpriseAreaService enterpriseAreaService;
    private final SysUserAreaService sysUserAreaService;
    private final SysAreaEntityService areaEntityService;

    public String getDeptBuildName(String deptId) {
        String buildName = "";
        SysDept sysDept = sysDeptService.getById(deptId);
        if (null != sysDept) {
            // buildName=sysDept.getName();
            SysDept sysDeptP1 = sysDeptService.getById(sysDept.getParentId());
            if (null != sysDeptP1) {
                buildName = sysDeptP1.getName();
                if (null != sysDeptP1.getParentId() && sysDeptP1.getParentId() > 1) {
                    SysDept sysDeptP2 = sysDeptService.getById(sysDeptP1.getParentId());
                    if (null != sysDeptP2) {
                        buildName = sysDeptP2.getName() + "-" + buildName;

                        if (null != sysDeptP2.getParentId() && sysDeptP2.getParentId() > 1) {
                            SysDept sysDeptP3 = sysDeptService.getById(sysDeptP2.getParentId());
                            if (null != sysDeptP3) {
                                buildName = sysDeptP3.getName() + "-" + buildName;
                                if (null != sysDeptP3.getParentId() && sysDeptP3.getParentId() > 1) {
                                    SysDept sysDeptP4 = sysDeptService.getById(sysDeptP3.getParentId());
                                    if (null != sysDeptP4) {
                                        buildName = sysDeptP4.getName() + "-" + buildName;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        return buildName;
    }

    public List<WmDaAgent> selectByScope(Wrapper<WmDaAgent> queryWrapper) {
        return wmDaAgentMapper.selectListByScope(queryWrapper, new DataScope());
    }

    public Boolean saveAgent(WmDaAgent wmDaAgent) {
        Integer deptId = SecurityUtils.getUser().getDeptId();
        SysDept queryDept = sysDeptMapper.selectById(deptId);

        wmDaAgent.setCreateTime(LocalDateTime.now());
        boolean isSave = super.save(wmDaAgent);
        List<SysDept> list = sysDeptMapper.selectByName(wmDaAgent.getGsmc());
        if (isSave) {

            if (SecurityUtils.getRoles().contains(3)) {
                if (CollUtil.isEmpty(list)) {
                    SysDept sysDept = new SysDept();
                    sysDept.setDeptId(IDUtils.getId());
                    sysDept.setName(wmDaAgent.getGsmc());
                    sysDept.setTaxCode(wmDaAgent.getZjNumber());
                    sysDept.setLevel(3);
                    sysDept.setAbbr(wmDaAgent.getAbbr());
                    sysDept.setProvAbbr(wmDaAgent.getProvAbbr());
                    sysDept.setExpiryDate(queryDept.getExpiryDate());
                    sysDeptService.save(sysDept);
                    wmDaAgent.setDeptId(sysDept.getDeptId());
                    wmDaAgentMapper.updateById(wmDaAgent);
                } else {
                    wmDaAgent.setDeptId(list.get(0).getDeptId());
                    wmDaAgentMapper.updateById(wmDaAgent);
                }
                // 区域关系
                if (CollUtil.isNotEmpty(wmDaAgent.getAreaCodes())) {
                    enterpriseAreaService.saveRelation(Long.valueOf(wmDaAgent.getDeptId()), wmDaAgent.getAreaCodes());
                }

                // 初始化企业限制信息
                taskSubmissionRuleService.initDeptTaskSubmissionRule(Collections.singleton(wmDaAgent.getDeptId()), deptId);
                // 初始化企业的任务类型配置的信息
                taskSubmissionPercentRuleService.initTaskTypeConfigRule(Collections.singleton(wmDaAgent.getDeptId()), deptId);

                List<SysDeptRelation> newList = new ArrayList<>(2);
                SysDeptRelation sysDeptRelation = new SysDeptRelation();
                sysDeptRelation.setAncestor(SecurityUtils.getUser().getDeptId());
                sysDeptRelation.setDescendant(wmDaAgent.getDeptId());
                newList.add(sysDeptRelation);
                SysDeptRelation sysDeptRelation1 = new SysDeptRelation();
                sysDeptRelation1.setAncestor(wmDaAgent.getDeptId());
                sysDeptRelation1.setDescendant(wmDaAgent.getDeptId());
                newList.add(sysDeptRelation1);
                return sysDeptRelationService.saveBatch(newList);
            } else if (SecurityUtils.getRoles().contains(4)) {
                if (CollUtil.isEmpty(list)) {
                    SysDept sysDept = new SysDept();
                    sysDept.setDeptId(IDUtils.getId());
                    sysDept.setName(wmDaAgent.getGsmc());
                    sysDept.setLevel(4);
                    sysDept.setAbbr(wmDaAgent.getAbbr());
                    sysDept.setProvAbbr(wmDaAgent.getProvAbbr());
                    sysDept.setTaxCode(wmDaAgent.getZjNumber());
                    sysDept.setExpiryDate(queryDept.getExpiryDate());
                    sysDeptService.save(sysDept);
                    wmDaAgent.setDeptId(sysDept.getDeptId());
                    wmDaAgentMapper.updateById(wmDaAgent);
                } else {
                    wmDaAgent.setDeptId(list.get(0).getDeptId());
                    wmDaAgentMapper.updateById(wmDaAgent);
                }
                // 区域关系
                if (CollUtil.isNotEmpty(wmDaAgent.getAreaCodes())) {
                    enterpriseAreaService.saveRelation(Long.valueOf(wmDaAgent.getDeptId()), wmDaAgent.getAreaCodes());
                }

                // 初始化企业限制信息
                taskSubmissionRuleService.initDeptTaskSubmissionRule(Collections.singleton(wmDaAgent.getDeptId()), deptId);
                // 初始化企业的任务类型配置的信息
                taskSubmissionPercentRuleService.initTaskTypeConfigRule(Collections.singleton(wmDaAgent.getDeptId()), deptId);

                List<SysDeptRelation> newList = new ArrayList<>(2);
                SysDeptRelation sysDeptRelation = new SysDeptRelation();
                sysDeptRelation.setAncestor(SecurityUtils.getUser().getDeptId());
                sysDeptRelation.setDescendant(wmDaAgent.getDeptId());
                newList.add(sysDeptRelation);
                SysDeptRelation sysDeptRelation1 = new SysDeptRelation();
                sysDeptRelation1.setAncestor(wmDaAgent.getDeptId());
                sysDeptRelation1.setDescendant(wmDaAgent.getDeptId());
                newList.add(sysDeptRelation1);
                return sysDeptRelationService.saveBatch(newList);
            }


        }
        return false;
    }

    @Override
    public Page<WmDaAgent> selectWmManagementList(Page<WmDaAgent> page, WmDaAgent wmDaAgent) {

        QueryWrapper queryWrapper = Wrappers.query();
        if (null != wmDaAgent.getGsmc()) {
            queryWrapper.like("gsmc", wmDaAgent.getGsmc());
        }
        if (null != wmDaAgent.getZjNumber()) {
            queryWrapper.like("zjNamber", wmDaAgent.getZjNumber());
        }

        List<Long> areaIds;
        if (CollUtil.isNotEmpty(wmDaAgent.getAreaCodes())) {
            areaIds = wmDaAgent.getAreaCodes();
        } else {
            areaIds = sysUserAreaService.listUserAreas(Long.valueOf(SecurityUtils.getUser().getId()));
        }


        List<Long> ents = enterpriseAreaService.listAreaEnts(areaIds);
        List<Long> collect = new ArrayList<>(new HashSet<>(ents));
        log.info("total: {} to {}", ents.size(), collect.size());
        wmDaAgent.setEntIds(collect);


        wmDaAgentMapper.selectWmManagementPage(page, wmDaAgent);

        if (CollUtil.isNotEmpty(page.getRecords())) {
            page.getRecords().forEach(agent -> {
                List<Long> areas = enterpriseAreaService.listEntAreas(Collections.singletonList(Long.valueOf(agent.getDeptId())));
                agent.setAreaCodes(areas);
                SysDept sysDept = sysDeptMapper.selectById(agent.getDeptId());
                agent.setAbbr(sysDept != null ? sysDept.getAbbr() : "");
                agent.setProvAbbr(sysDept != null ? sysDept.getProvAbbr() : "");
            });
        }

        return page;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public R<?> insert(WmDaAgent wmDaAgent) {
        LocalDateTime now = LocalDateTime.now();

        WmDaAgent query = new WmDaAgent();
        query.setGsmc(wmDaAgent.getGsmc());
        List<WmDaAgent> list1 = wmDaAgentMapper.selectList(Wrappers.query(query));
        WmDaAgent wmDaAgent1 = new WmDaAgent();
        wmDaAgent1.setZjNumber(wmDaAgent.getZjNumber());
        List<WmDaAgent> list2 = wmDaAgentMapper.selectList(Wrappers.query(wmDaAgent1));

        if (CollUtil.isNotEmpty(list1)) {
            return R.failed("企业名称已存在");
        }
        if (CollUtil.isNotEmpty(list2)) {
            return R.failed("统一社会信用代码已经存在");
        }
        wmDaAgent.setTenantId(1);
        wmDaAgent.setDelFlag(CommonConstants.STATUS_NORMAL);
        List<WmDaDrugEnt> listEnts = new ArrayList<>();
        if (wmDaAgent.getExtDrugEnt() != null) {
            String[] ents = wmDaAgent.getExtDrugEnt().split(",");
            listEnts = wmDaDrugEntService.listByIds(Arrays.asList(ents));
        }
        List<String> ids = listEnts.stream().map(p -> p.getDeptId().toString()).collect(Collectors.toList());
        String temp1 = "";
        if (CollUtil.isNotEmpty(listEnts)) {
            for (WmDaDrugEnt wmD : listEnts) {
                temp1 += wmD.getEntname() + ",";
            }
            temp1 = temp1.substring(0, temp1.length() - 1);
        }
        wmDaAgent.setTemp1(temp1);
        wmDaAgent.setCreateTime(now);
        wmDaAgent.setCreateUser(SecurityUtils.getUser().getId());
        wmDaAgent.setManagement(String.valueOf(1));
        wmDaAgent.setPgqx("1");
        super.save(wmDaAgent);
        List<SysDept> list3 = sysDeptMapper.selectByName(wmDaAgent.getGsmc());
        int deptId;
        if (list3.size() == 0) {
            SysDept sysDept = new SysDept();
            sysDept.setDeptId(IDUtils.getId());
            sysDept.setTaxCode(wmDaAgent.getZjNumber());
            sysDept.setAbbr(wmDaAgent.getAbbr());
            sysDept.setProvAbbr(wmDaAgent.getProvAbbr());
            sysDept.setDeptPermissions(wmDaAgent.getDeptPermissions());
            sysDept.setFinancialReviewType(wmDaAgent.getFinancialReviewType());
            sysDept.setExpiryDate(now.plusYears(1L).toLocalDate());
            if (wmDaAgent.getQylx().contains("0")) {
                sysDept.setName(wmDaAgent.getGsmc());
                sysDept.setLevel(3);
                sysDeptService.save(sysDept);
            } else {
                sysDept.setName(wmDaAgent.getGsmc());
                sysDept.setLevel(5);
                sysDeptService.save(sysDept);
            }

            deptId = sysDept.getDeptId();


            wmDaAgent.setDeptId(sysDept.getDeptId());
            List<WmDaDrugEnt> newList1 = new ArrayList<>();
            for (String id : ids) {
                WmDaDrugEnt wmDaDrugEnt = new WmDaDrugEnt();
                wmDaDrugEnt.setDeptId(Integer.valueOf(id));
                WmDaDrugEnt wmDaDrugEnt1 = wmDaDrugEntMapper.selectDeptId(wmDaDrugEnt);
                newList1.add(wmDaDrugEnt1);
            }
            List<String> ids2 = newList1.stream().map(p -> p.getDeptId().toString()).collect(Collectors.toList());
            List<SysDeptRelation> newList2 = new ArrayList<>();
            for (String id : ids2) {
                SysDeptRelation sysDeptRelation = new SysDeptRelation();
                sysDeptRelation.setAncestor(Integer.parseInt(id));
                sysDeptRelation.setDescendant(sysDept.getDeptId());
                newList2.add(sysDeptRelation);
            }
            SysDeptRelation sysDeptRelation = new SysDeptRelation();
            sysDeptRelation.setAncestor(sysDept.getDeptId());
            sysDeptRelation.setDescendant(sysDept.getDeptId());
            newList2.add(sysDeptRelation);
            sysDeptRelationService.saveBatch(newList2);
        } else {

            deptId = list3.get(0).getDeptId();
            wmDaAgent.setDeptId(deptId);

            List<WmDaDrugEnt> newList1 = new ArrayList<>();
            for (String id : ids) {
                WmDaDrugEnt wmDaDrugEnt = new WmDaDrugEnt();
                wmDaDrugEnt.setDeptId(Integer.valueOf(id));
                WmDaDrugEnt wmDaDrugEnt1 = wmDaDrugEntMapper.selectDeptId(wmDaDrugEnt);
                newList1.add(wmDaDrugEnt1);
            }
            List<String> ids2 = newList1.stream().map(p -> p.getDeptId().toString()).collect(Collectors.toList());
            List<SysDeptRelation> newList2 = new ArrayList<>();
            for (String id : ids2) {
                SysDeptRelation sysDeptRelation = new SysDeptRelation();
                sysDeptRelation.setAncestor(Integer.parseInt(id));
                sysDeptRelation.setDescendant(list3.get(0).getDeptId());
                newList2.add(sysDeptRelation);
            }
            SysDeptRelation sysDeptRelation = new SysDeptRelation();
            sysDeptRelation.setAncestor(list3.get(0).getDeptId());
            sysDeptRelation.setDescendant(list3.get(0).getDeptId());
            newList2.add(sysDeptRelation);
            sysDeptRelationService.saveBatch(newList2);
        }

        // 初始化任务规则
        taskSubmissionRuleService.initDeptTaskSubmissionRule(Collections.singleton(deptId));
        // 初始化企业的任务类型配置的信息
        taskSubmissionPercentRuleService.initTaskTypeConfigRule(Collections.singleton(Integer.valueOf(wmDaAgent.getDeptId())));

        this.updateById(wmDaAgent);

        // CSM创建的企业,负责人默认是该CSM
        Integer userId = SecurityUtils.getUser().getId();
        SysUser user = sysUserMapper.selectById(userId);
        SysDeptCsm insert = new SysDeptCsm();
        insert.setDeptId(deptId);
        insert.setUserId(userId);
        insert.setCsmName(user.getRealname());
        insert.setQrCodeId(null);
        insert.setCorpId(null);
        sysDeptCsmMapper.insert(insert);

        List<WmRelation> newList = new ArrayList<>();
        for (String upId : ids) {
            WmRelation wmRelation = new WmRelation();
            wmRelation.setUpId(Integer.parseInt(upId));
            wmRelation.setDownId(wmDaAgent.getDeptId());
            newList.add(wmRelation);
        }
        wmRelationService.saveBatch(newList);

        // cso
        if (wmDaAgent.getQylx().equals("0")) {
            WmTaskTypeEntRef wmTaskTypeEntRef = new WmTaskTypeEntRef();
            wmTaskTypeEntRef.setAgentId(wmDaAgent.getId());
            wmTaskTypeEntRef.setDrugentId(null);

            LambdaQueryWrapper<WmTaskType> queryWrapper = Wrappers.<WmTaskType>lambdaQuery()
                    .eq(WmTaskType::getLevel1Id, wmDaAgent.getId())
                    .eq(WmTaskType::getDelFlag, CommonConstants.STATUS_NORMAL);

            if (StrUtil.isNotBlank(wmDaAgent.getDrugEntId())) {
                String[] drugId = wmDaAgent.getDrugEntId().contains(StrUtil.COMMA) ? wmDaAgent.getDrugEntId().split(StrUtil.COMMA) : new String[]{wmDaAgent.getDrugEntId()};
                queryWrapper.in(WmTaskType::getDurgentId, Arrays.stream(drugId).collect(Collectors.toSet()));
            }

            List<WmTaskType> list = wmTaskTypeMapper.selectList(queryWrapper);
            if (CollUtil.isNotEmpty(list)) {
                return R.failed("一代积分规则已分配");
            } else {
                if (null != wmDaAgent) {
                    wmTaskTypeEntRef.setDeptId(wmDaAgent.getDeptId().toString());
                }
                wmTaskTypeEntRefMapper.insert(wmTaskTypeEntRef);

                WmTaskType wmTaskTypeQ = new WmTaskType();
                wmTaskTypeQ.setTaskTypeLevel("1");
                wmTaskTypeQ.setStatus(CommonConstants.STATUS_NORMAL);
                wmTaskTypeQ.setDelFlag(CommonConstants.STATUS_NORMAL);

                List<WmTaskType> tempList = wmTaskTypeMapper.selectList(Wrappers.query(wmTaskTypeQ));

                for (WmTaskType wmTaskType1 : tempList) {
                    WmTaskType newOne = wmTaskType1;
                    newOne.setId(null);
                    newOne.setLevel1Id(wmTaskTypeEntRef.getAgentId());
                    newOne.setTaskTypeLevel("2");
                    newOne.setTaskEntId(wmTaskTypeEntRef.getAgentId());
                    newOne.setRuleId(wmTaskTypeEntRef.getAgentId().toString());
                    newOne.setDeptId(wmDaAgent.getDeptId());
                    newOne.setCreateTime(LocalDateTime.now());
                    newOne.setStatus(CommonConstants.STATUS_NORMAL);
                    newOne.setBaseId(wmTaskType1.getId());
                    wmTaskTypeMapper.insert(newOne);
                }
            }
        }
        return R.ok();
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public R updateByPrimaryKeySelective(WmDaAgent wmDaAgent) {
        WmDaAgent query = new WmDaAgent();
        query.setGsmc(wmDaAgent.getGsmc());
        List<WmDaAgent> list1 = wmDaAgentMapper.selectList(Wrappers.query(query));

        if (list1.size() > 1) {
            return R.failed("企业名称已存在");
        }
        wmDaAgent.setUpdateTime(LocalDateTime.now());

        List<WmDaAgent> agentList = new ArrayList<>();
        if (wmDaAgent.getDeptLevel() != null && wmDaAgent.getDeptLevel().equals(4)) {
            // 如果是4-二级代理商，则根据extDrugEnt查询代理商列表
            if (StringUtils.isNotBlank(wmDaAgent.getExtDrugEnt())) {
                String[] ents = wmDaAgent.getExtDrugEnt().split(",");
                agentList = this.listByIds(Arrays.asList(ents));
                if (CollectionUtil.isNotEmpty(agentList)) {
                    List<String> gsmcList = agentList.stream().map(WmDaAgent::getGsmc).collect(Collectors.toList());
                    wmDaAgent.setTemp1(String.join(",", gsmcList));
                }
            }
        } else if (wmDaAgent.getQylx().equals("0")) {
            if (null != wmDaAgent.getExtDrugEnt()) {
                String[] ents = wmDaAgent.getExtDrugEnt().split(",");
                List<WmDaDrugEnt> listEnts = wmDaDrugEntService.listByIds(Arrays.asList(ents));
                String temp1 = "";
                if (listEnts.size() > 0) {
                    for (WmDaDrugEnt wmD : listEnts) {
                        temp1 += wmD.getEntname() + ",";
                    }
                    temp1 = temp1.substring(0, temp1.length() - 1);
                }
                wmDaAgent.setTemp1(temp1);
            }
        }
        List<WmDaDrugEnt> listEnts = new ArrayList<>();
        if (wmDaAgent.getExtDrugEnt() != null) {
            String[] ents = wmDaAgent.getExtDrugEnt().split(",");
            listEnts = wmDaDrugEntService.listByIds(Arrays.asList(ents));
        } else {
            wmDaAgent.setExtDrugEnt("");
            wmDaAgent.setTemp1("");
        }

        // 关联上级(上级可能是药企的情况，也可能是代理商的情况)
        // 药企或代理商id
        List<String> ids = null;
        // 对应的部门id
        List<String> deptIds = null;
        if (CollectionUtil.isNotEmpty(agentList)) {
            // ids = agentList.stream().map(WmDaAgent::getId).collect(Collectors.toList());
            deptIds = agentList.stream().map(agent -> agent.getDeptId().toString()).collect(Collectors.toList());
        } else {
            // ids = listEnts.stream().map(p -> p.getId()).collect(Collectors.toList());
            deptIds = listEnts.stream().map(ent -> ent.getDeptId().toString()).collect(Collectors.toList());
        }
        List<WmRelation> newList = new ArrayList<>();
//		List<WmDaDrugEnt> newList1 = new ArrayList<>();
        List<SysDeptRelation> newList2 = new ArrayList<>();

        WmDaAgent wmDaAgent1 = wmDaAgentMapper.selectOne(Wrappers.query(query));
        if (wmDaAgent1 != null) {
            for (String upId : deptIds) {
                WmRelation wmRelation = new WmRelation();
                wmRelation.setUpId(Integer.parseInt(upId));
                wmRelation.setDownId(wmDaAgent1.getDeptId());
                newList.add(wmRelation);
                wmRelationMapper.deleteByPrimaryKey(Long.valueOf(wmRelation.getDownId()));
            }
            wmRelationService.saveBatch(newList);
        }

        for (String id : deptIds) {
            SysDeptRelation sysDeptRelation = new SysDeptRelation();
            sysDeptRelation.setAncestor(Integer.parseInt(id));
            sysDeptRelation.setDescendant(wmDaAgent.getDeptId());
            newList2.add(sysDeptRelation);
        }
        sysDeptRelationMapper.deleteByPrimaryKey(Long.valueOf(wmDaAgent.getDeptId()));
        SysDeptRelation sysDeptRelation = new SysDeptRelation();
        sysDeptRelation.setAncestor(wmDaAgent.getDeptId());
        sysDeptRelation.setDescendant(wmDaAgent.getDeptId());
        if (!newList2.contains(sysDeptRelation)) {
            newList2.add(sysDeptRelation);
        }
        sysDeptRelationService.saveBatch(newList2);

        wmDaAgentMapper.updateById(wmDaAgent);
        SysDept sysDept1 = new SysDept();
        sysDept1.setDeptId(wmDaAgent.getDeptId());
        SysDept sysDept = sysDeptMapper.selectDept(sysDept1);
        sysDept.setDelFlag(wmDaAgent.getEnableFlag());
        sysDept.setName(wmDaAgent.getGsmc());
        sysDept.setDeptId(wmDaAgent.getDeptId());
//		sysDept.setSubjectType(wmDaAgent.getSubjectType());


        sysDept.setTaxCode(wmDaAgent.getZjNumber());

//		if(!Arrays.equals(sysDept.getSubjectType(),wmDaAgent.getSubjectType())){
//
//			sysDeptSubMapper.update(new SysDeptSub(), Wrappers.<SysDeptSub>lambdaUpdate()
//					.eq(SysDeptSub::getDeptId,sysDept.getDeptId())
//					.set(SysDeptSub::getEnableFlag, SubjectTypeEnum.ENABLE_FLAG_FALSE.getCode()));

//			if (CollUtil.isNotEmpty(wmDaAgent.getSubjectTypeAndChannel())) {
//				for (Map.Entry<String, Integer> entry : wmDaAgent.getSubjectTypeAndChannel().entrySet()) {
//					SysDeptSub condition = new SysDeptSub();
//					condition.setDeptId(sysDept.getDeptId());
//					condition.setSubjectType(entry.getKey());
//					condition.setSubjectChannel(entry.getValue());
//					SysDeptSub existSub = sysDeptSubMapper.selectOne(Wrappers.query(condition));
//					if (null != existSub) {
//						existSub.setEnableFlag(SubjectTypeEnum.ENABLE_FLAG_TRUE.getCode());
//						existSub.setUpdateTime(LocalDateTime.now());
//						sysDeptSubMapper.updateById(existSub);
//					} else {
//						existSub = new SysDeptSub();
//						existSub.setEnableFlag(SubjectTypeEnum.ENABLE_FLAG_TRUE.getCode());
//						existSub.setDeptId(sysDept.getDeptId());
//						existSub.setSubjectType(entry.getKey());
//						existSub.setSubjectChannel(entry.getValue());
//						existSub.setUpdateTime(LocalDateTime.now());
//						sysDeptSubMapper.insert(existSub);
//					}
//				}
//			}

//		}

        sysDept.setDeptPermissions(wmDaAgent.getDeptPermissions());
        sysDept.setProvAbbr(wmDaAgent.getProvAbbr());
        sysDept.setAbbr(wmDaAgent.getAbbr());
        sysDept.setFinancialReviewType(wmDaAgent.getFinancialReviewType());
        sysDeptMapper.updateByPrimaryKeySelective(sysDept);
        SysUser sysUser1 = new SysUser();
        sysUser1.setDeptId(wmDaAgent.getDeptId());
        List<SysUser> sysUserList = sysUserMapper.selectUserById(sysUser1);
        List<Integer> id1 = sysUserList.stream().map(p -> p.getUserId()).collect(Collectors.toList());
        for (Integer id : id1) {
            SysUser sysUser = new SysUser();
            sysUser.setUserId(id);
            sysUser.setDelFlag(wmDaAgent.getEnableFlag());
            sysUserMapper.updateByPrimaryKeySelective(sysUser);
        }

        if (EnableEnum.DISABLE.val().equals(wmDaAgent.getEnableFlag())) {
            // 移除user的缓存
            Set<String> userNameKeys = sysUserList.stream()
                    .map(sysUser -> String.format("%s%s", CacheConstants.USER_DETAILS, sysUser.getUsername()))
                    .collect(Collectors.toSet());
            redisTemplate.delete(userNameKeys);
        }

        // 如果是二级cso 则允许更新区域
        if (sysDept.getLevel() == 4 && CollUtil.isNotEmpty(wmDaAgent.getAreaCodes())) {
            enterpriseAreaService.updateRelation(Long.valueOf(sysDept.getDeptId()), wmDaAgent.getAreaCodes());
        }

        return R.ok();
    }

    @Override
    public List<Map<String, Object>> selectDeptId1(Integer deptId) {
        List<Map<String, Object>> map1;
        if (SecurityUtils.getRoles().contains(3)
                || SecurityUtils.getRoles().contains(39)
                || SecurityUtils.getRoles().contains(41)) {
            map1 = wmDaDrugEntMapper.selectDeptId1(deptId);
        } else if (SecurityUtils.getRoles().contains(4)) {
            map1 = wmDaAgentMapper.selectDeptId1(deptId);
        } else {
            map1 = Collections.emptyList();
        }
        return map1;
    }

    @Override
    public List<WmDaAgent> selectWmDaDrugEntByDeptId(Integer deptId) {
        return wmDaAgentMapper.selectWmDaDrugEntByDeptId(deptId);
    }

    @Override
    public List<WmDaAgent> selectWmDaDrugEntByDeptIds(Integer deptId) {
        return wmDaAgentMapper.selectWmDaDrugEntByDeptIds(deptId);
    }

    @Override
    public List selectWmDaAgentByRelationId(Integer deptId) {
        return wmDaAgentMapper.selectWmDaAgentByRelationId(deptId);
    }

    @Override
    public List selectWmDaAgentByRelationIds(Integer deptId) {
        return wmDaAgentMapper.selectWmDaAgentByRelationIds(deptId);
    }

    @Override
    public List selectWmDaAgentByDeptId(String deptId) {
        return wmDaAgentMapper.selectWmDaAgentByDeptId(deptId);
    }


    @Override
    public WmDaAgent selectByDeptId(Integer deptId) {
        return wmDaAgentMapper.selectByDeptIds(deptId);
    }


    @Override
    public List<WmDept> listByDept() {
        List<WmDept> wmDeptList = new ArrayList<>();
//		if(SecurityUtils.getRoles().contains(9)){
//			WmDept wmDept = new WmDept();
//			SysDept sysDept = sysDeptMapper.selectById(SecurityUtils.getUser().getDeptId());
//			wmDept.setDeptId(sysDept.getDeptId());
//			wmDept.setName(sysDept.getName());
//			wmDeptList.add(wmDept);
//			return wmDeptList;
//		}
        if (SecurityUtils.getRoles().contains(1) || SecurityUtils.getRoles().contains(2) || SecurityUtils.getRoles().contains(35)) {
            SysDept sysDept = new SysDept();
            List<SysDept> sysDeptList = sysDeptMapper.selectListByDept(sysDept);
            for (SysDept dept : sysDeptList) {
                WmDept wmDept = new WmDept();
                wmDept.setDeptId(Integer.parseInt(String.valueOf(dept.getDeptId())));
                wmDept.setName(dept.getName());
                wmDeptList.add(wmDept);
            }
            return wmDeptList;
        } else if (SecurityUtils.getRoles().contains(50)) {

            List<SysDept> sysDepts = sysDeptMapper.selectList(Wrappers.<SysDept>lambdaQuery()
                    .gt(SysDept::getLevel, 1)
                    .eq(SysDept::getDelFlag, CommonConstants.STATUS_NORMAL));

            for (SysDept dept : sysDepts) {
                WmDept wmDept = new WmDept();
                wmDept.setDeptId(Integer.parseInt(String.valueOf(dept.getDeptId())));
                wmDept.setName(dept.getName());
                wmDeptList.add(wmDept);
            }
            return wmDeptList;

        } else {

            final List<SysDeptRelation> sysDeptRelationList = new ArrayList<>();
            if (SecurityUtils.getRoles().contains(19)) {
                // CSM只能查看自己维护的企业下的数据, 以及下属维护的企业下的数据
                Integer userId = SecurityUtils.getUser().getId();
                // 递归查询下属关联的userId
                Set<Integer> allUserIds = sysCsmUserRelationService.recurseCsmLowerUserId(Collections.singleton(userId), new AtomicInteger(10));
                // 查询企业id
                List<SysDeptCsm> deptCsms = sysDeptCsmMapper.selectList(Wrappers.<SysDeptCsm>lambdaQuery()
                        .in(SysDeptCsm::getUserId, allUserIds));
                if (CollUtil.isEmpty(deptCsms)) {
                    return Collections.emptyList();
                }

                deptCsms.forEach(deptCsm -> {
                    SysDeptRelation sysDeptRelation = new SysDeptRelation();
                    sysDeptRelation.setAncestor(deptCsm.getDeptId());
                    List<SysDeptRelation> relations = sysDeptRelationMapper.selectDeptRelationsList(sysDeptRelation);
                    sysDeptRelationList.addAll(relations);
                });
            } else {
                SysDeptRelation sysDeptRelation = new SysDeptRelation();
                sysDeptRelation.setAncestor(SecurityUtils.getUser().getDeptId());
                sysDeptRelationList.addAll(sysDeptRelationMapper.selectDeptRelationsList(sysDeptRelation));
            }

            List<WmDaAgent> wmDaAgentList = new ArrayList<>();
            List<WmDaDrugEnt> wmDaDrugEntList = new ArrayList<>();
            List<SysDept> sysDeptList = new ArrayList<>();
            if (CollUtil.isNotEmpty(sysDeptRelationList)) {

                // 区域限制
                List<Long> areaId = sysUserAreaService.listUserAreas(Long.valueOf(SecurityUtils.getUser().getId()));
                if (CollUtil.isNotEmpty(areaId)) {
                    areaId = areaEntityService.list(Wrappers.<SysAreaEntity>lambdaQuery()
                                    .in(SysAreaEntity::getAreaId, areaId)
                                    .eq(SysAreaEntity::getAreaStatus, Boolean.TRUE)
                                    .eq(SysAreaEntity::getAreaType, UpmsType.AreaType.DISTRICT))
                            .stream()
                            .mapToLong(SysAreaEntity::getAreaId).boxed().distinct().collect(Collectors.toList());
                } else {
                    return Collections.emptyList();
                }

                List<Long> entIds = enterpriseAreaService.listAreaEnts(areaId);

                // 交集
                List<Integer> ids = sysDeptRelationList.stream().map(SysDeptRelation::getDescendant).collect(Collectors.toList());
                Set<Integer> resSet = new HashSet<>(ids);
                resSet.retainAll(entIds.stream().map(Long::intValue).collect(Collectors.toSet()));

                for (Integer id : resSet) {
                    SysDept sysDept = sysDeptService.getById(id);
                    if (null != sysDept) {
                        sysDeptList.add(sysDept);
                    }
                }
                List<Integer> ids1 = sysDeptList.stream().filter(task -> 2 == task.getLevel()).map(SysDept::getDeptId).collect(Collectors.toList());
                List<Integer> ids2 = sysDeptList.stream().filter(task -> 3 == task.getLevel()).map(SysDept::getDeptId).collect(Collectors.toList());
                List<Integer> ids3 = sysDeptList.stream().filter(task -> 4 == task.getLevel()).map(SysDept::getDeptId).collect(Collectors.toList());
                List<Integer> ids4 = sysDeptList.stream().filter(task -> 5 == task.getLevel()).map(SysDept::getDeptId).collect(Collectors.toList());

                for (Integer id : ids1) {
                    WmDaDrugEnt wmDaDrugEnt1 = wmDaDrugEntMapper.selectByDeptId(id);
                    if (Integer.parseInt(wmDaDrugEnt1.getEnableFlag()) == 0) {
                        wmDaDrugEntList.add(wmDaDrugEnt1);
                    }
                }
                WmDaAgent wmDaAgent1 = new WmDaAgent();
                for (Integer id : ids2) {
                    wmDaAgent1.setDeptId(id);
                    WmDaAgent wmDaAgent2 = wmDaAgentMapper.selectByDeptId(wmDaAgent1);
                    if (Integer.parseInt(wmDaAgent2.getEnableFlag()) == 0) {
                        wmDaAgentList.add(wmDaAgent2);
                    }
                }
                for (Integer id : ids3) {
                    wmDaAgent1.setDeptId(id);
                    WmDaAgent wmDaAgent2 = wmDaAgentMapper.selectByDeptId(wmDaAgent1);
                    if (Integer.parseInt(wmDaAgent2.getEnableFlag()) == 0) {
                        wmDaAgentList.add(wmDaAgent2);
                    }
                }
                for (Integer id : ids4) {
                    wmDaAgent1.setDeptId(id);
                    WmDaAgent wmDaAgent2 = wmDaAgentMapper.selectByDeptId(wmDaAgent1);
                    if (Integer.parseInt(wmDaAgent2.getEnableFlag()) == 0) {
                        wmDaAgentList.add(wmDaAgent2);
                    }
                }
                for (WmDaDrugEnt wmDaDrugEnt : wmDaDrugEntList) {
                    WmDept wmDept = new WmDept();
                    wmDept.setDeptId(wmDaDrugEnt.getDeptId());
                    wmDept.setName(wmDaDrugEnt.getEntname());
                    wmDeptList.add(wmDept);
                }
                for (WmDaAgent wmDaAgent : wmDaAgentList) {
                    WmDept wmDept = new WmDept();
                    wmDept.setDeptId(wmDaAgent.getDeptId());
                    wmDept.setName(wmDaAgent.getGsmc());
                    wmDeptList.add(wmDept);
                }
            }
            return wmDeptList;
        }
    }

    @Override
    public List<WmDaAgent> selectNameByDeptId(Integer deptId) {

        SysDept deptIds = sysDeptService.getById(SecurityUtils.getUser().getDeptId());
        List<WmDaAgent> wmDaDrugEnts = null;
        if (deptIds.getLevel() == 2) {
            wmDaDrugEnts = wmDaDrugEntMapper.selectByUserDeptId(SecurityUtils.getUser().getDeptId());
        } else if (deptIds.getLevel() == 3 || deptIds.getLevel() == 4) {
            wmDaDrugEnts = wmDaAgentMapper.selectByUserDeptId(SecurityUtils.getUser().getDeptId());
        }
        return wmDaDrugEnts;
    }

    @Override
    public int updateUserByDeptId(WmDaAgent wmDaAgent) {

        SysDept deptIds = sysDeptService.getById(SecurityUtils.getUser().getDeptId());
        WmDaDrugEnt wmDaDrugEnt = new WmDaDrugEnt();
        Integer wmDaDrugEnts = null;
        if (deptIds.getLevel() == 2) {
            deptIds.setName(wmDaAgent.getGsmc());
            sysDeptService.updateById(deptIds);
            wmDaDrugEnt.setId(wmDaAgent.getId());
            wmDaDrugEnt.setEntname(wmDaAgent.getGsmc());
            wmDaDrugEnt.setEntcode(wmDaAgent.getZjNumber());
            wmDaDrugEnt.setManagement(wmDaAgent.getManagement());
            wmDaDrugEnts = wmDaDrugEntMapper.updateById(wmDaDrugEnt);
        } else if (deptIds.getLevel() == 3 || deptIds.getLevel() == 4) {
            deptIds.setName(wmDaAgent.getGsmc());
            sysDeptService.updateById(deptIds);
            wmDaDrugEnts = wmDaAgentMapper.updateById(wmDaAgent);
        } else {
            return -1;
        }
        return wmDaDrugEnts;
    }

    /**
     * 根据sys_dept表的level字段查询
     *
     * @param deptLevel 企业等级
     * @return 代理商列表
     */
    @Override
    public List<WmDaAgent> listAgentByDeptLevel(String deptLevel) {
        return wmDaAgentMapper.listAgentByDeptLevel(deptLevel);
    }

    /**
     * 根据deptRelation查询
     *
     * @param deptId 企业ID
     * @return 代理列表
     */
    @Override
    public List<WmDaAgent> listAgentByDeptRelation(Integer deptId) {
        return wmDaAgentMapper.listAgentByDeptRelation(deptId);
    }


}
