
package com.qunzhixinxi.hnqz.admin.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDeptBudget;
import com.qunzhixinxi.hnqz.admin.api.entity.WmScorePackage;
import com.qunzhixinxi.hnqz.admin.api.model.output.BudgetViewOutput;
import com.qunzhixinxi.hnqz.admin.mapper.WmDeptBudgetMapper;
import com.qunzhixinxi.hnqz.admin.service.WmDeptBudgetService;
import com.qunzhixinxi.hnqz.admin.service.WmScorePackageService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 *
 *
 * @author xyz
 * @date 2021-04-26 18:05:10
 */
@Service
@AllArgsConstructor
public class WmDeptBudgetServiceImpl extends ServiceImpl<WmDeptBudgetMapper, WmDeptBudget> implements WmDeptBudgetService {

	private final WmDeptBudgetMapper wmDeptBudgetMapper;
	private final WmScorePackageService wmScorePackageService;

	@Override
	public IPage getBudgetViewPage(Page page, WmDeptBudget wmDeptBudget) {
		IPage iPage = wmDeptBudgetMapper.getBudgetViewPage(page,wmDeptBudget);
		List<BudgetViewOutput> outputList = iPage.getRecords();
		for (BudgetViewOutput output : outputList) {
			Integer score = 0;
			WmScorePackage condition = new WmScorePackage();
			condition.setSendPackageDeptId(output.getDeclareDept()+"");
			condition.setDeptId(output.getDeptId()+"");
			condition.setBelongDate(output.getBelongDate());
			condition.setPackageType1("1");
			List<WmScorePackage> packageList = wmScorePackageService.list(Wrappers.query(condition));
			for (WmScorePackage wmScorePackage : packageList) {
				score+=wmScorePackage.getScore();
			}
			output.setScoreIssue(score);
		}
//		return wmDeptBudgetMapper.getBudgetViewPage(page,wmDeptBudget);
		return iPage;
	}

	@Override
	public IPage getBudgetEntViewPage(Page page, WmDeptBudget wmDeptBudget) {

		IPage iPage = wmDeptBudgetMapper.getBudgetEntViewPage(page, wmDeptBudget);
		List<BudgetViewOutput> outputList = iPage.getRecords();
		for (BudgetViewOutput output : outputList) {
			Integer score = 0;
			WmScorePackage condition = new WmScorePackage();
			condition.setSendPackageDeptId(output.getDeclareDept()+"");
			condition.setDeptId(output.getDeptId()+"");
			condition.setBelongDate(output.getBelongDate());
			condition.setPackageType1("1");
			List<WmScorePackage> packageList = wmScorePackageService.list(Wrappers.query(condition));
			for (WmScorePackage wmScorePackage : packageList) {
				score+=wmScorePackage.getScore();
			}
			output.setScoreIssue(score);
		}
//		return wmDeptBudgetMapper.getBudgetEntViewPage(page,wmDeptBudget);
		return iPage;
	}
}
