package com.qunzhixinxi.hnqz.admin.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qunzhixinxi.hnqz.admin.api.entity.WmPackageTaskTypeQty;
import com.qunzhixinxi.hnqz.admin.mapper.WmPackageTaskTypeQtyMapper;
import com.qunzhixinxi.hnqz.admin.service.WmPackageTaskTypeQtyService;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.Collections;
import java.util.List;

/**
 * 包任务类型数量服务实现
 *
 * @author jimmy
 * @date 2024-08-18 12:30
 */
@Slf4j
@Service
@AllArgsConstructor
public class WmPackageTaskTypeQtyServiceImpl extends ServiceImpl<WmPackageTaskTypeQtyMapper, WmPackageTaskTypeQty> implements WmPackageTaskTypeQtyService {


    /**
     * 获取积分包的任务类型数量关系
     *
     * @param pkgIds 积分包ID
     * @return 管理列表
     */
    @Override
    public List<WmPackageTaskTypeQty> listPkgTaskTypeQtyByPkgIds(Collection<Integer> pkgIds) {

        if (CollUtil.isEmpty(pkgIds)){
            return Collections.emptyList();
        }

        return this.list(Wrappers.<WmPackageTaskTypeQty>lambdaQuery().in(WmPackageTaskTypeQty::getPackageId, pkgIds));
    }
}
