
package com.qunzhixinxi.hnqz.daemon.quartz.config;

import com.qunzhixinxi.hnqz.daemon.quartz.constants.HnqzQuartzEnum;
import com.qunzhixinxi.hnqz.daemon.quartz.entity.SysJob;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.quartz.DisallowConcurrentExecution;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * @author 郑健楠
 *
 * <p>
 * 动态任务工厂
 */
@Slf4j
@DisallowConcurrentExecution
public class HnqzQuartzFactory implements Job {

	@Autowired
	private HnqzQuartzInvokeFactory hnqzQuartzInvokeFactory;

	@Override
	@SneakyThrows
	public void execute(JobExecutionContext jobExecutionContext) {
		SysJob sysJob = (SysJob) jobExecutionContext.getMergedJobDataMap()
				.get(HnqzQuartzEnum.SCHEDULE_JOB_KEY.getType());
		hnqzQuartzInvokeFactory.init(sysJob, jobExecutionContext.getTrigger());
	}

}
