

package com.qunzhixinxi.hnqz.daemon.quartz.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.log.annotation.SysLog;
import com.qunzhixinxi.hnqz.daemon.quartz.entity.WmScorePackage;
import com.qunzhixinxi.hnqz.daemon.quartz.service.WmScorePackageService;
import org.springframework.security.access.prepost.PreAuthorize;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;


/**
 * 积分包
 *
 * @author pigx code generator
 * @date 2020-07-31 20:07:52
 */
@RestController
@AllArgsConstructor
@RequestMapping("/wmscorepackage" )
public class WmScorePackageController {

    private final  WmScorePackageService wmScorePackageService;

    /**
     * 分页查询
     * @param page 分页对象
     * @param wmScorePackage 积分包
     * @return
     */
    @GetMapping("/page" )
    @PreAuthorize("@pms.hasPermission('quartz_wmscorepackage_view')" )
    public R getWmScorePackagePage(Page page, WmScorePackage wmScorePackage) {
        return R.ok(wmScorePackageService.page(page, Wrappers.query(wmScorePackage)));
    }


    /**
     * 通过id查询积分包
     * @param id id
     * @return R
     */
    @GetMapping("/{id}" )
    @PreAuthorize("@pms.hasPermission('quartz_wmscorepackage_view')" )
    public R getById(@PathVariable("id" ) Integer id) {
        return R.ok(wmScorePackageService.getById(id));
    }

    /**
     * 新增积分包
     * @param wmScorePackage 积分包
     * @return R
     */
    @SysLog("新增积分包" )
    @PostMapping
    @PreAuthorize("@pms.hasPermission('quartz_wmscorepackage_add')" )
    public R save(@RequestBody WmScorePackage wmScorePackage) {
        return R.ok(wmScorePackageService.save(wmScorePackage));
    }

    /**
     * 修改积分包
     * @param wmScorePackage 积分包
     * @return R
     */
    @SysLog("修改积分包" )
    @PutMapping
    @PreAuthorize("@pms.hasPermission('quartz_wmscorepackage_edit')" )
    public R updateById(@RequestBody WmScorePackage wmScorePackage) {
        return R.ok(wmScorePackageService.updateById(wmScorePackage));
    }

    /**
     * 通过id删除积分包
     * @param id id
     * @return R
     */
    @SysLog("通过id删除积分包" )
    @DeleteMapping("/{id}" )
    @PreAuthorize("@pms.hasPermission('quartz_wmscorepackage_del')" )
    public R removeById(@PathVariable Integer id) {
        return R.ok(wmScorePackageService.removeById(id));
    }

}
