
package com.qunzhixinxi.hnqz.daemon.quartz.event;

import com.qunzhixinxi.hnqz.daemon.quartz.config.HnqzQuartzInvokeFactory;
import com.qunzhixinxi.hnqz.daemon.quartz.service.SysJobLogService;
import com.qunzhixinxi.hnqz.daemon.quartz.util.TaskInvokUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnWebApplication;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableAsync;

/**
 * @author frwcloud
 * @date 2018/6/28
 * <p>
 * 多线程自动配置
 */
@EnableAsync
@Configuration
@ConditionalOnWebApplication
public class EventAutoConfiguration {

	@Autowired
	private TaskInvokUtil taskInvokUtil;

	@Autowired
	private SysJobLogService sysJobLogService;

	@Bean
	public SysJobListener sysJobListener() {
		return new SysJobListener(taskInvokUtil);
	}

	@Bean
	public HnqzQuartzInvokeFactory hnqzQuartzInvokeFactory(ApplicationEventPublisher publisher) {
		return new HnqzQuartzInvokeFactory(publisher);
	}

	@Bean
	public SysJobLogListener sysJobLogListener() {
		return new SysJobLogListener(sysJobLogService);
	}

	@Bean
	public TaskInvokUtil taskInvokUtil(ApplicationEventPublisher publisher) {
		return new TaskInvokUtil(publisher);
	}

}
