
package com.qunzhixinxi.hnqz.daemon.quartz.mapper;

import com.qunzhixinxi.hnqz.common.data.datascope.DataScopeMapper;
import com.qunzhixinxi.hnqz.daemon.quartz.entity.SysDept;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 部门管理 Mapper 接口
 * </p>
 *
 * @author hnqz
 * @since 2018-01-20
 */
@Mapper
public interface SysDeptMapper extends DataScopeMapper<SysDept> {
	List<SysDept> selectDeptList(@Param("query") SysDept sysDept);

	List<SysDept> selectListByDept(@Param("query") SysDept sysDept);

	List<SysDept> selectDeptByIds(@Param("query") SysDept sysDept);

	List<SysDept> getAllParentDept(@Param("query") SysDept sysDept);

	SysDept selectDistinctDeptId(@Param("query") SysDept sysDept);

	List<SysDept> selectDeptByName(@Param("query")SysDept sysDept);

	List<Map<String,Object>> selectDeptById(@Param("query") SysDept sysDept);

	List<SysDept> selectByName(String entname);


	String selectEntCodeByLevelId(@Param(value = "levelId") long levelId,
								  @Param(value = "level") int level);

	/**
	 * 修改名称 结算渠道
	 */
	void updateByPrimaryKeySelective(SysDept sysDept);

	SysDept selectDept(SysDept sysDept);

	List<SysDept> getParentDept(@Param("query") SysDept sysDept);

	List getDeptConvertToName();

	List getChildDept(@Param("query") SysDept sysDept);

	/**
	 * 查询所有dept
	 *
	 * @return
	 */
	List<SysDept> listAllDept();
}
