
package com.qunzhixinxi.hnqz.daemon.quartz.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.daemon.quartz.entity.WmScorePackage;

import java.time.LocalDateTime;

/**
 * 积分包
 *
 * @author pigx code generator
 * @date 2020-07-31 20:07:52
 */
public interface WmScorePackageService extends IService<WmScorePackage> {

	/**
	 * 将本企业结算数据发送到企业
	 *
	 * @param deptId     部门 ID
	 * @param toEmail    发送电子邮件至
	 * @param startOfDay 一天开始
	 * @param endOfDay   一天结束
	 * @return {@link Boolean}
	 * @throws Exception 例外
	 */
	Boolean sendSelfSettleDataToDept(Integer deptId, String toEmail, LocalDateTime startOfDay, LocalDateTime endOfDay) throws Exception;

	/**
	 * 将MAH结算数据发送到企业
	 *
	 * @param deptId     部门 ID
	 * @param toEmail    发送电子邮件至
	 * @param startOfDay 一天开始
	 * @param endOfDay   一天结束
	 * @return {@link Boolean}
	 * @throws Exception 例外
	 */
	Boolean sendMAHSettleDataToDept(Integer deptId, String toEmail, LocalDateTime startOfDay, LocalDateTime endOfDay) throws Exception;
}
