package com.qunzhixinxi.hnqz.report;

import com.qunzhixinxi.hnqz.common.feign.annotation.EnableHnqzFeignClients;
import com.qunzhixinxi.hnqz.common.security.annotation.EnableHnqzResourceServer;
import lombok.AllArgsConstructor;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.SpringCloudApplication;
import org.springframework.retry.annotation.EnableRetry;

/**
 * 启动类
 *
 * @author hnqz
 * @author hengchen.sun modify on 2021.06.15 enable retry
 * @date 2018年06月21日
 * 用户统一管理系统
 */
@SpringCloudApplication
@EnableHnqzFeignClients
@EnableHnqzResourceServer
@EnableRetry
@MapperScan(value = {"com.qunzhixinxi.hnqz.report.mapper"})
public class HnqzReportApplication {

    public static void main(String[] args) {
        SpringApplication.run(HnqzReportApplication.class, args);
    }

}
