package com.qunzhixinxi.hnqz.report.controller;

import com.qunzhixinxi.hnqz.admin.api.entity.WmTask;
import com.qunzhixinxi.hnqz.report.service.ReportExportService;
import com.qunzhixinxi.hnqz.report.service.WmTaskService;
import com.qunzhixinxi.hnqz.common.core.util.R;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;

/**
 * <p>
 * 报告审核导出
 * </p>
 */
@Slf4j
@RestController
@AllArgsConstructor
@RequestMapping("/reportExport")
public class ReportExportController {

    private final ReportExportService reportExportService;
    private final WmTaskService wmTaskService;

    /**
     * 个人报告导出--导出汇总或详情  汇总和详情合为一个模版
     *
     * @param wmTask
     * @return
     * @throws IOException
     */
    @GetMapping("/exportZbReport")
    public R exportZbReport(WmTask wmTask) throws IOException {

        return reportExportService.newExportZb(wmTask, null);//报告汇总


    }


}
