package com.qunzhixinxi.hnqz.report.mq;

import com.qunzhixinxi.hnqz.admin.api.constant.MqConstants;
import com.qunzhixinxi.hnqz.report.event.NbQueueEvent;
import com.qunzhixinxi.hnqz.common.core.entity.BaseMap;
import com.qunzhixinxi.hnqz.common.rabbitmq.annotation.RabbitMqComponent;
import com.qunzhixinxi.hnqz.common.rabbitmq.core.BaseRabbiMqHandler;
import com.qunzhixinxi.hnqz.common.rabbitmq.listenter.MqListener;
import com.rabbitmq.client.Channel;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.rabbit.annotation.RabbitHandler;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.amqp.support.AmqpHeaders;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.messaging.handler.annotation.Header;

import java.util.HashMap;
import java.util.Map;

/**
 * zb对列监听器
 */
@Slf4j
@AllArgsConstructor
@RabbitListener(queues = MqConstants.DIRECT_MODE_REPORT_EXPORT_NB_QUEUE)
@RabbitMqComponent(value = "nbReportExportReceiver")
public class ReportExportNbReceiver extends BaseRabbiMqHandler<BaseMap> {

    private final ApplicationEventPublisher publisher;

    @RabbitHandler
    public void onMessage(BaseMap baseMap, Channel channel, @Header(AmqpHeaders.DELIVERY_TAG) long deliveryTag) {
        super.onMessageAck1(baseMap, deliveryTag, channel, (MqListener<BaseMap>) (map, channel1) -> {
            //业务处理
            log.info("直接队列：nb报告导出，手动ACK，接收消息TAG:{},消息内容：{}", deliveryTag, baseMap);
            String requestBody = map.get("requestBody").toString();
            String username = map.get("username").toString();
            Integer deptId = Integer.valueOf(map.get("deptId").toString());

            publisher.publishEvent(new NbQueueEvent(requestBody, username, deptId));


            Map<String, String> res = new HashMap<>(1);
            res.put("res", "success");
            return res;
        });
    }
}
