package com.qunzhixinxi.hnqz.report.service;

import com.qunzhixinxi.hnqz.admin.api.entity.WmReport;
import com.qunzhixinxi.hnqz.admin.api.entity.WmScorePackage;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTask;
import com.qunzhixinxi.hnqz.common.core.util.R;

import java.io.IOException;

/**
 * @author: lixuesong
 * @createTime: 2022/11/28 13:03
 * @description: Excel报告导出
 */
public interface ExcelReportExportService {

    /**
     * 个人承接任务-按积分值，个人承接任务-按任务量，个人承接任务-通用，个人报告管理-个人报告导出的导出
     *
     * @param wmTask
     * @param username
     * @return
     * @throws IOException
     */
    R newExportZb(WmTask wmTask, String username) throws IOException;

    /**
     * 企业承接任务的导出、任务中心单的导出
     *
     * @param wmScorePackage
     * @param deptId
     * @param username
     * @return
     * @throws IOException
     */
    R newExportNba(WmScorePackage wmScorePackage, Integer deptId, String username) throws IOException;

    /**
     * 企业承接任务的导出、任务中心单的导出History
     *
     * @param wmScorePackage
     * @param deptId
     * @param username
     * @return
     * @throws IOException
     */
    R newExportNbaHistory(WmScorePackage wmScorePackage,Integer deptId,String username) throws IOException;

    /**
     * 结算报告管理，结算报告审批的导出
     *
     * @param wmReport
     * @param deptId
     * @param username
     * @return
     * @throws IOException
     */
    R newExportNb(WmReport wmReport, Integer deptId, String username) throws IOException;
}
