package com.qunzhixinxi.hnqz.report.service;

import com.qunzhixinxi.hnqz.admin.api.entity.WmReport;
import com.qunzhixinxi.hnqz.admin.api.entity.WmScorePackage;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTask;
import com.qunzhixinxi.hnqz.common.core.util.R;

import java.io.IOException;
import java.util.List;
import java.util.Map;


/**
 * <p>
 * 报告导出--服务类
 * </p>
 *
 * @author hnqz
 * @since 2018-01-20
 */
public interface ReportExportService {

    /**
     * 个人承接任务-按积分值，个人承接任务-按任务量，个人承接任务-通用，个人报告管理-个人报告导出的导出
     *
     * @param wmTask   参数信息
     * @param username 操作人
     * @return 上传信息
     * @throws IOException 异常
     */
    R<Map<String, String>> newExportZb(WmTask wmTask, String username) throws IOException;

    /**
     * 企业承接任务的导出、任务中心单的导出
     *
     * @param wmScorePackage 积分包
     * @param deptId         企业ID
     * @param username       操作人
     * @return 导出结果
     * @throws IOException 异常
     */
    R<?> newExportNba(WmScorePackage wmScorePackage, Integer deptId, String username) throws IOException;

    /**
     * 企业承接任务的导出、任务中心单的导出History
     *
     * @param wmScorePackage
     * @param deptId
     * @param username
     * @return
     * @throws IOException
     */
    R newExportNbaHistory(WmScorePackage wmScorePackage, Integer deptId, String username) throws IOException;

    /**
     * 结算报告管理，结算报告审批的导出
     *
     * @param wmReport
     * @param deptId
     * @param username
     * @return
     * @throws IOException
     */
    R<?> newExportNb(WmReport wmReport, Integer deptId, String username) throws IOException;

    List<Map<String, Object>> exportZbInfo(WmTask wmTask) throws IOException;

}
