package com.qunzhixinxi.hnqz.report.service;

import com.qunzhixinxi.hnqz.admin.api.entity.ReportHandlerDeptRelation;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.report.service.ExcelReportExportService;
import com.qunzhixinxi.hnqz.report.service.ReportExportService;

/**
* @author lixuesong
* @description 针对表【report_handler_dept_relation(导出报告处理类和企业关系表)】的数据库操作Service
* @createDate 2022-11-25 09:01:19
*/
public interface ReportHandlerDeptRelationService extends IService<ReportHandlerDeptRelation> {

    /**
     * 根据企业查询对应的处理类
     *
     * @param reportType 报告类型
     * @param deptId 企业id
     * @return 处理类
     */
    ReportExportService getHandlerClass(String reportType, Integer deptId);

    /**
     * 根据企业查询对应的处理类
     *
     * @param reportType 报告类型
     * @param deptId 企业id
     * @return 处理类
     */
    ReportExportService getReviewHandlerClass(String reportType, Integer deptId);

    /**
     * 根据企业查询对应的处理类
     *
     * @param reportType 报告类型
     * @param deptId 企业id
     * @return 处理类
     */
   ExcelReportExportService getExcelHandlerClass(String reportType, Integer deptId);

    /**
     * 根据企业查询对应的处理类
     *
     * @param reportType 报告类型
     * @param deptId 企业id
     * @return 处理类
     */
    ExcelReportExportService getExcelReviewHandlerClass(String reportType, Integer deptId);
}
