package com.qunzhixinxi.hnqz.report.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.ArrayUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaDrugEntDrugtable;
import com.qunzhixinxi.hnqz.report.mapper.WmDaDrugEntDrugtableMapper;
import com.qunzhixinxi.hnqz.report.service.WmDaDrugEntDrugtableService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * 档案-药企药品
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
@Service
@AllArgsConstructor
public class WmDaDrugEntDrugtableServiceImpl extends ServiceImpl<WmDaDrugEntDrugtableMapper, WmDaDrugEntDrugtable> implements WmDaDrugEntDrugtableService {

	/**
	 * 获取药品列表
	 *
	 * @param drugProducerList 关联药品生产厂商名称
	 * @return 名称列表
	 */
	@Override
	public List<String> listDrugByDrugEntName(String[] drugProducerList) {

		if (ArrayUtil.isNotEmpty(drugProducerList)){
			List<String> split = Stream.of(drugProducerList).filter(StrUtil::isNotEmpty).collect(Collectors.toList());
			if (CollUtil.isNotEmpty(split)){
				return this.list(Wrappers.<WmDaDrugEntDrugtable>lambdaQuery().in(WmDaDrugEntDrugtable::getDrugEntName, split))
						.stream().map(WmDaDrugEntDrugtable::getDrugname).distinct().collect(Collectors.toList());
			}

		}
		return new ArrayList<>();
	}


}
