package com.qunzhixinxi.hnqz.report.util;

import lombok.experimental.UtilityClass;
import lombok.extern.slf4j.Slf4j;
import org.openqa.selenium.Dimension;
import org.openqa.selenium.JavascriptExecutor;
import org.openqa.selenium.remote.DesiredCapabilities;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import ru.yandex.qatools.ashot.AShot;
import ru.yandex.qatools.ashot.Screenshot;
import ru.yandex.qatools.ashot.coordinates.WebDriverCoordsProvider;

import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

@Slf4j
@UtilityClass
public class Html2ImageByJsWrapper {


	public static BufferedImage renderHtml2Image(String url,String serverUrl) throws IOException {
		log.info("url: {}", url);

		DesiredCapabilities dc = DesiredCapabilities.chrome();
		try {
			RemoteWebDriver driver = new RemoteWebDriver(new URL(serverUrl), dc);
			driver.get(url);
			Thread.sleep(500);

		//等待页面加载完成
		new WebDriverWait(driver, 1000).until(driver1 -> ((JavascriptExecutor) driver)
				.executeScript("return document.readyState").equals("complete"));
		JavascriptExecutor jexec = (JavascriptExecutor) driver;
		Long width = (Long) jexec.executeScript("return document.body.scrollWidth");
		Long height = (Long) jexec.executeScript("return document.body.scrollHeight");
		//设置浏览窗口大小
		driver.manage().window().setSize(new Dimension(width.intValue(), height.intValue()));
		Screenshot screenshot = new AShot().coordsProvider(new WebDriverCoordsProvider()).takeScreenshot(driver);

		driver.quit();
		return  screenshot.getImage();

		} catch (Exception e) {
			log.error("renderHtml2Image截取图片失败");
			e.printStackTrace();
		}
		return null;
	}


}
